datasheet = '''<!DOCTYPE Datasheets>
  <Datasheets Version="1.0">
    <GenericMeasurements>
      <Measurement ID="0" Tag="None" UnitGroup="None"/>
      <Measurement ID="1" Tag="Time" UnitGroup="Time"/>
      <Measurement ID="2" Tag="Index" UnitGroup="Unitless"/>
      <Measurement ID="3" Tag="Frequency" UnitGroup="Frequency"/>
      <Measurement ID="4" Tag="Voltage" UnitGroup="Voltage"/>
      <Measurement ID="5" Tag="Temperature" UnitGroup="Temperature"/>
      <Measurement ID="6" Tag="Position" UnitGroup="Length"/>
      <Measurement ID="7" Tag="Force" UnitGroup="Force"/>
      <Measurement ID="8" Tag="MagneticField" UnitGroup="MagneticField"/>
      <Measurement ID="9" Tag="Pressure" UnitGroup="Pressure"/>
      <Measurement ID="10" Tag="Acceleration" UnitGroup="Acceleration"/>
      <Measurement ID="11" Tag="DewPoint" UnitGroup="Temperature"/>
      <Measurement ID="12" Tag="Altitude" UnitGroup="Length"/>
      <Measurement ID="13" Tag="Velocity" UnitGroup="Velocity"/>
      <Measurement ID="14" Tag="Angle" UnitGroup="Angle"/>
      <Measurement ID="15" Tag="AngularVelocity" UnitGroup="AngularVelocity"/>
      <Measurement ID="16" Tag="AngularAcceleration" UnitGroup="AngularAcceleration"/>
      <Measurement ID="17" Tag="ConcentrationGaseous" UnitGroup="Percent"/>
      <Measurement ID="18" Tag="ConcentrationAqueous" UnitGroup="Percent"/>
      <Measurement ID="19" Tag="Charge" UnitGroup="Charge"/>
      <Measurement ID="20" Tag="pH" UnitGroup="Unitless"/>
      <Measurement ID="21" Tag="Transmittance" UnitGroup="Unitless"/>
      <Measurement ID="22" Tag="Absorbance" UnitGroup="Unitless"/>
      <Measurement ID="23" Tag="Conductivity" UnitGroup="Conductivity"/>
      <Measurement ID="24" Tag="SoundIntensity" UnitGroup="SoundIntensity"/>
      <Measurement ID="25" Tag="LightIntensity" UnitGroup="Light"/>
      <Measurement ID="26" Tag="Current" UnitGroup="Current"/>
      <Measurement ID="27" Tag="HeartRate" UnitGroup="HeartRate"/>
      <Measurement ID="28" Tag="Radiation" UnitGroup="Unitless"/>
      <Measurement ID="29" Tag="AbsoluteHumidity" UnitGroup="AbsoluteHumidity"/>
      <Measurement ID="30" Tag="RelativeHumidity" UnitGroup="Percent"/>
      <Measurement ID="31" Tag="IntensityIR" UnitGroup="Percent"/>
      <Measurement ID="32" Tag="RelativeIrradiance" UnitGroup="Unitless"/> 
      <Measurement ID="33" Tag="Volume" UnitGroup="Volume"/>
      <Measurement ID="34" Tag="FlowVolume" UnitGroup="Volume"/>
      <Measurement ID="35" Tag="Turbidity" UnitGroup="Turbidity"/>
      <Measurement ID="36" Tag="Power" UnitGroup="Power"/>
      <Measurement ID="37" Tag="Resistance" UnitGroup="Resistance"/>
      <Measurement ID="38" Tag="Capacitance" UnitGroup="Capacitance"/>
      <Measurement ID="39" Tag="KineticEnergy" UnitGroup="Energy"/>
      <Measurement ID="40" Tag="Energy" UnitGroup="Energy" Default="1"/>
      <Measurement ID="41" Tag="ISEVoltage" UnitGroup="Voltage"/>
      <Measurement ID="42" Tag="DissolvedOxygen" UnitGroup="Percent"/>
      <Measurement ID="43" Tag="O2Concentration" UnitGroup="Percent"/>
      <Measurement ID="44" Tag="Speed" UnitGroup="Velocity"/>
      <Measurement ID="45" Tag="SoundLevelA" UnitGroup="SoundLevelA"/>
      <Measurement ID="46" Tag="Humidex" UnitGroup="Temperature"/>
      <Measurement ID="47" Tag="WindChill" UnitGroup="Temperature"/>
      <Measurement ID="48" Tag="BarometricPressure" UnitGroup="Pressure"/>
      <Measurement ID="49" Tag="Latitude" UnitGroup="Angle"/>
      <Measurement ID="50" Tag="LatitudeMinutes" UnitGroup="Angle"/>
      <Measurement ID="51" Tag="Longitude" UnitGroup="Angle"/>
      <Measurement ID="52" Tag="LongitudeMinutes" UnitGroup="Angle"/>
      <Measurement ID="53" Tag="Direction" UnitGroup="Angle"/>
      <Measurement ID="54" Tag="HeartBeat" UnitGroup="Unitless"/>
      <Measurement ID="55" Tag="SoundLevelC" UnitGroup="SoundLevelC"/>
      <Measurement ID="56" Tag="UncorrectedBarometricPressure" UnitGroup="Pressure"/>
      <Measurement ID="57" Tag="AltitudeCorrection" UnitGroup="Pressure"/>
      <Measurement ID="58" Tag="Video" UnitGroup="Unitless"/>
      <Measurement ID="59" Tag="Snapshot" UnitGroup="Unitless"/>
      <Measurement ID="60" Tag="Mass" UnitGroup="Mass"/>
      <Measurement ID="61" Tag="Action" UnitGroup="Action"/>
      <Measurement ID="62" Tag="DropsPerSample" UnitGroup="Drops"/>
      <Measurement ID="63" Tag="TotalDrops" UnitGroup="Drops"/>
      <Measurement ID="65" Tag="Intensity" UnitGroup="Intensity"/>
      <Measurement ID="66" Tag="Concentration" UnitGroup="Concentration"/>
      <Measurement ID="67" Tag="BreathRate" UnitGroup="Respiration"/>
      <Measurement ID="68" Tag="Humidity" UnitGroup="Percent"/>
      <Measurement ID="69" Tag="Count" UnitGroup="Unitless"/>
      <!-- Measurement ID="71" Tag="Flow" has been obsoleted in favor of FlowVolume -->
      <Measurement ID="72" Tag="VolumeFlowRate" UnitGroup="FlowRate"/>
      <Measurement ID="73" Tag="Salinity" UnitGroup="PartsPerNotation"/>
      <Measurement ID="74" Tag="PercentVWC" UnitGroup="Percent"/>
      <Measurement ID="75" Tag="WaterPotential" UnitGroup="Pressure"/>
      <Measurement ID="76" Tag="State" UnitGroup="Unitless"/>
      <Measurement ID="77" Tag="Saturation" UnitGroup="Percent"/>
      <Measurement ID="78" Tag="Amplitude" UnitGroup="Voltage"/>
      <Measurement ID="79" Tag="CalibratedUnits" UnitGroup="Voltage"/>
      <Measurement ID="80" Tag="Period" UnitGroup="Time"/>
      <Measurement ID="81" Tag="AngularSpeed" UnitGroup="AngularVelocity"/>
      <Measurement ID="82" Tag="CountsPerSample" UnitGroup="CountsPerSample"/>
      <Measurement ID="83" Tag="Counter" UnitGroup="Unitless"/>
      <Measurement ID="84" Tag="Density" UnitGroup="MassDensity"/>
      <Measurement ID="85" Tag="Area" UnitGroup="Area"/>
      <Measurement ID="86" Tag="Molarity" UnitGroup="Molarity"/>
      <Measurement ID="87" Tag="CountsPerRev" UnitGroup="Count"/>
      <Measurement ID="88" Tag="Length" UnitGroup="Length"/>
      <Measurement ID="89" Tag="Distance" UnitGroup="Length"/>
      <Measurement ID="90" Tag="PotentialEnergy" UnitGroup="Energy"/>
      <Measurement ID="91" Tag="Wavelength" UnitGroup="Length"/>
      <Measurement ID="92" Tag="Momentum" UnitGroup="Momentum"/>
      <Measurement ID="93" Tag="PAR" UnitGroup="PAR"/>
      <Measurement ID="94" Tag="UVIndex" UnitGroup="Unitless"/>
      <Measurement ID="95" Tag="Brightness" UnitGroup="Percent"/>
      <Measurement ID="96" Tag="Loudness" UnitGroup="Percent"/>
      <Measurement ID="97" Tag="LineDetectors" UnitGroup="Unitless"/>
      <Measurement ID="98" Tag="Ozone" UnitGroup="PartsPerNotation"/>
      <Measurement ID="99" Tag="VOC" UnitGroup="Unitless"/>
      <Measurement ID="100" Tag="Particulate" UnitGroup="MassDensity"/>
    </GenericMeasurements>
    <!-- DisplayTypes section is used to convert between new xml datasheet tags and old sds datasheet IDs -->
    <DisplayTypes>
      <Display ID="0" Tag="None"/>
      <Display ID="1" Tag="Digits"/>
      <Display ID="2" Tag="Graph"/>
      <Display ID="3" Tag="Table"/>
      <Display ID="4" Tag="Meter"/>
    </DisplayTypes>
    <!-- Macros section is used to describe all available measurement macros and convert between new xml datasheet tags and old sds datasheet IDs -->
    <MacroTypes>
      <Macro MeasID="0" Tag="Direct" Description="Direct 16.16 measurement"/>
      <Macro MeasID="1" Tag="RawAnalog" Description="Raw Analog value"/>
      <Macro MeasID="2" Tag="RawDigital" Description="Raw Digital Value"/>
      <Macro MeasID="3" Tag="FactoryCal" Description="Factory Calibration">
        <Param ID="0" Name="Point 1 Input"/>
        <Param ID="1" Name="Point 1 Output"/>
        <Param ID="2" Name="Point 2 Input"/>
        <Param ID="3" Name="Point 2 Output"/>
      </Macro>
      <Macro MeasID="7" Tag="UserCal" Description="User Calibration">
        <Param Description="Point 1 Input" ID="0"/>
        <Param Description="Point 1 Output" ID="1"/>
        <Param Description="Point 2 Input" ID="2"/>
        <Param Description="Point 2 Output" ID="3"/>
      </Macro>
      <Macro MeasID="4" Tag="Rate" Description="Rate Calculation" MacroID="2">
        <Param Description="Time Average Window" ID="0"/>
        <Param Description="Time Report Scale" ID="1"/>
      </Macro>
      <Macro MeasID="4" Tag="USoundPos" Description="USound Position" MacroID="3">
        <Param Description="Speed of sound (m/s/s)" ID="0"/>
      </Macro>
      <Macro MeasID="4" Tag="RotaryPos" Description="Rotary Position" MacroID="4">
        <Param Description="Input Units" ID="0"/>
        <Param Description="Output Units" ID="1"/>
      </Macro>
      <Macro MeasID="4" Tag="Derivative" Description="Derivative" MacroID="5">
        <Param Description="Point Span" ID="0"/>
      </Macro>
      <Macro MeasID="4" Tag="Absorbance" Description="Absorbance" MacroID="6"/>
      <Macro MeasID="4" Tag="LinearConv" Description="Linear Conversion" MacroID="7">
        <Param Description="Scale" ID="0"/>
        <Param Description="Offset" ID="1"/>
      </Macro>
      <Macro MeasID="4" Tag="Temperature" Description="Thermistor Temperature" MacroID="13">
        <Param Description="Max ADC Value" ID="0"/>
      </Macro>
      <Macro MeasID="8" Tag="TwoInputCombo" Description="Two Input Combination" MacroID="8">
        <Param Description="Product Scale" ID="0"/>
        <Param Description="Input 1 Scale" ID="1"/>
        <Param Description="Input 2 Scale" ID="2"/>
        <Param Description="Absolute Value (1=yes)" ID="3"/>
      </Macro>
      <Macro MeasID="8" Tag="TwoInputVector" Description="Two Input Vector Sum" MacroID="9"/>
      <Macro Tag="DigitalState" Description="Digital State (on/off)"/>
      <Macro Tag="TimeInGate" Description="Time photogate is blocked"/>
      <Macro Tag="VelocityInGate" Description="Velocity of object blocking the photogate"/>
    </MacroTypes>
    <!-- Units section is used to describe all available units, group them, and provide scale/offset conversions between units -->
    <Units>
      <UnitGroup ID="0" Tag="Unitless">
        <Unit ID="0" Tag="Unitless" Scale="1" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="1" Tag="Time" Default="s">
        <Unit ID="0" Tag="s" Scale="1" Offset="0"/>
        <Unit ID="1" Tag="ms" Scale="1000" Offset="0"/>
        <Unit ID="2" Tag="us" Scale="1000000" Offset="0"/>
        <Unit ID="3" Tag="minutes" Scale="0.01666666666666667" Offset="0"/>
        <Unit ID="4" Tag="hours" Scale="0.0002777777777777778" Offset="0"/>
        <Unit ID="5" Tag="days" Scale="1.157407407407407e-005" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="2" Tag="Temperature" Default="DegC" USDefault="DegF">
        <Unit ID="0" Tag="DegC" Scale="1" Offset="0"/>
        <Unit ID="1" Tag="DegF" Scale="1.8" Offset="32"/>
        <Unit ID="2" Tag="K" Scale="1" Offset="273.15"/>
        <Group Default="DegC" Tag="Weather" Units="DegC,DegF"/>
        <Group Default="DegF" Locale="usc" Tag="Weather" Units="DegC,DegF"/>
      </UnitGroup>
      <UnitGroup ID="3" Tag="Pressure" Default="kPa" USDefault="psi">
        <Unit ID="0" Tag="psi" Scale="1" Offset="0"/>
        <Unit ID="1" Tag="Nm2" Scale="6894.757293" Offset="0"/>
        <Unit ID="2" Tag="kPa" Scale="6.894757293" Offset="0"/>
        <Unit ID="3" Tag="atm" Scale="0.068045964" Offset="0"/>
        <Unit ID="4" Tag="torr" Scale="51.71492032" Offset="0"/>
        <Unit ID="5" Tag="hPa" Scale="68.94757293" Offset="0"/>
        <Unit ID="6" Tag="inHg" Scale="2.036021" Offset="0"/>
        <Unit ID="7" Tag="mmHg" Scale="51.71492032" Offset="0"/>
        <Unit ID="8" Tag="mBar" Scale="68.94757293" Offset="0"/>
        <Unit ID="9" Tag="Pa" Scale="6894.757293" Offset="0"/>
        <Unit ID="10" Tag="inH2O" Scale="27.679904843" Offset="0"/>
        <Group Default="mmHg" Tag="Weather" Units="atm,torr,hPa,inHg,mmHg,mBar,Pa,inH20"/>
        <Group Default="inHg" Locale="usc" Tag="Weather" Units="atm,torr,hPa,inHg,mmHg,mBar,Pa,inH20"/>
      </UnitGroup>
      <UnitGroup ID="4" Tag="Voltage" Default="V">
        <Unit ID="0" Tag="V" Scale="1" Offset="0"/>
        <Unit ID="1" Tag="mV" Scale="1000" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="5" Tag="Length" Default="m" USDefault="ft">
        <Unit ID="0" Tag="m" Scale="1" Offset="0"/>
        <Unit ID="1" Tag="cm" Scale="100" Offset="0"/>
        <Unit ID="2" Tag="mm" Scale="1000" Offset="0"/>
        <Unit ID="3" Tag="in" Scale="39.37007874" Offset="0"/>
        <Unit ID="4" Tag="ft" Scale="3.280839895" Offset="0"/>
        <Unit ID="5" Tag="mil" Scale="39370.07874" Offset="0"/>
        <Unit ID="6" Tag="km" Scale="0.001" Offset="0"/>
		    <Unit ID="7" Tag="um" Scale="1000000" Offset="0"/>
  	    <Unit ID="8" Tag="nm" Scale="1000000000" Offset="0"/>
        <Group Default="m" Tag="GPS" Units="m,km"/>
        <Group Default="ft" Locale="usc" Tag="GPS" Units="ft"/>
		  <Group Tag="Scientific" Units="m,cm"/>
      </UnitGroup>
      <UnitGroup ID="6" Tag="Force" Default="N" USDefault="lbs">
        <Unit ID="0" Tag="N" Scale="1" Offset="0"/>
        <Unit ID="1" Tag="lbs" Scale="0.224808943" Offset="0"/>
        <Unit ID="2" Tag="kgmps2" Scale="1" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="7" Tag="MagneticField" Default="tesla">
        <Unit ID="0" Tag="gauss" Scale="1" Offset="0"/>
        <Unit ID="1" Tag="mtesla" Scale="0.1" Offset="0"/>
        <Unit ID="2" Tag="tesla" Scale="0.0001" Offset="0"/>
        <Unit ID="3" Tag="utesla" Scale="100" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="8" Tag="Acceleration" Default="ms2" USDefault="fts2">
        <Unit ID="0" Tag="ms2" Scale="1" Offset="0"/>
        <Unit ID="1" Tag="grav" Scale="0.101972" Offset="0"/>
        <Unit ID="2" Tag="fts2" Scale="3.280839895" Offset="0"/>
        <Unit ID="3" Tag="cms2" Scale="100.0" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="9" Tag="Velocity" Default="mps" USDefault="fps">
        <Unit ID="0" Tag="mps" Scale="1" Offset="0"/>
        <Unit ID="1" Tag="fps" Scale="3.280839895" Offset="0"/>
        <Unit ID="2" Tag="kph" Scale="3.6" Offset="0"/>
        <Unit ID="3" Tag="mph" Scale="2.236936292" Offset="0"/>
        <Unit ID="4" Tag="knots" Scale="1.943844492" Offset="0"/>
        <Unit ID="5" Tag="cmps" Scale="100.0" Offset="0"/>
        <Unit ID="6" Tag="mmps" Scale="1000.0" Offset="0"/>
        <Unit ID="7" Tag="mmpmin" Scale="60000.0" Offset="0"/>
        <Unit ID="8" Tag="furlongperfortnight" Scale="6012.87" Offset="0"/>
        <Group Tag="Scientific" Units="mps,cmps,fps"/>
        <Group Default="kph" Tag="WindSpeed" Units="kph,mph,knots"/>
        <Group Default="mph" Locale="enu" Tag="WindSpeed" Units="kph,mph,knots"/>
        <Group Default="mph" Locale="usc" Tag="WindSpeed" Units="kph,mph,knots"/>
        <Group Default="mps" Tag="GPS" Units="mps,fps,kph,mph,knots"/>
        <Group Default="fps" Locale="usc" Tag="GPS" Units="mps,fps,kph,mph,knots"/>
      </UnitGroup>
      <UnitGroup ID="10" Tag="Angle" Default="rad">
        <Unit ID="0" Tag="rad" Scale="1" Offset="0"/>
        <Unit ID="1" Tag="deg" Scale="57.2957795" Offset="0"/>
        <Unit ID="2" Tag="rev" Scale="0.159155" Offset="0" />
        <Group Default="deg" Tag="GPS" Units="deg"/>
      </UnitGroup>
      <UnitGroup ID="11" Tag="AngularVelocity" Default="radps">
        <Unit ID="0" Tag="radps" Scale="1" Offset="0"/>
        <Unit ID="1" Tag="degps" Scale="57.2957795" Offset="0"/>
        <Unit ID="2" Tag="revpm" Scale="9.549297" Offset="0"/>
        <Unit ID="3" Tag="revps" Scale="0.159155" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="12" Tag="AngularAcceleration" Default="radps2">
        <Unit ID="0" Tag="radps2" Scale="1" Offset="0"/>
        <Unit ID="1" Tag="degps2" Scale="57.2957795" Offset="0"/>
        <Unit ID="2" Tag="revpmps" Scale="9.549297" Offset="0"/>
        <Unit ID="3" Tag="revps2" Scale="0.159155" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="13" Tag="Charge" Default="uC">
        <Unit ID="0" Tag="nC" Scale="1" Offset="0"/>
        <Unit ID="1" Tag="uC" Scale="0.001" Offset="0"/>
        <Unit ID="2" Tag="C" Scale="0.000000001" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="14" Tag="Current" Default="A">
        <Unit ID="0" Tag="A" Scale="1" Offset="0"/>
        <Unit ID="1" Tag="mA" Scale="1000" Offset="0"/>
        <Unit ID="2" Tag="uA" Scale="1e+6" Offset="0"/>
        <Unit ID="3" Tag="nA" Scale="1e+9" Offset="0"/>
        <Unit ID="4" Tag="pA" Scale="1e+12" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="15" Tag="Volume" Default="L">
        <Unit ID="0" Tag="L" Scale="1" Offset="0"/>
        <Unit ID="1" Tag="mL" Scale="1000" Offset="0"/>
        <Unit ID="2" Tag="ft3" Scale="0.035314667" Offset="0"/>
        <Unit ID="3" Tag="m3" Scale="0.001" Offset="0"/>
        <Unit ID="4" Tag="mm3" Scale="1000000" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="16" Tag="FlowRate" Default="Lps">
        <Unit ID="0" Tag="Lps" Scale="1" Offset="0"/>
        <Unit ID="1" Tag="cfm" Scale="2.118879973" Offset="0"/>
        <Unit ID="2" Tag="m3ps" Scale="0.001" Offset="0"/>
        <Unit ID="3" Tag="galps" Scale="0.26417205236" Offset="0"/>
        <Unit ID="4" Tag="galpd" Scale="22824.465" Offset="0"/>
        <Unit ID="5" Tag="galpm" Scale="15.850323" Offset="0"/>
        <Unit ID="6" Tag="m3pm" Scale="0.06" Offset="0"/>
        <Unit ID="7" Tag="Lpm" Scale="60" Offset="0"/>
        <Unit ID="8" Tag="Lph" Scale="3600" Offset="0"/>
        <Unit ID="9" Tag="igalpd" Scale="19005.343" Offset="0"/>
        <Unit ID="10" Tag="igalpm" Scale="13.198154" Offset="0"/>
        <Unit ID="11" Tag="igalps" Scale="0.219969248" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="17" Tag="Resistance" Default="ohm">
        <Unit ID="0" Tag="ohm" Scale="1" Offset="0"/>
        <Unit ID="1" Tag="kohm" Scale="0.001" Offset="0"/>
        <Unit ID="2" Tag="megaohm" Scale="1e-006" Offset="0"/>
        <Unit ID="3" Tag="milliohm" Scale="1000" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="18" Tag="Capacitance" Default="uF">
        <Unit ID="0" Tag="F" Scale="1" Offset="0"/>
        <Unit ID="1" Tag="mF" Scale="1000" Offset="0"/>
        <Unit ID="2" Tag="uF" Scale="1000000" Offset="0"/>
        <Unit ID="3" Tag="nF" Scale="1000000000" Offset="0"/>
        <Unit ID="4" Tag="pF" Scale="1000000000000" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="19" Tag="Energy" Default="J">
        <Unit ID="0" Tag="J" Scale="1" Offset="0"/>
        <Unit ID="1" Tag="Nm" Scale="1" Offset="0"/>
        <Unit ID="2" Tag="eV" Scale="6.241506479963234e+018" Offset="0"/>
        <Unit ID="3" Tag="kWh" Scale="2.777777777777778e-007" Offset="0"/>
        <Unit ID="4" Tag="Ws" Scale="1" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="20" Tag="PartsPerNotation">
        <Unit ID="0" Tag="ppm" Scale="1" Offset="0"/>
        <Unit ID="1" Tag="ppt" Scale="0.001" Offset="0"/>
        <Unit ID="2" Tag="pph" Scale="0.0001" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="21" Tag="Percent">
        <Unit ID="0" Tag="percent" Scale="1" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="22" Tag="Conductivity">
        <Unit ID="0" Tag="uSpcm" Scale="1" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="24" Tag="HeartRate">
        <Unit ID="0" Tag="BeatsPerMin" Scale="1" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="25" Tag="Respiration">
        <Unit ID="0" Tag="BreathPerMin" Scale="1" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="26" Tag="Count">
        <Unit ID="0" Tag="counts" Scale="1" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="27" Tag="SoundLevelA">
        <Unit ID="0" Tag="dBA" Scale="1" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="28" Tag="SoundLevelC">
        <Unit ID="0" Tag="dBC" Scale="1" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="29" Tag="Drops">
        <Unit ID="0" Tag="drops" Scale="1" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="30" Tag="AbsoluteHumidity">
        <Unit ID="0" Tag="gpm3" Scale="1" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="31" Tag="Frequency">
        <Unit ID="0" Tag="Hz" Scale="1" Offset="0"/>
        <Unit ID="1" Tag="kHz" Scale="0.001" Offset="0"/>
        <Unit ID="2" Tag="MHz" Scale="0.000001" Offset="0"/>
        <Unit ID="3" Tag="GHz" Scale="0.000000001" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="32" Tag="Light">
        <Unit ID="0" Tag="lux" Scale="1" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="33" Tag="Concentration">
        <Unit ID="0" Tag="mgpL" Scale="1" Offset="0"/>
        <Unit ID="1" Tag="gpL" Scale="0.001" Offset="0"/>
        <Unit ID="2" Tag="mgpmL" Scale="0.001" Offset="0"/>
        <Unit ID="3" Tag="ugpuL" Scale="0.001" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="34" Tag="Turbidity">
        <Unit ID="0" Tag="NTU" Scale="1" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="35" Tag="OpticalDensity">
        <Unit ID="0" Tag="od" Scale="1" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="36" Tag="Pulses">
        <Unit ID="0" Tag="pulses" Scale="1" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="37" Tag="Power">
        <Unit ID="0" Tag="W" Scale="1" Offset="0"/>
        <Unit ID="1" Tag="mW" Scale="1000" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="38" Tag="Intensity">
        <Unit ID="0" Tag="wpm2" Scale="1" Offset="0"/>
        <Unit ID="1" Tag="mWpm2" Scale="1000" Offset="0"/>
        <Unit ID="2" Tag="uWpm2" Scale="1000000" Offset="0"/>
        <Unit ID="3" Tag="uWpcm2" Scale="100" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="39" Tag="Video">
        <Unit ID="0" Tag="Video" Scale="1" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="40" Tag="Snapshot">
        <Unit ID="0" Tag="Snapshot" Scale="1" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="41" Tag="Mass">
        <Unit ID="0" Tag="kg" Scale="1" Offset="0"/>
        <Unit ID="1" Tag="g" Scale="1000" Offset="0"/>
        <Unit ID="2" Tag="oz" Scale="35.273962" Offset="0"/>
        <Unit ID="3" Tag="lb" Scale="2.204623" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="42" Tag="Action">
        <Unit ID="0" Tag="Js" Scale="1" Offset="0"/>
        <Unit ID="1" Tag="eVs" Scale="6.241506479963234e+018" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="43" Tag="CountsPerSample">
        <Unit ID="0" Tag="CountsPerSample" Scale="1" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="44" Tag="MassDensity">
        <Unit ID="0" Tag="kgpm3" Scale="1" Offset="0"/>
        <Unit ID="1" Tag="gpm3" Scale="1000" Offset="0"/>
        <Unit ID="2" Tag="ugpm3" Scale="1000000000" Offset="0"/>
        <Unit ID="3" Tag="mgpm3" Scale="1000000" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="45" Tag="Area">
        <Unit ID="0" Tag="m2" Scale="1" Offset="0"/>
        <Unit ID="1" Tag="cm2" Scale="10000" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="46" Tag="Molarity">
        <Unit ID="0" Tag="molpm3" Scale="1" Offset="0"/>
        <Unit ID="1" Tag="molpL" Scale="1000" Offset="0"/>
        <Unit ID="2" Tag="molar" Scale="1000" Offset="0"/>
        <Unit ID="3" Tag="mMolar" Scale="1" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="47" Tag="PercentOfScaleMax">
        <Unit ID="0" Tag="Percentofscalemax" Scale="1" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="48" Tag="Momentum">
        <Unit ID="0" Tag="kgmps" Scale="1" Offset="0"/>
        <Unit ID="1" Tag="Ns" Scale="1" Offset="0"/>
        <Unit ID="2" Tag="gcmps" Scale="100000" Offset="0"/>
      </UnitGroup>
      <UnitGroup ID="49" Tag="PAR">
        <Unit ID="0" Tag="umolpm2ps" Scale="1" Offset="0"/>
        <Unit ID="1" Tag="molpm2ps" Scale="1e-006" Offset="0"/>
      </UnitGroup>
    </Units>
    <!-- Sensor groups define collections of sensors -->
    <SensorGroups>
      <Group ID="1" Name="GeneralPasport" SensorIDs="100-1999"/>
      <Group ID="2" Name="SpecialPasport" SensorIDs="2000-3999"/>
      <Group ID="3" Name="AllPasport" SensorIDs="1-3999"/>
      <Group ID="4" Name="CIAnalog" SensorIDs="20000-20299"/>
      <Group ID="5" Name="Vernier" SensorIDs="30000-30099"/>
      <Group ID="6" Name="CIAnalogAndVernier" SensorIDs="20000-20299,30000-30099"/>
      <Group ID="7" Name="Probe" SensorIDs="22000-22199"/>
      <Group ID="8" Name="DefaultDigital" SensorIDs="22128,22133,21006,21008,21005,21001,21030,21031,21017,22016,21012,21023,21013,21021,21130,21131,21011,22020"/>
      <Group ID="9" Name="AllDigital" SensorIDs="21001-22199"/>
      <Group ID="10" Name="PhotogatePort" SensorIDs="21006,21011,21012,21013,21017,21021,21023,22016,22020,22128,22133"/>
      <Group ID="11" Name="SmartGateLaser" SensorIDs="22016"/>
      <Group ID="12" Name="SmartGateAux" SensorIDs="22128,22133,21006,21008,21005,21001,21030,21031,21017,21012,21023,21013,21021,21011,22020"/>
      <Group ID="13" Name="SmartGate" SensorIDs="21034, 21035, 21005, 21008, 21006"/>
      <Group ID="14" Name="1InputPGTimers" SensorIDs="21001,21005,21006,21008,21030,21031,23050,23051"/>
      <Group ID="15" Name="2InputPGTimers" SensorIDs="21009,21010,21032,21033,23052,23053"/>
      <Group ID="16" Name="AllPGTimers" SensorIDs="21001,21005,21006,21008,21009,21010,21030,21031,21032,21033,21034,21035,23050-23053"/>
      <Group ID="17" Name="AllCounters" SensorIDs="21011,21012,21013,21021,21023,21131"/>
      <Group ID="18" Name="Computer" SensorIDs="32299-33001"/>
      <Group ID="19" Name="SensorGroupSparkVueSmartGate" SensorIDs="23001-23006, 23008,23010-23011,23015,23018,23019,23050-23053"/>
      <Group ID="20" Name="SensorGroupSparkVueDigAdapter" SensorIDs="23001-23006, 23008,23010-23013,23018,23019,23050-23053"/>
      <Group ID="21" Name="SensorGroupSparkVueAnalogAdapter" SensorIDs="20000-20174,20201-20299,30000-30099"/>
      <Group ID="22" Name="OnboardSensors" SensorIDs="2012-2015,2017"/>
      <Group ID="23" Name="Conductivity_1X_10X_Sensor" SensorIDs="141,231,264,267"/>
      <Group ID="24" Name="GPSSensors" SensorIDs="237,2038"/>
      <Group ID="25" Name="SmartCartSensors" SensorIDs="2025,2026,2027,2029"/>
      <Group ID="26" Name="ScienceJournal" SensorIDs="2020-2039,2043-2054,2056-2057"/>
      <Group ID="27" Name="PascoDataStreamer" SensorIDs="2020-2039,2043-2054,2056-2057"/>
      <Group ID="28" Name="ControlNode8PinSensors" SensorIDs="2501-2502,2506,2508"/>
      <Group ID="29" Name="ControlNode6PinSensors" SensorIDs="2504-2505,2507"/>
      <Group ID="30" Name="MasqueradingSensors" SensorIDs="2506,2508"/>
      <Group ID="31" Name="Chemvue" SensorIDs="135-137,139,141-143,145,146,153,200,201,207,209-211,213,216,219,220,223,224,230,232,234,236,239,241,242,246,251,253,264,267,2020-2022,2030-2035,2037-2039,2041,2042,2049,2050,2052,2057,2073,2079,2080,2083,2084,2086,3003" />
    </SensorGroups>
    <Sensors>
      <!-- Sensor IDs 1 - 2000 are for standard Pasport sensors -->
      <Sensor ID="1" Tag="LoadTestSensor" Version="2.5" Class="0" DefaultRate="20Hz" FloatParams="0" IconID="135" Latency="100" MaxDatasheet="2048" MaxRate="5000Hz" Model="PS-2104" Warmup="1">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="1" Accuracy="1" Display="None" Internal="1" Maximum="32767" Minimum="0" Precision="0" TypicalMax="32767" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="Voltage" UnitType="V" Type="LinearConv" Inputs="0" Params="31.3,0" Accuracy="0.1" Display="Graph" Internal="0" Maximum="50" MeasType="Voltage" Minimum="-50" Precision="1" SymbolTag="F" TypicalMax="5" TypicalMin="-5" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="130" Tag="ForceSensor" Version="2.5" Class="0" DefaultRate="20Hz" FileName="Force.sds" FloatParams="0" Icon="000000000e000e001f380e3804380038067c3838c011800e4031e00300000000" IconID="130" Latency="100" MaxDatasheet="2048" MaxRate="5000Hz" Model="PS-2104" Warmup="1">
        <Measurement ID="0" NameTag="ForceCounts" Type="RawDigital" DataSize="2" Accuracy="1" Display="None" Internal="1" Maximum="32767" Minimum="0" Precision="0" TypicalMax="32767" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="Forcepushpositive" UnitType="N" Type="FactoryCal" Inputs="0" Params="2048,0,4000,50" Accuracy="0.1" Display="Graph" Internal="0" Maximum="50" MeasType="Force" Minimum="-50" Precision="1" ShortNameTag="ForcePush" SymbolTag="F" TypicalMax="5" TypicalMin="-5" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="Forcepullpositive" UnitType="N" Type="LinearConv" Inputs="1" Params="-1,0" Accuracy="0.1" Display="Graph" Internal="0" Maximum="50" MeasType="Force" Minimum="-50" Precision="1" ShortNameTag="ForcePull" SymbolTag="F" TypicalMax="5" TypicalMin="-5" Visible="0" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="Force" UnitType="N" Type="LinearConv" Inputs="1" Params="1,0" Accuracy="0.1" CanChangeSign="1" Display="Graph" Internal="0" Maximum="50" MeasType="Force" Minimum="-50" Precision="1" SymbolTag="F" TypicalMax="5" TypicalMin="-5" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1" IsDefaultMeas="1"/>
      </Sensor>
      <Sensor ID="131" Tag="AccelerationSensor" Version="2.7" Class="0" DefaultRate="20Hz" FileName="Acceleration.sds" FloatParams="0" Icon="002980130011000100010001000100010201ffe1024000e40500021005400060" IconID="131" Latency="750" MaxDatasheet="8192" MaxRate="100Hz" Model="PS-2118/9" SupportsZeroOnStart="1" Warmup="1000">
        <Measurement ID="0" NameTag="Accelerationx" UnitType="grav" Type="FactoryCal" Inputs="3" Params="4096,0,4424,1" Accuracy="0.1" Display="Graph" Internal="0" Maximum="10" MeasType="Acceleration" Minimum="-10" OffsetZero="1" Precision="1" ShortNameTag="accx" SymbolTag="ax" TypicalMax="1" TypicalMin="-1" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="Accelerationy" UnitType="grav" Type="FactoryCal" Inputs="4" Params="4096,0,4424,1" Accuracy="0.1" Display="Graph" Internal="0" Maximum="10" MeasType="Acceleration" Minimum="-10" OffsetZero="1" Precision="1" ShortNameTag="accy" SymbolTag="ay" TypicalMax="1" TypicalMin="-1" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="Accelerationz" UnitType="grav" Type="FactoryCal" Inputs="5" Params="4096,0,4424,1" Accuracy="0.1" Display="Graph" Internal="0" Maximum="10" MeasType="Acceleration" Minimum="-10" OffsetZero="1" Precision="1" ShortNameTag="accz" SymbolTag="az" TypicalMax="1" TypicalMin="-1" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="X" Type="RawDigital" DataSize="2" Accuracy="4" Display="Digits" Internal="1" Maximum="7400" Minimum="800" Precision="0" ShortNameTag="counts" TypicalMax="7400" TypicalMin="800"/>
        <Measurement ID="4" NameTag="Y" Type="RawDigital" DataSize="2" Accuracy="4" Display="Digits" Internal="1" Maximum="7400" Minimum="800" Precision="0" ShortNameTag="counts" TypicalMax="7400" TypicalMin="800"/>
        <Measurement ID="5" NameTag="Z" Type="RawDigital" DataSize="2" Accuracy="4" Display="Digits" Internal="1" Maximum="7400" Minimum="800" Precision="0" ShortNameTag="counts" TypicalMax="7400" TypicalMin="800"/>
        <Measurement ID="6" NameTag="AccelerationResultant" UnitType="grav" Type="ThreeInputVector" Inputs="0,1,2" Accuracy="0.1" Display="Graph" Internal="0" Maximum="10" MeasType="Acceleration" Minimum="0" Precision="1" ShortNameTag="accresult" SymbolTag="a" TypicalMax="1" TypicalMin="0" Visible="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="7" NameTag="Accelerationx" UnitType="ms2" Type="LinearConv" Inputs="0" Params="9.80664,0" Accuracy="1" Display="Graph" Internal="0" InternalUnit="1" Maximum="100" MeasType="Acceleration" Minimum="-100" Precision="1" ShortNameTag="accx" SymbolTag="ax" TypicalMax="20" TypicalMin="-20" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="8" NameTag="Accelerationy" UnitType="ms2" Type="LinearConv" Inputs="1" Params="9.80664,0" Accuracy="1" Display="Graph" Internal="0" InternalUnit="1" Maximum="100" MeasType="Acceleration" Minimum="-100" Precision="1" ShortNameTag="accy" SymbolTag="ay" TypicalMax="20" TypicalMin="-20" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="9" NameTag="Accelerationz" UnitType="ms2" Type="LinearConv" Inputs="2" Params="9.80664,0" Accuracy="1" Display="Graph" Internal="0" InternalUnit="1" Maximum="100" MeasType="Acceleration" Minimum="-100" Precision="1" ShortNameTag="accz" SymbolTag="az" TypicalMax="20" TypicalMin="-20" XplorerDisplay="1"/>
        <Measurement ID="10" NameTag="AccelerationResultant" UnitType="ms2" Type="ThreeInputVector" Inputs="7,8,9" Accuracy="1.1" Display="Graph" Internal="0" InternalUnit="1" Maximum="100" MeasType="Acceleration" Minimum="0" Precision="1" ShortNameTag="accresult" SymbolTag="a" TypicalMax="20" TypicalMin="0" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="132" Tag="LightSensor" Version="2.2" Class="0" DefaultRate="20Hz" FileName="Light.sds" FloatParams="0" Icon="000104010820c013200410081008166810082004200440024002c00340028001" IconID="132" Latency="100" MaxDatasheet="2048" MaxRate="1000Hz" Model="PS-2106A" Warmup="1">
        <Measurement ID="0" NameTag="LightIntensity" UnitType="lux" Type="Direct" DataSize="4" Accuracy="2" Display="Graph" Internal="0" Maximum="30000" MeasType="LightIntensity" Minimum="0" Precision="2" ShortNameTag="Intens" SymbolTag="IntensityLight" TypicalMax="300" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="134" Tag="MagneticFieldSensor" Version="2.54" Class="0" DefaultRate="20Hz" FileName="MagneticField.sds" FloatParams="0" Icon="c003e007f00f781e381c381c3c3c3c3c3c3c242424243c3c0000081028142004" IconID="134" Latency="100" MaxDatasheet="2048" MaxRate="20Hz" Model="PS-2112" Warmup="1">
        <Measurement ID="0" NameTag="RawMagFieldData" Type="Direct" DataSize="4" Accuracy="0" Display="Digits" Internal="1" Maximum="10" Minimum="0" Precision="0" ShortNameTag="RawMagField" TypicalMax="10" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="MagneticFieldStrength" Type="FactoryCal" Inputs="0" Params="8.089309999999999,0,6.12321,-500" Accuracy="0.2" Display="Graph" Internal="1" Maximum="1000" Minimum="-1000" Precision="1" TypicalMax="1000" TypicalMin="-1000"/>
        <Measurement ID="2" NameTag="MagneticFieldStrength" UnitType="gauss" Type="LinearConv" Inputs="1" Params="-1,0" Accuracy="0.01"  CanChangeSign="1" Display="Graph" Internal="0" Maximum="1000" MeasType="MagneticField" Minimum="-1000" Precision="2" ShortNameTag="MagField" SymbolTag="B" TypicalMax="10" TypicalMin="-10" Visible="1" VisibleSds="1" XplorerDisplay="1" DefaultUnit="gauss" IsDefaultMeas="1"/>
        <Measurement ID="3" NameTag="MagneticFieldStrength" UnitType="mtesla" Type="LinearConv" Inputs="2" Params="0.1,0" Accuracy="0.001" Display="Graph" Internal="0" InternalUnit="1" Maximum="100" MeasType="MagneticField" Minimum="-100" Precision="3" ShortNameTag="MagField" SymbolTag="B" TypicalMax="100" TypicalMin="-100" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="MagneticFieldStrength" UnitType="tesla" Type="LinearConv" Inputs="2" Params="9.000000000000001e-005,0" Accuracy="9.000000000000001e-005" Display="Graph" Internal="0" InternalUnit="1" Maximum="0.1" MeasType="MagneticField" Minimum="-0.1" Precision="6" ShortNameTag="MagField" SymbolTag="B" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="135" Tag="VoltageCurrentSensor" Version="2.6" Class="0" DefaultRate="20Hz" FileName="VoltageCurrent.sds" FloatParams="0" Icon="000000100010007c0210841088019002a004c0088010002000001e0000000000" IconID="135" Latency="100" MaxDatasheet="2048" MaxRate="1000Hz" Model="PS-2115" Warmup="1">
        <Measurement ID="0" NameTag="UncalibratedCurrent" Type="RawDigital" DataSize="2" Accuracy="1" Display="None" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="UncalCurrent" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="UncalibratedVoltage" Type="RawDigital" DataSize="2" Accuracy="1" Display="None" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="UncalVoltage" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="Current" UnitType="A" Type="FactoryCal" Inputs="0" Params="2048,0,3992,1" Accuracy="0.01" Display="Digits" Internal="0" Maximum="1" MeasType="Current" Minimum="-1" Precision="2" ShortNameTag="Curr" SymbolTag="current" TypicalMax="0.1" TypicalMin="-0.1" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="Voltage" UnitType="V" Type="FactoryCal" Inputs="1" Params="2045,0,3974,10" Accuracy="0.01" Display="Digits" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="2" ShortNameTag="Volt" SymbolTag="V" TypicalMax="1" TypicalMin="-1" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="4" NameTag="Power" UnitType="W" Type="TwoInputCombo" Inputs="2,3" Params="1,0,0,1" Accuracy="0.01" Display="None" Internal="0" Maximum="10" MeasType="Power" Minimum="0" Precision="2" ShortNameTag="Pwr" SymbolTag="P" TypicalMax="1" TypicalMin="0" Visible="1" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="136" Tag="TemperatureSensor" Version="2.5" Class="0" DefaultRate="2Hz" FileName="Temperature.sds" FloatParams="0" Icon="80078004800580048005800480058004800580078007800780078007400bc00f" IconID="136" Latency="100" MaxDatasheet="8192" MaxRate="10Hz" Model="PS-2125" Warmup="1">
        <Measurement ID="0" NameTag="Temperature" UnitType="DegC" Type="UserCal" Inputs="3" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="0.5" Display="Graph" Internal="0" Maximum="135" MeasType="Temperature" Minimum="-35" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="30" TypicalMin="15" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="Temperature" UnitType="DegF" Type="LinearConv" Inputs="0" Params="1.8,32" Accuracy="0.9" Display="Graph" Internal="0" InternalUnit="1" Maximum="275" MeasType="Temperature" Minimum="-31" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="212" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="Temperature" UnitType="K" Type="LinearConv" Inputs="0" Params="1,273.15" Accuracy="0.5" Display="Graph" Internal="0" InternalUnit="1" Maximum="408" MeasType="Temperature" Minimum="238" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="373" TypicalMin="273" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="RawTemperature" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="0.05" Display="Graph" Internal="1" Maximum="100" Minimum="-10" Precision="2" TypicalMax="100" TypicalMin="0" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="137" Tag="TemperatureSensorTypeK" Version="2.0" Class="0" DefaultRate="2Hz" FileName="TemperatureTypeK.sds" FloatParams="0" Icon="003c0024002cee244434483c503c6034503c483c4434ee3c003c0034005a007e" IconID="137" Latency="100" MaxDatasheet="8192" MaxRate="10Hz" Model="PS-2134" Warmup="1">
        <Measurement ID="0" NameTag="Temperature" UnitType="DegC" Type="UserCal" Inputs="3" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="3" Display="Graph" Internal="0" Maximum="1000" MeasType="Temperature" Minimum="-200" Precision="0" ShortNameTag="Temp" SymbolTag="T" TypicalMax="250" TypicalMin="50" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="Temperature" UnitType="DegF" Type="LinearConv" Inputs="0" Params="1.8,32" Accuracy="3" Display="Graph" Internal="0" InternalUnit="1" Maximum="1832" MeasType="Temperature" Minimum="-328" Precision="0" ShortNameTag="Temp" SymbolTag="T" TypicalMax="212" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="Temperature" UnitType="K" Type="LinearConv" Inputs="0" Params="1,273.15" Accuracy="3" Display="Graph" Internal="0" InternalUnit="1" Maximum="1273" MeasType="Temperature" Minimum="73" Precision="0" ShortNameTag="Temp" SymbolTag="T" TypicalMax="373" TypicalMin="273" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="RawTemperature" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="0.05" Display="Graph" Internal="1" Maximum="100" Minimum="-10" Precision="2" TypicalMax="100" TypicalMin="0" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="139" Tag="pHSensor" Version="2.5" Class="0" DefaultRate="5Hz" FileName="pH.sds" FloatParams="0" Icon="0000c600c600c600c600fe7cfe7ec666c666c67ec67c00600060006000600000" IconID="139" Latency="100" MaxDatasheet="8192" MaxRate="50Hz" Model="PS-2102" Warmup="1">
        <Measurement ID="0" NameTag="pH" UnitType="Unitless" Type="UserCal" Inputs="1" Params="4,4,7,7" CalFlags="1,1,1,1" Accuracy="0.1" Display="Digits" Internal="0" Maximum="14" MeasType="pH" Minimum="0" Precision="1" SymbolTag="pH" TypicalMax="9" TypicalMin="4" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="RawpH" UnitType="Unitless" Type="Direct" DataSize="4" Accuracy="0.01" Display="Digits" Internal="1" Maximum="14" Minimum="0" Precision="2" TypicalMax="14" TypicalMin="0" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="140" Tag="DissolvedOxygenSensor" Version="2.4" Class="0" DefaultRate="2Hz" FileName="DissolvedOxygen.sds" FloatParams="0" Icon="20005441a4420c4108221920376241dc27a219a208a248a2a8e26c62845ce440" IconID="140" Latency="45000" MaxDatasheet="2048" MaxRate="20Hz" Model="PS-2108" Warmup="1000">
        <Measurement ID="0" NameTag="RawADdata" Type="Direct" DataSize="4" Accuracy="5e-005" Display="None" Internal="1" Maximum="2" Minimum="0" Precision="5" TypicalMax="2" TypicalMin="0"/>
        <Measurement ID="1" NameTag="OxygenConcentration" UnitType="mgpL" Type="UserCal" Inputs="0" Params="0,0,2,20" CalFlags="0,0,1,1" Accuracy="2" Display="Digits" Internal="0" Maximum="20" MeasType="Concentration" Minimum="0" Precision="1" ShortNameTag="O2Conc" SymbolTag="O2Con" TypicalMax="14" TypicalMin="6" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="OxygenSaturation" UnitType="percent" Type="UserCal" Inputs="0" Params="0,0,2,100" CalFlags="0,0,1,0" Accuracy="10" Display="None" Internal="0" Maximum="100" MeasType="Saturation" Minimum="0" Precision="0" ShortNameTag="O2Sat" SymbolTag="O2Sat" TypicalMax="100" TypicalMin="80" Visible="1" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="141" Tag="ConductivitySensor" Version="2.7" Class="0" DefaultRate="2Hz" FileName="Conductivity.sds" FloatParams="0" Icon="000030184824444444445454f01f501450145014101110121010e00f00000000" IconID="141" Latency="1000" MaxDatasheet="2048" MaxRate="20Hz" Model="PS-2116A" Warmup="1">
        <Measurement ID="0" NameTag="RawValue" Type="Direct" DataSize="4" Accuracy="4" Display="None" Internal="1" Maximum="3200" Minimum="0" Precision="0" TypicalMax="3200" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="Conductivity10XProbe" UnitType="uSpcm" Type="UserCal" Inputs="0" Params="0,0,100,1000" CalFlags="0,0,1,1" Accuracy="4" Display="Digits" Internal="0" Maximum="32000" MeasType="Conductivity" Minimum="0" Precision="0" ShortNameTag="Conduct10X" SymbolTag="sigmaL10X" TypicalMax="20000" TypicalMin="2000" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="Conductivity1XProbe" UnitType="uSpcm" Type="UserCal" Inputs="0" Params="0,0,100,100" CalFlags="0,0,1,1" Accuracy="4" Display="Digits" Internal="0" Maximum="10000" MeasType="Conductivity" Minimum="0" Precision="0" ShortNameTag="Conduct1X" SymbolTag="sigmaL1X" TypicalMax="1000" TypicalMin="100" Visible="1" XplorerDisplay="1" IsDefaultMeas="1"/>
      </Sensor>
      <Sensor ID="142" Tag="Colorimeter" Version="2.2" Class="0" DefaultRate="1Hz" FileName="Colorimeter.sds" FloatParams="0" Icon="800340044004c007480444044244f2ff45444904400440044004400440048003" IconID="142" Latency="2000" MaxDatasheet="8192" MaxRate="5Hz" Model="PS-2121" Warmup="1">
        <Measurement ID="1" NameTag="Red660nmTransmittance" UnitType="percent" Type="Direct" DataSize="4" Accuracy="1" Display="Graph" Internal="0" Maximum="100" MeasType="Transmittance" Minimum="0" Precision="1" ShortNameTag="RedTransmit" SymbolTag="TR" TypicalMax="100" TypicalMin="0" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="Green565nmTransmittance" UnitType="percent" Type="Direct" DataSize="4" Accuracy="1" Display="Graph" Internal="0" Maximum="100" MeasType="Transmittance" Minimum="0" Precision="1" ShortNameTag="GreenTransmit" SymbolTag="TG" TypicalMax="100" TypicalMin="0" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="Blue468nmTransmittance" UnitType="percent" Type="Direct" DataSize="4" Accuracy="1" Display="Graph" Internal="0" Maximum="100" MeasType="Transmittance" Minimum="0" Precision="1" ShortNameTag="BlueTransmit" SymbolTag="TB" TypicalMax="100" TypicalMin="0" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Orange610nmTransmittance" UnitType="percent" Type="Direct" DataSize="4" Accuracy="1" Display="Graph" Internal="0" Maximum="100" MeasType="Transmittance" Minimum="0" Precision="1" ShortNameTag="OrangeTransmit" SymbolTag="TO" TypicalMax="100" TypicalMin="0" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Red660nmAbsorbance" UnitType="Unitless" Type="Absorbance" Inputs="1" Accuracy="0.01" Display="Graph" Internal="0" Maximum="2" MeasType="Absorbance" Minimum="0" Precision="3" ShortNameTag="RedAbsorb" SymbolTag="AR" TypicalMax="2" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="6" NameTag="Green565nmAbsorbance" UnitType="Unitless" Type="Absorbance" Inputs="2" Accuracy="0.01" Display="Graph" Internal="0" Maximum="2" MeasType="Absorbance" Minimum="0" Precision="3" ShortNameTag="GreenAbsorb" SymbolTag="AG" TypicalMax="2" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="7" NameTag="Blue468nmAbsorbance" UnitType="Unitless" Type="Absorbance" Inputs="3" Accuracy="0.01" Display="Graph" Internal="0" Maximum="2" MeasType="Absorbance" Minimum="0" Precision="3" ShortNameTag="BlueAbsorb" SymbolTag="AB" TypicalMax="2" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="8" NameTag="Orange610nmAbsorbance" UnitType="Unitless" Type="Absorbance" Inputs="4" Accuracy="0.01" Display="Graph" Internal="0" Maximum="2" MeasType="Absorbance" Minimum="0" Precision="3" ShortNameTag="OrangeAbsorb" SymbolTag="AO" TypicalMax="2" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="143" Tag="AbsolutePressureSensor" Version="2.6" Class="0" DefaultRate="20Hz" FileName="AbsolutePressure.sds" FloatParams="0" Icon="001e0012003300330033003f002100210021701e880c140b2407040188007000" IconID="143" Latency="45000" ListNameTag="PressureSensorAbsolute" MaxDatasheet="8192" MaxRate="200Hz" Model="PS-2107" Warmup="20">
        <Measurement ID="0" NameTag="DirectValue" Type="Direct" DataSize="4" Accuracy="2e-005" Display="Digits" Internal="1" Maximum="14" Minimum="0" Precision="5" TypicalMax="14" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="AbsolutePressure" UnitType="psi" Type="FactoryCal" Inputs="0" Params="0,4.3,0.02092,14.7" Accuracy="0.1" Display="Graph" Internal="0" Maximum="150" MeasType="Pressure" Minimum="0" Precision="1" ShortNameTag="Press" SymbolTag="pressureAbsolute" TypicalMax="20" TypicalMin="0" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="AbsolutePressure" UnitType="Nm2" Type="LinearConv" Inputs="1" Params="6897.5,0" Accuracy="1" Display="Graph" Internal="0" InternalUnit="1" Maximum="32767" MeasType="Pressure" Minimum="0" Precision="0" ShortNameTag="Press" SymbolTag="pressureAbsolute" TypicalMax="32767" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="AbsolutePressure" UnitType="kPa" Type="LinearConv" Inputs="1" Params="6.89789,0" Accuracy="1" Display="Graph" Internal="0" InternalUnit="1" Maximum="700" MeasType="Pressure" Minimum="0" Precision="0" ShortNameTag="Press" SymbolTag="pressureAbsolute" TypicalMax="700" TypicalMin="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="AbsolutePressure" UnitType="atm" Type="LinearConv" Inputs="3" Params="0.009860000000000001,0" Accuracy="0.01" Display="Graph" Internal="0" InternalUnit="1" Maximum="7" MeasType="Pressure" Minimum="0" Precision="4" ShortNameTag="Press" SymbolTag="pressureAbsolute" TypicalMax="7" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="AbsolutePressure" UnitType="torr" Type="LinearConv" Inputs="3" Params="7.50061,0" Accuracy="7" Display="Graph" Internal="0" InternalUnit="1" Maximum="4900" MeasType="Pressure" Minimum="0" Precision="1" ShortNameTag="Press" SymbolTag="pressureAbsolute" TypicalMax="4900" TypicalMin="0" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="145" Tag="RelativePressureSensor" Version="2.5" Class="0" DefaultRate="20Hz" FileName="RelativePressure.sds" FloatParams="0" Icon="2878824838ccc5cc24cd7dfc828401840084c67926325a2c9c1c10042002c001" IconID="145" Latency="45000" ListNameTag="PressureSensorRelative" MaxDatasheet="8192" MaxRate="20Hz" Model="PS-2114" Warmup="20" SupportsZeroOnStart="1">
        <Measurement ID="0" NameTag="DirectValue" Type="Direct" DataSize="4" Accuracy="0.0004" Display="None" Internal="1" Maximum="14" Minimum="0" Precision="5" TypicalMax="14" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="RelativePressure" UnitType="psi" Type="FactoryCal" Inputs="0" Params="0,0,0.4,14.6" Accuracy="0.01" Display="Graph" Internal="0" Maximum="1.5" MeasType="Pressure" Minimum="0" OffsetZero="1" Precision="2" ShortNameTag="RelPress" SymbolTag="pressureRelative" TypicalMax="0.5" TypicalMin="0" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="RelativePressure" UnitType="Nm2" Type="LinearConv" Inputs="1" Params="6897.5,0" Accuracy="10" Display="Graph" Internal="0" InternalUnit="1" Maximum="10000" MeasType="Pressure" Minimum="0" Precision="0" ShortNameTag="RelPress" SymbolTag="pressureRelative" TypicalMax="10000" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="RelativePressure" UnitType="kPa" Type="LinearConv" Inputs="1" Params="6.89789,0" Accuracy="0.1" Display="Graph" Internal="0" InternalUnit="1" Maximum="10" MeasType="Pressure" Minimum="0" Precision="1" ShortNameTag="RelPress" SymbolTag="pressureRelative" TypicalMax="10" TypicalMin="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="RelativePressure" UnitType="atm" Type="LinearConv" Inputs="3" Params="0.009860000000000001,0" Accuracy="0.01" Display="Graph" Internal="0" InternalUnit="1" Maximum="0.1" MeasType="Pressure" Minimum="0" Precision="4" ShortNameTag="RelPress" SymbolTag="pressureRelative" TypicalMax="0.1" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="RelativePressure" UnitType="torr" Type="LinearConv" Inputs="3" Params="7.50061,0" Accuracy="0.7" Display="Graph" Internal="0" InternalUnit="1" Maximum="70" MeasType="Pressure" Minimum="0" Precision="1" ShortNameTag="RelPress" SymbolTag="pressureRelative" TypicalMax="70" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="6" NameTag="RespirationRate" UnitType="BreathPerMin" Type="Period" Inputs="1" Params="30,30,5,60" Accuracy="1" Internal="0" Maximum="20" MeasType="BreathRate" Minimum="2" Precision="0" ShortNameTag="Rate" SymbolTag="Rbreath" TypicalMax="20" TypicalMin="0" Visible="0"/>
      </Sensor>
      <Sensor ID="146" Tag="Barometer" Version="2.6" Class="0" DefaultRate="1Hz" FileName="Barometer.sds" FloatParams="0" Icon="a0000802e00014039004f4010802040000001807980868117012401080080007" IconID="146" Latency="100" MaxDatasheet="8192" MaxRate="20Hz" Model="PS-2113A" Warmup="1">
        <Measurement ID="0" NameTag="DirectValue" Type="Direct" DataSize="4" Accuracy="0.0002" Display="Digits" Internal="1" Maximum="10" Minimum="-10" Precision="5" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="BarometricPressure" UnitType="inHg" Type="FactoryCal" Inputs="0" Params="0,0,1.62,29.92" Accuracy="0.02" Display="Graph" Internal="0" Maximum="50" MeasType="Pressure" Minimum="0" Precision="2" ShortNameTag="BarPress" SymbolTag="pressureBarometric" TypicalMax="32" TypicalMin="24" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1" defaultUnit="mmHg" IsDefaultMeas="1"/>
        <Measurement ID="3" NameTag="BarometricPressure" UnitType="hPa" Type="LinearConv" Inputs="1" Params="33.9,0" Accuracy="0.7" Display="Graph" Internal="0" InternalUnit="1" Maximum="1700" MeasType="Pressure" Minimum="0" Precision="1" ShortNameTag="BarPress" SymbolTag="pressureBarometric" TypicalMax="1090" TypicalMin="800" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="BarometricPressure" UnitType="mBar" Type="LinearConv" Inputs="3" Params="1,0" Accuracy="0.7" Display="Graph" Internal="0" InternalUnit="1" Maximum="1700" MeasType="Pressure" Minimum="0" Precision="1" ShortNameTag="BarPress" SymbolTag="pressureBarometric" TypicalMax="1090" TypicalMin="800" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="AbsolutePressure" UnitType="kPa" Type="LinearConv" Inputs="4" Params="0.1,0" Accuracy="7" Display="Graph" Internal="0" Maximum="17000" MeasType="Pressure" Minimum="0" Precision="1" ShortNameTag="AbsPress" SymbolTag="pressureAbsolute" TypicalMax="11000" TypicalMin="8000" Visible="0" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="147" Tag="EKGSensor" Version="2.3" Class="0" DefaultRate="200Hz" FileName="ekg.sds" FloatParams="0" Icon="000000000000781ecc338421042004200c300810181810086006c00380010000" IconID="147" Latency="100" MaxDatasheet="8192" MaxRate="1000Hz" MinRate="50Hz" Model="PS-2111" Warmup="1">
        <Measurement ID="0" NameTag="Voltage" UnitType="mV" Type="Direct" DataSize="4" Accuracy="0.005" DefaultUnit="mV" Display="Graph" Internal="0" Maximum="5" MeasType="Voltage" Minimum="0" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="2" TypicalMin="-1" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <Measurement ID="1" NameTag="HeartRateCount" Type="RawDigital" DataSize="2" Accuracy="1" Display="None" Internal="1" Maximum="4095" Minimum="0" Precision="0" TypicalMax="1023" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="HeartRate" UnitType="BeatsPerMin" Type="Rate" Inputs="1" Params="5,60" Accuracy="1" Display="Digits" Internal="0" Maximum="250" MeasType="HeartRate" Minimum="47" Precision="0" ShortNameTag="HeartRt" SymbolTag="HR" TypicalMax="120" TypicalMin="50" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="148" Tag="HeartrateSensor" Version="2.1" Class="0" DefaultRate="50Hz" FileName="HeartRate.sds" FloatParams="0" Icon="000000000000781ecc338421042004200c300810181810086006c00380010000" IconID="148" Latency="100" MaxDatasheet="8192" MaxRate="100Hz" MinRate="50Hz" Model="PS-2105" Warmup="1">
        <Measurement ID="0" NameTag="HeartBeat" UnitType="Unitless" Type="RawDigital" DataSize="1" Accuracy="1" Display="Graph" Internal="0" Maximum="256" MeasType="HeartBeat" Minimum="0" Precision="0" ShortNameTag="Beat" SymbolTag="N" TypicalMax="256" TypicalMin="0" Visible="1" VisibleSds="1"/>
        <Measurement ID="1" NameTag="HeartRateCount" Type="RawDigital" DataSize="2" Accuracy="1" Display="None" Internal="1" Maximum="256" Minimum="0" Precision="0" TypicalMax="256" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="HeartRate" UnitType="BeatsPerMin" Type="Rate" Inputs="1" Params="5,60" Accuracy="1" Display="Digits" Internal="0" Maximum="160" MeasType="HeartRate" Minimum="20" Precision="0" ShortNameTag="Rate" SymbolTag="HR" TypicalMax="120" TypicalMin="50" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1" IsDefaultMeas="1"/>
      </Sensor>
      <Sensor ID="151" Tag="SoundLevelSensor" Version="2.0" Class="0" DefaultRate="5Hz" FileName="SoundLevel.sds" FloatParams="0" Icon="000000000000f0000811c8492829a8292848d0109000a000e000000000000000" IconID="151" Latency="100" MaxDatasheet="8192" MaxRate="20Hz" Model="PS-2109" Warmup="1">
        <Measurement ID="0" NameTag="ScaledCPwrDensity" Type="Direct" DataSize="4" Accuracy="5" Display="Digits" Internal="1" Maximum="32000" Minimum="0" Precision="3" TypicalMax="32000" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="SoundLevelC" UnitType="dBC" Type="Direct" DataSize="4" Accuracy="3" Display="Digits" Internal="0" Maximum="110" MeasType="SoundLevelC" Minimum="30" Precision="1" ShortNameTag="SoundLvlC" SymbolTag="IC" TypicalMax="80" TypicalMin="30" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="SoundLevelA" UnitType="dBA" Type="Direct" DataSize="4" Accuracy="3" Display="Digits" Internal="0" Maximum="110" MeasType="SoundLevelA" Minimum="30" Precision="1" ShortNameTag="SoundLvlA" SymbolTag="IA" TypicalMax="80" TypicalMin="30" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="SoundIntensity" UnitType="uWpm2" Type="LinearConv" Inputs="0" Params="4,0" Accuracy="6" Display="Digits" Internal="0" Maximum="10000" MeasType="SoundIntensity" Minimum="0" Precision="3" ShortNameTag="SoundInt" SymbolTag="IntensitySound" TypicalMax="100" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="153" Tag="HumiditySensor" Version="2.1" Class="0" DefaultRate="2Hz" FileName="Humidity.sds" FloatParams="0" Icon="04000a003a000a223a540a283a140a2a0a4411000e00000084104a2931c60000" IconID="153" Latency="100" MaxDatasheet="8192" MaxRate="10Hz" Model="PS-2124A" Warmup="1">
        <Measurement ID="0" NameTag="Temperature" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="0.5" Display="Digits" Internal="0" Maximum="55" MeasType="Temperature" Minimum="-20" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="35" TypicalMin="15" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="Temperature" UnitType="DegF" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="131" MeasType="Temperature" Minimum="-4" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="104" TypicalMin="5" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="RelativeHumidity" UnitType="percent" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" Maximum="100" MeasType="Humidity" Minimum="0" Precision="0" ShortNameTag="RelHum" SymbolTag="RH" TypicalMax="85" TypicalMin="15" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="3" NameTag="DewPoint" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="2" Display="Digits" Internal="0" Maximum="55" MeasType="DewPoint" Minimum="-50" Precision="1" ShortNameTag="DewPt" SymbolTag="TD" TypicalMax="35" TypicalMin="-10" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="DewPoint" UnitType="DegF" Type="Direct" DataSize="4" Accuracy="4" Display="Digits" Internal="0" InternalUnit="1" Maximum="125" MeasType="DewPoint" Minimum="-58" Precision="1" ShortNameTag="DewPt" SymbolTag="TD" TypicalMax="95" TypicalMin="-30" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="AbsoluteHumidity" UnitType="gpm3" Type="Direct" DataSize="4" Accuracy="0.1" Display="Digits" Internal="0" Maximum="100" MeasType="AbsoluteHumidity" Minimum="0" Precision="1" ShortNameTag="AbsHum" SymbolTag="H" TypicalMax="25" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="200" Tag="TurbiditySensor" Version="2.0" Class="0" DefaultRate="1Hz" FileName="Turbidity.sds" FloatParams="0" Icon="000000000000204020402050a042204020482041206020442040a040c03f0000" IconID="200" Latency="10000" MaxDatasheet="1024" MaxRate="5Hz" Model="PS-2122" Warmup="1000">
        <Measurement ID="0" NameTag="Turbidity" UnitType="NTU" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" Maximum="400" MeasType="Turbidity" Minimum="0" Precision="1" ShortNameTag="Turb" SymbolTag="Turb" TypicalMax="200" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="201" Tag="CarbonDioxideGasSensor" Version="2.2" Class="0" DefaultRate="1Hz" FileName="CarbonDioxideGas.sds" FloatParams="0" Icon="f00f200420041008081004200240c19821a521a129a135a5c9981d800180fe7f" IconID="201" Latency="50" MaxDatasheet="8192" MaxRate="1Hz" Model="PS-2110" Warmup="120000">
        <Measurement ID="0" NameTag="CO2Concentration" UnitType="ppm" Type="RawDigital" DataSize="4" Accuracy="1" Display="Digits" Internal="0" Maximum="32000" MeasType="Concentration" Minimum="0" Precision="0" ShortNameTag="CO2Conc" SymbolTag="CO2" TypicalMax="1000" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="203" Tag="ChargeSensor" Version="2.1" Class="0" DefaultRate="10Hz" FileName="Charge.sds" FloatParams="0" Icon="0020002000f8c0236026300c300c300c300c6006c0038001cf00000000000000" IconID="203" Latency="500" MaxDatasheet="2048" MaxRate="100Hz" Model="PS-2132" Warmup="2000">
        <Measurement ID="0" NameTag="UncalibratedCounts" Type="RawDigital" DataSize="4" Accuracy="1" Display="Digits" Internal="1" Maximum="32000" Minimum="-32000" Precision="0" ShortNameTag="Counts" TypicalMax="32000" TypicalMin="-32000" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="Voltage" UnitType="V" Type="FactoryCal" Inputs="0" Params="0,0,-18658,10" Accuracy="1" Display="Graph" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="1" TypicalMin="-1" Visible="1" XplorerDisplay="1" />
        <Measurement ID="2" NameTag="Charge" UnitType="nC" Type="LinearConv" Inputs="1" Params="10,0" Accuracy="1" Display="Graph" Internal="0" Maximum="100" MeasType="Charge" Minimum="-100" Precision="3" SymbolTag="Q" TypicalMax="10" TypicalMin="-10" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1" DefaultUnit="nC" IsDefaultMeas="1"/>
      </Sensor>
      <Sensor ID="204" Tag="VisualAccelerometer" Version="2.1" Class="0" DefaultRate="20Hz" FileName="VisualAccelerometer.sds" FloatParams="0" Icon="0000020007e002000000042002407ffe024004200000dbdbdbdb000000000000" IconID="204" Latency="100" MaxDatasheet="2048" MaxRate="100Hz" Model="PS-2128" Warmup="1000">
        <Measurement ID="0" NameTag="RawAccel" Type="RawDigital" DataSize="4" Accuracy="1" Display="None" Internal="1" Maximum="4000" Minimum="-4000" Precision="0" TypicalMax="2000" TypicalMin="2000" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="Acceleration" UnitType="ms2" Type="LinearConv" Inputs="0" Params="0.0098,0" Accuracy="1" Display="Graph" Internal="0" Maximum="20" MeasType="Acceleration" Minimum="-20" Precision="2" ShortNameTag="acc" SymbolTag="a" TypicalMax="2" TypicalMin="-2" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="Acceleration" UnitType="grav" Type="LinearConv" Inputs="1" Params="0.102,0" Accuracy="0.01" Display="Graph" Internal="0" InternalUnit="1" Maximum="4" MeasType="Acceleration" Minimum="-4" Precision="2" ShortNameTag="acc" SymbolTag="a" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="205" Tag="ExerciseHeartRateSensor" Version="2.1" Class="0" DefaultRate="5s" FileName="ExerciseHeartRate.sds" FloatParams="0" Icon="0063809cb888b880b88010417822fc143709300138003c006c00c40084010401" IconID="205" Latency="100" MaxDatasheet="2048" MaxRate="2s" MinRate="60s" Model="PS-2129" Warmup="500">
        <Measurement ID="0" NameTag="HeartRate" UnitType="BeatsPerMin" Type="RawDigital" DataSize="2" Accuracy="1" Display="Graph" Internal="0" Maximum="240" MeasType="HeartRate" Minimum="40" Precision="0" ShortNameTag="HeartRt" SymbolTag="HR" TypicalMax="120" TypicalMin="50" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="206" Tag="FlowRateSensor" Version="2.2" Class="0" DefaultRate="2Hz" FileName="FlowRate.sds" FloatParams="0" Icon="000060003000f87ff87f300060000000000010113033feffcecc000000000000" IconID="206" Latency="2000" MaxDatasheet="2048" MaxRate="20Hz" MinRate="100s" Model="PS-2130" SupportsZeroOnStart="1" Warmup="100">
        <Measurement ID="0" NameTag="FlowRate" UnitType="fps" Type="Direct" DataSize="4" Accuracy="0.1" Display="Graph" Internal="0" Maximum="15" MeasType="Speed" Minimum="0" OffsetZero="1" Precision="1" ShortNameTag="Flow" SymbolTag="flowRateVelocity" TypicalMax="10" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="1" NameTag="FlowRate" UnitType="mps" Type="LinearConv" Inputs="0" Params="0.304,0" Accuracy="0.1" Display="Graph" Internal="0" InternalUnit="1" Maximum="4" MeasType="Speed" Minimum="0" OffsetZero="1" Precision="2" ShortNameTag="Flow" SymbolTag="flowRateVelocity" TypicalMax="2" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="Temperature" UnitType="DegF" Type="Direct" DataSize="4" Accuracy="0.1" Display="Graph" Internal="0" Maximum="110" MeasType="Temperature" Minimum="25" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="86" TypicalMin="50" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="Temperature" UnitType="DegC" Type="LinearConv" Inputs="2" Params="0.55553,-17.778" Accuracy="0.1" Display="Graph" Internal="0" InternalUnit="1" Maximum="40" MeasType="Temperature" Minimum="-5" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="30" TypicalMin="0" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Counts" Type="RawDigital" DataSize="4" Accuracy="1" Display="Graph" Internal="1" Maximum="10000" Minimum="0" Precision="1" TypicalMax="1000" TypicalMin="0"/>
      </Sensor>
      <Sensor ID="207" Tag="DropCounter" Version="2.5" Class="0" DefaultRate="5Hz" FileName="DropCounter.sds" FloatParams="0" Icon="feffeade6aad62ee7addfa8efeff000008000c001c003e0072007a007e003c00" IconID="207" Latency="100" MaxDatasheet="8192" MaxRate="10Hz" MinRate="60s" Model="PS-2117" Warmup="1" ZeroOnRead="1" ZeroOnStart="1">
        <Measurement ID="0" NameTag="DropsSample" UnitType="drops" Type="RawDigital" DataSize="4" Accuracy="1" Display="Graph" Internal="0" Maximum="50" MeasType="DropsPerSample" Minimum="0" Precision="0" SymbolTag="R" TypicalMax="30" TypicalMin="0" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="DropCount" UnitType="drops" Type="RotaryPos" Inputs="0" Params="1,1" Accuracy="1" Display="Graph" Internal="0" Maximum="500" MeasType="Count" Minimum="0" Precision="0" ShortNameTag="Drops" SymbolTag="N" TypicalMax="100" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="2" NameTag="FluidVolume" UnitType="mL" Type="UserCal" Inputs="1" Params="0,0,30,1" CalFlags="0,0,1,1" Accuracy="0.01" DefaultUnit="mL" Display="Graph" Internal="0" Maximum="20" MeasType="Volume" Minimum="0" Precision="2" ShortNameTag="Vol" SymbolTag="V" TypicalMax="20" TypicalMin="0" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="100" NameTag="DropVolume" UnitType="mL" Type="Constant" Internal="1" MeasType="Volume" Value="0.033" Minimum="0" Maximum="20" CalibrationID="2"/>
      </Sensor>
      <Sensor ID="208" Tag="AccelerationAltimeter" Version="2.8" Class="0" DefaultRate="20Hz" FileName="Accel-Alt.sds" FloatParams="0" Icon="002980130211080100012001000140010201ffe1024000e40500021005400060" IconID="208" Latency="500" MaxDatasheet="8192" MaxRate="20Hz" Model="PS-2136" SupportsZeroOnStart="1" Warmup="1000">
        <Measurement ID="0" NameTag="X" Type="RawDigital" DataSize="2" Accuracy="4" Display="Digits" Internal="1" Maximum="7400" Minimum="800" Precision="0" ShortNameTag="counts" TypicalMax="7400" TypicalMin="800"/>
        <Measurement ID="1" NameTag="Accelerationx" UnitType="grav" Type="FactoryCal" Inputs="0" Params="4060,0,4390,1" Accuracy="0.1" Display="Graph" Internal="0" Maximum="5" MeasType="Acceleration" Minimum="-5" OffsetZero="1" Precision="1" ShortNameTag="accx" SymbolTag="ax" TypicalMax="0.5" TypicalMin="-0.5" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="Accelerationx" UnitType="ms2" Type="LinearConv" Inputs="1" Params="9.80663,0" Accuracy="1" Display="Graph" Internal="0" InternalUnit="1" Maximum="50" MeasType="Acceleration" Minimum="-50" Precision="1" ShortNameTag="accx" SymbolTag="ax" TypicalMax="50" TypicalMin="-50" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="Y" Type="RawDigital" DataSize="2" Accuracy="4" Display="Digits" Internal="1" Maximum="7400" Minimum="800" Precision="0" TypicalMax="7400" TypicalMin="800"/>
        <Measurement ID="4" NameTag="Accelerationy" UnitType="grav" Type="FactoryCal" Inputs="3" Params="3865,0,3543,1" Accuracy="0.1" Display="Graph" Internal="0" Maximum="5" MeasType="Acceleration" Minimum="-5" OffsetZero="1" Precision="1" ShortNameTag="accy" SymbolTag="ay" TypicalMax="0.5" TypicalMin="-0.5" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Accelerationy" UnitType="ms2" Type="LinearConv" Inputs="4" Params="9.80663,0" Accuracy="1" Display="Graph" Internal="0" InternalUnit="1" Maximum="50" MeasType="Acceleration" Minimum="-50" Precision="1" ShortNameTag="accy" SymbolTag="ay" TypicalMax="50" TypicalMin="-50" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="6" NameTag="Z" Type="RawDigital" DataSize="2" Accuracy="4" Display="Digits" Internal="1" Maximum="7400" Minimum="800" Precision="0" ShortNameTag="counts" TypicalMax="7400" TypicalMin="800"/>
        <Measurement ID="7" NameTag="Accelerationz" UnitType="grav" Type="FactoryCal" Inputs="6" Params="4196,0,4529,1" Accuracy="0.1" Display="Graph" Internal="0" Maximum="5" MeasType="Acceleration" Minimum="-5" OffsetZero="1" Precision="1" ShortNameTag="accz" SymbolTag="az" TypicalMax="0.5" TypicalMin="-0.5" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="8" NameTag="Accelerationz" UnitType="ms2" Type="LinearConv" Inputs="7" Params="9.80663,0" Accuracy="1" Display="Graph" Internal="0" InternalUnit="1" Maximum="50" MeasType="Acceleration" Minimum="-50" Precision="1" ShortNameTag="accz" SymbolTag="az" TypicalMax="50" TypicalMin="-50" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="9" NameTag="AccelerationResultant" UnitType="grav" Type="ThreeInputVector" Inputs="1,4,7" Accuracy="0.1" Display="Graph" Internal="0" Maximum="5" MeasType="Acceleration" Minimum="0" Precision="1" ShortNameTag="accresult" SymbolTag="a" TypicalMax="0.5" TypicalMin="0" Visible="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="10" NameTag="AccelerationResultant" UnitType="ms2" Type="ThreeInputVector" Inputs="2,5,8" Accuracy="1" Display="Graph" Internal="0" InternalUnit="1" Maximum="50" MeasType="Acceleration" Minimum="0" Precision="1" ShortNameTag="accresult" SymbolTag="a" TypicalMax="50" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="11" NameTag="AltitudeCounts" Type="RawDigital" DataSize="4" Accuracy="4" Display="Digits" Internal="1" Maximum="10" Minimum="-10" Precision="0" ShortNameTag="counts" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="12" NameTag="Altitude" UnitType="m" Type="LinearConv" Inputs="11" Params="0.01204,0" Accuracy="1" Display="Graph" Internal="0" Maximum="300" MeasType="Altitude" Minimum="0" OffsetZero="1" Precision="1" ShortNameTag="Alt" SymbolTag="h" TypicalMax="30" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="13" NameTag="Altitude" UnitType="ft" Type="LinearConv" Inputs="12" Params="3.281,0" Accuracy="1" Display="Graph" Internal="0" InternalUnit="1" Maximum="1000" MeasType="Altitude" Minimum="0" Precision="0" ShortNameTag="Alt" SymbolTag="h" TypicalMax="250" TypicalMin="0" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="209" Tag="pHORPISETemperature" Version="3.3" Class="0" DefaultRate="2Hz" FileName="pH ORP ISE Temp.sds" FloatParams="0" Icon="00000000dc3b1012d81350105010dc3b000080018001e007e007800180010000" IconID="209" Latency="100" MaxDatasheet="8192" MaxRate="50Hz" Model="PS-2147" Warmup="1">
        <Measurement ID="0" NameTag="uncalmV" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="1" Maximum="2" Minimum="0" Precision="1" TypicalMax="2" TypicalMin="0"/>
        <Measurement ID="1" NameTag="uncalTemperature" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="3" Display="Digits" Internal="1" Maximum="135" Minimum="0" Precision="1" ShortNameTag="Temp" TypicalMax="30" TypicalMin="20"/>
        <Measurement ID="2" NameTag="ISEVoltage" UnitType="mV" Type="FactoryCal" Inputs="0" Params="-1500,-1500,1500,1500" Accuracy="4" DefaultUnit="mV" Display="Digits" Internal="0" Maximum="2000" MeasType="Voltage" Minimum="-2000" Precision="1" ShortNameTag="ISE" SymbolTag="V" TypicalMax="1000" TypicalMin="-1000" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="pH" UnitType="Unitless" Type="UserCal" Inputs="2" Params="177,4,0,7" CalFlags="1,1,1,1" Accuracy="0.1" Display="Digits" Internal="0" Maximum="14" MeasType="pH" Minimum="0" Precision="2" SymbolTag="pH" TypicalMax="10" TypicalMin="4" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="5" NameTag="Temperature" UnitType="DegC" Type="UserCal" Inputs="1" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="3" Display="Digits" Internal="0" Maximum="135" MeasType="Temperature" Minimum="-35" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="30" TypicalMin="15" Visible="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="6" NameTag="Temperature" UnitType="DegF" Type="LinearConv" Inputs="5" Params="1.8,32" Accuracy="3" Display="Digits" Internal="0" InternalUnit="1" Maximum="275" MeasType="Temperature" Minimum="-31" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="86" TypicalMin="68" XplorerDisplay="1"/>
        <Measurement ID="7" NameTag="Temperature" UnitType="K" Type="LinearConv" Inputs="5" Params="1,273.15" Accuracy="3" Display="Digits" Internal="0" InternalUnit="1" Maximum="408" MeasType="Temperature" Minimum="238" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="303" TypicalMin="293" XplorerDisplay="1"/>
        <SupportedCmd ID="64" Size="1"/>
      </Sensor>
      <Sensor ID="210" Tag="OxygenGasSensor" Version="2.2" Class="0" DefaultRate="2Hz" FileName="O2Gas.sds" FloatParams="0" Icon="5000040170008a014802fa0004013a3840440044004480444045c0440039c001" IconID="210" Latency="100" MaxDatasheet="8192" MaxRate="100Hz" Model="PS-2126" Warmup="1">
        <Measurement ID="0" NameTag="PercentOxygenConcentration" UnitType="percent" Type="Direct" DataSize="4" Accuracy="3" Display="Digits" Internal="0" Maximum="100" MeasType="Concentration" Minimum="0" Precision="1" ShortNameTag="O2Conc" SymbolTag="O2" TypicalMax="24" TypicalMin="14" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="1" NameTag="OxygenGasConcentration" UnitType="ppm" Type="LinearConv" Inputs="0" Params="10000,0" Accuracy="6" DefaultUnit="pph" Display="Digits" Internal="0" Maximum="30000" MeasType="Concentration" Minimum="0" Precision="0" ShortNameTag="O2Conc" SymbolTag="O2" TypicalMax="15000" TypicalMin="2000" Visible="1" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="211" Tag="TemperatureLightSoundSensor" Version="2.5" Class="0" DefaultRate="2Hz" FileName="TempLightSound.sds" FloatParams="0" Icon="1010822838e8442845e9442828e8382838280044003812003410d21fb4141203" IconID="211" Latency="100" MaxDatasheet="8192" MaxRate="5Hz" Model="PS-2140" Warmup="1">
        <Measurement ID="0" NameTag="SoundLevel" UnitType="dBA" Type="Direct" DataSize="4" Accuracy="3" Display="Graph" Internal="0" Maximum="110" MeasType="SoundLevelA" Minimum="30" Precision="0" ShortNameTag="SoundLvl" SymbolTag="IA" TypicalMax="80" TypicalMin="30" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="UncalibratedProbeTemp" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="0.5" Display="Graph" Internal="1" Maximum="135" Minimum="-35" Precision="1" TypicalMax="35" TypicalMin="15" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="AmbientTemperature" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="1" Display="Graph" Internal="0" Maximum="50" MeasType="Temperature" Minimum="-10" Precision="1" ShortNameTag="AmbTemp" SymbolTag="T" TypicalMax="30" TypicalMin="15" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="LightLevel" UnitType="lux" Type="Direct" DataSize="4" Accuracy="1" Display="Graph" Internal="0" Maximum="100" MeasType="LightIntensity" Minimum="0" Precision="1" ShortNameTag="LtLvl" SymbolTag="IntensityLight" TypicalMax="10000" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="4" NameTag="ProbeTemperature" UnitType="DegC" Type="UserCal" Inputs="1" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="0.5" Display="Graph" Internal="0" Maximum="135" MeasType="Temperature" Minimum="-35" Precision="1" ShortNameTag="ProbeTemp" SymbolTag="T" TypicalMax="30" TypicalMin="15" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="ProbeTemperature" UnitType="DegF" Type="LinearConv" Inputs="4" Params="1.8,32" Accuracy="0.9" Display="Graph" Internal="0" InternalUnit="1" Maximum="275" MeasType="Temperature" Minimum="-31" Precision="1" ShortNameTag="ProbeTemp" SymbolTag="T" TypicalMax="95" TypicalMin="59" XplorerDisplay="1"/>
        <Measurement ID="6" NameTag="ProbeTemperature" UnitType="K" Type="LinearConv" Inputs="4" Params="1,273.15" Accuracy="0.5" Display="Graph" Internal="0" InternalUnit="1" Maximum="408" MeasType="Temperature" Minimum="238" Precision="1" ShortNameTag="ProbeTemp" SymbolTag="T" TypicalMax="373" TypicalMin="273" XplorerDisplay="1"/>
        <Measurement ID="7" NameTag="AmbientTemperature" UnitType="DegF" Type="LinearConv" Inputs="2" Params="1.8,32" Accuracy="1" Display="Graph" Internal="0" InternalUnit="1" Maximum="275" MeasType="Temperature" Minimum="-31" Precision="1" ShortNameTag="AmbTemp" SymbolTag="T" TypicalMax="95" TypicalMin="59" XplorerDisplay="1"/>
        <SupportedCmd ID="64" Size="1"/>
      </Sensor>
      <Sensor ID="212" Tag="AngleSensor" Version="2.32" Class="0" DefaultRate="20Hz" FileName="AngleSensor.sds" FloatParams="0" Icon="00070006000580004000a000100108011001a000400080000001000a000c000e" IconID="212" Latency="250" MaxDatasheet="8192" MaxRate="500Hz" Model="PS-2139" Warmup="1000">
        <Measurement ID="0" NameTag="Angle1RawCounts" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="1200" Minimum="0" Ordinal="1" Precision="0" TypicalMax="1200" TypicalMin="0"/>
        <Measurement ID="1" NameTag="Angle2RawCounts" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="10" Minimum="-10" Ordinal="2" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="2" NameTag="AngleOrd" UnitType="deg" Type="UserCal" Inputs="0" Params="0,170,8191,-170" CalFlags="1,1,1,1" Accuracy="1" Display="Graph" Internal="0" Maximum="170" MeasType="Angle" Minimum="-170" Ordinal="1" Precision="1" ShortNameTag="angleOrd" SymbolTag="thetaLOrd" TypicalMax="90" TypicalMin="-90" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="AngleOrd" UnitType="deg" Type="UserCal" Inputs="1" Params="0,170,8191,-170" CalFlags="1,1,1,1" Accuracy="1" Display="Graph" Internal="0" Maximum="170" MeasType="Angle" Minimum="-170" Ordinal="2" Precision="1" ShortNameTag="angleOrd" SymbolTag="thetaLOrd" TypicalMax="90" TypicalMin="-90" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="AngleOrd" UnitType="rad" Type="LinearConv" Inputs="2" Params="0.01743,0" Accuracy="0.02" Display="Graph" Internal="0" InternalUnit="1" Maximum="3" MeasType="Angle" Minimum="-3" Ordinal="1" Precision="2" ShortNameTag="angleOrd" SymbolTag="thetaLOrd" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="AngleOrd" UnitType="rad" Type="LinearConv" Inputs="3" Params="0.01744,0" Accuracy="0.02" Display="Graph" Internal="0" InternalUnit="1" Maximum="3" MeasType="Angle" Minimum="-3" Ordinal="2" Precision="2" ShortNameTag="angleOrd" SymbolTag="thetaLOrd" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="6" NameTag="AngularVelocityOrd" UnitType="radps" Type="Derivative" Inputs="4" Params="3" Accuracy="0.2" Display="Graph" Internal="0" Maximum="6" MeasType="AngularVelocity" Minimum="-6" Ordinal="1" Precision="1" ShortNameTag="angvelOrd" SymbolTag="omegaLOrd" TypicalMax="1" TypicalMin="-1" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="7" NameTag="AngularVelocityOrd" UnitType="radps" Type="Derivative" Inputs="5" Params="3" Accuracy="0.2" Display="Graph" Internal="0" Maximum="6" MeasType="AngularVelocity" Minimum="-6" Ordinal="2" Precision="1" ShortNameTag="angvelOrd" SymbolTag="omegaLOrd" TypicalMax="1" TypicalMin="-1" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="8" NameTag="AngularAccelerationOrd" UnitType="radps2" Type="Derivative" Inputs="6" Params="3" Accuracy="0.5" Display="Graph" Internal="0" Maximum="3" MeasType="AngularAcceleration" Minimum="-3" Ordinal="1" Precision="1" ShortNameTag="angaccOrd" SymbolTag="alphaLOrd" TypicalMax="0.5" TypicalMin="-0.5" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="9" NameTag="AngularAccelerationOrd" UnitType="radps2" Type="Derivative" Inputs="7" Params="3" Accuracy="0.5" Display="Graph" Internal="0" Maximum="3" MeasType="AngularAcceleration" Minimum="-3" Ordinal="2" Precision="1" ShortNameTag="angaccOrd" SymbolTag="alphaLOrd" TypicalMax="0.5" TypicalMin="-0.5" Visible="1" XplorerDisplay="1"/>
        <SupportedCmd ID="64" Size="1"/>
      </Sensor>
      <Sensor ID="213" Tag="TemperatureSensorQuad" Version="2.4" Class="0" DefaultRate="20Hz" FileName="Quad Temp.sds" FloatParams="0" Icon="0000180024202420982f0022002200220022c03f000200020002000200000000" IconID="213" Latency="100" MaxDatasheet="1024" MaxRate="100Hz" Model="PS-2143" Warmup="1">
        <Measurement ID="0" NameTag="TemperatureOrd" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="3" Display="Digits" Internal="1" Maximum="408" Minimum="238" Ordinal="1" Precision="1" ShortNameTag="RTemp1" TypicalMax="305" TypicalMin="290"/>
        <Measurement ID="1" NameTag="TemperatureOrd" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="3" Display="Digits" Internal="1" Maximum="408" Minimum="238" Ordinal="2" Precision="1" ShortNameTag="RTemp2" TypicalMax="305" TypicalMin="290"/>
        <Measurement ID="2" NameTag="TemperatureOrd" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="3" Display="Digits" Internal="1" Maximum="408" Minimum="238" Ordinal="3" Precision="1" ShortNameTag="RTemp3" TypicalMax="305" TypicalMin="290"/>
        <Measurement ID="3" NameTag="TemperatureOrd" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="3" Display="Digits" Internal="1" Maximum="408" Minimum="238" Ordinal="4" Precision="1" ShortNameTag="RTemp4" TypicalMax="305" TypicalMin="290"/>
        <Measurement ID="4" NameTag="TemperatureOrd" UnitType="DegC" Type="UserCal" Inputs="0" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="1" Display="Digits" Internal="0" Maximum="135" MeasType="Temperature" Minimum="-35" Ordinal="1" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="30" TypicalMin="15" Visible="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="5" NameTag="TemperatureOrd" UnitType="DegC" Type="UserCal" Inputs="1" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="1" Display="Digits" Internal="0" Maximum="135" MeasType="Temperature" Minimum="-35" Ordinal="2" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="30" TypicalMin="15" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="6" NameTag="TemperatureOrd" UnitType="DegC" Type="UserCal" Inputs="2" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="1" Display="Digits" Internal="0" Maximum="135" MeasType="Temperature" Minimum="-35" Ordinal="3" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="30" TypicalMin="15" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="7" NameTag="TemperatureOrd" UnitType="DegC" Type="UserCal" Inputs="3" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="1" Display="Digits" Internal="0" Maximum="135" MeasType="Temperature" Minimum="-35" Ordinal="4" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="30" TypicalMin="15" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="8" NameTag="TemperatureOrd" UnitType="DegF" Type="LinearConv" Inputs="4" Params="1.8,32" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="275" MeasType="Temperature" Minimum="-31" Ordinal="1" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="86" TypicalMin="65" XplorerDisplay="1"/>
        <Measurement ID="9" NameTag="TemperatureOrd" UnitType="DegF" Type="LinearConv" Inputs="5" Params="1.8,32" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="275" MeasType="Temperature" Minimum="-31" Ordinal="2" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="86" TypicalMin="65" XplorerDisplay="1"/>
        <Measurement ID="10" NameTag="TemperatureOrd" UnitType="DegF" Type="LinearConv" Inputs="6" Params="1.8,32" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="275" MeasType="Temperature" Minimum="-31" Ordinal="3" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="86" TypicalMin="65" XplorerDisplay="1"/>
        <Measurement ID="11" NameTag="TemperatureOrd" UnitType="DegF" Type="LinearConv" Inputs="7" Params="1.8,32" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="275" MeasType="Temperature" Minimum="-31" Ordinal="4" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="86" TypicalMin="65" XplorerDisplay="1"/>
        <Measurement ID="12" NameTag="TemperatureOrd" UnitType="K" Type="LinearConv" Inputs="4" Params="1,273.15" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="410" MeasType="Temperature" Minimum="238" Ordinal="1" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="305" TypicalMin="290" XplorerDisplay="1"/>
        <Measurement ID="13" NameTag="TemperatureOrd" UnitType="K" Type="LinearConv" Inputs="5" Params="1,273.15" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="410" MeasType="Temperature" Minimum="238" Ordinal="2" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="305" TypicalMin="290" XplorerDisplay="1"/>
        <Measurement ID="14" NameTag="TemperatureOrd" UnitType="K" Type="LinearConv" Inputs="6" Params="1,273.15" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="410" MeasType="Temperature" Minimum="238" Ordinal="3" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="305" TypicalMin="290" XplorerDisplay="1"/>
        <Measurement ID="15" NameTag="TemperatureOrd" UnitType="K" Type="LinearConv" Inputs="7" Params="1,273.15" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="410" MeasType="Temperature" Minimum="238" Ordinal="4" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="305" TypicalMin="290" XplorerDisplay="1"/>
        <SupportedCmd ID="64" Size="1"/>
      </Sensor>
      <Sensor ID="214" Tag="ThermoclineSensor" Version="2.4" Class="0" DefaultRate="1Hz" FileName="Thermocline.sds" FloatParams="0" Icon="0000000410153037c84ccecc40041c04540414045c041c0e5c111c115c1f3e00" IconID="214" Latency="100" MaxDatasheet="8192" MaxRate="10Hz" Model="PS-2151" Warmup="1200">
        <Measurement ID="0" NameTag="Temperature" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="2" Display="Digits" Internal="0" Maximum="55" MeasType="Temperature" Minimum="-5" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="30" TypicalMin="15" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="1" NameTag="DepthFreshWater" UnitType="m" Type="Direct" DataSize="4" Accuracy="2" Display="Digits" Internal="0" Maximum="10.5" MeasType="Position" Minimum="0" Precision="1" ShortNameTag="DepthFreshWater_SN" SymbolTag="depthFresh" TypicalMax="10.5" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="DepthFreshWater" UnitType="ft" Type="LinearConv" Inputs="1" Params="3.281,0" Accuracy="2" Display="Digits" Internal="0" InternalUnit="1" Maximum="34" MeasType="Position" Minimum="0" Precision="1" ShortNameTag="DepthFreshWater_SN" SymbolTag="depthFresh" TypicalMax="34" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="DepthSaltWater" UnitType="m" Type="LinearConv" Inputs="1" Params="0.981,0" Accuracy="2" Display="Digits" Internal="0" Maximum="10.5" MeasType="Position" Minimum="0" Precision="1" ShortNameTag="DepthSaltWater_SN" SymbolTag="depthSalt" TypicalMax="10.5" TypicalMin="0" Visible="0" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="DepthSaltWater" UnitType="ft" Type="LinearConv" Inputs="3" Params="3.281,0" Accuracy="2" Display="Digits" Internal="0" InternalUnit="1" Maximum="34" MeasType="Position" Minimum="0" Precision="1" ShortNameTag="DepthSaltWater_SN" SymbolTag="depthSalt" TypicalMax="34" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Temperature" UnitType="DegF" Type="LinearConv" Inputs="0" Params="1.8,32" Accuracy="2" Display="Digits" Internal="0" InternalUnit="1" Maximum="130" MeasType="Temperature" Minimum="10" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="85" TypicalMin="60" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="215" Tag="WeatherSensor" Version="2.81" Class="0" DefaultRate="1Hz" FileName="Weather.sds" FloatParams="0" Icon="40011004c00128062009e8031004e870005108509570ca70e471aa73f573c2f9" IconID="215" Latency="100" MaxDatasheet="8192" MaxRate="5Hz" Model="PS-2154" Warmup="5000">
        <Measurement ID="0" NameTag="Temperature" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" Maximum="55" MeasType="Temperature" Minimum="-20" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="30" TypicalMin="15" UnitGroup="Weather" Visible="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="1" NameTag="RelativeHumidity" UnitType="percent" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" Maximum="100" MeasType="Humidity" Minimum="0" Precision="0" ShortNameTag="RelHumid" SymbolTag="RH" TypicalMax="85" TypicalMin="15" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="DewPoint" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" Maximum="55" MeasType="DewPoint" Minimum="-50" Precision="1" ShortNameTag="DewPt" SymbolTag="TD" TypicalMax="35" TypicalMin="-10" UnitGroup="Weather" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="AbsoluteHumidity" UnitType="gpm3" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" Maximum="100" MeasType="AbsoluteHumidity" Minimum="0" Precision="1" ShortNameTag="AbsHum" SymbolTag="H" TypicalMax="20" TypicalMin="5" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="DirectBaroADC" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="1" Maximum="4096" Minimum="0" Precision="2" TypicalMax="4096" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="BarometricPressure" UnitType="inHg" Type="FactoryCal" Inputs="4" Params="0,0,3327.8,29.92" Accuracy="1" Display="Digits" Internal="0" Maximum="32" MeasType="Pressure" Minimum="0" Precision="2" ShortNameTag="Press" SymbolTag="pressureBarometric" TypicalMax="31" TypicalMin="28" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="6" NameTag="BarometricPressure" UnitType="hPa" Type="LinearConv" Inputs="5" Params="33.9,0" Accuracy="0.7" Display="Digits" Internal="0" InternalUnit="1" Maximum="1700" MeasType="Pressure" Minimum="0" Precision="1" ShortNameTag="Press" SymbolTag="pressureBarometric" TypicalMax="1090" TypicalMin="800" XplorerDisplay="1"/>
        <Measurement ID="7" NameTag="BarometricPressure" UnitType="mBar" Type="LinearConv" Inputs="6" Params="1,0" Accuracy="0.7" Display="Digits" Internal="0" InternalUnit="1" Maximum="1700" MeasType="Pressure" Minimum="0" Precision="1" ShortNameTag="Press" SymbolTag="pressureBarometric" TypicalMax="1090" TypicalMin="800" XplorerDisplay="1"/>
        <Measurement ID="8" NameTag="Temperature" UnitType="DegF" Type="LinearConv" Inputs="0" Params="1.8,32" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="55" MeasType="Temperature" Minimum="-20" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="40" TypicalMin="-15" UnitGroup="Weather" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="9" NameTag="RelativeAltitude" UnitType="m" Type="LinearConv" Inputs="12" Params="1.2,0" Accuracy="1" Display="Digits" Internal="0" Maximum="7000" MeasType="Altitude" Minimum="-200" Precision="0" ShortNameTag="RelAlt" SymbolTag="h" TypicalMax="300" TypicalMin="10" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="10" NameTag="RelativeAltitude" UnitType="ft" Type="LinearConv" Inputs="9" Params="3.28079,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="21000" MeasType="Altitude" Minimum="-600" Precision="0" ShortNameTag="RelAlt" SymbolTag="h" TypicalMax="2100" TypicalMin="-15" XplorerDisplay="1"/>
        <Measurement ID="11" NameTag="DewPoint" UnitType="DegF" Type="LinearConv" Inputs="2" Params="1.8,32" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="130" MeasType="DewPoint" Minimum="-4" Precision="1" ShortNameTag="DewPt" SymbolTag="TD" TypicalMax="104" TypicalMin="5" UnitGroup="Weather" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="12" NameTag="rawalt" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="1" Maximum="7000" Minimum="-200" Precision="0" TypicalMax="300" TypicalMin="-5" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="216" Tag="AbsolutePressureTemperatureSensor" Version="2.8" Class="0" DefaultRate="20Hz" FileName="AbsolutePressureTemperature.sds" FloatParams="0" Icon="071e051207337c331033103f102110210021701e880c140b2407040188007000" IconID="216" Latency="45000" ListNameTag="PressureTemperatureSensorAbsolute" MaxDatasheet="8192" MaxRate="100Hz" Model="PS-2146" Warmup="20">
        <Measurement ID="0" NameTag="uncalPressure" Type="Direct" DataSize="4" Accuracy="2e-005" Display="Digits" Internal="1" Maximum="14" Minimum="0" Precision="5" TypicalMax="14" TypicalMin="0"/>
        <Measurement ID="1" NameTag="AbsolutePressure" UnitType="psi" Type="UserCal" Inputs="10" Params="0,0,14.696,14.696" Accuracy="0.1" CalFlags="0,0,1,1" Display="Digits" Internal="0" Maximum="100" MeasType="Pressure" Minimum="0" Precision="3" ShortNameTag="AbsPress" SymbolTag="pressureAbsolute" TypicalMax="20" TypicalMin="0" Visible="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="2" NameTag="AbsolutePressure" UnitType="Nm2" Type="LinearConv" Inputs="1" Params="6897.5,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="32767" MeasType="Pressure" Minimum="0" Precision="0" ShortNameTag="AbsPress" SymbolTag="pressureAbsolute" TypicalMax="32767" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="AbsolutePressure" UnitType="kPa" Type="LinearConv" Inputs="1" Params="6.89789,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="700" MeasType="Pressure" Minimum="0" Precision="2" ShortNameTag="AbsPress" SymbolTag="pressureAbsolute" TypicalMax="700" TypicalMin="0" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="uncalTemperature" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="1" Display="Graph" Internal="1" Maximum="408" Minimum="238" Precision="1" TypicalMax="373" TypicalMin="273"/>
        <Measurement ID="5" NameTag="Temperature" UnitType="DegC" Type="UserCal" Inputs="4" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="1" Display="Digits" Internal="0" Maximum="135" MeasType="Temperature" Minimum="-35" Precision="2" ShortNameTag="Temp" SymbolTag="T" TypicalMax="30" TypicalMin="15" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="6" NameTag="Temperature" UnitType="K" Type="LinearConv" Inputs="5" Params="1,273.15" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="408" MeasType="Temperature" Minimum="238" Precision="2" ShortNameTag="Temp" SymbolTag="T" TypicalMax="308" TypicalMin="288" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="7" NameTag="Temperature" UnitType="DegF" Type="LinearConv" Inputs="5" Params="1.8,32" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="275" MeasType="Temperature" Minimum="-31" Precision="2" ShortNameTag="Temp" SymbolTag="T" TypicalMax="95" TypicalMin="60" XplorerDisplay="1"/>
        <Measurement ID="8" NameTag="AbsolutePressure" UnitType="atm" Type="LinearConv" Inputs="3" Params="0.009860000000000001,0" Accuracy="0.01" Display="Digits" Internal="0" InternalUnit="1" Maximum="7" MeasType="Pressure" Minimum="0" Precision="4" ShortNameTag="Press" SymbolTag="pressureAbsolute" TypicalMax="7" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="9" NameTag="AbsolutePressure" UnitType="torr" Type="LinearConv" Inputs="3" Params="7.50061,0" Accuracy="7" Display="Digits" Internal="0" InternalUnit="1" Maximum="4900" MeasType="Pressure" Minimum="0" Precision="1" ShortNameTag="Press" SymbolTag="pressureAbsolute" TypicalMax="4900" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="10" NameTag="FactCalPressure" UnitType="psi" Type="FactoryCal" Inputs="0" Params="0,0,2766,14.94" Accuracy="0.1" Display="Digits" Internal="1" Maximum="100" MeasType="Pressure" Minimum="0" Precision="3" TypicalMax="100" TypicalMin="0"/>
        <SupportedCmd ID="64" Size="1"/>
      </Sensor>
      <Sensor ID="217" Tag="Spirometer" Version="2.5" Class="0" DefaultRate="50Hz" FileName="Spirometer.sds" FloatParams="0" Icon="0000800180018001700ed81b5422442a6a62424a52424a5652427a5e06600000" IconID="217" Latency="100" MaxDatasheet="8192" MaxRate="100Hz" MinRate="20Hz" Model="PS-2152" Warmup="1500">
        <Measurement ID="0" NameTag="VolumetricFlowRate" UnitType="cfm" Type="Direct" DataSize="4" Accuracy="0.01" Display="Graph" Internal="0" Maximum="10" MeasType="VolumeFlowRate" Minimum="-10" Precision="2" ShortNameTag="VoluFlowRate" SymbolTag="flowRateVolume" TypicalMax="1" TypicalMin="-1" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="VolumetricFlowRate" UnitType="Lps" Type="LinearConv" Inputs="0" Params="0.47198,0" Accuracy="0.1" Display="Graph" Internal="0" InternalUnit="1" Maximum="5" MeasType="VolumeFlowRate" Minimum="-5" Precision="2" ShortNameTag="VoluFlowRate" SymbolTag="flowRateVolume" TypicalMax="3" TypicalMin="-3" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="TotalFlow" UnitType="ft3" Type="Direct" DataSize="4" Accuracy="0.01" Display="Graph" Internal="0" Maximum="0.2" MeasType="FlowVolume" Minimum="-0.2" Precision="2" ShortNameTag="TotFlow" SymbolTag="flowVolume" TypicalMax="0.1" TypicalMin="-0.1" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="TotalFlow" UnitType="L" Type="LinearConv" Inputs="2" Params="28.32,0" Accuracy="0.1" Display="Graph" Internal="0" InternalUnit="1" Maximum="6" MeasType="FlowVolume" Minimum="-6" Precision="2" ShortNameTag="TotFlow" SymbolTag="flowVolume" TypicalMax="3" TypicalMin="-3" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="MaxFlowRate" UnitType="cfm" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" Maximum="10" MeasType="VolumeFlowRate" Minimum="-10" Precision="2" ShortNameTag="MaxFlow" SymbolTag="Rmax" TypicalMax="1" TypicalMin="-1" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="MaxFlowRate" UnitType="Lps" Type="LinearConv" Inputs="4" Params="0.47197,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="10" MeasType="VolumeFlowRate" Minimum="-10" Precision="2" ShortNameTag="MaxFlow" SymbolTag="Rmax" TypicalMax="10" TypicalMin="-10" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="6" NameTag="PerBreathVolume" UnitType="L" Equation="perbreathvolume([1],[3],3)" MeasType="FlowVolume" Minimum="0" Maximum="10" ShortNameTag="PerBreathVol" SymbolTag="perBreathV" TypicalMin="0" TypicalMax="3" Visible="1"/>
        <Measurement ID="7" NameTag="LungVolume" UnitType="L" Equation="2.5-[3]" MeasType="FlowVolume" Minimum="0" Maximum="10" ShortNameTag="LungVol" SymbolTag="lungV" TypicalMin="0" TypicalMax="6" Visible="1" IsDefaultMeas="1"/>
      </Sensor>
      <Sensor ID="219" Tag="UVASensor" Version="2.6" Class="0" DefaultRate="10Hz" FileName="UV Light.sds" FloatParams="0" Icon="000104010820c013e007f00ff00ff66ff00fe007e007c003c003c00340028001" IconID="219" Latency="100" MaxDatasheet="2048" MaxRate="1000Hz" Model="PS-2149" Warmup="1">
        <Measurement ID="0" NameTag="DirectValueLight" Type="Direct" DataSize="4" Accuracy="2" Display="Graph" Internal="1" Maximum="30000" Minimum="0" Precision="2" TypicalMax="300" TypicalMin="0"/>
        <Measurement ID="1" NameTag="RelativeIntensity" UnitType="Percentofscalemax" Type="LinearConv" Inputs="0" Params="0.38104,0" Accuracy="2" Display="Graph" Internal="0" Maximum="10000" MeasType="LightIntensity" Minimum="0" Precision="2" ShortNameTag="RelIntens" SymbolTag="IntensityUV" TypicalMax="100" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="220" Tag="IRSensor" Version="2.4" Class="0" DefaultRate="10Hz" FileName="IR.sds" FloatParams="0" Icon="00000000783e4408440844087808480844084408443e00000000000000000000" IconID="220" Latency="100" ListNameTag="LightSensorInfrared" MaxDatasheet="8192" MaxRate="100Hz" Model="PS-2148" SupportsZeroOnStart="1" Warmup="1">
        <Measurement ID="0" NameTag="uncalmV" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="1" Maximum="2" Minimum="0" Precision="1" TypicalMax="2" TypicalMin="0"/>
        <Measurement ID="1" NameTag="Temperature" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="3" Display="Digits" Internal="0" Maximum="135" MeasType="Temperature" Minimum="0" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="30" TypicalMin="15" Visible="0" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="Voltage" UnitType="mV" Type="FactoryCal" Inputs="0" Params="-1500,-1500,1500,1500" Accuracy="4" Display="Digits" Internal="0" Maximum="300" MeasType="Voltage" Minimum="-30" Precision="1" ShortNameTag="Volt" SymbolTag="V" TypicalMax="50" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="6" NameTag="Temperature" UnitType="DegF" Type="LinearConv" Inputs="1" Params="1.8,32" Accuracy="3" Display="Digits" Internal="0" InternalUnit="1" Maximum="275" MeasType="Temperature" Minimum="-31" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="86" TypicalMin="68" XplorerDisplay="1"/>
        <Measurement ID="7" NameTag="Temperature" UnitType="K" Type="LinearConv" Inputs="1" Params="1,273.15" Accuracy="3" Display="Digits" Internal="0" InternalUnit="1" Maximum="408" MeasType="Temperature" Minimum="238" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="303" TypicalMin="293" XplorerDisplay="1"/>
        <Measurement ID="8" NameTag="LightIntensity" UnitType="wpm2" Type="LinearConv" Inputs="2" Params="17.8,0" Accuracy="4" Display="Digits" Internal="0" Maximum="4500" MeasType="LightIntensity" Minimum="-500" OffsetZero="1" Precision="0" ShortNameTag="Intens" SymbolTag="IntensityIR" TypicalMax="1000" TypicalMin="-25" Visible="1" VisibleSds="1" XplorerDisplay="1" IsDefaultMeas="1"/>
      </Sensor>
      <Sensor ID="221" Tag="AnalogAdapter" Version="2.2" Class="0" DefaultRate="10Hz" FileName="AnalogAdapter.sds" FloatParams="0" Icon="00000020002000f8042008211003200540098011002100003e00000000000000" IconID="221" Latency="19" MaxDatasheet="768" MaxRate="50000Hz" Model="PS-2158" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" CalFlags="1,1,1,1" Accuracy="0.005" Display="None" Internal="0" InternalUnit="1" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="10" TypicalMin="-10" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="222" Tag="TemperatureArray" Version="2.1" Class="0" DefaultRate="20Hz" FileName="TemperatureArray.sds" FloatParams="0" Icon="0078004870588848884888787068886888788868706800780068006800b400fc" IconID="222" Latency="100" MaxDatasheet="8192" MaxRate="100Hz" Model="PS-2157" Warmup="1">
        <Measurement ID="0" NameTag="TemperatureOrd" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="1" Display="None" Internal="1" Maximum="408" Minimum="238" Ordinal="1" Precision="1" TypicalMax="305" TypicalMin="290"/>
        <Measurement ID="1" NameTag="TemperatureOrd" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="3" Display="None" Internal="1" Maximum="408" Minimum="238" Ordinal="2" Precision="1" TypicalMax="305" TypicalMin="290"/>
        <Measurement ID="2" NameTag="TemperatureOrd" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="3" Display="None" Internal="1" Maximum="408" Minimum="238" Ordinal="3" Precision="1" TypicalMax="305" TypicalMin="290"/>
        <Measurement ID="3" NameTag="TemperatureOrd" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="3" Display="None" Internal="1" Maximum="0" Minimum="0" Ordinal="4" Precision="1" TypicalMax="0" TypicalMin="0"/>
        <Measurement ID="4" NameTag="TemperatureOrd" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="3" Display="None" Internal="1" Maximum="408" Minimum="238" Ordinal="5" Precision="1" TypicalMax="305" TypicalMin="290"/>
        <Measurement ID="5" NameTag="TemperatureOrd" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="3" Display="None" Internal="1" Maximum="408" Minimum="238" Ordinal="6" Precision="1" TypicalMax="305" TypicalMin="290"/>
        <Measurement ID="6" NameTag="TemperatureOrd" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="3" Display="None" Internal="1" Maximum="408" Minimum="238" Ordinal="7" Precision="1" TypicalMax="305" TypicalMin="290"/>
        <Measurement ID="7" NameTag="TemperatureOrd" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="3" Display="None" Internal="1" Maximum="408" Minimum="238" Ordinal="8" Precision="1" TypicalMax="305" TypicalMin="290"/>
        <Measurement ID="8" NameTag="TemperatureOrd" UnitType="DegC" Type="UserCal" Inputs="0" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="1" Display="Digits" Internal="0" Maximum="135" MeasType="Temperature" Minimum="-35" Ordinal="1" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="30" TypicalMin="15" Visible="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="9" NameTag="TemperatureOrd" UnitType="DegC" Type="UserCal" Inputs="1" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="1" Display="Digits" Internal="0" Maximum="135" MeasType="Temperature" Minimum="-35" Ordinal="2" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="30" TypicalMin="15" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="10" NameTag="TemperatureOrd" UnitType="DegC" Type="UserCal" Inputs="2" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="1" Display="Digits" Internal="0" Maximum="135" MeasType="Temperature" Minimum="-35" Ordinal="3" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="30" TypicalMin="15" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="11" NameTag="TemperatureOrd" UnitType="DegC" Type="UserCal" Inputs="3" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="1" Display="Digits" Internal="0" Maximum="135" MeasType="Temperature" Minimum="-35" Ordinal="4" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="30" TypicalMin="15" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="12" NameTag="TemperatureOrd" UnitType="DegC" Type="UserCal" Inputs="4" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="1" Display="Digits" Internal="0" Maximum="135" MeasType="Temperature" Minimum="-35" Ordinal="5" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="30" TypicalMin="15" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="13" NameTag="TemperatureOrd" UnitType="DegC" Type="UserCal" Inputs="5" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="1" Display="Digits" Internal="0" Maximum="135" MeasType="Temperature" Minimum="-35" Ordinal="6" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="30" TypicalMin="15" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="14" NameTag="TemperatureOrd" UnitType="DegC" Type="UserCal" Inputs="6" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="1" Display="Digits" Internal="0" Maximum="135" MeasType="Temperature" Minimum="-35" Ordinal="7" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="30" TypicalMin="15" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="15" NameTag="TemperatureOrd" UnitType="DegC" Type="UserCal" Inputs="7" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="1" Display="Digits" Internal="0" Maximum="135" MeasType="Temperature" Minimum="-35" Ordinal="8" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="30" TypicalMin="15" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="16" NameTag="TemperatureOrd" UnitType="DegF" Type="LinearConv" Inputs="8" Params="1.8,32" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="275" MeasType="Temperature" Minimum="-31" Ordinal="1" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="86" TypicalMin="65" XplorerDisplay="1"/>
        <Measurement ID="17" NameTag="TemperatureOrd" UnitType="DegF" Type="LinearConv" Inputs="9" Params="1.8,32" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="275" MeasType="Temperature" Minimum="-31" Ordinal="2" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="86" TypicalMin="65" XplorerDisplay="1"/>
        <Measurement ID="18" NameTag="TemperatureOrd" UnitType="DegF" Type="LinearConv" Inputs="10" Params="1.8,32" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="275" MeasType="Temperature" Minimum="-31" Ordinal="3" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="86" TypicalMin="65" XplorerDisplay="1"/>
        <Measurement ID="19" NameTag="TemperatureOrd" UnitType="DegF" Type="LinearConv" Inputs="11" Params="1.8,32" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="275" MeasType="Temperature" Minimum="-31" Ordinal="4" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="86" TypicalMin="65" XplorerDisplay="1"/>
        <Measurement ID="20" NameTag="TemperatureOrd" UnitType="DegF" Type="LinearConv" Inputs="12" Params="1.8,32" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="275" MeasType="Temperature" Minimum="-31" Ordinal="5" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="86" TypicalMin="65" XplorerDisplay="1"/>
        <Measurement ID="21" NameTag="TemperatureOrd" UnitType="DegF" Type="LinearConv" Inputs="13" Params="1.8,32" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="275" MeasType="Temperature" Minimum="-31" Ordinal="6" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="86" TypicalMin="65" XplorerDisplay="1"/>
        <Measurement ID="22" NameTag="TemperatureOrd" UnitType="DegF" Type="LinearConv" Inputs="14" Params="1.8,32" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="275" MeasType="Temperature" Minimum="-31" Ordinal="7" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="86" TypicalMin="65" XplorerDisplay="1"/>
        <Measurement ID="23" NameTag="TemperatureOrd" UnitType="DegF" Type="LinearConv" Inputs="15" Params="1.8,32" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="275" MeasType="Temperature" Minimum="-31" Ordinal="8" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="86" TypicalMin="65" XplorerDisplay="1"/>
        <Measurement ID="24" NameTag="TemperatureOrd" UnitType="K" Type="LinearConv" Inputs="8" Params="1,273.15" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="408" MeasType="Temperature" Minimum="238" Ordinal="1" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="305" TypicalMin="290" XplorerDisplay="1"/>
        <Measurement ID="25" NameTag="TemperatureOrd" UnitType="K" Type="LinearConv" Inputs="9" Params="1,273.15" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="408" MeasType="Temperature" Minimum="238" Ordinal="2" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="305" TypicalMin="290" XplorerDisplay="1"/>
        <Measurement ID="26" NameTag="TemperatureOrd" UnitType="K" Type="LinearConv" Inputs="10" Params="1,273.15" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="408" MeasType="Temperature" Minimum="238" Ordinal="3" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="305" TypicalMin="290" XplorerDisplay="1"/>
        <Measurement ID="27" NameTag="TemperatureOrd" UnitType="K" Type="LinearConv" Inputs="11" Params="1,273.15" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="408" MeasType="Temperature" Minimum="238" Ordinal="4" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="305" TypicalMin="290" XplorerDisplay="1"/>
        <Measurement ID="28" NameTag="TemperatureOrd" UnitType="K" Type="LinearConv" Inputs="12" Params="1,273.15" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="408" MeasType="Temperature" Minimum="238" Ordinal="5" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="305" TypicalMin="290" XplorerDisplay="1"/>
        <Measurement ID="29" NameTag="TemperatureOrd" UnitType="K" Type="LinearConv" Inputs="13" Params="1,273.15" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="408" MeasType="Temperature" Minimum="238" Ordinal="6" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="305" TypicalMin="290" XplorerDisplay="1"/>
        <Measurement ID="30" NameTag="TemperatureOrd" UnitType="K" Type="LinearConv" Inputs="14" Params="1,273.15" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="408" MeasType="Temperature" Minimum="238" Ordinal="7" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="305" TypicalMin="290" XplorerDisplay="1"/>
        <Measurement ID="31" NameTag="TemperatureOrd" UnitType="K" Type="LinearConv" Inputs="15" Params="1,273.15" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="408" MeasType="Temperature" Minimum="238" Ordinal="8" Precision="2" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="305" TypicalMin="290" XplorerDisplay="1"/>
        <SupportedCmd ID="64" Size="1"/>
      </Sensor>
      <Sensor ID="223" Tag="Galvanometer" Version="2.35" Class="0" DefaultRate="20Hz" FileName="Galvanometer.sds" FloatParams="0" Icon="000000100010007c0210841088019002a004c0088010002000001e0000000000" IconID="223" Latency="100" MaxDatasheet="8192" MaxRate="5000Hz" Model="PS-2160" Warmup="1">
        <Measurement ID="0" NameTag="RawADC" Type="Direct" DataSize="4" Accuracy="1" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="0" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="1" NameTag="Voltage" UnitType="mV" Type="FactoryCal" Inputs="0" Params="-2e-005,-2e-005,-2e-005,-2e-005" Accuracy="1" Display="Digits" Internal="0" Maximum="2000" MeasType="Voltage" Minimum="-2000" Precision="2" ShortNameTag="Volt" SymbolTag="V" TypicalMax="200" TypicalMin="-200" Visible="1" XplorerDisplay="1" DefaultUnit="mV" IsDefaultMeas="1"/>
        <Measurement ID="2" NameTag="Voltage" UnitType="V" Type="LinearConv" Inputs="1" Params="0.001,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="2" MeasType="Voltage" Minimum="-2" Precision="2" ShortNameTag="Volt" SymbolTag="V" TypicalMax="2" TypicalMin="-2" VisibleSds="1" XplorerDisplay="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="224" Tag="PressureSensorQuad" Version="2.13" Class="0" DefaultRate="20Hz" FileName="QuadPressure.sds" FloatParams="0" Icon="0078404848cc48cc48cc7cfc088408840084c67926325a2c9c1c10042002c001" IconID="224" Latency="45000" MaxDatasheet="8192" MaxRate="1000Hz" Model="PS-2164" Warmup="20">
        <Measurement ID="0" NameTag="RawValue1" Type="Direct" DataSize="4" Accuracy="0.0004" Display="None" Internal="1" Maximum="14" Minimum="0" Precision="5" TypicalMax="14" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="SCalPressure1" Type="FactoryCal" Inputs="0" Params="46.29004,14.85,80.24957000000001,24.85" Accuracy="0.01" Display="Graph" Internal="1" Maximum="1.5" Minimum="0" Precision="2" ShortNameTag="RelPress" TypicalMax="1.5" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="AbsolutePressureOrd" UnitType="kPa" Type="UserCal" Inputs="1" Params="0,0,14.85,102.45" CalFlags="1,1,1,1" Accuracy="0.01" Display="Graph" Internal="0" Maximum="200" MeasType="Pressure" Minimum="0" Ordinal="1" Precision="2" ShortNameTag="AbsPOrd" SymbolTag="POrd" TypicalMax="120" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="3" NameTag="AbsolutePressureOrd" UnitType="Nm2" Type="LinearConv" Inputs="2" Params="1000,0" Accuracy="0.001" Display="Graph" Internal="0" InternalUnit="1" Maximum="10" MeasType="Pressure" Minimum="0" Ordinal="1" Precision="3" ShortNameTag="AbsPOrd" SymbolTag="POrd" TypicalMax="10" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="AbsolutePressureOrd" UnitType="psi" Type="LinearConv" Inputs="2" Params="0.145,0" Accuracy="0.001" Display="Graph" Internal="0" InternalUnit="1" Maximum="10" MeasType="Pressure" Minimum="0" Ordinal="1" Precision="3" ShortNameTag="AbsPOrd" SymbolTag="POrd" TypicalMax="10" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="6" NameTag="RawValue2" Type="Direct" DataSize="4" Accuracy="0.0004" Display="None" Internal="1" Maximum="14" Minimum="0" Precision="5" TypicalMax="14" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="7" NameTag="SCalPressure2" Type="FactoryCal" Inputs="6" Params="46.65485,14.85,80.59769,24.85" Accuracy="0.01" Display="Graph" Internal="1" Maximum="1.5" Minimum="0" Precision="2" TypicalMax="1.5" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="8" NameTag="AbsolutePressureOrd" UnitType="kPa" Type="UserCal" Inputs="7" Params="0,0,14.85,102.45" CalFlags="1,1,1,1" Accuracy="0.01" Display="Graph" Internal="0" Maximum="200" MeasType="Pressure" Minimum="0" Ordinal="2" Precision="2" ShortNameTag="AbsPOrd" SymbolTag="POrd" TypicalMax="120" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="9" NameTag="AbsolutePressureOrd" UnitType="Nm2" Type="LinearConv" Inputs="8" Params="1000,0" Accuracy="0.001" Display="Graph" Internal="0" InternalUnit="1" Maximum="10" MeasType="Pressure" Minimum="0" Ordinal="2" Precision="3" ShortNameTag="AbsPOrd" SymbolTag="POrd" TypicalMax="10" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="10" NameTag="AbsolutePressureOrd" UnitType="psi" Type="LinearConv" Inputs="8" Params="0.145,0" Accuracy="0.001" Display="Graph" Internal="0" InternalUnit="1" Maximum="10" MeasType="Pressure" Minimum="0" Ordinal="2" Precision="3" ShortNameTag="AbsPOrd" SymbolTag="POrd" TypicalMax="10" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="11" NameTag="RawValue3" Type="Direct" DataSize="4" Accuracy="0.0004" Display="None" Internal="1" Maximum="14" Minimum="0" Precision="5" TypicalMax="14" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="12" NameTag="SCalPressure3" Type="FactoryCal" Inputs="11" Params="46.71365,14.85,80.64044,24.85" Accuracy="0.01" Display="Graph" Internal="1" Maximum="1.5" Minimum="0" Precision="2" TypicalMax="1.5" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="13" NameTag="AbsolutePressureOrd" UnitType="kPa" Type="UserCal" Inputs="12" Params="0,0,14.85,102.45" CalFlags="1,1,1,1" Accuracy="0.01" Display="Graph" Internal="0" Maximum="200" MeasType="Pressure" Minimum="0" Ordinal="3" Precision="2" ShortNameTag="AbsPOrd" SymbolTag="POrd" TypicalMax="120" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="14" NameTag="AbsolutePressureOrd" UnitType="Nm2" Type="LinearConv" Inputs="13" Params="1000,0" Accuracy="0.001" Display="Graph" Internal="0" InternalUnit="1" Maximum="10" MeasType="Pressure" Minimum="0" Ordinal="3" Precision="3" ShortNameTag="AbsPOrd" SymbolTag="POrd" TypicalMax="10" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="15" NameTag="AbsolutePressureOrd" UnitType="psi" Type="LinearConv" Inputs="13" Params="0.145,0" Accuracy="0.001" Display="Graph" Internal="0" InternalUnit="1" Maximum="10" MeasType="Pressure" Minimum="0" Ordinal="3" Precision="3" ShortNameTag="AbsPOrd" SymbolTag="POrd" TypicalMax="10" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="16" NameTag="RawValue4" Type="Direct" DataSize="4" Accuracy="0.0004" Display="None" Internal="1" Maximum="14" Minimum="0" Precision="5" TypicalMax="14" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="17" NameTag="SCalPressure4" Type="FactoryCal" Inputs="16" Params="46.38489,14.85,80.43868999999999,24.85" Accuracy="0.01" Display="Graph" Internal="1" Maximum="1.5" Minimum="0" Precision="2" TypicalMax="1.5" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="18" NameTag="AbsolutePressureOrd" UnitType="kPa" Type="UserCal" Inputs="17" Params="0,0,14.85,102.45" CalFlags="1,1,1,1" Accuracy="0.01" Display="Graph" Internal="0" Maximum="200" MeasType="Pressure" Minimum="0" Ordinal="4" Precision="2" ShortNameTag="AbsPOrd" SymbolTag="POrd" TypicalMax="120" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="19" NameTag="AbsolutePressureOrd" UnitType="Nm2" Type="LinearConv" Inputs="18" Params="1000,0" Accuracy="0.001" Display="Graph" Internal="0" InternalUnit="1" Maximum="10" MeasType="Pressure" Minimum="0" Ordinal="4" Precision="3" ShortNameTag="AbsPOrd" SymbolTag="POrd" TypicalMax="10" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="20" NameTag="AbsolutePressureOrd" UnitType="psi" Type="LinearConv" Inputs="18" Params="0.145,0" Accuracy="0.001" Display="Graph" Internal="0" InternalUnit="1" Maximum="10" MeasType="Pressure" Minimum="0" Ordinal="4" Precision="3" ShortNameTag="AbsPOrd" SymbolTag="POrd" TypicalMax="10" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="21" NameTag="DifferentialPressure12" UnitType="kPa" Type="TwoInputCombo" Inputs="2,8" Params="0,1,-1,0" Accuracy="0.01" Display="None" Internal="0" Maximum="10" MeasType="Pressure" Minimum="-10" Precision="2" ShortNameTag="DiffPress12" SymbolTag="deltaUP12" TypicalMax="1" TypicalMin="-1" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="22" NameTag="DifferentialPressure34" UnitType="kPa" Type="TwoInputCombo" Inputs="13,18" Params="0,1,-1,0" Accuracy="0.01" Display="None" Internal="0" Maximum="10" MeasType="Pressure" Minimum="-10" Precision="2" ShortNameTag="DiffPress34" SymbolTag="deltaUP34" TypicalMax="1" TypicalMin="-1" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="30" NameTag="cycle_count" Type="RawDigital" DataSize="2" Accuracy="1" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="2" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="225" Tag="ForcePlatform" Version="2.99" Class="0" DefaultRate="20Hz" FileName="Force Platform.sds" FloatParams="0" Icon="00000000100810081008100810081008381c1008fe7f02400a500a50f81f0000" IconID="225" Latency="45000" MaxDatasheet="8192" MaxRate="2000Hz" Model="PS-2141" Warmup="20">
        <Measurement ID="0" NameTag="ScaledRawValue1" Type="LinearConv" Inputs="3" Params="0.5,0" Accuracy="0" Display="None" Internal="1" Maximum="14" Minimum="0" Precision="2" TypicalMax="14" TypicalMin="0"/>
        <Measurement ID="1" NameTag="ForceBeamOrd" UnitType="N" Type="LinearConv" Inputs="2" Params="4.448,0" Accuracy="10" Display="None" Internal="0" CanChangeSign="1" Maximum="1100" MeasType="Force" Minimum="-350" Ordinal="1" Precision="2" ShortNameTag="ForceOrd" SymbolTag="FOrd" TypicalMax="250" TypicalMin="0" Visible="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="ForceBeamOrd" UnitType="lbs" Type="FactoryCal" Inputs="0" Params="6553,0,25558.5,224.9" Accuracy="0.01" Display="None" Internal="0" InternalUnit="1" Maximum="250" MeasType="Force" Minimum="-80" Ordinal="1" Precision="2" ShortNameTag="ForceOrd" SymbolTag="FOrd" TypicalMax="100" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="RawValue1" Type="RawDigital" DataSize="2" Accuracy="0" Display="None" Internal="1" Maximum="14" Minimum="0" Precision="2" TypicalMax="14" TypicalMin="0"/>
        <Measurement ID="6" NameTag="ScaledRawValue2" Type="LinearConv" Inputs="29" Params="0.5,0" Accuracy="0" Display="None" Internal="1" Maximum="14" Minimum="0" Precision="2" TypicalMax="14" TypicalMin="0"/>
        <Measurement ID="7" NameTag="ForceBeamOrd" UnitType="N" Type="LinearConv" Inputs="8" Params="4.448,0" Accuracy="10" Display="None" Internal="0" CanChangeSign="1" Maximum="1100" MeasType="Force" Minimum="-350" Ordinal="2" Precision="2" ShortNameTag="ForceOrd" SymbolTag="FOrd" TypicalMax="250" TypicalMin="0" Visible="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="8" NameTag="ForceBeamOrd" UnitType="lbs" Type="FactoryCal" Inputs="6" Params="6554.5,0,26040,224.9" Accuracy="0.01" Display="None" Internal="0" InternalUnit="1" Maximum="250" MeasType="Force" Minimum="-80" Ordinal="2" Precision="2" ShortNameTag="ForceOrd" SymbolTag="FOrd" TypicalMax="100" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="11" NameTag="ScaledRawValue3" Type="LinearConv" Inputs="30" Params="0.5,0" Accuracy="0" Display="None" Internal="1" Maximum="14" Minimum="0" Precision="2" TypicalMax="14" TypicalMin="0"/>
        <Measurement ID="12" NameTag="ForceBeamOrd" UnitType="N" Type="LinearConv" Inputs="13" Params="4.448,0" Accuracy="10" Display="None" Internal="0" CanChangeSign="1" Maximum="1100" MeasType="Force" Minimum="-350" Ordinal="3" Precision="2" ShortNameTag="ForceOrd" SymbolTag="FOrd" TypicalMax="250" TypicalMin="0" Visible="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="13" NameTag="ForceBeamOrd" UnitType="lbs" Type="FactoryCal" Inputs="11" Params="6550.5,0,25596,224.9" Accuracy="0.01" Display="None" Internal="0" InternalUnit="1" Maximum="250" MeasType="Force" Minimum="-80" Ordinal="3" Precision="2" ShortNameTag="ForceOrd" SymbolTag="FOrd" TypicalMax="100" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="16" NameTag="ScaledRawValue4" Type="LinearConv" Inputs="31" Params="0.5,0" Accuracy="0" Display="None" Internal="1" Maximum="14" Minimum="0" Precision="2" TypicalMax="14" TypicalMin="0"/>
        <Measurement ID="17" NameTag="ForceBeamOrd" UnitType="N" Type="LinearConv" Inputs="18" Params="4.448,0" Accuracy="10" Display="None" Internal="0" CanChangeSign="1" Maximum="1100" MeasType="Force" Minimum="-350" Ordinal="4" Precision="2" ShortNameTag="ForceOrd" SymbolTag="FOrd" TypicalMax="250" TypicalMin="0" Visible="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="18" NameTag="ForceBeamOrd" UnitType="lbs" Type="FactoryCal" Inputs="16" Params="6550.5,0,25655.5,224.9" Accuracy="0.01" Display="None" Internal="0" InternalUnit="1" Maximum="250" MeasType="Force" Minimum="-80" Ordinal="4" Precision="2" ShortNameTag="ForceOrd" SymbolTag="FOrd" TypicalMax="100" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="20" NameTag="pounds1and2" Type="TwoInputCombo" Inputs="2,8" Params="0,1,1,0" Accuracy="1" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="22" NameTag="pounds3and4" Type="TwoInputCombo" Inputs="13,18" Params="0,1,1,0" Accuracy="1" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="23" NameTag="VerticalForce" UnitType="lbs" Type="TwoInputCombo" Inputs="20,22" Params="0,1,1,0" Accuracy="1" Display="Digits" Internal="0" CanChangeSign="1" Maximum="1200" MeasType="Force" Minimum="-300" Precision="2" ShortNameTag="VertForce" SymbolTag="F" TypicalMax="250" TypicalMin="0" Visible="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="24" NameTag="newtons1and2" Type="TwoInputCombo" Inputs="1,7" Params="0,1,1,0" Accuracy="1" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="25" NameTag="newtons3and4" Type="TwoInputCombo" Inputs="12,17" Params="0,1,1,0" Accuracy="1" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="26" NameTag="VerticalForce" UnitType="N" Type="TwoInputCombo" Inputs="24,25" Params="0,1,1,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="5400" MeasType="Force" Minimum="-1300" Precision="2" ShortNameTag="VertForce" SymbolTag="F" TypicalMax="2250" TypicalMin="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="29" NameTag="RawValue2" Type="RawDigital" DataSize="2" Accuracy="0" Display="None" Internal="1" Maximum="14" Minimum="0" Precision="2" TypicalMax="14" TypicalMin="0"/>
        <Measurement ID="30" NameTag="RawValue3" Type="RawDigital" DataSize="2" Accuracy="0" Display="None" Internal="1" Maximum="14" Minimum="0" Precision="2" TypicalMax="14" TypicalMin="0"/>
        <Measurement ID="31" NameTag="RawValue4" Type="RawDigital" DataSize="2" Accuracy="0" Display="None" Internal="1" Maximum="14" Minimum="0" Precision="2" TypicalMax="14" TypicalMin="0"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="226" Tag="ForcePlatform2D" Version="2.52" Class="0" DefaultRate="20Hz" FileName="2D_Force Platform.sds" FloatParams="0" Icon="0000000010081408fe3f140810081008381c1008fe7f02400a500a50f81f0000" IconID="226" Latency="500" MaxDatasheet="8192" MaxRate="2000Hz" Model="PS-2142" Warmup="20">
        <Measurement ID="0" NameTag="ScaledRawValue1" Type="LinearConv" Inputs="3" Params="0.5,0" Accuracy="0" Display="None" Internal="1" Maximum="14" Minimum="0" Precision="2" TypicalMax="14" TypicalMin="0"/>
        <Measurement ID="1" NameTag="ForceBeamOrd" UnitType="N" Type="LinearConv" Inputs="2" Params="4.448,0" Accuracy="10" Display="None" Internal="0" CanChangeSign="1" Maximum="1100" MeasType="Force" Minimum="-350" Ordinal="1" Precision="2" ShortNameTag="ForceOrd" SymbolTag="FOrd" TypicalMax="250" TypicalMin="0" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="ForceBeamOrd" UnitType="lbs" Type="FactoryCal" Inputs="0" Params="6552.5,0,25622,224.9" Accuracy="0.01" Display="None" Internal="0" InternalUnit="1" Maximum="250" MeasType="Force" Minimum="-80" Ordinal="1" Precision="2" ShortNameTag="ForceOrd" SymbolTag="FOrd" TypicalMax="100" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="RawValue1" Type="RawDigital" DataSize="2" Accuracy="0" Display="None" Internal="1" Maximum="14" Minimum="0" Precision="2" TypicalMax="14" TypicalMin="0"/>
        <Measurement ID="6" NameTag="ScaledRawValue2" Type="LinearConv" Inputs="29" Params="0.5,0" Accuracy="0" Display="None" Internal="1" Maximum="14" Minimum="0" Precision="2" TypicalMax="14" TypicalMin="0"/>
        <Measurement ID="7" NameTag="ForceBeamOrd" UnitType="N" Type="LinearConv" Inputs="8" Params="4.448,0" Accuracy="10" Display="None" Internal="0" CanChangeSign="1" Maximum="1100" MeasType="Force" Minimum="-350" Ordinal="2" Precision="2" ShortNameTag="ForceOrd" SymbolTag="FOrd" TypicalMax="250" TypicalMin="0" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="8" NameTag="ForceBeamOrd" UnitType="lbs" Type="FactoryCal" Inputs="6" Params="6554,0,26127,224.9" Accuracy="0.01" Display="None" Internal="0" InternalUnit="1" Maximum="250" MeasType="Force" Minimum="-80" Ordinal="2" Precision="2" ShortNameTag="ForceOrd" SymbolTag="FOrd" TypicalMax="100" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="11" NameTag="ScaledRawValue3" Type="LinearConv" Inputs="30" Params="0.5,0" Accuracy="0" Display="None" Internal="1" Maximum="14" Minimum="0" Precision="2" TypicalMax="14" TypicalMin="0"/>
        <Measurement ID="12" NameTag="ForceBeamOrd" UnitType="N" Type="LinearConv" Inputs="13" Params="4.448,0" Accuracy="10" Display="None" Internal="0" CanChangeSign="1" Maximum="1100" MeasType="Force" Minimum="-350" Ordinal="3" Precision="2" ShortNameTag="ForceOrd" SymbolTag="FOrd" TypicalMax="250" TypicalMin="0" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="13" NameTag="ForceBeamOrd" UnitType="lbs" Type="FactoryCal" Inputs="11" Params="6555.5,0,25728.5,224.9" Accuracy="0.01" Display="None" Internal="0" InternalUnit="1" Maximum="250" MeasType="Force" Minimum="-80" Ordinal="3" Precision="2" ShortNameTag="ForceOrd" SymbolTag="FOrd" TypicalMax="100" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="16" NameTag="ScaledRawValue4" Type="LinearConv" Inputs="31" Params="0.5,0" Accuracy="0" Display="None" Internal="1" Maximum="14" Minimum="0" Precision="2" TypicalMax="14" TypicalMin="0"/>
        <Measurement ID="17" NameTag="ForceBeamOrd" UnitType="N" Type="LinearConv" Inputs="18" Params="4.448,0" Accuracy="10" Display="None" Internal="0" CanChangeSign="1" Maximum="1100" MeasType="Force" Minimum="-350" Ordinal="4" Precision="2" ShortNameTag="ForceOrd" SymbolTag="FOrd" TypicalMax="250" TypicalMin="0" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="18" NameTag="ForceBeamOrd" UnitType="lbs" Type="FactoryCal" Inputs="16" Params="6547.5,0,25982.5,224.9" Accuracy="0.01" Display="None" Internal="0" InternalUnit="1" Maximum="250" MeasType="Force" Minimum="-80" Ordinal="4" Precision="2" ShortNameTag="ForceOrd" SymbolTag="FOrd" TypicalMax="100" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="19" NameTag="ScaledRawValue5" Type="LinearConv" Inputs="32" Params="0.5,0" Accuracy="1" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="20" NameTag="pounds1and2" Type="TwoInputCombo" Inputs="2,8" Params="0,1,1,0" Accuracy="1" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="22" NameTag="pounds3and4" Type="TwoInputCombo" Inputs="13,18" Params="0,1,1,0" Accuracy="1" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="23" NameTag="ForceNormal" UnitType="N" Type="TwoInputCombo" Inputs="24,25" Params="0,1,1,0" Accuracy="1" Display="Digits" Internal="0" Maximum="5400" MeasType="Force" Minimum="-1300" Precision="2" ShortNameTag="ForceNormal_SN" SymbolTag="ForceNormal" TypicalMax="1000" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="24" NameTag="newtons1and2" Type="TwoInputCombo" Inputs="1,7" Params="0,1,1,0" Accuracy="1" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="25" NameTag="newtons3and4" Type="TwoInputCombo" Inputs="12,17" Params="0,1,1,0" Accuracy="1" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="26" NameTag="ForceNormal" UnitType="lbs" Type="TwoInputCombo" Inputs="20,22" Params="0,1,1,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="1200" MeasType="Force" Minimum="-300" Precision="2" ShortNameTag="ForceNormal_SN" SymbolTag="ForceNormal" TypicalMax="500" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="27" NameTag="ParallelForce" UnitType="N" Type="LinearConv" Inputs="28" Params="4.448,0" Accuracy="10" Display="Digits" Internal="0" CanChangeSign="1" Maximum="1100" MeasType="Force" Minimum="-1100" Precision="2" ShortNameTag="ParallelF" SymbolTag="ForceParallel" TypicalMax="250" TypicalMin="-250" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="28" NameTag="ParallelForce" UnitType="lbs" Type="FactoryCal" Inputs="19" Params="6560.5,0,25792.5,224.9" Accuracy="0.01" Display="Digits" Internal="0" InternalUnit="1" Maximum="250" MeasType="Force" Minimum="-250" Precision="2" ShortNameTag="ParallelF" SymbolTag="ForceParallel" TypicalMax="50" TypicalMin="-50" XplorerDisplay="1"/>
        <Measurement ID="29" NameTag="RawValue2" Type="RawDigital" DataSize="2" Accuracy="0" Display="None" Internal="1" Maximum="14" Minimum="0" Precision="2" TypicalMax="14" TypicalMin="0"/>
        <Measurement ID="30" NameTag="RawValue3" Type="RawDigital" DataSize="2" Accuracy="0" Display="None" Internal="1" Maximum="14" Minimum="0" Precision="2" TypicalMax="14" TypicalMin="0"/>
        <Measurement ID="31" NameTag="RawValue4" Type="RawDigital" DataSize="2" Accuracy="0" Display="None" Internal="1" Maximum="14" Minimum="0" Precision="2" TypicalMax="14" TypicalMin="0"/>
        <Measurement ID="32" NameTag="RawValue5" Type="RawDigital" DataSize="2" Accuracy="1" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="230" Tag="GeneralScience" Version="2.83" Class="0" DefaultRate="2Hz" FileName="General Science.sds" FloatParams="0" Icon="1020825038584450455944502858385138890271040508051e15045508551000" IconID="230" Latency="100" MaxDatasheet="8192" MaxRate="200Hz" Model="PS-2168" Warmup="1">
        <Measurement ID="0" NameTag="DirectTemp" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="1" Display="None" Internal="1" Maximum="150" Minimum="-50" Precision="2" TypicalMax="30" TypicalMin="20"/>
        <Measurement ID="1" NameTag="VoltageADC" Type="Direct" DataSize="4" Accuracy="1" Display="None" Internal="1" Maximum="24" Minimum="-24" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="2" NameTag="RawLightIntensity" Type="Direct" DataSize="4" Accuracy="1" Display="None" Internal="1" Maximum="30000" Minimum="0" Precision="0" TypicalMax="50" TypicalMin="0"/>
        <Measurement ID="3" NameTag="SoundLevel" UnitType="dBA" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" Maximum="120" MeasType="SoundLevelA" Minimum="40" Precision="0" TypicalMax="80" TypicalMin="40" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="FactoryCal" Inputs="1" Params="23395.95,11,9407.700000000001,-11" Accuracy="0.01" Display="Digits" Internal="0" Maximum="24" MeasType="Voltage" Minimum="-24" Precision="2" TypicalMax="10" TypicalMin="-10" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Temperature" UnitType="DegC" Type="UserCal" Inputs="0" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="1" Display="Digits" Internal="0" Maximum="135" MeasType="Temperature" Minimum="-35" Precision="1" TypicalMax="30" TypicalMin="15" Visible="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="6" NameTag="Temperature" UnitType="DegF" Type="LinearConv" Inputs="5" Params="1.8,32" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="275" MeasType="Temperature" Minimum="-31" Precision="1" TypicalMax="95" TypicalMin="60" XplorerDisplay="1"/>
        <Measurement ID="7" NameTag="Temperature" UnitType="K" Type="LinearConv" Inputs="5" Params="1,273.15" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="373" MeasType="Temperature" Minimum="238" Precision="1" TypicalMax="308" TypicalMin="288" XplorerDisplay="1"/>
        <Measurement ID="8" NameTag="LightIntensity" UnitType="lux" Type="LinearConv" Inputs="2" Params="32.7,0" Accuracy="1" Display="Digits" Internal="0" Maximum="30000" MeasType="LightIntensity" Minimum="0" Precision="0" ShortNameTag="Intens" SymbolTag="IntensityLight" TypicalMax="5000" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <SupportedCmd ID="64" Size="1"/>
      </Sensor>
      <Sensor ID="231" Tag="WaterQualitySensor" Version="2.55" Class="0" DefaultRate="1Hz" FileName="WaterQuality.sds" FloatParams="0" Icon="00200a50ca58ae50ca588a50008884704a2935c7080710073e30043008001040" IconID="231" Latency="100" MaxDatasheet="8192" MaxRate="1Hz" Model="PS-2169" Warmup="1">
        <Measurement ID="0" NameTag="RawDO_ADC" UnitType="counts" Type="Direct" DataSize="4" Accuracy="1" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="0" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="1" NameTag="RawISEVoltage" Type="Direct" DataSize="4" Accuracy="1" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="2" NameTag="RawUncalConductivity" Type="Direct" DataSize="4" Accuracy="1" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="3" NameTag="Raw_Temperature" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="1" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="4" NameTag="Temperature" UnitType="DegC" Type="UserCal" Inputs="3" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="1" Display="Digits" Internal="0" Maximum="135" MeasType="Temperature" Minimum="-35" Precision="2" ShortNameTag="Temp" SymbolTag="T" TypicalMax="30" TypicalMin="15" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="OxygenConcentration" UnitType="mgpL" Type="UserCal" Inputs="0" Params="0,0,32767,20" CalFlags="0,1,0,1" Accuracy="2" Display="Digits" Internal="0" Maximum="20" MeasType="Concentration" Minimum="0" Precision="1" ShortNameTag="O2Conc" SymbolTag="O2Con" TypicalMax="14" TypicalMin="6" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="6" NameTag="ISEVoltage" UnitType="mV" Type="FactoryCal" Inputs="1" Params="-1000,-1000,1000,1000" Accuracy="4" DefaultUnit="mV" Display="None" Internal="0" Maximum="2000" MeasType="Voltage" Minimum="-2000" Precision="1" ShortNameTag="ISE" SymbolTag="V" TypicalMax="1000" TypicalMin="-1000" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="7" NameTag="Conductivity1XProbe" UnitType="uSpcm" Type="UserCal" Inputs="2" Params="-1000,-1000,1000,1000" CalFlags="0,0,0,1" Accuracy="1" Display="Digits" Internal="0" Maximum="10" MeasType="Conductivity" Minimum="-10" Precision="0" ShortNameTag="Conduct1X" SymbolTag="sigmaL1X" TypicalMax="1000" TypicalMin="50" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="8" NameTag="pH" UnitType="Unitless" Type="UserCal" Inputs="6" Params="177,4,0,7" CalFlags="1,1,1,1" Accuracy="0.1" Display="Digits" Internal="0" Maximum="14" MeasType="pH" Minimum="0" Precision="2" SymbolTag="pH" TypicalMax="10" TypicalMin="4" Visible="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="9" NameTag="Conductivity10XProbe" UnitType="uSpcm" Type="UserCal" Inputs="2" Params="-1000,-10000,1000,10000" CalFlags="0,0,0,1" Accuracy="4" Display="Digits" Internal="0" Maximum="32000" MeasType="Conductivity" Minimum="0" Precision="0" ShortNameTag="Conduct10X" SymbolTag="sigmaL10X" TypicalMax="1000" TypicalMin="50" Visible="1" VisibleSds="1" XplorerDisplay="1" />
        <Measurement ID="10" NameTag="Temperature" UnitType="DegF" Type="LinearConv" Inputs="4" Params="1.8,32" Accuracy="1" Display="None" Internal="0" InternalUnit="1" Maximum="275" MeasType="Temperature" Minimum="-31" Precision="2" ShortNameTag="Temp" SymbolTag="T" TypicalMax="86" TypicalMin="65" XplorerDisplay="1"/>
        <Measurement ID="11" NameTag="Temperature" UnitType="K" Type="LinearConv" Inputs="4" Params="1,273.15" Accuracy="1" Display="None" Internal="0" InternalUnit="1" Maximum="410" MeasType="Temperature" Minimum="238" Precision="2" ShortNameTag="Temp" SymbolTag="T" TypicalMax="305" TypicalMin="290" XplorerDisplay="1"/>
        <Measurement ID="12" NameTag="OxygenSaturation" UnitType="percent" Type="UserCal" Inputs="0" Params="0,0,32767,100" CalFlags="0,1,0,1" Accuracy="2" Display="None" Internal="0" Maximum="200" MeasType="Saturation" Minimum="0" Precision="1" ShortNameTag="O2Sat" SymbolTag="O2Sat" TypicalMax="100" TypicalMin="60" Visible="1" XplorerDisplay="1"/>
        <SupportedCmd ID="64" Size="1"/>
      </Sensor>
      <Sensor ID="232" Tag="ChemistrySensor" Version="2.77" Class="0" DefaultRate="10Hz" FileName="Chemistry.sds" FloatParams="0" Icon="002000500a58ca50ae58ca508a888070000000678099819a8a981c97289040f0" IconID="232" Latency="45000" MaxDatasheet="8192" MaxRate="100Hz" Model="PS-2170" Warmup="20">
        <Measurement ID="0" NameTag="uncalPressure" Type="Direct" DataSize="4" Accuracy="2e-005" Display="Digits" Internal="1" Maximum="14" Minimum="0" Precision="5" TypicalMax="6" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="AbsolutePressure" UnitType="psi" Type="FactoryCal" Inputs="0" Params="5583.90039,14.81,17067.40234,54.81" Accuracy="0.1" Display="Digits" Internal="0" Maximum="100" MeasType="Pressure" Minimum="0" Precision="1" ShortNameTag="AbsPress" SymbolTag="pressureAbsolute" TypicalMax="20" TypicalMin="0" Visible="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="2" NameTag="AbsolutePressure" UnitType="Nm2" Type="LinearConv" Inputs="1" Params="6897.5,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="32767" MeasType="Pressure" Minimum="0" Precision="0" ShortNameTag="AbsPress" SymbolTag="pressureAbsolute" TypicalMax="32767" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="AbsolutePressure" UnitType="kPa" Type="LinearConv" Inputs="1" Params="6.89789,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="700" MeasType="Pressure" Minimum="0" Precision="0" ShortNameTag="AbsPress" SymbolTag="pressureAbsolute" TypicalMax="700" TypicalMin="0" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="uncalTemperature" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="1" Maximum="408" Minimum="238" Precision="1" TypicalMax="373" TypicalMin="273" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Temperature" UnitType="DegC" Type="UserCal" Inputs="4" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="1" Display="Digits" Internal="0" Maximum="135" MeasType="Temperature" Minimum="-35" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="30" TypicalMin="15" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="6" NameTag="Temperature" UnitType="DegF" Type="LinearConv" Inputs="5" Params="1.8,32" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="275" MeasType="Temperature" Minimum="-31" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="275" TypicalMin="-31" XplorerDisplay="1"/>
        <Measurement ID="7" NameTag="Temperature" UnitType="K" Type="LinearConv" Inputs="5" Params="1,273.15" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="275" MeasType="Temperature" Minimum="-31" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="95" TypicalMin="60" XplorerDisplay="1"/>
        <Measurement ID="8" NameTag="AbsolutePressure" UnitType="atm" Type="LinearConv" Inputs="3" Params="0.009860000000000001,0" Accuracy="0.01" Display="Digits" Internal="0" InternalUnit="1" Maximum="7" MeasType="Pressure" Minimum="0" Precision="2" ShortNameTag="AbsPress" SymbolTag="pressureAbsolute" TypicalMax="7" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="9" NameTag="AbsolutePressure" UnitType="torr" Type="LinearConv" Inputs="3" Params="7.50061,0" Accuracy="7" Display="Digits" Internal="0" InternalUnit="1" Maximum="4900" MeasType="Pressure" Minimum="0" Precision="0" ShortNameTag="AbsPress" SymbolTag="pressureAbsolute" TypicalMax="4900" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="10" NameTag="uncalVoltage" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="1" Maximum="10" Minimum="-10" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="11" NameTag="uncalpH_ISE_ORP" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="1" Maximum="10" Minimum="-10" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="12" NameTag="Voltage" UnitType="V" Type="FactoryCal" Inputs="10" Params="23210.25195,6.21,9569.80078,-6.21" Accuracy="1" Display="Digits" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="2" ShortNameTag="Volt" SymbolTag="V" TypicalMax="5" TypicalMin="-5" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="13" NameTag="ISEVoltage" UnitType="mV" Type="FactoryCal" Inputs="11" Params="-1581.95544,-1796,1572.18677,1796" Accuracy="1" DefaultUnit="mV" Display="Digits" Internal="0" Maximum="2000" MeasType="Voltage" Minimum="-2000" Precision="0" ShortNameTag="ISE" SymbolTag="V" TypicalMax="1000" TypicalMin="-1000" Visible="0" XplorerDisplay="1"/>
        <Measurement ID="14" NameTag="pH" UnitType="Unitless" Type="UserCal" Inputs="13" Params="177,4,0,7" CalFlags="1,1,1,1" Accuracy="1" Display="None" Internal="0" Maximum="14" MeasType="pH" Minimum="0" Precision="2" SymbolTag="pH" TypicalMax="10" TypicalMin="4" Visible="1" XplorerDisplay="1"/>
        <SupportedCmd ID="64" Size="1"/>
      </Sensor>
      <Sensor ID="233" Tag="MagneticFieldSensor2axis" Version="2.36" Class="0" DefaultRate="10Hz" FileName="2D_MagneticField.sds" FloatParams="0" Icon="c003e007f00f781eb81db81f7c3efc3d3c3ce42724243c3c0000081028142004" IconID="233" Latency="100" MaxDatasheet="8192" MaxRate="1000Hz" Model="PS-2162" Warmup="1">
        <Measurement ID="0" NameTag="RawRadialMagFieldData" Type="Direct" DataSize="4" Accuracy="0" Display="Digits" Internal="1" Maximum="10" Minimum="0" Precision="0" TypicalMax="10" TypicalMin="0"/>
        <Measurement ID="1" NameTag="RawAxialMagFieldData" Type="Direct" DataSize="4" Accuracy="0" Display="Digits" Internal="1" Maximum="10" Minimum="0" Precision="0" TypicalMax="10" TypicalMin="0"/>
        <Measurement ID="2" NameTag="InvertedMagneticFieldAxial" Type="FactoryCal" Inputs="0" Params="8192.235350000001,0,5918.1333,-580" Accuracy="1" Display="Digits" Internal="1" Maximum="1000" Minimum="0" Precision="2" TypicalMax="1000" TypicalMin="0"/>
        <Measurement ID="3" NameTag="InvertedMagneticFieldPerpendicular" Type="FactoryCal" Inputs="1" Params="8191.07861,0,5852.75049,-580" Accuracy="1" Display="Digits" Internal="1" Maximum="1000" Minimum="0" Precision="2" TypicalMax="1000" TypicalMin="0"/>
        <Measurement ID="4" NameTag="MagneticFieldStrengthAxial" UnitType="gauss" Type="LinearConv" Inputs="2" Params="-1,0" Accuracy="1" CanChangeSign="1" Display="Digits" Internal="0" Maximum="1000" MeasType="MagneticField" Minimum="-1000" Precision="2" ShortNameTag="MagFieldAxial" SymbolTag="BAxial" TypicalMax="100" TypicalMin="-100" Visible="1" VisibleSds="1" XplorerDisplay="1" DefaultUnit="gauss"/>
        <Measurement ID="5" NameTag="MagneticFieldStrengthPerpendicular" UnitType="gauss" Type="LinearConv" Inputs="3" Params="-1,0" Accuracy="1" CanChangeSign="1" Display="Digits" Internal="0" Maximum="1000" MeasType="MagneticField" Minimum="-1000" Precision="2" ShortNameTag="MagFieldPerp" SymbolTag="BPerpendicular" TypicalMax="100" TypicalMin="-100" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="6" NameTag="MagneticFieldStrengthAxial" UnitType="mtesla" Type="LinearConv" Inputs="4" Params="0.1,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="100" MeasType="MagneticField" Minimum="-100" Precision="3" ShortNameTag="MagFieldAxial" SymbolTag="BAxial" TypicalMax="100" TypicalMin="-100" XplorerDisplay="1"/>
        <Measurement ID="7" NameTag="MagneticFieldStrengthPerpendicular" UnitType="mtesla" Type="LinearConv" Inputs="5" Params="0.1,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="100" MeasType="MagneticField" Minimum="-100" Precision="3" ShortNameTag="MagFieldPerp" SymbolTag="BPerpendicular" TypicalMax="100" TypicalMin="-100" XplorerDisplay="1"/>
        <Measurement ID="8" NameTag="MagneticFieldStrengthAxial" UnitType="tesla" Type="LinearConv" Inputs="4" Params="9.000000000000001e-005,0" Accuracy="9.000000000000001e-005" Display="Digits" Internal="0" InternalUnit="1" Maximum="0.1" MeasType="MagneticField" Minimum="-0.1" Precision="6" ShortNameTag="MagFieldAxial" SymbolTag="BAxial" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="9" NameTag="MagneticFieldStrengthPerpendicular" UnitType="tesla" Type="LinearConv" Inputs="5" Params="9.000000000000001e-005,0" Accuracy="9.000000000000001e-005" Display="Digits" Internal="0" InternalUnit="1" Maximum="0.1" MeasType="MagneticField" Minimum="-0.1" Precision="6" ShortNameTag="MagFieldPerp" SymbolTag="B" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="234" Tag="HighSensitivityLightSensor" Version="2.5" Class="0" DefaultRate="20Hz" FileName="Hi_Sens_Light.sds" FloatParams="0" Icon="000104010820c013200410081008166810082004200440024002c00340028001" IconID="234" Latency="100" ListNameTag="LightSensorHighSensitivity" MaxDatasheet="2048" MaxRate="1000Hz" Model="PS-2176" Warmup="1">
        <Measurement ID="0" NameTag="LightIntensity" UnitType="lux" Type="Direct" DataSize="4" Accuracy="0.01" Display="Graph" Internal="0" InternalUnit="1" Maximum="10000" MeasType="LightIntensity" Minimum="0" Precision="2" TypicalMax="100" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="LightIntensity" UnitType="Percentofscalemax" Type="Direct" DataSize="4" Accuracy="1" Display="Graph" Internal="0" Maximum="100" MeasType="LightIntensity" Minimum="0" Precision="1" ShortNameTag="Intens" SymbolTag="IntensityLight" TypicalMax="10" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDefault="1"/>
        <Measurement ID="2" NameTag="RelativeIntensity" UnitType="Unitless" Type="LinearConv" Inputs="0" Params="1,0" Accuracy="1" Display="Graph" Internal="0" Maximum="10" MeasType="LightIntensity" Minimum="-10" Precision="2" ShortNameTag="RelIntens" TypicalMax="1" TypicalMin="-1" Visible="1" XplorerDisplay="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="236" Tag="OpticalDissolvedOxygenSensor" Version="2.5" Class="0" DefaultRate="2Hz" FileName="OpticalDissolvedOxygen.sds" FloatParams="0" Icon="20005441a4420c4108221920376241dc27a219a208a248a2a8e26c62845ce440" IconID="140" Latency="45000" MaxDatasheet="8192" MaxRate="2Hz" Model="PS-2196" Warmup="1000">
        <Measurement ID="0" NameTag="DO2Concentration" UnitType="mgpL" Type="Direct" DataSize="4" Accuracy="0" Display="Digits" Maximum="50" MeasType="Concentration" Minimum="0" Precision="2" TypicalMax="14" TypicalMin="4" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <Measurement ID="1" NameTag="DO2Saturation" UnitType="percent" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Maximum="300" MeasType="Saturation" Minimum="0" Precision="0" TypicalMax="100" TypicalMin="75" UserCalType="Ysi" Visible="1" VisibleSds="1"/>
        <Measurement ID="2" NameTag="O2GasConcentration" UnitType="percent" Type="LinearConv" Inputs="1" Params="0.209,0" Accuracy="1" Maximum="100" Minimum="0" Precision="2" TypicalMax="100" TypicalMin="75" Visible="1" VisibleSds="1"/>
        <Measurement ID="3" NameTag="SolutionTemperature" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Maximum="50" MeasType="Temperature" Minimum="0" Precision="1" TypicalMax="30" TypicalMin="15" Visible="1" VisibleSds="1"/>
        <Measurement ID="4" NameTag="AmbientPressure" UnitType="mmHg" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Maximum="825" MeasType="Pressure" Minimum="325" Precision="1" TypicalMax="800" TypicalMin="700" Visible="1" VisibleSds="1"/>
        <Measurement ID="5" NameTag="SalinityConstant" UnitType="ppt" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Maximum="50" MeasType="Salinity" Minimum="0" Precision="1" TypicalMax="30" TypicalMin="15" Visible="1" VisibleSds="1"/>
        <Measurement ID="100" NameTag="Salinity" UnitType="ppt" Type="Constant" Description="DescSalinityConstant" Internal="1" MeasType="Salinity" UserCalType="Constant" Value="0"/>
        <SupportedCmd ID="64" Size="1"/>
      </Sensor>
      <Sensor ID="237" Tag="GPSPositionSensor" Version="2.3" Class="0" DefaultRate="1Hz" FileName="GPS_position.sds" FloatParams="0" Icon="000000040a0404040a0400040004000400040004fe0700080010002000400080" IconID="237" Latency="100" MaxDatasheet="8192" MaxRate="1Hz" Model="PS-2175" Warmup="42000">
        <Measurement ID="0" NameTag="Latitude" UnitType="deg" UnitGroup="GPS" Type="Direct" DataSize="4" Accuracy="0" Display="Digits" Internal="0" Maximum="90" MeasType="Latitude" Minimum="-90" Precision="6" ShortNameTag="Lat" SymbolTag="Lat" TypicalMax="70" TypicalMin="-70" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="1" NameTag="Longitude" UnitType="deg" UnitGroup="GPS" Type="Direct" DataSize="4" Accuracy="0" Display="Digits" Internal="0" Maximum="180" MeasType="Longitude" Minimum="-180" Precision="6" ShortNameTag="Long" SymbolTag="Long" TypicalMax="180" TypicalMin="-180" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="Velocity" UnitType="mps" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" Maximum="100" MeasType="Velocity" Minimum="0" Precision="2" ShortNameTag="vel" SymbolTag="velocity" TypicalMax="20" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="Course" UnitType="deg" UnitGroup="GPS" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" Maximum="360" MeasType="Direction" Minimum="0" Precision="2" SymbolTag="Course" TypicalMax="360" TypicalMin="0" Visible="1" VisibleSds="1"/>
        <Measurement ID="4" NameTag="Altitude" UnitType="m" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" Maximum="10000" MeasType="Altitude" Minimum="-200" Precision="0" ShortNameTag="Alt" SymbolTag="Alt" TypicalMax="300" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="LatitudeMinutes" UnitType="deg" UnitGroup="GPS" Type="Direct" DataSize="4" Accuracy="0" Display="Digits" Internal="0" Maximum="59.99989" MeasType="LatitudeMinutes" Minimum="0" Precision="4" ShortNameTag="LatMin" TypicalMax="60" TypicalMin="0" Visible="0"/>
        <Measurement ID="6" NameTag="LongitudeMinutes" UnitType="deg" UnitGroup="GPS" Type="Direct" DataSize="4" Accuracy="0" Display="Digits" Internal="0" Maximum="59.99989" MeasType="LongitudeMinutes" Minimum="0" Precision="4" ShortNameTag="LonMin" TypicalMax="60" TypicalMin="0" Visible="0"/>
        <Measurement ID="7" NameTag="SatelliteCount" UnitType="Unitless" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" Maximum="12" MeasType="Count" Minimum="0" Precision="0" ShortNameTag="SatCount" SymbolTag="Count" TypicalMax="12" TypicalMin="0" Visible="1" VisibleSds="1"/>
        <Measurement ID="8" NameTag="LatitudeRelative" UnitType="m" Type="Direct" DataSize="4" Accuracy="0" Display="Digits" Internal="0" Maximum="10000" MeasType="Latitude" Minimum="-10000" Precision="1" ShortNameTag="LatRel" SymbolTag="LatRel" TypicalMax="100" TypicalMin="-100" Visible="1" VisibleSds="1"/>
        <Measurement ID="9" NameTag="LongitudeRelative" UnitType="m" Type="Direct" DataSize="4" Accuracy="0" Display="Digits" Internal="0" Maximum="10000" MeasType="Longitude" Minimum="-10000" Precision="1" ShortNameTag="LongRel" SymbolTag="LongRel" TypicalMax="100" TypicalMin="-100" Visible="1" VisibleSds="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="238" Tag="WeatherAnemometer" Version="2.29" Class="0" DefaultRate="5Hz" FileName="Weather-Anemometer.sds" FloatParams="0" Icon="000e003b8c61dc4a7691029f0240fe7f20043006100318018c01840000000000" IconID="238" Latency="100" MaxDatasheet="8192" MaxRate="5Hz" Model="PS-2174" Warmup="1">
        <Measurement ID="0" NameTag="WindSpeed" UnitType="mph" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" Maximum="65" MeasType="Speed" Minimum="0" Precision="1" ShortNameTag="speed" SymbolTag="speedWind" TypicalMax="20" TypicalMin="0" Visible="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="1" NameTag="WindSpeed" UnitType="mps" Type="LinearConv" Inputs="0" Params="0.447,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="29" MeasType="Speed" Minimum="0" Precision="1" ShortNameTag="speed" SymbolTag="speedWind" TypicalMax="9" TypicalMin="0" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="Temperature" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" Maximum="135" MeasType="Temperature" Minimum="-35" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="30" TypicalMin="15" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="RelativeHumidity" UnitType="percent" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" Maximum="100" MeasType="Humidity" Minimum="0" Precision="0" ShortNameTag="RelHumid" SymbolTag="RH" TypicalMax="85" TypicalMin="15" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="InternalBarometricPressure" Type="Direct" DataSize="4" Accuracy="1" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="1" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="5" NameTag="BarometricPressure" UnitType="mBar" Type="LinearConv" Inputs="27" Params="33.86,0" Accuracy="1" Display="Digits" Internal="0" Maximum="1150" MeasType="Pressure" Minimum="150" Precision="2" ShortNameTag="BarPress" SymbolTag="pressureBarometric" TypicalMax="1100" TypicalMin="900" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="6" NameTag="WindGust" UnitType="mph" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" Maximum="65" MeasType="Speed" Minimum="0" Precision="1" ShortNameTag="gust" SymbolTag="vmax" TypicalMax="20" TypicalMin="0" Visible="1"/>
        <Measurement ID="7" NameTag="WindGust" UnitType="mps" Type="LinearConv" Inputs="6" Params="0.447,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="29" MeasType="Speed" Minimum="0" Precision="1" ShortNameTag="gust" SymbolTag="vmax" TypicalMax="9" TypicalMin="0" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="8" NameTag="DewPoint" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" Maximum="135" MeasType="DewPoint" Minimum="-35" Precision="1" ShortNameTag="DewPt" SymbolTag="TD" TypicalMax="35" TypicalMin="-10" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="9" NameTag="WindChill" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" Maximum="135" MeasType="WindChill" Minimum="-35" Precision="1" SymbolTag="TW" TypicalMax="30" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="10" NameTag="Humidex" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" Maximum="10" MeasType="Humidex" Minimum="-10" Precision="1" SymbolTag="TH" TypicalMax="10" TypicalMin="-10" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="11" NameTag="AbsoluteHumidity" UnitType="gpm3" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" Maximum="50" MeasType="AbsoluteHumidity" Minimum="0" Precision="1" ShortNameTag="AbsHum" SymbolTag="H" TypicalMax="20" TypicalMin="5" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="12" NameTag="WindSpeed" UnitType="kph" Type="LinearConv" Inputs="0" Params="1.609,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="104" MeasType="Speed" Minimum="0" Precision="1" ShortNameTag="speed" SymbolTag="speedWind" TypicalMax="32" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="13" NameTag="WindSpeed" UnitType="knots" Type="LinearConv" Inputs="0" Params="0.89,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="56" MeasType="Speed" Minimum="0" Precision="1" ShortNameTag="speed" SymbolTag="speedWind" TypicalMax="18" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="14" NameTag="WindSpeed" UnitType="fps" Type="LinearConv" Inputs="0" Params="1.467,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="95" MeasType="Speed" Minimum="0" Precision="1" ShortNameTag="speed" SymbolTag="speedWind" TypicalMax="30" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="15" NameTag="Temperature" UnitType="DegF" Type="LinearConv" Inputs="2" Params="1.8,32" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="135" MeasType="Temperature" Minimum="-35" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="86" TypicalMin="65" XplorerDisplay="1"/>
        <Measurement ID="16" NameTag="UncorrectedBarometricPressure" UnitType="hPa" Type="LinearConv" Inputs="26" Params="1,0" Accuracy="1" Display="Digits" Internal="0" Maximum="1150" MeasType="Pressure" Minimum="150" Precision="1" ShortNameTag="UncorrPress" SymbolTag="pressureBarometricUncorrected" TypicalMax="1100" TypicalMin="900" Visible="0" XplorerDisplay="1"/>
        <Measurement ID="17" NameTag="DewPoint" UnitType="DegF" Type="LinearConv" Inputs="8" Params="1.8,32" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="275" MeasType="DewPoint" Minimum="-31" Precision="1" ShortNameTag="DewPt" SymbolTag="TD" TypicalMax="86" TypicalMin="65" XplorerDisplay="1"/>
        <Measurement ID="18" NameTag="WindChill" UnitType="DegF" Type="LinearConv" Inputs="9" Params="1.8,32" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="275" MeasType="WindChill" Minimum="31" Precision="1" SymbolTag="TW" TypicalMax="86" TypicalMin="65" XplorerDisplay="1"/>
        <Measurement ID="19" NameTag="Humidex" UnitType="DegF" Type="LinearConv" Inputs="10" Params="1.8,32" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="275" MeasType="Humidex" Minimum="-31" Precision="1" SymbolTag="TH" TypicalMax="86" TypicalMin="65" XplorerDisplay="1"/>
        <Measurement ID="20" NameTag="WindGust" UnitType="kph" Type="LinearConv" Inputs="6" Params="1.609,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="105" MeasType="Speed" Minimum="0" Precision="1" ShortNameTag="gust" SymbolTag="vmax" TypicalMax="32" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="21" NameTag="WindGust" UnitType="knots" Type="LinearConv" Inputs="6" Params="0.89,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="56" MeasType="Speed" Minimum="0" Precision="1" ShortNameTag="gust" SymbolTag="vmax" TypicalMax="18" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="22" NameTag="WindGust" UnitType="fps" Type="LinearConv" Inputs="6" Params="1.467,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="95" MeasType="Speed" Minimum="0" Precision="1" ShortNameTag="gust" SymbolTag="vmax" TypicalMax="30" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="23" NameTag="UncorrectedBarometricPressure" UnitType="inHg" Type="FactoryCal" Inputs="4" Params="0,0,3314.28125,14.61" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="34" MeasType="Pressure" Minimum="4.4" Precision="2" ShortNameTag="UncorrPress" SymbolTag="pressureBarometricUncorrected" TypicalMax="32.5" TypicalMin="26.5" XplorerDisplay="1"/>
        <Measurement ID="24" NameTag="AltitudeCorrection" UnitType="inHg" Type="Direct" DataSize="4" Accuracy="1" Display="None" Internal="0" Maximum="34" MeasType="Altitude" Minimum="4.4" Precision="2" ShortNameTag="AltCorr" SymbolTag="ho" TypicalMax="40" TypicalMin="20" Visible="0"/>
        <Measurement ID="25" NameTag="BarometricPressure" UnitType="hPa" Type="LinearConv" Inputs="5" Params="1,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="1150" MeasType="Pressure" Minimum="150" Precision="1" ShortNameTag="BarPress" SymbolTag="pressureBarometric" TypicalMax="1100" TypicalMin="900" XplorerDisplay="1"/>
        <Measurement ID="26" NameTag="UncorrectedBarometricPressure" UnitType="mBar" Type="LinearConv" Inputs="23" Params="33.86,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="1150" MeasType="Pressure" Minimum="150" Precision="1" ShortNameTag="UncorrPress" SymbolTag="pressureBarometricUncorrected" TypicalMax="1100" TypicalMin="900" XplorerDisplay="1"/>
        <Measurement ID="27" NameTag="BarometricPressure" UnitType="inHg" Type="TwoInputCombo" Inputs="23,24" Params="0,1,1,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="34" MeasType="Pressure" Minimum="4.4" Precision="2" ShortNameTag="BarPress" SymbolTag="pressureBarometric" TypicalMax="26.5" TypicalMin="32.5" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="28" NameTag="SiteAltitude" UnitType="m" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" Maximum="-75" MeasType="Altitude" Minimum="4000" Precision="0" ShortNameTag="SiteAlt" SymbolTag="h" TypicalMax="300" TypicalMin="0" Visible="0" XplorerDisplay="1"/>
        <Measurement ID="29" NameTag="SiteAltitude" UnitType="ft" Type="LinearConv" Inputs="28" Params="3.281,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="-250" MeasType="Altitude" Minimum="10000" Precision="0" ShortNameTag="SiteAlt" SymbolTag="h" TypicalMax="0" TypicalMin="2000" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="239" Tag="WaterQualityColorimeter" Version="2.7" Class="0" DefaultRate="1Hz" FileName="ColorimeterWQ.sds" FloatParams="0" Icon="800340044004c007480444044244f2ff45444904400440044004400440048003" IconID="239" Latency="2000" MaxDatasheet="8192" MaxRate="5Hz" Model="PS-2179" Warmup="1">
        <Measurement ID="1" NameTag="Red660nmTransmittance" UnitType="percent" Type="Direct" DataSize="4" Accuracy="1" Display="None" Internal="0" Maximum="100" MeasType="Transmittance" Minimum="0" Precision="1" ShortNameTag="RedTransmit" SymbolTag="TR" TypicalMax="100" TypicalMin="0" Visible="1" XplorerDisplay="1"  IsDefaultMeas="1"/>
        <Measurement ID="2" NameTag="Green565nmTransmittance" UnitType="percent" Type="Direct" DataSize="4" Accuracy="1" Display="None" Internal="0" Maximum="100" MeasType="Transmittance" Minimum="0" Precision="1" ShortNameTag="GreenTransmit" SymbolTag="TG" TypicalMax="100" TypicalMin="0" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="Blue461nmTransmittance" UnitType="percent" Type="Direct" DataSize="4" Accuracy="1" Display="None" Internal="0" Maximum="100" MeasType="Transmittance" Minimum="0" Precision="1" ShortNameTag="BlueTransmit" SymbolTag="TB" TypicalMax="100" TypicalMin="0" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Orange610nmTransmittance" UnitType="percent" Type="Direct" DataSize="4" Accuracy="1" Display="None" Internal="0" Maximum="100" MeasType="Transmittance" Minimum="0" Precision="1" ShortNameTag="OrangeTransmit" SymbolTag="TO" TypicalMax="100" TypicalMin="0" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Red660nmAbsorbance" UnitType="Unitless" Type="Absorbance" Inputs="1" Accuracy="0.01" Display="None" Internal="0" Maximum="2" MeasType="Absorbance" Minimum="0" Precision="3" ShortNameTag="RedAbsorb" SymbolTag="AR" TypicalMax="2" TypicalMin="0" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="6" NameTag="Green565nmAbsorbance" UnitType="Unitless" Type="Absorbance" Inputs="2" Accuracy="0.01" Display="None" Internal="0" Maximum="2" MeasType="Absorbance" Minimum="0" Precision="3" ShortNameTag="GreenAbsorb" SymbolTag="AG" TypicalMax="2" TypicalMin="0" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="7" NameTag="Blue461nmAbsorbance" UnitType="Unitless" Type="Absorbance" Inputs="3" Accuracy="0.01" Display="None" Internal="0" Maximum="2" MeasType="Absorbance" Minimum="0" Precision="3" ShortNameTag="BlueAbsorb" SymbolTag="AB" TypicalMax="2" TypicalMin="0" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="8" NameTag="Orange610nmAbsorbance" UnitType="Unitless" Type="Absorbance" Inputs="4" Accuracy="0.01" Display="None" Internal="0" Maximum="2" MeasType="Absorbance" Minimum="0" Precision="3" ShortNameTag="OrangeAbsorb" SymbolTag="AO" TypicalMax="2" TypicalMin="0" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="9" NameTag="AmmoniaL" UnitType="mgpL" Type="LinearConv" Inputs="5" Params="2.5747,-0.2011" Accuracy="0.05" Display="Digits" Internal="0" Maximum="1" MeasType="Concentration" Minimum="0" Precision="2" ShortNameTag="NH3LO" SymbolTag="NH3LO" TypicalMax="1" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="10" NameTag="AmmoniaH" UnitType="mgpL" Type="LinearConv" Inputs="8" Params="2.8356,-0.3715" Accuracy="0.1" Display="Digits" Internal="0" Maximum="3" MeasType="Concentration" Minimum="1" Precision="1" ShortNameTag="NH3HI" SymbolTag="NH3HI" TypicalMax="3" TypicalMin="1" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="11" NameTag="Chlorine" UnitType="mgpL" Type="LinearConv" Inputs="6" Params="10.43,-0.32" Accuracy="0.1" Display="Digits" Internal="0" Maximum="6" MeasType="Concentration" Minimum="0" Precision="1" ShortNameTag="ChlorineSN" SymbolTag="Cl" TypicalMax="6" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="12" NameTag="Fluoride" UnitType="mgpL" Type="LinearConv" Inputs="6" Params="-5.8,7.308" Accuracy="0.1" Display="Digits" Internal="0" Maximum="2" MeasType="Concentration" Minimum="0" Precision="1" ShortNameTag="Fluoride_SN" SymbolTag="Fluoride_SYM" TypicalMax="2" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="13" NameTag="Iron" UnitType="mgpL" Type="LinearConv" Inputs="7" Params="7.65,0.38" Accuracy="0.1" Display="Digits" Internal="0" Maximum="7" MeasType="Concentration" Minimum="0" Precision="1" ShortNameTag="Fe" SymbolTag="Fe" TypicalMax="7" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="14" NameTag="PhosphateL" UnitType="mgpL" Type="LinearConv" Inputs="5" Params="5.601,-0.095" Accuracy="0.05" Display="Digits" Internal="0" Maximum="1" MeasType="Concentration" Minimum="0" Precision="2" ShortNameTag="PO4LO" SymbolTag="PO4LO" TypicalMax="1" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="15" NameTag="PhosphateH" UnitType="mgpL" Type="LinearConv" Inputs="5" Params="6.34889,-0.26019" Accuracy="0.1" Display="Digits" Internal="0" Maximum="8" MeasType="Concentration" Minimum="1" Precision="1" ShortNameTag="PO4HI" SymbolTag="PO4HI" TypicalMax="8" TypicalMin="1" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="16" NameTag="Sulfate" UnitType="mgpL" Type="LinearConv" Inputs="7" Params="162.98,8.609999999999999" Accuracy="1" Display="Digits" Internal="0" Maximum="120" MeasType="Concentration" Minimum="20" Precision="0" ShortNameTag="SO4" SymbolTag="SO4" TypicalMax="120" TypicalMin="20" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="17" NameTag="NitrateL" UnitType="mgpL" Type="LinearConv" Inputs="7" Params="2.04,0.1" Accuracy="0.05" Display="Digits" Internal="0" Maximum="1" MeasType="Concentration" Minimum="0" Precision="2" ShortNameTag="NO3LO" SymbolTag="NO3LO" TypicalMax="1" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="18" NameTag="NitrateH" UnitType="mgpL" Type="LinearConv" Inputs="7" Params="1.53,0.32" Accuracy="0.05" Display="Digits" Internal="0" Maximum="2" MeasType="Concentration" Minimum="1" Precision="2" ShortNameTag="NO3HI" SymbolTag="NO3HI" TypicalMax="2" TypicalMin="1" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="241" Tag="DualPressureSensor" Version="2.23" Class="0" DefaultRate="20Hz" FileName="DualPressure.sds" FloatParams="0" Icon="0078384844cc04cc08cc10fc20847c840084c67926325a2c9c1c10042002c001" IconID="241" Latency="45000" ListNameTag="PressureSensorDual" MaxDatasheet="8192" MaxRate="1000Hz" Model="PS-2181" Warmup="20">
        <Measurement ID="0" NameTag="RawValue1" Type="Direct" DataSize="4" Accuracy="0.0004" Display="None" Internal="1" Maximum="14" Minimum="0" Precision="5" TypicalMax="14" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="SCalPressure1" UnitType="psi" Type="FactoryCal" Inputs="0" Params="-2e-005,-2e-005,-2e-005,-2e-005" Accuracy="0.01" Display="Graph" Internal="1" Maximum="1.5" Minimum="0" Precision="2" TypicalMax="1.5" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="AbsolutePressureOrd" UnitType="kPa" Type="UserCal" Inputs="1" Params="0,0,14.85,102.45" CalFlags="1,1,1,1" Accuracy="0.01" Display="Graph" Internal="0" Maximum="200" MeasType="Pressure" Minimum="0" Ordinal="1" Precision="2" ShortNameTag="AbsPOrd" SymbolTag="POrd" TypicalMax="200" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="3" NameTag="AbsolutePressureOrd" UnitType="Nm2" Type="LinearConv" Inputs="2" Params="1000,0" Accuracy="0.001" Display="Graph" Internal="0" InternalUnit="1" Maximum="10" MeasType="Pressure" Minimum="0" Ordinal="1" Precision="3" ShortNameTag="AbsPOrd" SymbolTag="POrd" TypicalMax="10" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="AbsolutePressureOrd" UnitType="psi" Type="LinearConv" Inputs="2" Params="0.145,0" Accuracy="0.001" Display="Graph" Internal="0" InternalUnit="1" Maximum="10" MeasType="Pressure" Minimum="0" Ordinal="1" Precision="3" ShortNameTag="AbsPOrd" SymbolTag="POrd" TypicalMax="10" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="6" NameTag="RawValue2" Type="Direct" DataSize="4" Accuracy="0.0004" Display="None" Internal="1" Maximum="14" Minimum="0" Precision="5" TypicalMax="14" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="7" NameTag="SCalPressure2" UnitType="psi" Type="FactoryCal" Inputs="6" Params="-2e-005,-2e-005,-2e-005,-2e-005" Accuracy="0.01" Display="Graph" Internal="1" Maximum="1.5" Minimum="0" Precision="2" TypicalMax="1.5" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="8" NameTag="AbsolutePressureOrd" UnitType="kPa" Type="UserCal" Inputs="7" Params="0,0,14.85,102.45" CalFlags="1,1,1,1" Accuracy="0.01" Display="Graph" Internal="0" Maximum="200" MeasType="Pressure" Minimum="0" Ordinal="2" Precision="2" ShortNameTag="AbsPOrd" SymbolTag="POrd" TypicalMax="200" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="9" NameTag="AbsolutePressureOrd" UnitType="Nm2" Type="LinearConv" Inputs="8" Params="1000,0" Accuracy="0.001" Display="Graph" Internal="0" InternalUnit="1" Maximum="10" MeasType="Pressure" Minimum="0" Ordinal="2" Precision="3" ShortNameTag="AbsPOrd" SymbolTag="POrd" TypicalMax="10" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="10" NameTag="AbsolutePressureOrd" UnitType="psi" Type="LinearConv" Inputs="8" Params="0.145,0" Accuracy="0.001" Display="Graph" Internal="0" InternalUnit="1" Maximum="10" MeasType="Pressure" Minimum="0" Ordinal="2" Precision="3" ShortNameTag="AbsPOrd" SymbolTag="POrd" TypicalMax="10" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="11" NameTag="DifferentialPressure12" UnitType="kPa" Type="TwoInputCombo" Inputs="2,8" Params="0,1,-1,0" Accuracy="0.01" Display="None" Internal="0" Maximum="10" MeasType="Pressure" Minimum="-10" Precision="2" ShortNameTag="DiffPress" SymbolTag="deltaUP" TypicalMax="1" TypicalMin="-1" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="12" NameTag="DifferentialPressure12" UnitType="Nm2" Type="LinearConv" Inputs="11" Params="1000,0" Accuracy="0.01" Display="None" Internal="0" InternalUnit="1" Maximum="10" MeasType="Pressure" Minimum="-10" Precision="2" ShortNameTag="DiffPress" SymbolTag="deltaUP" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="13" NameTag="DifferentialPressure12" UnitType="psi" Type="LinearConv" Inputs="11" Params="0.145,0" Accuracy="0.01" Display="None" Internal="0" InternalUnit="1" Maximum="10" MeasType="Pressure" Minimum="-10" Precision="2" ShortNameTag="DiffPress" SymbolTag="deltaUP" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="242" Tag="BroadSpectrumLightSensor" Version="2.2" Class="0" DefaultRate="20Hz" FileName="BroadSpectrumLight.sds" FloatParams="0" Icon="80010420c81320041008166820042004c003400280010000ffffc993c993ffff" IconID="242" Latency="100" ListNameTag="LightSensorBroadSpectrum" MaxDatasheet="8192" MaxRate="100Hz" Model="PS-2150" Warmup="1">
        <Measurement ID="0" NameTag="RelativeIntensity" UnitType="percent" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" Maximum="100" MeasType="LightIntensity" Minimum="0" Precision="2" ShortNameTag="RelIntens" SymbolTag="IntensityLight" TypicalMax="100" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="1" NameTag="OSetV" Type="Direct" DataSize="4" Accuracy="5" Display="None" Internal="1" Maximum="135" Minimum="0" Precision="0" TypicalMax="30" TypicalMin="20"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="243" Tag="DualVoltageSensor1MHz" Version="2.2" Class="0" DefaultRate="20Hz" FileName="DualVoltage1MHz.sds" FloatParams="0" Icon="00000020002000f8042008211003200540098011002100003e00000000000000" IconID="243" Latency="19" ListNameTag="VoltageSensorDual1MHz" MaxBurstRate="1000000Hz" MaxDatasheet="8192" MaxRate="20000Hz" Model="PS-2190" SupportsTrigger="1" Warmup="250" MaxBurstSamples="512">
        <Measurement ID="0" NameTag="V1ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="16383" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="16383" TypicalMin="0"/>
        <Measurement ID="1" NameTag="V11x" Type="FactoryCal" Inputs="0" Params="0,-10,4095,10" Accuracy="0.003" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="2" NameTag="V110x" Type="FactoryCal" Inputs="0" Params="0,-1,4095,1" Accuracy="9.000000000000001e-005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1"/>
        <Measurement ID="3" NameTag="V1100x" Type="FactoryCal" Inputs="0" Params="0,-0.1,4095,0.1" Accuracy="9.000000000000001e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="4" TypicalMax="0.1" TypicalMin="-0.1"/>
        <Measurement ID="4" NameTag="VoltageOrd" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" CalFlags="1,1,1,1" Accuracy="1" Display="Graph" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Ordinal="1" Precision="2" ShortNameTag="VoltOrd" SymbolTag="VOrd" TypicalMax="1" TypicalMin="-1" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="5" NameTag="VoltageOrd" UnitType="mV" Type="LinearConv" Inputs="4" Params="1000,0" Accuracy="0.1" Display="Graph" Internal="0" InternalUnit="1" Maximum="200" MeasType="Voltage" Minimum="-200" Ordinal="1" Precision="1" ShortNameTag="VoltOrd" SymbolTag="VOrd" TypicalMax="200" TypicalMin="-200" XplorerDisplay="1"/>
        <Measurement ID="6" NameTag="CurrentProbeOrd" UnitType="A" Type="LinearConv" Inputs="4" Params="10,0" Accuracy="1" Internal="0" Maximum="1" MeasType="Current" Minimum="-1" Ordinal="1" Precision="4" ShortNameTag="CurrOrd" SymbolTag="IOrd" TypicalMax="0.1" TypicalMin="-0.1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="10" NameTag="V2ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="16383" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="16383" TypicalMin="0"/>
        <Measurement ID="11" NameTag="V21x" Type="FactoryCal" Inputs="10" Params="0,-10,4095,10" Accuracy="0.003" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="12" NameTag="V210x" Type="FactoryCal" Inputs="10" Params="0,-1,4095,1" Accuracy="9.000000000000001e-005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1"/>
        <Measurement ID="13" NameTag="V2100x" Type="FactoryCal" Inputs="10" Params="0,-0.1,4095,0.1" Accuracy="9.000000000000001e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="4" TypicalMax="0.1" TypicalMin="-0.1"/>
        <Measurement ID="14" NameTag="VoltageOrd" UnitType="V" Type="UserCal" Inputs="11" Params="0,0,10,10" CalFlags="1,1,1,1" Accuracy="1" Display="Graph" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Ordinal="2" Precision="2" ShortNameTag="VoltOrd" SymbolTag="VOrd" TypicalMax="1" TypicalMin="-1" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="15" NameTag="VoltageOrd" UnitType="mV" Type="LinearConv" Inputs="14" Params="1000,0" Accuracy="0.1" Display="Graph" Internal="0" InternalUnit="1" Maximum="200" MeasType="Voltage" Minimum="-200" Ordinal="2" Precision="1" ShortNameTag="VoltOrd" SymbolTag="VOrd" TypicalMax="200" TypicalMin="-200" XplorerDisplay="1"/>
        <Measurement ID="16" NameTag="CurrentProbeOrd" UnitType="A" Type="LinearConv" Inputs="14" Params="10,0" Accuracy="1" Internal="0" Maximum="1" MeasType="Current" Minimum="-1" Ordinal="2" Precision="4" ShortNameTag="CurrOrd" SymbolTag="IOrd" TypicalMax="0.1" TypicalMin="-0.1" VisibleSds="1" XplorerDisplay="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="245" Tag="BreathRateSensor" Version="2.6" Class="0" DefaultRate="10Hz" FileName="BreathRate.sds" FloatParams="0" Icon="4055c07fc0604040c04cc04a404860486044c4613e21c4314010c0108010c03f" IconID="245" Latency="45000" MaxDatasheet="8192" MaxRate="1000Hz" Model="PS-2187" Warmup="20">
        <Measurement ID="0" NameTag="RawAtoDValue" Type="Direct" DataSize="4" Accuracy="5" Display="Graph" Internal="1" Maximum="25" Minimum="0" Precision="0" TypicalMax="14" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="BreathRate" UnitType="BreathPerMin" Type="Direct" DataSize="4" Accuracy="3" Display="Digits" Internal="0" Maximum="14" MeasType="BreathRate" Minimum="0" Precision="0" ShortNameTag="breathrate" SymbolTag="R" TypicalMax="14" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="2" NameTag="BreathRateAverage" UnitType="BreathPerMin" Type="Direct" DataSize="4" Accuracy="3" Display="Digits" Internal="0" Maximum="14" MeasType="BreathRate" Minimum="0" Precision="0" ShortNameTag="AvgBreathRate" SymbolTag="Ravg" TypicalMax="14" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="246" Tag="HighCurrentSensor" Version="2.2" Class="0" DefaultRate="20Hz" FileName="HighCurrent.sds" FloatParams="0" Icon="000000000000c00160033006180cfb6f1b6c180c000000000000000000000000" ListNameTag="CurrentSensorHigh" IconID="246" Latency="100" MaxDatasheet="8192" MaxRate="1000Hz" Model="PS-2193" Warmup="1">
        <Measurement ID="0" NameTag="RawCurrent" Type="RawDigital" DataSize="4" Accuracy="0" Display="Digits" Internal="1" Maximum="32767" Minimum="-32767" Precision="0" TypicalMax="16535" TypicalMin="-16535" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="Current" UnitType="A" Type="FactoryCal" Inputs="0" Params="-49.5625,0,12163.25,4" Accuracy="0.1" Display="Graph" Internal="0" Maximum="10" MeasType="Current" Minimum="-10" Precision="2" ShortNameTag="Curr" SymbolTag="current" TypicalMax="1" TypicalMin="-1" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="249" Tag="HandGripHeartRateSensor" Version="2.1" Class="0" DefaultRate="5s" FileName="HandGripHeartRate.sds" FloatParams="0" Icon="0063809cb888b880b88010417822fc143709300138003c006c00c40084010401" IconID="249" Latency="100" MaxDatasheet="8192" MaxRate="2s" MinRate="60s" Model="PS-2186" Warmup="500">
        <Measurement ID="0" NameTag="HeartRate" UnitType="BeatsPerMin" Type="RawDigital" DataSize="2" Accuracy="1" Display="Graph" Internal="0" Maximum="240" MeasType="HeartRate" Minimum="40" Precision="0" ShortNameTag="HeartRt" SymbolTag="HR" TypicalMax="120" TypicalMin="50" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="250" Tag="HighResolutionForceSensor" Version="2.4" Class="0" DefaultRate="20Hz" FileName="Hi_Res_Force.sds" FloatParams="0" Icon="000000000e000e001f380e3804380038067c3838c011800e4031e00300000000" IconID="250" Latency="500" ListNameTag="ForceSensorHighResolution" MaxDatasheet="8192" MaxRate="2000Hz" Model="PS-2189" Warmup="100">
        <Measurement ID="0" NameTag="RawForce" Type="RawDigital" DataSize="4" Accuracy="1" Display="Digits" Internal="1" Maximum="10" Minimum="-10" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="1" NameTag="ForceInverted" UnitType="N" Type="LinearConv" Inputs="2" Params="-1,0" Accuracy="1" Display="Graph" Internal="0" Maximum="50" MeasType="Force" Minimum="-50" Precision="3" ShortNameTag="ForceInv" SymbolTag="F" TypicalMax="5" TypicalMin="-5" Visible="0" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="Force" UnitType="N" Type="UserCal" Inputs="5" Params="0,0,50,50" CalFlags="1,1,1,1" Accuracy="1" CanChangeSign="1" Display="Graph" Internal="0" Maximum="50" MeasType="Force" Minimum="-50" Precision="3" ShortNameTag="Force" SymbolTag="F" TypicalMax="5" TypicalMin="-5" Visible="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="4" NameTag="UncalibratedForceInverted" UnitType="N" Type="FactoryCal" Inputs="0" Params="-33.375,0,-30838.25,50" Accuracy="1" Internal="1" Maximum="50" MeasType="Force" Minimum="-50" Precision="3" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="5" NameTag="UncalibratedForce" UnitType="N" Type="LinearConv" Inputs="4" Params="-1,0" Accuracy="1" Internal="1" Maximum="50" MeasType="Force" Minimum="-50" Precision="3" TypicalMax="10" TypicalMin="-10"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="251" Tag="EthanolSensor" Version="2.2" Class="0" DefaultRate="5Hz" FileName="Ethanol.sds" FloatParams="0" Icon="000010002660fc3fd818b00d6006c00380018001800180018001f81f00000000" IconID="251" Latency="100" MaxDatasheet="8192" MaxRate="1000Hz" Model="PS-2194" Warmup="1">
        <Measurement ID="0" NameTag="SensorResistance" UnitType="kohm" DefaultUnit="kohm" Type="Direct" DataSize="4" Accuracy="2" Display="Digits" Internal="0" Maximum="2000" MeasType="Resistance" Minimum="0" Precision="0" ShortNameTag="SensorR" SymbolTag="R" TypicalMax="15" TypicalMin="0" Visible="1"/>
        <Measurement ID="1" NameTag="PercentEthanol" UnitType="percent" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" Maximum="4" MeasType="Concentration" Minimum="0" Precision="2" ShortNameTag="percentEth" SymbolTag="percentEth" TypicalMax="5" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1" IsDefaultMeas="1"/>
      </Sensor>
      <Sensor ID="252" Tag="NonContactTemperatureSensor" Version="2.4" Class="0" DefaultRate="20Hz" FileName="NonContactTemperature.sds" FloatParams="0" Icon="00003078304808584348f7584748f7584748f7584348084830fc30fc00fc0000" IconID="252" Latency="100" ListNameTag="TemperatureSensorNonContact" MaxDatasheet="8192" MaxRate="200Hz" Model="PS-2197" Warmup="1">
        <Measurement ID="0" NameTag="Temperature" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" Maximum="350" MeasType="Temperature" Minimum="-80" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="30" TypicalMin="15" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="1" NameTag="Temperature" UnitType="DegF" Type="LinearConv" Inputs="0" Params="1.8,32" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="700" MeasType="Temperature" Minimum="-100" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="120" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="Temperature" UnitType="K" Type="LinearConv" Inputs="0" Params="1,273.15" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="600" MeasType="Temperature" Minimum="200" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="400" TypicalMin="200" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="253" Tag="SalinitySensor" Version="2.8" Class="0" DefaultRate="5Hz" FileName="Salinity.sds" FloatParams="0" Icon="000000004992b66d0000000024782e40a47ba40aa47b0000dc1d4815c81d0811" IconID="253" Latency="100" MaxDatasheet="8192" MaxRate="50Hz" Model="PS-2195" Warmup="1">
        <Measurement ID="0" NameTag="CondADC" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="1" Maximum="32000" Minimum="-32000" Precision="0" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="1" NameTag="Conddivby4" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="1" Maximum="32000" Minimum="-32000" Precision="0" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="2" NameTag="Cond" Type="LinearConv" Inputs="1" Params="4,0" Accuracy="1" Display="Digits" Internal="1" Maximum="10" Minimum="-10" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="3" NameTag="Conductivity" UnitType="uSpcm" Type="UserCal" Inputs="2" Params="0,0,-15536,-15536" CalFlags="1,1,1,1" Accuracy="1" Display="Digits" Internal="0" Maximum="32000" MeasType="Conductivity" Minimum="0" Precision="0" ShortNameTag="Conduct" SymbolTag="sigmaL" TypicalMax="1000" TypicalMin="50" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Temperature" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" Maximum="135" MeasType="Temperature" Minimum="-35" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="30" TypicalMin="15" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Temperature" UnitType="DegF" Type="LinearConv" Inputs="4" Params="1.8,32" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="260" MeasType="Temperature" Minimum="-35" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="80" TypicalMin="32" XplorerDisplay="1"/>
        <Measurement ID="6" NameTag="Salinity" UnitType="ppt" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="1" Maximum="10" Minimum="-10" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="7" NameTag="Salinity" UnitType="ppt" Type="UserCal" Inputs="6" Params="0,0,35,35" CalFlags="0,0,1,1" Accuracy="1" Display="Digits" Internal="0" Maximum="55" MeasType="Salinity" Minimum="0" Precision="1" ShortNameTag="Sal" SymbolTag="Salinity" TypicalMax="40" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1" IsDefaultMeas="1"/>
      </Sensor>
      <Sensor ID="254" Tag="LoadCellAmplifier6port" Version="2.11" Class="0" DefaultRate="20Hz" FileName="Load Cell Amp.sds" FloatParams="0" Icon="00000e000e381f380e380438067c3838c011800e4031ee030800ae004a00ae00" IconID="254" Latency="45000" MaxDatasheet="8192" MaxRate="500Hz" Model="PS-2198" Warmup="20">
        <Measurement ID="0" NameTag="RawForce1" UnitType="N" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="1" Maximum="10" Minimum="-10" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="1" NameTag="RawForce2" UnitType="N" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="1" Maximum="10" Minimum="-10" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="2" NameTag="RawForce3" UnitType="N" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="1" Maximum="10" Minimum="-10" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="3" NameTag="RawForce4" UnitType="N" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="1" Maximum="10" Minimum="-10" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="4" NameTag="RawForce5" UnitType="N" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="1" Maximum="10" Minimum="-10" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="5" NameTag="RawForce6" UnitType="N" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="1" Maximum="10" Minimum="-10" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="6" NameTag="ForceOrd" UnitType="N" Type="UserCal" Inputs="0" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="1" CanChangeSign="1" Display="Digits" Internal="0" Maximum="100" MeasType="Force" Minimum="-100" Ordinal="1" Precision="2" SymbolTag="FOrd" TypicalMax="10" TypicalMin="-10" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <Measurement ID="7" NameTag="ForceOrd" UnitType="N" Type="UserCal" Inputs="1" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="1" CanChangeSign="1" Display="Digits" Internal="0" Maximum="100" MeasType="Force" Minimum="-100" Ordinal="2" Precision="2" SymbolTag="FOrd" TypicalMax="10" TypicalMin="-10" Visible="1" VisibleSds="1"/>
        <Measurement ID="8" NameTag="ForceOrd" UnitType="N" Type="UserCal" Inputs="2" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="1" CanChangeSign="1" Display="Digits" Internal="0" Maximum="100" MeasType="Force" Minimum="-100" Ordinal="3" Precision="2" SymbolTag="FOrd" TypicalMax="10" TypicalMin="-10" Visible="1" VisibleSds="1"/>
        <Measurement ID="9" NameTag="ForceOrd" UnitType="N" Type="UserCal" Inputs="3" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="1" CanChangeSign="1" Display="Digits" Internal="0" Maximum="100" MeasType="Force" Minimum="-100" Ordinal="4" Precision="2" SymbolTag="FOrd" TypicalMax="10" TypicalMin="-10" Visible="1" VisibleSds="1"/>
        <Measurement ID="10" NameTag="ForceOrd" UnitType="N" Type="UserCal" Inputs="4" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="1" CanChangeSign="1" Display="Digits" Internal="0" Maximum="100" MeasType="Force" Minimum="-100" Ordinal="5" Precision="2" SymbolTag="FOrd" TypicalMax="10" TypicalMin="-10" Visible="1" VisibleSds="1"/>
        <Measurement ID="11" NameTag="ForceOrd" UnitType="N" Type="UserCal" Inputs="5" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="1" CanChangeSign="1" Display="Digits" Internal="0" Maximum="100" MeasType="Force" Minimum="-100" Ordinal="6" Precision="2" SymbolTag="FOrd" TypicalMax="10" TypicalMin="-10" Visible="1" VisibleSds="1"/>
        <Measurement ID="12" NameTag="ForceOrd" UnitType="lbs" Type="LinearConv" Inputs="6" Params="0.22481,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="225" MeasType="Force" Minimum="-225" Ordinal="1" Precision="2" SymbolTag="FOrd" TypicalMax="5" TypicalMin="-5"/>
        <Measurement ID="13" NameTag="ForceOrd" UnitType="lbs" Type="LinearConv" Inputs="7" Params="0.22481,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="225" MeasType="Force" Minimum="-225" Ordinal="2" Precision="2" SymbolTag="FOrd" TypicalMax="5" TypicalMin="-5"/>
        <Measurement ID="14" NameTag="ForceOrd" UnitType="lbs" Type="LinearConv" Inputs="8" Params="0.22481,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="225" MeasType="Force" Minimum="-225" Ordinal="3" Precision="2" SymbolTag="FOrd" TypicalMax="5" TypicalMin="-5"/>
        <Measurement ID="15" NameTag="ForceOrd" UnitType="lbs" Type="LinearConv" Inputs="9" Params="0.22481,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="225" MeasType="Force" Minimum="-225" Ordinal="4" Precision="2" SymbolTag="FOrd" TypicalMax="5" TypicalMin="-5"/>
        <Measurement ID="16" NameTag="ForceOrd" UnitType="lbs" Type="LinearConv" Inputs="10" Params="0.22481,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="225" MeasType="Force" Minimum="-225" Ordinal="5" Precision="2" SymbolTag="FOrd" TypicalMax="5" TypicalMin="-5"/>
        <Measurement ID="17" NameTag="ForceOrd" UnitType="lbs" Type="LinearConv" Inputs="11" Params="0.22481,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="225" MeasType="Force" Minimum="-225" Ordinal="6" Precision="2" SymbolTag="FOrd" TypicalMax="5" TypicalMin="-5"/>
        <SupportedCmd ID="64" Size="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="255" Tag="TemperatureSensorQuadTypeK" Version="2.4" Class="0" DefaultRate="2Hz" FileName="TypeKArray.sds" FloatParams="0" Icon="003cd825902ca024c024a02c9034d835003c1034543d94345e3d0434047e007e" IconID="255" Latency="100" MaxDatasheet="8192" MaxRate="250Hz" Model="PS-2127" Warmup="1">
        <Measurement ID="0" NameTag="RawTemp1" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="0.05" Display="None" Internal="1" Maximum="100" Minimum="-10" Precision="2" TypicalMax="100" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="RawTemp2" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="0.05" Display="Digits" Internal="1" Maximum="100" Minimum="-10" Precision="2" TypicalMax="100" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="RawTemp3" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="0.05" Display="Digits" Internal="1" Maximum="100" Minimum="-10" Precision="2" TypicalMax="100" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="RawTemp4" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="0.05" Display="Digits" Internal="1" Maximum="100" Minimum="-10" Precision="2" TypicalMax="100" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="TemperatureOrd" UnitType="DegC" Type="UserCal" Inputs="0" Params="0,0,100,100" CalFlags="0,1,0,1" Accuracy="1" Display="Digits" Internal="0" Maximum="1000" MeasType="Temperature" Minimum="-200" Ordinal="1" Precision="1" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="200" TypicalMin="-10" Visible="1" VisibleSds="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="5" NameTag="TemperatureOrd" UnitType="DegC" Type="UserCal" Inputs="1" Params="0,0,100,100" CalFlags="0,1,0,1" Accuracy="1" Display="Digits" Internal="0" Maximum="1000" MeasType="Temperature" Minimum="-200" Ordinal="2" Precision="1" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="200" TypicalMin="-10" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="6" NameTag="TemperatureOrd" UnitType="DegC" Type="UserCal" Inputs="2" Params="0,0,100,100" CalFlags="0,1,0,1" Accuracy="1" Display="Digits" Internal="0" Maximum="1000" MeasType="Temperature" Minimum="-200" Ordinal="3" Precision="1" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="200" TypicalMin="-10" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="7" NameTag="TemperatureOrd" UnitType="DegC" Type="UserCal" Inputs="3" Params="0,0,100,100" CalFlags="0,1,0,1" Accuracy="1" Display="Digits" Internal="0" Maximum="1000" MeasType="Temperature" Minimum="-200" Ordinal="4" Precision="1" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="200" TypicalMin="-10" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="8" NameTag="TemperatureOrd" UnitType="DegF" Type="LinearConv" Inputs="4" Params="1.8,32" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="1832" MeasType="Temperature" Minimum="-328" Ordinal="1" Precision="1" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="392" TypicalMin="14" XplorerDisplay="1"/>
        <Measurement ID="9" NameTag="TemperatureOrd" UnitType="DegF" Type="LinearConv" Inputs="5" Params="1.8,32" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="1832" MeasType="Temperature" Minimum="-328" Ordinal="2" Precision="1" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="392" TypicalMin="14" XplorerDisplay="1"/>
        <Measurement ID="10" NameTag="TemperatureOrd" UnitType="DegF" Type="LinearConv" Inputs="6" Params="1.8,32" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="1832" MeasType="Temperature" Minimum="-328" Ordinal="3" Precision="1" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="392" TypicalMin="14" XplorerDisplay="1"/>
        <Measurement ID="11" NameTag="TemperatureOrd" UnitType="DegF" Type="LinearConv" Inputs="7" Params="1.8,32" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="1832" MeasType="Temperature" Minimum="-328" Ordinal="4" Precision="1" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="392" TypicalMin="14" XplorerDisplay="1"/>
        <Measurement ID="12" NameTag="TemperatureOrd" UnitType="K" Type="LinearConv" Inputs="4" Params="1,273.15" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="1274" MeasType="Temperature" Minimum="73" Ordinal="1" Precision="1" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="450" TypicalMin="260" XplorerDisplay="1"/>
        <Measurement ID="13" NameTag="TemperatureOrd" UnitType="K" Type="LinearConv" Inputs="5" Params="1,273.15" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="1274" MeasType="Temperature" Minimum="73" Ordinal="2" Precision="1" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="450" TypicalMin="260" XplorerDisplay="1"/>
        <Measurement ID="14" NameTag="TemperatureOrd" UnitType="K" Type="LinearConv" Inputs="6" Params="1,273.15" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="1274" MeasType="Temperature" Minimum="73" Ordinal="3" Precision="1" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="450" TypicalMin="260" XplorerDisplay="1"/>
        <Measurement ID="15" NameTag="TemperatureOrd" UnitType="K" Type="LinearConv" Inputs="7" Params="1,273.15" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="1274" MeasType="Temperature" Minimum="73" Ordinal="4" Precision="1" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="450" TypicalMin="260" XplorerDisplay="1"/>
        <SupportedCmd ID="64" Size="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="256" Tag="DisplacementSensor" Version="2.2" Class="0" DefaultRate="5Hz" FileName="Displacement.sds" FloatParams="0" Icon="8001c003300c08102810442084218421042008100810300cc003800180018001" IconID="256" Latency="10000" MaxDatasheet="8192" MaxRate="5Hz" Model="PS-2204" Warmup="1000">
        <Measurement ID="0" NameTag="RawDisplacement" Type="RawDigital" DataSize="4" Accuracy="1" Display="Digits" Internal="1" Maximum="15000" Minimum="-15000" Precision="0" TypicalMax="5000" TypicalMin="-5000"/>
        <Measurement ID="1" NameTag="Displacement" UnitType="mil" Type="LinearConv" Inputs="0" Params="0.5,0" Accuracy="1" DefaultUnit="mm" Display="Digits" Internal="0" Maximum="600" MeasType="Position" Minimum="-600" Precision="1" ShortNameTag="Displ" SymbolTag="deltaUx" TypicalMax="60" TypicalMin="-60" Visible="1" IsDefaultMeas="1"/>
        <Measurement ID="2" NameTag="Displacement" UnitType="mm" Type="LinearConv" Inputs="1" Params="0.02539,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="12" MeasType="Position" Minimum="-12" Precision="2" ShortNameTag="Displ" SymbolTag="deltaUx" TypicalMax="5" TypicalMin="-5" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="257" Tag="SoilMoistureSensor" Version="2.8" Class="0" DefaultRate="10Hz" FileName="Soil_Moisture.sds" FloatParams="0" Icon="000028380820a83ba80aa83b00001e121212121ed2125212de128000c0000000" IconID="257" Latency="100" MaxDatasheet="8192" MaxRate="10Hz" Model="PS-2163" Warmup="1">
        <Measurement ID="0" NameTag="PercentVWCPottingSoil" UnitType="percent" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" Maximum="50" MeasType="PercentVWC" ShortNameTag="PctVWCPottingSoil" SymbolTag="thetaL" Minimum="0" Precision="1" TypicalMax="30" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="1" NameTag="PercentVWCMineralSoil" UnitType="percent" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" Maximum="50" MeasType="PercentVWC" ShortNameTag="PctVWCMineralSoil" SymbolTag="thetaL" Minimum="0" Precision="1" TypicalMax="30" TypicalMin="0" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="PercentVWCRockwool" UnitType="percent" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" Maximum="75" MeasType="PercentVWC" ShortNameTag="PctVWCRockwool" SymbolTag="thetaL" Minimum="0" Precision="1" TypicalMax="30" TypicalMin="0" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="WaterPotential" UnitType="kPa" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" Maximum="0" MeasType="WaterPotential" Minimum="-600" Precision="1" ShortNameTag="WaterPot" SymbolTag="WP" TypicalMax="0" TypicalMin="-100" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="SensorVoltageOut" UnitType="mV" Type="Direct" DataSize="4" Accuracy="1" Display="None" Internal="0" Maximum="2500" MeasType="Voltage" Minimum="0" Precision="0" ShortNameTag="VoltsOut" SymbolTag="V" TypicalMax="2500" TypicalMin="0" Visible="1"/>
        <SupportedCmd ID="64" Size="1"/>
      </Sensor>
      <Sensor ID="258" Tag="DualLoadCellAmplifier" Version="2.6" Class="0" DefaultRate="20Hz" FileName="Dual Load Cell Amp.sds" FloatParams="0" Icon="00000e000e381f380e380438067c3838c011800e4031ee030200ae004800ae00" IconID="258" Latency="45000" ListNameTag="LoadCellAmplifierDual" MaxDatasheet="8192" MaxRate="1000Hz" Model="PS-2205" Warmup="20">
        <Measurement ID="0" NameTag="RawForce1" UnitType="N" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="1" Maximum="10" Minimum="-10" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="1" NameTag="RawForce2" UnitType="N" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="1" Maximum="10" Minimum="-10" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="2" NameTag="ForceOrd" UnitType="N" Type="UserCal" Inputs="0" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="1" CanChangeSign="1" Display="Digits" Internal="0" Maximum="100" MeasType="Force" Minimum="-100" Ordinal="1" Precision="1" SymbolTag="FOrd" TypicalMax="10" TypicalMin="-10" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="3" NameTag="ForceOrd" UnitType="N" Type="UserCal" Inputs="1" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="1" CanChangeSign="1" Display="Digits" Internal="0" Maximum="100" MeasType="Force" Minimum="-100" Ordinal="2" Precision="1" SymbolTag="FOrd" TypicalMax="10" TypicalMin="-10" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="ForceOrd" UnitType="lbs" Type="LinearConv" Inputs="2" Params="0.22481,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="225" MeasType="Force" Minimum="-225" Ordinal="1" Precision="1" SymbolTag="FOrd" TypicalMax="5" TypicalMin="-5" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="ForceOrd" UnitType="lbs" Type="LinearConv" Inputs="3" Params="0.22481,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="225" MeasType="Force" Minimum="-225" Ordinal="2" Precision="1" SymbolTag="FOrd" TypicalMax="5" TypicalMin="-5" XplorerDisplay="1"/>
        <SupportedCmd ID="64" Size="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="259" Tag="BloodPressureSensor" Version="2.10" Class="0" DefaultRate="10Hz" FileName="Blood Pressure.sds" FloatParams="0" Icon="001e7712553377335433543f742100210021701e880c140d2407040188007000" IconID="259" Latency="100" MaxDatasheet="8192" MaxRate="100Hz" Model="PS-2207" Warmup="1">
        <Measurement ID="0" NameTag="uncalPressure" Type="Direct" DataSize="4" Accuracy="1" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="0" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="1" NameTag="CuffPressure" UnitType="psi" Type="FactoryCal" Inputs="0" Params="538.66669,0,6177.0835,2.8" Accuracy="1" DefaultUnit="mmHg" Display="Digits" Internal="0" Maximum="7.5" MeasType="Pressure" Minimum="0" Precision="2" ShortNameTag="CuffPress" SymbolTag="pressureBlood" TypicalMax="7.5" TypicalMin="0" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="CuffPressure" UnitType="Nm2" Type="LinearConv" Inputs="1" Params="6894.8,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="32000" MeasType="Pressure" Minimum="0" Precision="1" ShortNameTag="CuffPress" SymbolTag="pressureBlood" TypicalMax="32000" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="CuffPressure" UnitType="kPa" Type="LinearConv" Inputs="1" Params="6.89479,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="52" MeasType="Pressure" Minimum="0" Precision="2" ShortNameTag="CuffPress" SymbolTag="pressureBlood" TypicalMax="52" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="CuffPressure" UnitType="atm" Type="LinearConv" Inputs="3" Params="0.00986,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="0.5" MeasType="Pressure" Minimum="0" Precision="2" ShortNameTag="CuffPress" SymbolTag="pressureBlood" TypicalMax="0.5" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="CuffPressure" UnitType="mmHg" Type="LinearConv" Inputs="3" Params="7.501,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="520" MeasType="Pressure" Minimum="0" Precision="0" ShortNameTag="CuffPress" SymbolTag="pressureBlood" TypicalMax="210" TypicalMin="0" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="6" NameTag="PulseRate" UnitType="BeatsPerMin" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" Maximum="200" MeasType="HeartRate" Minimum="0" Precision="0" ShortNameTag="Pulse" SymbolTag="bloodPressRate" TypicalMax="120" TypicalMin="40" Visible="1" VisibleSds="1"/>
        <Measurement ID="7" NameTag="SystolicPressure" UnitType="mmHg" Type="Direct" DataSize="4" Accuracy="1" DefaultUnit="mmHg" Display="Digits" Internal="0" Maximum="200" MeasType="Pressure" Minimum="0" Precision="0" ShortNameTag="SystolicPress" SymbolTag="pressureBlood" TypicalMax="200" TypicalMin="50" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <Measurement ID="8" NameTag="DiastolicPressure" UnitType="mmHg" Type="Direct" DataSize="4" Accuracy="1" DefaultUnit="mmHg" Display="Digits" Internal="0" Maximum="200" MeasType="Pressure" Minimum="0" Precision="0" ShortNameTag="DiastolicPress" SymbolTag="pressureBlood" TypicalMax="200" TypicalMin="50" Visible="1" VisibleSds="1"/>
        <SupportedCmd ID="64" Size="2"/>
      </Sensor>
      <Sensor ID="260" Tag="LightLevelSensor" Version="2.37" Class="0" DefaultRate="20Hz" FileName="Lux_Light.sds" FloatParams="0" Icon="000104010820c0132004558a528a528ad5eb2004200440024002c00340028001" IconID="260" Latency="100" MaxDatasheet="8192" MaxRate="250Hz" Model="PS-2177" Warmup="1">
        <Measurement ID="0" NameTag="LightLevel" Type="Direct" DataSize="4" Accuracy="2" Display="Digits" Internal="1" Maximum="30000" Minimum="0" Precision="2" TypicalMax="300" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="LightLevel" UnitType="lux" Type="LinearConv" Inputs="0" Params="8,0" Accuracy="1" Display="Digits" Internal="0" Maximum="32000" MeasType="LightIntensity" Minimum="0" Precision="0" ShortNameTag="Level" SymbolTag="IntensityLight" TypicalMax="5000" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="261" Tag="DualHumidityTempDewPoint" Version="2.5" Class="0" DefaultRate="1Hz" FileName="Remote Humidity Temperature.sds" FloatParams="0" Icon="04000a003a000a223a540a283a140a2a0a4411000e00000084104a2931c60000" IconID="261" Latency="100" ListNameTag="HumidityTempDewPointDual" MaxDatasheet="8192" MaxRate="2Hz" Model="PS-2156" Warmup="500">
        <Measurement ID="0" NameTag="TemperatureOrd" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="0.5" Display="Digits" Internal="0" Maximum="55" MeasType="Temperature" Minimum="-20" Ordinal="1" Precision="1" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="30" TypicalMin="15" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="TemperatureOrd" UnitType="DegF" Type="LinearConv" Inputs="0" Params="1.8,32" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="131" MeasType="Temperature" Minimum="-4" Ordinal="1" Precision="1" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="104" TypicalMin="5" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="RelativeHumidityOrd" UnitType="percent" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" Maximum="100" MeasType="Humidity" Minimum="0" Ordinal="1" Precision="0" ShortNameTag="RelHumOrd" SymbolTag="RHOrd" TypicalMax="85" TypicalMin="15" Visible="1" VisibleSds="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="3" NameTag="DewPointOrd" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="2" Display="Digits" Internal="0" Maximum="55" MeasType="DewPoint" Minimum="-50" Ordinal="1" Precision="1" ShortNameTag="DewPtOrd" SymbolTag="TDOrd" TypicalMax="35" TypicalMin="-10" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="DewPointOrd" UnitType="DegF" Type="LinearConv" Inputs="3" Params="1.8,32" Accuracy="4" Display="Digits" Internal="0" InternalUnit="1" Maximum="125" MeasType="DewPoint" Minimum="-58" Ordinal="1" Precision="1" ShortNameTag="DewPtOrd" SymbolTag="TDOrd" TypicalMax="95" TypicalMin="-30" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="AbsoluteHumidityOrd" UnitType="gpm3" Type="Direct" DataSize="4" Accuracy="0.1" Display="Digits" Internal="0" Maximum="100" MeasType="AbsoluteHumidity" Minimum="0" Ordinal="1" Precision="1" ShortNameTag="AbsHumOrd" SymbolTag="HOrd" TypicalMax="20" TypicalMin="5" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="6" NameTag="TemperatureOrd" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="0.5" Display="Digits" Internal="0" Maximum="55" MeasType="Temperature" Minimum="-20" Ordinal="2" Precision="1" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="30" TypicalMin="15" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="7" NameTag="TemperatureOrd" UnitType="DegF" Type="LinearConv" Inputs="6" Params="1.8,32" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="131" MeasType="Temperature" Minimum="-4" Ordinal="2" Precision="1" ShortNameTag="TempOrd" SymbolTag="TOrd" TypicalMax="104" TypicalMin="5" XplorerDisplay="1"/>
        <Measurement ID="8" NameTag="RelativeHumidityOrd" UnitType="percent" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" Maximum="100" MeasType="Humidity" Minimum="0" Ordinal="2" Precision="0" ShortNameTag="RelHumOrd" SymbolTag="RHOrd" TypicalMax="85" TypicalMin="15" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="9" NameTag="DewPointOrd" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="2" Display="Digits" Internal="0" Maximum="55" MeasType="DewPoint" Minimum="-50" Ordinal="2" Precision="1" ShortNameTag="DewPtOrd" SymbolTag="TDOrd" TypicalMax="35" TypicalMin="-10" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="10" NameTag="DewPointOrd" UnitType="DegF" Type="LinearConv" Inputs="9" Params="1.8,32" Accuracy="4" Display="Digits" Internal="0" InternalUnit="1" Maximum="125" MeasType="DewPoint" Minimum="-58" Ordinal="2" Precision="1" ShortNameTag="DewPtOrd" SymbolTag="TDOrd" TypicalMax="95" TypicalMin="-30" XplorerDisplay="1"/>
        <Measurement ID="11" NameTag="AbsoluteHumidityOrd" UnitType="gpm3" Type="Direct" DataSize="4" Accuracy="0.1" Display="Digits" Internal="0" Maximum="100" MeasType="AbsoluteHumidity" Minimum="0" Ordinal="2" Precision="1" ShortNameTag="AbsHumOrd" SymbolTag="HOrd" TypicalMax="20" TypicalMin="5" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <SupportedCmd ID="64" Size="1"/>
      </Sensor>
      <Sensor ID="262" Tag="GeneralFlowSensor" Version="2.7" Class="0" DefaultRate="10Hz" FileName="GeneralFlow.sds" FloatParams="0" Icon="00003c60c010082f3cf0082fc0103c6000000000fe2302f4f223120012000000" IconID="262" Latency="45000" MaxDatasheet="8192" MaxRate="100Hz" MinRate="1Hz" Model="PS-2222" SupportsZeroOnStart="1" Warmup="20" ZeroOnStart="0">
        <Measurement ID="0" NameTag="DirectADCValue" UnitType="Unitless" Type="Direct" DataSize="4" Accuracy="0.0004" Display="Digits" Internal="1" Maximum="14" Minimum="0" Precision="5" TypicalMax="14" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="PressureDifferential" UnitType="psi" Type="FactoryCal" Inputs="0" Params="1298.34,0,32507.5,5" Accuracy="0.001" Display="Digits" Internal="0" InternalUnit="1" Maximum="7.5" MeasType="Pressure" Minimum="0" OffsetZero="1" Precision="3" TypicalMax="7.5" TypicalMin="0" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="DirectDiffPress" UnitType="Unitless" Type="Direct" DataSize="4" Accuracy="0" Display="None" Internal="1" Maximum="50" Minimum="0" Precision="0" TypicalMax="50" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="PressureDifferential" UnitType="Pa" Type="LinearConv" Inputs="2" Params="2,0" Accuracy="1" Display="Digits" Internal="0" Maximum="10" MeasType="Pressure" Minimum="-10" OffsetZero="1" Precision="2" ShortNameTag="DiffPress" SymbolTag="deltaUP" TypicalMax="1" TypicalMin="-1" Visible="1" VisibleSds="1"/>
        <Measurement ID="4" NameTag="PitotAir" UnitType="mps" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="120" MeasType="Velocity" Minimum="0" Precision="1" TypicalMax="120" TypicalMin="0" Visible="1" VisibleSds="1"/>
        <Measurement ID="5" NameTag="VenturiAir" UnitType="m3ps" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="10" MeasType="VolumeFlowRate" Minimum="0" Precision="6" TypicalMax="10" TypicalMin="0" Visible="1"/>
        <Measurement ID="6" NameTag="PitotWater" UnitType="mps" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="1" MeasType="Velocity" Minimum="0" Precision="3" TypicalMax="1" TypicalMin="0" Visible="1" />
        <Measurement ID="7" NameTag="VenturiWater" UnitType="m3ps" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="10" MeasType="VolumeFlowRate" Minimum="0" Precision="6" TypicalMax="10" TypicalMin="0" Visible="1" VisibleSds="1"/>
        <Measurement ID="8" NameTag="PressureDifferential" UnitType="inH2O" Type="LinearConv" Inputs="3" Params="0.004,0" Accuracy="0.00098" Display="Graph" Internal="0" InternalUnit="1" Maximum="7.5" MeasType="Pressure" Minimum="0" Precision="5" TypicalMax="7.5" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="9" NameTag="PitotAir" UnitType="fps" Type="LinearConv" Inputs="4" Params="3.28084,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="120" MeasType="Velocity" Minimum="0" Precision="1" TypicalMax="120" TypicalMin="0"/>
        <Measurement ID="10" NameTag="PitotWater" UnitType="fps" Type="LinearConv" Inputs="6" Params="3.28084,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="1" MeasType="Velocity" Minimum="0" Precision="3" TypicalMax="1" TypicalMin="0"/>
        <Measurement ID="11" NameTag="VenturiAir" UnitType="galps" Type="LinearConv" Inputs="5" Params="264.17,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="10" MeasType="VolumeFlowRate" Minimum="0" Precision="6" TypicalMax="10" TypicalMin="0"/>
        <Measurement ID="12" NameTag="VenturiWater" UnitType="galps" Type="LinearConv" Inputs="7" Params="264.17,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="10" MeasType="VolumeFlowRate" Minimum="0" Precision="6" TypicalMax="10" TypicalMin="0"/>
        <Measurement ID="20" NameTag="PitotSpeed" UnitType="mps" Equation="sqrt(2*limit([3],0,1000000)/[102])" Accuracy="1" Maximum="10" MeasType="Speed" Minimum="0" TypicalMax="1" TypicalMin="0" Precision="3" SymbolTag="vp" Visible="1"/>
        <Measurement ID="21" NameTag="VenturiVolumetricFlowRate" UnitType="m3ps" Equation="(([100]/10000)/[103])*sqrt((2*limit([3],0,1000000))/([102]*((([100]/[101])^2)-1)))" Accuracy="1" Maximum="10" MeasType="VolumeFlowRate" Minimum="0" TypicalMax="1" TypicalMin="0" Precision="6" ShortNameTag="VolFlow" SymbolTag="flowRateVolume" Visible="1" IsDefaultMeas="1"/>
        <Measurement ID="100" NameTag="PipeArea" UnitType="cm2" Type="Constant" Description="DescPipeArea" Internal="1" MeasType="Area" Value="3.44"/>
        <Measurement ID="101" NameTag="ThroatArea" UnitType="cm2" Type="Constant" Description="DescThroatArea" Internal="1" MeasType="Area" Value="1.24"/>
        <Measurement ID="102" NameTag="Density" UnitType="kgpm3" Type="Constant" Description="DescFluidDensity" HasCustom="1" Internal="1" MeasType="Density" Value="1000" Values="Air:1.25:Water:1000:UserDefined:1.00"/>
        <Measurement ID="103" NameTag="ViscosityFactor" UnitType="Unitless" Type="Constant" Description="DescViscosityFactor" Internal="1" MeasType="None" Value="0.94"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="263" Tag="MaterialsTestingSystem" Version="2.5" Class="0" DefaultRate="5Hz" FileName="Material Test System.sds" FloatParams="0" Icon="00008000c001e00380008000c001c001c001c00180008000e003c00180000000" IconID="263" Latency="100" MaxDatasheet="8192" MaxRate="500Hz" MinRate="1Hz" Model="ME-8230" SupportsTareCmd="1" SupportsZeroOnStart="1" Warmup="1" ZeroOnRead="1" ZeroOnStart="1">
        <Measurement ID="0" NameTag="RawCountChange" UnitType="Unitless" Type="RawDigital" DataSize="4" Accuracy="1" Display="None" Internal="1" Maximum="32000" Minimum="-32000" Name="Raw Count Change" Precision="0" TypicalMax="100" TypicalMin="-100" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="Position" UnitType="m" Type="RotaryPos" UserCalType="Polynomial:4" Inputs="0" Params="0.00254,4000" Accuracy="0.00098" CanChangeSign="1" Display="Graph" Maximum="0.38" MeasType="Position" Minimum="0" Name="Linear Position" Precision="5" ShortNameTag="pos" SymbolTag="x" TypicalMax="0.01" TypicalMin="-0.01" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="Position" UnitType="in" Type="LinearConv" Inputs="1" Params="39.3701,0" Accuracy="0.001" Display="Graph" InternalUnit="1" Maximum="1" MeasType="Position" Minimum="-1" Name="Linear Position" Precision="3" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="RawForce" UnitType="Unitless" Type="Direct" DataSize="4" Accuracy="1" Display="None" Internal="1" Maximum="10" Minimum="-10" Name="Raw Force" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="4" NameTag="Force" UnitType="N" Type="UserCal" Inputs="3" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="1" CanChangeSign="1" Display="Graph" Maximum="1000" MeasType="Force" Minimum="-1000" Name="Force" OffsetZero="1" Precision="0" TypicalMax="1000" TypicalMin="-1000" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="5" NameTag="Force" UnitType="lbs" Type="LinearConv" Inputs="4" Params="0.22481,0" Accuracy="1" Display="None" InternalUnit="1" Maximum="7100" MeasType="Force" Minimum="-7100" Name="Force" Precision="1" TypicalMax="1000" TypicalMin="-1000" XplorerDisplay="1"/>
        <Measurement ID="6" NameTag="CycleCount" UnitType="Unitless" Type="Direct" DataSize="4" Accuracy="1" Display="None" Internal="1" Maximum="10" MeasType="Count" Minimum="-10" Name="Cycle count" Precision="2" TypicalMax="10" TypicalMin="-10"  Visible="1"/>
        <Measurement ID="7" NameTag="Samples" UnitType="Unitless" Type="Direct" DataSize="4" Accuracy="1" Display="None" Internal="1" Maximum="10" MeasType="Count" Minimum="-10" Precision="2" TypicalMax="10" TypicalMin="-10" Visible="1"/>
        <Measurement ID="8" NameTag="Speed" UnitType="mps" Type="Derivative" Inputs="1" Params="3" MeasType="Speed" DefaultUnit="mmpmin" ShortNameTag="speed" SymbolTag="speed" Visible="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="264" Tag="AdvancedChemistrySensor" Version="2.6" Class="0" DefaultRate="1Hz" FileName="AdvancedChemistry.sds" FloatParams="0" Icon="00200a50ca58ae50ca588a50005884704a013510081010383e10047c087c1000" IconID="232" Latency="100" MaxDatasheet="8192" MaxRate="100Hz" Model="PS-2172" Warmup="1">
        <Measurement ID="0" NameTag="RawPressureADC" UnitType="Unitless" Type="Direct" DataSize="4" Accuracy="1" Internal="1" Maximum="10" Minimum="-10" Precision="0" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="1" NameTag="RawISEVoltage" UnitType="Unitless" Type="Direct" DataSize="4" Accuracy="1" Internal="1" Maximum="10" Minimum="-10" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="2" NameTag="RawUncalConductivity" UnitType="Unitless" Type="Direct" DataSize="4" Accuracy="1" Internal="1" Maximum="10" Minimum="-10" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="3" NameTag="RawTemperature" UnitType="Unitless" Type="Direct" DataSize="4" Accuracy="1" Internal="1" Maximum="10" Minimum="-10" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="4" NameTag="Temperature" UnitType="DegC" Type="UserCal" Inputs="3" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="1" Display="Digits" Maximum="135" MeasType="Temperature" Minimum="-35" Precision="2" ShortNameTag="Temp" SymbolTag="T" TypicalMax="30" TypicalMin="15" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Pressure" UnitType="kPa" Type="LinearConv" Inputs="12" Params="6.895,0" Accuracy="2" Display="Digits" InternalUnit="1" Maximum="200" MeasType="Pressure" Minimum="0" Precision="1" TypicalMax="120" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="6" NameTag="pH" UnitType="Unitless" Type="UserCal" Inputs="8" Params="177,4,0,7" CalFlags="1,1,1,1" Accuracy="0.1" Display="Digits" Maximum="14" MeasType="pH" Minimum="0" Precision="2" SymbolTag="pH" TypicalMax="10" TypicalMin="4" Visible="1" VisibleSds="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="7" NameTag="Conductivity10XProbe" UnitType="uSpcm" Type="UserCal" Inputs="2" Params="-1000,-10000,1000,10000" CalFlags="0,1,0,1" Accuracy="4" Display="Digits" Maximum="32000" MeasType="Conductivity" Minimum="0" Precision="0" ShortNameTag="Conduct10X" SymbolTag="sigmaL10X" TypicalMax="1000" TypicalMin="50" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="8" NameTag="ISEVoltage" UnitType="mV" Type="FactoryCal" Inputs="1" Params="50.126,0,1594.03,1593" Accuracy="4" DefaultUnit="mV" Maximum="2000" MeasType="Voltage" Minimum="-2000" Precision="1" ShortNameTag="ISE" SymbolTag="V" TypicalMax="1000" TypicalMin="-1000" Visible="1"/>
        <Measurement ID="9" NameTag="Conductivity1XProbe" UnitType="uSpcm" Type="UserCal" Inputs="2" Params="-1000,-1000,1000,1000" CalFlags="0,1,0,1" Accuracy="1" Display="Digits" Maximum="10" MeasType="Conductivity" Minimum="-10" Precision="0" ShortNameTag="Conduct1X" SymbolTag="sigmaL1X" TypicalMax="1000" TypicalMin="50" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="10" NameTag="Temperature" UnitType="DegF" Type="LinearConv" Inputs="4" Params="1.8,32" Accuracy="1" InternalUnit="1" Maximum="275" MeasType="Temperature" Minimum="-31" Precision="2" TypicalMax="86" TypicalMin="65" XplorerDisplay="1"/>
        <Measurement ID="11" NameTag="Temperature" UnitType="K" Type="LinearConv" Inputs="4" Params="1,273.15" Accuracy="1" InternalUnit="1" Maximum="410" MeasType="Temperature" Minimum="238" Precision="2" TypicalMax="305" TypicalMin="290" XplorerDisplay="1"/>
        <Measurement ID="12" NameTag="AbsolutePressure" UnitType="psi" Type="FactoryCal" Inputs="0" Params="6969.12,14.73,25238.5,64.73" Accuracy="2" Display="Digits" Maximum="20" MeasType="Pressure" Minimum="0" Precision="1" ShortNameTag="AbsPress" SymbolTag="pressure" TypicalMax="20" TypicalMin="0" Visible="1" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="266" Tag="SmartGate" Version="2.0" DefaultRate="500Hz" IconID="266" MaxDatasheet="2" MaxRate="1000Hz" MinRate="1Hz" Model="PS-2180" SendResetCmd="1">
        <Measurement ID="0" NameTag="Data" UnitType="Unitless" Type="RawDigital" DataSize="4" Accuracy="1" Internal="1" Maximum="1" Minimum="0" Precision="0"/>
        <SupportedCmd ID="64" Size="1"/>
      </Sensor>
      <Sensor ID="267" Tag="AdvancedWaterQualitySensor" Version="2.0" Class="0" DefaultRate="2Hz" FileName="Advanced Water Quality.sds" FloatParams="0" Icon="00200a50ca58ae50ca588a50008884704a2935c7080710073e30043008001040" IconID="231" Latency="45000" MaxDatasheet="8192" MaxRate="2Hz" Model="PS-2230" Warmup="1000" ZeroOnRead="1">
        <Measurement ID="0" NameTag="DO2Concentration" UnitType="mgpL" Type="Direct" DataSize="4" Accuracy="0" Display="Digits" Maximum="50" MeasType="Concentration" Minimum="0" Precision="2" TypicalMax="14" TypicalMin="4" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <Measurement ID="1" NameTag="DO2Saturation" UnitType="percent" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Maximum="300" MeasType="Saturation" Minimum="0" Precision="0" TypicalMax="100" TypicalMin="75" UserCalType="Ysi" Visible="1" VisibleSds="1"/>
        <Measurement ID="2" NameTag="O2GasConcentration" UnitType="percent" Type="LinearConv" Inputs="1" Params="0.209,0" Accuracy="1" Maximum="100" Minimum="0" Precision="2" TypicalMax="100" TypicalMin="75" Visible="1" VisibleSds="1"/>
        <Measurement ID="3" NameTag="SolutionTemperature" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Maximum="50" MeasType="Temperature" Minimum="0" Precision="1" TypicalMax="30" TypicalMin="15" Visible="1" VisibleSds="1"/>
        <Measurement ID="4" NameTag="AmbientPressure" UnitType="mmHg" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Maximum="825" MeasType="Pressure" Minimum="325" Precision="1" TypicalMax="800" TypicalMin="700" Visible="1" VisibleSds="1"/>
        <Measurement ID="5" NameTag="SalinityConstant" UnitType="ppt" Type="Direct" DataSize="4" Accuracy="1" Display="Digits" Maximum="50" MeasType="Salinity" Minimum="0" Precision="1" TypicalMax="30" TypicalMin="15" Visible="1" VisibleSds="1"/>
        <Measurement ID="6" NameTag="Raw_Temperature" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="1" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="7" NameTag="TemperatureAux" UnitType="DegC" Type="UserCal" Inputs="6" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="1" Display="Digits" Internal="0" Maximum="135" MeasType="Temperature" Minimum="-35" Precision="2" ShortNameTag="Temp" SymbolTag="T" TypicalMax="30" TypicalMin="15" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="8" NameTag="TemperatureAux" UnitType="DegF" Type="LinearConv" Inputs="7" Params="1.8,32" Accuracy="1" Display="None" Internal="0" InternalUnit="1" Maximum="275" MeasType="Temperature" Minimum="-31" Precision="2" ShortNameTag="Temp" SymbolTag="T" TypicalMax="86" TypicalMin="65" XplorerDisplay="1"/>
        <Measurement ID="9" NameTag="TemperatureAux" UnitType="K" Type="LinearConv" Inputs="7" Params="1,273.15" Accuracy="1" Display="None" Internal="0" InternalUnit="1" Maximum="410" MeasType="Temperature" Minimum="238" Precision="2" ShortNameTag="Temp" SymbolTag="T" TypicalMax="305" TypicalMin="290" XplorerDisplay="1"/>
        <Measurement ID="10" NameTag="RawISEVoltage" Type="Direct" DataSize="4" Accuracy="1" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="11" NameTag="ISEVoltage" UnitType="mV" Type="FactoryCal" Inputs="10" Params="-1000,-1000,1000,1000" Accuracy="4" DefaultUnit="mV" Display="None" Internal="0" Maximum="2000" MeasType="Voltage" Minimum="-2000" Precision="1" ShortNameTag="ISE" SymbolTag="V" TypicalMax="1000" TypicalMin="-1000" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="12" NameTag="pH" UnitType="Unitless" Type="UserCal" Inputs="11" Params="177,4,0,7" CalFlags="1,1,1,1" Accuracy="0.1" Display="Digits" Internal="0" Maximum="14" MeasType="pH" Minimum="0" Precision="2" SymbolTag="pH" TypicalMax="10" TypicalMin="4" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="13" NameTag="RawUncalConductivity" Type="Direct" DataSize="4" Accuracy="1" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="2" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="14" NameTag="Conductivity1XProbe" UnitType="uSpcm" Type="UserCal" Inputs="13" Params="-1000,-1000,1000,1000" CalFlags="0,1,0,1" Accuracy="1" Display="Digits" Internal="0" Maximum="10" MeasType="Conductivity" Minimum="-10" Precision="0" ShortNameTag="Conduct1X" SymbolTag="sigmaL1X" TypicalMax="1000" TypicalMin="50" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="15" NameTag="Conductivity10XProbe" UnitType="uSpcm" Type="UserCal" Inputs="13" Params="-1000,-10000,1000,10000" CalFlags="0,1,0,1" Accuracy="4" Display="Digits" Internal="0" Maximum="32000" MeasType="Conductivity" Minimum="0" Precision="0" ShortNameTag="Conduct10X" SymbolTag="sigmaL10X" TypicalMax="1000" TypicalMin="50" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="100" NameTag="Salinity" UnitType="ppt" Type="Constant" Description="DescSalinityConstant" Internal="1" MeasType="Salinity" UserCalType="Constant" Value="0"/>
        <SupportedCmd ID="64" Size="1"/>
      </Sensor>
      <Sensor ID="268" Tag="AccelerationAltimeterPS2136A" Version="2.8" Class="0" DefaultRate="20Hz" FileName="Accel-Alt.sds" FloatParams="0" Icon="002980130211080100012001000140010201ffe1024000e40500021005400060" IconID="208" Latency="500" MaxDatasheet="8192" MaxRate="500Hz" Model="PS-2136A" SupportsZeroOnStart="1" Warmup="1000">
        <Measurement ID="0" NameTag="X" Type="RawDigital" DataSize="2" Accuracy="4" Display="Digits" Internal="1" Maximum="7400" Minimum="800" Precision="0" ShortNameTag="counts" TypicalMax="7400" TypicalMin="800"/>
        <Measurement ID="1" NameTag="Accelerationx" UnitType="grav" Type="FactoryCal" Inputs="0" Params="4060,0,4390,1" Accuracy="0.1" Display="Graph" Internal="0" Maximum="5" MeasType="Acceleration" Minimum="-5" OffsetZero="1" Precision="1" ShortNameTag="accx" SymbolTag="ax" TypicalMax="1" TypicalMin="-1" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="Accelerationx" UnitType="ms2" Type="LinearConv" Inputs="1" Params="9.80663,0" Accuracy="1" Display="Graph" Internal="0" InternalUnit="1" Maximum="50" MeasType="Acceleration" Minimum="-50" Precision="1" ShortNameTag="accx" SymbolTag="ax" TypicalMax="50" TypicalMin="-50" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="Y" Type="RawDigital" DataSize="2" Accuracy="4" Display="Digits" Internal="1" Maximum="7400" Minimum="800" Precision="0" TypicalMax="7400" TypicalMin="800"/>
        <Measurement ID="4" NameTag="Accelerationy" UnitType="grav" Type="FactoryCal" Inputs="3" Params="3865,0,3543,1" Accuracy="0.1" Display="Graph" Internal="0" Maximum="5" MeasType="Acceleration" Minimum="-5" OffsetZero="1" Precision="1" ShortNameTag="accy" SymbolTag="ay" TypicalMax="1" TypicalMin="-1" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Accelerationy" UnitType="ms2" Type="LinearConv" Inputs="4" Params="9.80663,0" Accuracy="1" Display="Graph" Internal="0" InternalUnit="1" Maximum="50" MeasType="Acceleration" Minimum="-50" Precision="1" ShortNameTag="accy" SymbolTag="ay" TypicalMax="50" TypicalMin="-50" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="6" NameTag="Z" Type="RawDigital" DataSize="2" Accuracy="4" Display="Digits" Internal="1" Maximum="7400" Minimum="800" Precision="0" ShortNameTag="counts" TypicalMax="7400" TypicalMin="800"/>
        <Measurement ID="7" NameTag="Accelerationz" UnitType="grav" Type="FactoryCal" Inputs="6" Params="4196,0,4529,1" Accuracy="0.1" Display="Graph" Internal="0" Maximum="5" MeasType="Acceleration" Minimum="-5" OffsetZero="1" Precision="1" ShortNameTag="accz" SymbolTag="az" TypicalMax="1" TypicalMin="-1" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="8" NameTag="Accelerationz" UnitType="ms2" Type="LinearConv" Inputs="7" Params="9.80663,0" Accuracy="1" Display="Graph" Internal="0" InternalUnit="1" Maximum="50" MeasType="Acceleration" Minimum="-50" Precision="1" ShortNameTag="accz" SymbolTag="az" TypicalMax="50" TypicalMin="-50" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="9" NameTag="AccelerationResultant" UnitType="grav" Type="ThreeInputVector" Inputs="1,4,7" Accuracy="0.1" Display="Graph" Internal="0" Maximum="5" MeasType="Acceleration" Minimum="0" Precision="1" ShortNameTag="accresult" SymbolTag="a" TypicalMax="1" TypicalMin="0" Visible="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="10" NameTag="AccelerationResultant" UnitType="ms2" Type="ThreeInputVector" Inputs="2,5,8" Accuracy="1" Display="Graph" Internal="0" InternalUnit="1" Maximum="50" MeasType="Acceleration" Minimum="0" Precision="1" ShortNameTag="accresult" SymbolTag="a" TypicalMax="50" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="12" NameTag="Altitude" UnitType="m" Type="Direct" DataSize="4" Accuracy="1" Display="Graph" Internal="0" Maximum="300" MeasType="Altitude" Minimum="0" OffsetZero="1" Precision="1" ShortNameTag="Alt" SymbolTag="h" TypicalMax="30" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
        <Measurement ID="13" NameTag="Altitude" UnitType="ft" Type="LinearConv" Inputs="12" Params="3.281,0" Accuracy="1" Display="Graph" Internal="0" InternalUnit="1" Maximum="1000" MeasType="Altitude" Minimum="0" Precision="0" ShortNameTag="Alt" SymbolTag="h" TypicalMax="250" TypicalMin="0" XplorerDisplay="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="1128" Tag="PhotogatePort" Version="2.1" Class="0" DefaultRate="200Hz" FileName="PhotogatePort.sds" FloatParams="0" Icon="0000fc3ffc3f0c300c300c300c300c301c381c380000300c48124812300c0000" IconID="1129" Latency="50" MaxDatasheet="8192" MaxRate="1000Hz" MinRate="10Hz" Model="PS-2123" SendResetCmd="1" Warmup="150">
        <Measurement ID="0" NameTag="Time" Type="RawDigital" DataSize="4" Accuracy="1" Display="None" Internal="1" Maximum="32000" Minimum="0" Precision="0" TypicalMax="32000" TypicalMin="0"/>
        <Measurement ID="1" NameTag="DigitalStates" Type="RawDigital" DataSize="1" Accuracy="1" Display="None" Internal="1" Maximum="255" Minimum="0" Precision="0" TypicalMax="255" TypicalMin="0"/>
        <Measurement ID="2" NameTag="Channel1Count" Type="RawDigital" DataSize="1" Accuracy="1" Display="None" Internal="1" Maximum="255" Minimum="0" Precision="0" TypicalMax="50" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="Channel2Count" Type="RawDigital" DataSize="1" Accuracy="1" Display="None" Internal="1" Maximum="255" Minimum="0" Precision="0" TypicalMax="50" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="TimeInGate" UnitType="s" Type="LinearConv" Inputs="0" Params="1,0" Accuracy="0" Display="None" Internal="0" Maximum="60" MeasType="Time" ShortNameTag="TimeInGate_SN"  Minimum="0" Precision="6" TypicalMax="1" TypicalMin="0" Visible="0" XplorerDefault="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="5" NameTag="TimeBetweenGates" UnitType="s" Type="LinearConv" Inputs="0" Params="1,0" Accuracy="0" Display="None" Internal="0" Maximum="60" MeasType="Time" Minimum="0" Precision="6" ShortNameTag="TimeBetweenGates_SN" TypicalMax="1" TypicalMin="0" Visible="0" XplorerDisplay="1"/>
        <Measurement ID="6" NameTag="Count" UnitType="Unitless" Type="TwoInputCombo" Inputs="2,3" Params="0,1,1,0" Accuracy="1" Display="None" Internal="0" Maximum="32000" MeasType="Count" ShortNameTag="Count" SymbolTag="Count" Minimum="0" Precision="0" TypicalMax="300" TypicalMin="0" Visible="0" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="1129" Tag="DigitalAdapter" Version="2.2" Class="0" DefaultRate="200Hz" FileName="DigitalAdapter.sds" FloatParams="0" Icon="0000fc3ffc3f0c300c300c300c300c301c381c380000300c48124812300c0000" IconID="1129" Latency="50" MaxDatasheet="8192" MaxRate="1000Hz" MinRate="10Hz" Model="PS-2159" SendResetCmd="1" Warmup="150">
        <Measurement ID="0" NameTag="Time" Type="RawDigital" DataSize="4" Accuracy="1" Display="None" Internal="1" Maximum="32000" Minimum="0" Precision="0" TypicalMax="32000" TypicalMin="0"/>
        <Measurement ID="1" NameTag="DigitalStates" Type="RawDigital" DataSize="1" Accuracy="1" Display="None" Internal="1" Maximum="255" Minimum="0" Precision="0" TypicalMax="255" TypicalMin="0"/>
        <Measurement ID="2" NameTag="Channel1Count" Type="RawDigital" DataSize="1" Accuracy="1" Display="None" Internal="1" Maximum="255" Minimum="0" Precision="0" TypicalMax="50" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="Channel2Count" Type="RawDigital" DataSize="1" Accuracy="1" Display="None" Internal="1" Maximum="255" Minimum="0" Precision="0" TypicalMax="50" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="TimeInGate" UnitType="s" Type="LinearConv" Inputs="0" Params="1,0" Accuracy="0" Display="None" Internal="0" Maximum="60" MeasType="Time" ShortNameTag="TimeInGate_SN" Minimum="0" Precision="6" TypicalMax="1" TypicalMin="0" Visible="0" XplorerDefault="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="5" NameTag="TimeBetweenGates" UnitType="s" Type="LinearConv" Inputs="0" Params="1,0" Accuracy="0" Display="None" Internal="0" Maximum="60" MeasType="Time" Minimum="0" Precision="6" ShortNameTag="TimeBetweenGates_SN" TypicalMax="1" TypicalMin="0" Visible="0" XplorerDisplay="1"/>
        <Measurement ID="6" NameTag="Count" UnitType="Unitless" Type="TwoInputCombo" Inputs="2,3" Params="0,1,1,0" Accuracy="1" Display="None" Internal="0" Maximum="32000" MeasType="Count" ShortNameTag="Count" SymbolTag="Count" Minimum="0" Precision="0" TypicalMax="300" TypicalMin="0" Visible="0" XplorerDisplay="1"/>
        <SupportedCmd ID="64" Size="1"/>
      </Sensor>
      <Sensor ID="1130" Tag="MotionSensor" Version="2.3" Class="1" DefaultRate="20Hz" FileName="Motion.sds" FloatParams="0" Icon="000020007000700020087044f824fc257725704578087800cc008c010c030000" IconID="1130" Latency="100000" MaxDatasheet="2048" MaxRate="250Hz" Model="PS-2103A" SupportsZeroOnStart="1" Warmup="1">
        <Measurement ID="0" NameTag="EchoTime" UnitType="s" Type="RawDigital" DataSize="2" Accuracy="1" Display="Graph" Internal="1" Maximum="20000" Minimum="0" Precision="0" TypicalMax="10000" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="Position" UnitType="m" Type="USoundPos" Inputs="0" Params="344" Accuracy="0.001" CanChangeSign="1" Display="Graph" Internal="0" Maximum="8" MeasType="Position" Minimum="0.015" OffsetZero="1" Precision="2" ShortNameTag="pos" SymbolTag="x" TypicalMax="1" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="2" NameTag="Velocity" UnitType="mps" Type="Derivative" Inputs="1" Params="3" Accuracy="0.01" Display="Graph" Internal="0" Maximum="2" MeasType="Velocity" Minimum="-2" Precision="2" ShortNameTag="vel" SymbolTag="velocity" TypicalMax="0.5" TypicalMin="-0.5" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="Acceleration" UnitType="ms2" Type="Derivative" Inputs="2" Params="3" Accuracy="0.1" Display="Graph" Internal="0" Maximum="10" MeasType="Acceleration" Minimum="-10" Precision="2" ShortNameTag="acc" SymbolTag="a" TypicalMax="2" TypicalMin="-2" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="PingEchoTime" UnitType="s" Type="USoundPos" Inputs="0" Params="2" Accuracy="0.000001" Display="Graph" Internal="0" Maximum="0.05" MeasType="Time" Minimum="0.0001" Precision="6" SymbolTag="t" TypicalMax="0.01" TypicalMin="0.0001" Visible="0"/>
        <Measurement ID="100" NameTag="SpeedOfSound" UnitType="mps" Type="Constant" CIVarName="speedOfSound" Internal="1" MeasType="Velocity" Value="344" ConstType="SpeedOfSound"/>
      </Sensor>
      <Sensor ID="1131" Tag="RotaryMotionSensor" Version="2.3" Class="0" DefaultRate="20Hz" FileName="RotaryMotion.sds" FloatParams="0" Icon="0001c003000d0010c0213026104488e8c849884810043006c0011004fc1f1004" IconID="1131" Latency="100" MaxDatasheet="8192" MaxRate="1000Hz" Model="PS-2120" SupportsZeroOnStart="1" Warmup="1" ZeroOnRead="1" ZeroOnStart="1">
        <Measurement ID="0" NameTag="RawCountChange" Type="RawDigital" DataSize="4" Accuracy="1" CanChangeSign="1" Display="None" Internal="1" Maximum="32000" Minimum="-32000" Precision="0" ShortNameTag="CountChg" TypicalMax="100" TypicalMin="-100" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="Angle" UnitType="rad" Type="RotaryPos" Inputs="0" Params="6.28319,4000" Accuracy="0.002" Display="Graph" Internal="0" Maximum="6.5" MeasType="Angle" Minimum="-6.5" Precision="3" ShortNameTag="ang" SymbolTag="thetaL" TypicalMax="1.5" TypicalMin="-1.5" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="AngularVelocity" UnitType="radps" Type="Derivative" Inputs="1" Params="3" Accuracy="0.002" Display="Graph" Internal="0" Maximum="6.5" MeasType="AngularVelocity" Minimum="-6.5" Precision="3" ShortNameTag="angvel" SymbolTag="omegaL" TypicalMax="1" TypicalMin="-1" Visible="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="3" NameTag="AngularAcceleration" UnitType="radps2" Type="Derivative" Inputs="2" Params="3" Accuracy="0.002" Display="Graph" Internal="0" Maximum="6.5" MeasType="AngularAcceleration" Minimum="-6.5" Precision="3" ShortNameTag="angacc" SymbolTag="alphaL" TypicalMax="1" TypicalMin="-1" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Angle" UnitType="deg" Type="LinearConv" Inputs="1" Params="57.29578,0" Accuracy="0.1" Display="Graph" Internal="0" InternalUnit="1" Maximum="360" MeasType="Angle" Minimum="-360" Precision="1" ShortNameTag="ang" SymbolTag="thetaL" TypicalMax="180" TypicalMin="-180" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="AngularVelocity" UnitType="degps" Type="LinearConv" Inputs="2" Params="57.29578,0" Accuracy="0.1" Display="Graph" Internal="0" InternalUnit="1" Maximum="360" MeasType="AngularVelocity" Minimum="-360" Precision="1" ShortNameTag="angvel" SymbolTag="omegaL" TypicalMax="180" TypicalMin="-180" XplorerDisplay="1"/>
        <Measurement ID="6" NameTag="AngularAcceleration" UnitType="degps2" Type="LinearConv" Inputs="3" Params="57.29578,0" Accuracy="0.1" Display="Graph" Internal="0" InternalUnit="1" Maximum="360" MeasType="AngularAcceleration" Minimum="-360" Precision="1" ShortNameTag="angacc" SymbolTag="alphaL" TypicalMax="180" TypicalMin="-180" XplorerDisplay="1"/>
        <Measurement ID="7" NameTag="Position" UnitType="m" Type="RotaryPos" Inputs="0" Params="0.15,4000" Accuracy="0.001" Display="Graph" Internal="0" Maximum="1" MeasType="Position" Minimum="-1" Precision="4" ShortNameTag="pos" SymbolTag="x" TypicalMax="0.1" TypicalMin="-0.1" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="8" NameTag="Velocity" UnitType="mps" Type="Derivative" Inputs="7" Params="3" Accuracy="0.001" Display="Graph" Internal="0" Maximum="0.5" MeasType="Velocity" Minimum="-0.5" Precision="3" ShortNameTag="vel" SymbolTag="velocity" TypicalMax="0.1" TypicalMin="-0.1" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="9" NameTag="Acceleration" UnitType="ms2" Type="Derivative" Inputs="8" Params="3" Accuracy="0.001" Display="Graph" Internal="0" Maximum="0.2" MeasType="Acceleration" Minimum="-0.2" Precision="3" ShortNameTag="acc" SymbolTag="a" TypicalMax="0.05" TypicalMin="-0.05" Visible="1" XplorerDisplay="1"/>
      </Sensor>
      <!-- Sensor IDs 2000 - 2999 are for special purpose sensors -->
      <Sensor ID="2001" Tag="GLXSoundSensor" Version="2.2" Class="0" DefaultRate="5000Hz" FileName="GLXSound.sds" FloatParams="0" Icon="0000003000490049000670008c010202aa02010455050104aa0202028c017000" IconID="2001" Latency="40" MaxDatasheet="2048" MaxRate="50000Hz" Model="PS-2002" Warmup="1">
        <Measurement ID="0" NameTag="SoundWave" UnitType="Unitless" Type="RawDigital" DataSize="2" Accuracy="5" Display="Graph" Internal="0" Maximum="32767" MeasType="SoundIntensity" Minimum="-32767" Precision="0" TwosComp="1" TypicalMax="32767" TypicalMin="-32767" Visible="1" VisibleSds="1" XplorerDefault="1"/>
      </Sensor>
      <Sensor ID="2002" Tag="GLXVoltageSensor" Version="2.1" Class="0" DefaultRate="20Hz" FileName="GLXVoltage.sds" FloatParams="0" Icon="00100410887c9011a012cf04800800100000c001e003300630063006e003c001" IconID="135" Latency="15" MaxDatasheet="2048" MaxRate="25000Hz" Model="PS-2002" Warmup="1">
        <Measurement ID="0" NameTag="RawVoltage" Type="Direct" DataSize="4" Accuracy="1" Display="None" Internal="1" Maximum="16" Minimum="0" Precision="4" ShortNameTag="raw" TypicalMax="16" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="Voltage" UnitType="V" Type="LinearConv" Inputs="0" Params="1.25,-10" Accuracy="0.01" Display="Digits" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="2" ShortNameTag="Volt" SymbolTag="V" TypicalMax="1" TypicalMin="-1" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="CurrentProbe" UnitType="A" Type="LinearConv" Inputs="1" Params="10,0" Accuracy="1" Internal="0" Maximum="1" MeasType="Current" Minimum="-1" Precision="4" ShortNameTag="Curr" SymbolTag="current" TypicalMax="0.1" TypicalMin="-0.1" VisibleSds="1" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="2003" Tag="GLXSoundLevelSensor" Version="2.0" Class="0" DefaultRate="5Hz" FileName="GLXSoundLevel.sds" FloatParams="0" Icon="0001000100050015005570008c010202aa02010455050104aa0202028c017000" IconID="2003" Latency="40" MaxDatasheet="2048" MaxRate="5Hz" Model="PS-2002" Warmup="1">
        <Measurement ID="0" NameTag="adcGain" Type="RawDigital" DataSize="1" Accuracy="1" Display="None" Internal="1" Maximum="119" Minimum="-24" Precision="0" TypicalMax="119" TypicalMin="-24"/>
        <Measurement ID="1" NameTag="SoundLevel" UnitType="dBA" Type="UserCal" Inputs="0" Params="112,65,74,85" CalFlags="1,1,1,1" Accuracy="2" Display="Graph" Internal="0" Maximum="110" MeasType="SoundLevelA" Minimum="62" Precision="1" ShortNameTag="SoundLvl" SymbolTag="IA" TypicalMax="80" TypicalMin="62" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="2004" Tag="GLXPACurrentSensor" Version="2.2" Class="0" DefaultRate="20Hz" FileName="GLXCurrent.sds" FloatParams="0" Icon="80030001000100010001800300000000c0072008101008200820f83fa82af83f" IconID="2004" Latency="15" MaxDatasheet="2048" MaxRate="25000Hz" Model="PS-2006" Warmup="1">
        <Measurement ID="0" NameTag="RawCurrent" Type="Direct" DataSize="4" Accuracy="1" Display="None" Internal="1" Maximum="16" Minimum="0" Precision="4" ShortNameTag="raw" TypicalMax="16" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="Current" UnitType="A" Type="LinearConv" Inputs="0" Params="0.125,-1" Accuracy="0.01" Display="Digits" Internal="0" Maximum="1" MeasType="Current" Minimum="-1" Precision="2" TypicalMax="1" TypicalMin="-0.1" Visible="0.1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="2005" Tag="GLXPAVoltageSensor" Version="2.1" Class="0" DefaultRate="20Hz" FileName="GLXOutputVoltage.sds" FloatParams="0" Icon="00100410887c9011a012cf0480080010c0072008101008200820f83fa82af83f" IconID="2005" Latency="15" MaxDatasheet="2048" MaxRate="25000Hz" Model="PS-2006" Warmup="1">
        <Measurement ID="0" NameTag="RawVoltage" Type="Direct" DataSize="4" Accuracy="1" Display="None" Internal="1" Maximum="16" Minimum="0" Precision="4" ShortNameTag="raw" TypicalMax="16" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="Voltage" UnitType="V" Type="LinearConv" Inputs="0" Params="1.25,-10" Accuracy="0.01" Display="Digits" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="2" TypicalMax="1" TypicalMin="-1" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="2006" Tag="GLXPAFrequency" Version="2.0" Class="0" DefaultRate="20Hz" FileName="GLXOutputFrequency.sds" FloatParams="0" Icon="00000000000900097009100f20094009700900000000300c4992499286610000" IconID="2006" Latency="0" MaxDatasheet="8192" MaxRate="1000Hz" Model="PS-2002" Warmup="0">
        <Measurement ID="0" NameTag="OutputFrequency" UnitType="Hz" Type="Direct" DataSize="4" Accuracy="1" Display="None" Internal="0" Maximum="32767" MeasType="Frequency" Minimum="0" Precision="0" ShortNameTag="Freq" SymbolTag="f" TypicalMax="5000" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDefault="1"/>
      </Sensor>
      <Sensor ID="2007" Tag="GLXPAPeakCurrent" Version="2.0" Class="0" DefaultRate="20Hz" FileName="GLXPeakCurrent.sds" FloatParams="0" Icon="0000003e0008e008a008e008803e8000000000000000300c4992499286610000" IconID="2007" Latency="15" MaxDatasheet="2048" MaxRate="1000Hz" Model="PS-2002" Warmup="1">
        <Measurement ID="0" NameTag="RawPeakCurrent" Type="Direct" DataSize="4" Accuracy="1" Display="None" Internal="1" Maximum="16" Minimum="0" Precision="4" TypicalMax="16" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="PeakCurrent" UnitType="A" Type="LinearConv" Inputs="0" Params="0.125,-1" Accuracy="0.001" Display="Digits" Internal="0" Maximum="1" MeasType="Current" Minimum="-1" Precision="3" ShortNameTag="PeakCurr" SymbolTag="Ipeak" TypicalMax="0.1" TypicalMin="-0.1" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="PeakCurrent" UnitType="mA" Type="LinearConv" Inputs="1" Params="1000,0" Accuracy="1" Display="Digits" Internal="0" InternalUnit="1" Maximum="1000" MeasType="Current" Minimum="-1000" Precision="0" ShortNameTag="PeakCurr" SymbolTag="Ipeak" TypicalMax="1000" TypicalMin="-1000" VisibleSds="1" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="2008" Tag="SPARKlinkVoltageSensor" Version="2.1" Class="0" DefaultRate="10Hz" FileName="SparkLinkVoltage.sds" FloatParams="0" Icon="0000e00fe00fc0008000800100010003c0078001800300030007000e000c0010" IconID="2008" Latency="100" MaxDatasheet="8192" MaxRate="10000Hz" Model="PS-2009" Warmup="1">
        <Measurement ID="0" NameTag="RawVoltage" Type="RawDigital" DataSize="2" Accuracy="1" Display="Graph" Internal="1" Maximum="10" Minimum="-10" Precision="0" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="Voltage" UnitType="V" Type="LinearConv" Inputs="0" Params="0.00487,-10" Accuracy="0.01" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="2" ShortNameTag="Volt" SymbolTag="V" TypicalMax="1" TypicalMin="-1" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="CurrentProbe" UnitType="A" Type="LinearConv" Inputs="1" Params="10,0" Accuracy="1" Internal="0" Maximum="1" MeasType="Current" Minimum="-1" Precision="4" ShortNameTag="Curr" SymbolTag="current" TypicalMax="0.1" TypicalMin="-0.1" VisibleSds="1" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="2009" Tag="SPARKlinkTemperatureSensor" Version="2.2" Class="0" DefaultRate="10Hz" FileName="SparkLinkTemperature.sds" FloatParams="0" Icon="000000018002800280028002800280038003800380038003c007c00780030000" IconID="2009" Latency="100" MaxDatasheet="8192" MaxRate="1000Hz" Model="PS-2009" Warmup="1">
        <Measurement ID="0" NameTag="RawTemperature" Type="RawDigital" DataSize="2" Accuracy="1" Display="Graph" Internal="1" Maximum="10" Minimum="-10" Precision="0" TypicalMax="10" TypicalMin="-10"/>
        <Measurement ID="1" NameTag="Temperature" UnitType="DegC" Type="UserCal" Inputs="4" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="0.5" Display="Graph" Internal="0" Maximum="135" MeasType="Temperature" Minimum="-35" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="30" TypicalMin="15" Visible="1" VisibleSds="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="2" NameTag="Temperature" UnitType="DegF" Type="LinearConv" Inputs="1" Params="1.8,32" Accuracy="0.5" Display="Graph" Internal="0" InternalUnit="1" Maximum="275" MeasType="Temperature" Minimum="-31" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="212" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="Temperature" UnitType="K" Type="LinearConv" Inputs="1" Params="1,273.15" Accuracy="0.5" Display="Graph" Internal="0" InternalUnit="1" Maximum="408" MeasType="Temperature" Minimum="238" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="373" TypicalMin="273" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="UnCalTemperature" UnitType="DegC" Type="Temperature" Inputs="0" Params="4.095" Accuracy="2" Display="Graph" Internal="1" Maximum="100" Minimum="0" Precision="1" TypicalMax="100" TypicalMin="0"/>
      </Sensor>
      <Sensor ID="2010" Tag="SPARKVoltageSensor" Version="2.0" Class="0" DefaultRate="10Hz" FileName="SparkVoltage.sds" FloatParams="0" Icon="00100410887c9011a012cf04800800100000c001e003300630063006e003c001" IconID="2010" Latency="15" MaxDatasheet="2048" MaxRate="25000Hz" Model="PS-2008" Warmup="1">
        <Measurement ID="0" NameTag="RawVoltage" Type="Direct" DataSize="4" Accuracy="1" Display="None" Internal="1" Maximum="16" Minimum="0" Precision="4" ShortNameTag="raw" TypicalMax="16" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="Voltage" UnitType="V" Type="LinearConv" Inputs="0" Params="1.25,-10" Accuracy="0.01" Display="Digits" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="2" ShortNameTag="Volt" SymbolTag="V" TypicalMax="1" TypicalMin="-1" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="2011" Tag="SPARKTemperatureSensor" Version="2.0" Class="0" DefaultRate="2Hz" FileName="SparkTemperature.sds" FloatParams="0" Icon="80078004800580048005800480058004800580078007800780078007400bc00f" IconID="2011" Latency="100" MaxDatasheet="8192" MaxRate="100Hz" Model="PS-2008" Warmup="1">
        <Measurement ID="0" NameTag="Temperature" UnitType="DegC" Type="UserCal" Inputs="3" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="0.5" Display="Graph" Internal="0" Maximum="135" MeasType="Temperature" Minimum="-35" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="30" TypicalMin="15" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="1" NameTag="Temperature" UnitType="DegF" Type="LinearConv" Inputs="0" Params="1.8,32" Accuracy="0.9" Display="Graph" Internal="0" InternalUnit="1" Maximum="275" MeasType="Temperature" Minimum="-31" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="212" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="Temperature" UnitType="K" Type="LinearConv" Inputs="0" Params="1,273.15" Accuracy="0.5" Display="Graph" Internal="0" InternalUnit="1" Maximum="408" MeasType="Temperature" Minimum="238" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="373" TypicalMin="273" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="RawTemperature" UnitType="DegC" Type="Direct" DataSize="4" Accuracy="0.05" Display="Graph" Internal="1" Maximum="100" Minimum="-10" Precision="2" TypicalMax="100" TypicalMin="0" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="2012" Tag="OnBoardAccelerometer" DefaultRate="20Hz" IconID="131" MaxRate="1000Hz" Model="" SupportsZeroOnStart="1">
          <Measurement ID="1" NameTag="Accelerationx" UnitType="grav" Type="RawDigital" DataSize="8" Accuracy="0.1" Maximum="10" MeasType="Acceleration" Minimum="-10" OffsetZero="1" Precision="1" ShortNameTag="accx" SymbolTag="ax" TypicalMax="1" TypicalMin="-1" Visible="1"/>
          <Measurement ID="4" NameTag="Accelerationy" UnitType="grav" Type="RawDigital" DataSize="8" Accuracy="0.1" Maximum="10" MeasType="Acceleration" Minimum="-10" OffsetZero="1" Precision="1" ShortNameTag="accy" SymbolTag="ay" TypicalMax="1" TypicalMin="-1" Visible="1"/>
          <Measurement ID="7" NameTag="Accelerationz" UnitType="grav" Type="RawDigital" DataSize="8" Accuracy="0.1" Maximum="10" MeasType="Acceleration" Minimum="-10" OffsetZero="1" Precision="1" ShortNameTag="accz" SymbolTag="az" TypicalMax="1" TypicalMin="-1" Visible="1"/>
          <Measurement ID="9" NameTag="AccelerationResultant" UnitType="grav" Type="ThreeInputVector" Inputs="1,4,7" Accuracy="0.1" Maximum="10" MeasType="Acceleration" Minimum="0" Precision="1" ShortNameTag="accresult" SymbolTag="a" TypicalMax="1" TypicalMin="0" Visible="1" IsDefaultMeas="1"/>
      </Sensor>
      <Sensor ID="2013" Tag="OnboardLightSensor" DefaultRate="20Hz" FloatParams="0" IconID="132" MaxRate="1000Hz" MinRate="1Hz">
          <Measurement ID="1" NameTag="LightLevel" UnitType="lux" Type="RawDigital" DataSize="8" Inputs="0" Accuracy="1" Display="Digits" Maximum="32000" Minimum="0" MeasType="LightIntensity" Precision="0" SymbolTag="" TypicalMax="5000" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="2014" Tag="OnboardMicrophone" DefaultRate="20Hz" IconID="151" MinRate="2Hz" MaxRate="50000Hz" Model="">
          <Measurement ID="0" NameTag="SoundIntensity" UnitType="uWpm2" Type="RawDigital" DataSize="8" Accuracy="6" Internal="1" Maximum="100" Minimum="0" Precision="3" TypicalMax="100" TypicalMin="0" MeasType="SoundIntensity"/>
          <Measurement ID="1" NameTag="SoundLevel" UnitType="dBC" Type="RawDigital" DataSize="8" Accuracy="3" Internal="1" Maximum="110" Minimum="0" Precision="1" TypicalMax="110" TypicalMin="0" MeasType="SoundLevelC"/>
          <Measurement ID="2" NameTag="SoundLevel" UnitType="dBC" Type="LinearConv" Inputs="1" Params="1,0" Accuracy="3" Display="Digits" Maximum="110" Minimum="0" Precision="1" SymbolTag="" TypicalMax="80" TypicalMin="30" Visible="1" MeasType="SoundLevelC"/>
          <Measurement ID="3" NameTag="SoundIntensity" UnitType="uWpm2" Type="LinearConv" Inputs="0" Params="1,0" Accuracy="6" Display="Digits" Maximum="1000" Minimum="0" Precision="3" SymbolTag="" TypicalMax="100" TypicalMin="0" Visible="1" MeasType="SoundIntensity" IsDefaultMeas="1"/>
      </Sensor>
      <Sensor ID="2015" Tag="OnboardTempSensor" DefaultRate="2Hz" IconID="153" MaxRate="1000Hz" Model="">
        <Measurement ID="0" NameTag="Temperature" UnitType="DegC" Type="UserCal" Inputs="3" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="0.5" Display="Graph" Maximum="135" Minimum="-35" MeasType="Temperature" Precision="1" SymbolTag="" TypicalMax="30" TypicalMin="15" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="1" NameTag="Temperature" UnitType="DegF" Type="LinearConv" Inputs="0" Params="1.8,32" Accuracy="0.9" InternalUnit="1" Maximum="275" Minimum="-31" MeasType="Temperature" Precision="1" TypicalMax="212" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="Temperature" UnitType="K" Type="LinearConv" Inputs="0" Params="1,273.15" Accuracy="0.5" InternalUnit="1" Maximum="408" Minimum="238" MeasType="Temperature" Precision="1" TypicalMax="373" TypicalMin="273" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="RawTemperature" UnitType="DegC" Type="RawDigital" DataSize="8" Accuracy="0.05" Internal="1" Maximum="100" Minimum="-10" Precision="2" TypicalMax="100" TypicalMin="0" XplorerDisplay="1"/>
      </Sensor>
      <Sensor ID="2016" Tag="SparkLinkAirBattery" DefaultRate="1Hz" IconID="203" MaxRate="10Hz">
        <Measurement ID="0" NameTag="Voltage" UnitType="mV" Type="RawDigital" DataSize="2" Accuracy="1" Maximum="4500" MeasType="Voltage" Minimum="3000" Precision="0" Visible="1" DefaultUnit="mV" />
        <Measurement ID="1" NameTag="Charge" UnitType="counts" Type="RawDigital" DataSize="2" Accuracy="1" Maximum="65535" MeasType="Count" Minimum="0" Precision="0" Visible="1"/>
      </Sensor>
      <Sensor ID="2017" Tag="OnboardGPSSensor" DefaultRate="1Hz" IconID="2038" MaxRate="1Hz" Model="">
          <Measurement ID="0" NameTag="Latitude" UnitType="deg" Type="RawDigital" DataSize="8" MeasType="Latitude" ShortNameTag="Lat" SymbolTag="Lat" DefaultUnit="deg" Precision="5" Minimum="-90" Maximum="90" TypicalMin="-70" TypicalMax="70" Visible="1" IsDefaultMeas="1"/>
          <Measurement ID="1" NameTag="Longitude" UnitType="deg" Type="RawDigital" DataSize="8" MeasType="Longitude" ShortNameTag="Long" SymbolTag="Long" DefaultUnit="deg" Precision="5" Minimum="-180" Maximum="180" TypicalMin="-180" TypicalMax="180" Visible="1"/>
          <Measurement ID="2" NameTag="Altitude" UnitType="m" Type="RawDigital" DataSize="8" MeasType="Altitude" ShortNameTag="Alt" SymbolTag="Alt" Precision="0" Minimum="-100" Maximum="10000" TypicalMin="0" TypicalMax="300" Visible="1"/>
          <Measurement ID="3" NameTag="Speed" UnitType="mps" Type="RawDigital" DataSize="8" MeasType="Speed" ShortNameTag="speed" SymbolTag="speed" Precision="2" Minimum="0" Maximum="100" TypicalMin="30" TypicalMax="30" Visible="1"/>
      </Sensor>
      <Sensor ID="2020" Tag="WirelessTemperatureSensor" DefaultRate="2Hz" IconID="136" MaxRate="10Hz" Model="PS-3201">
        <Measurement ID="0" NameTag="RawTemperature" Type="RawDigital" DataSize="2" Internal="1"/>
		<Measurement ID="1" NameTag="Temperature" UnitType="DegC" Type="UserCal" Inputs="2" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="0.5" Maximum="135" MeasType="Temperature" Minimum="-35" TypicalMin="15" TypicalMax="30" Precision="1" ShortNameTag="Temp" SymbolTag="T" Visible="1"/>
		<Measurement ID="2" NameTag="UncalTemperature" UnitType="DegC" Type="LinearConv" Inputs="0" Params="0.00268127,-46.85" Internal="1" MeasType="Temperature"/>
      </Sensor>
      <Sensor ID="2021" Tag="WirelessPHSensor" DefaultRate="5Hz" IconID="139" MaxRate="50Hz" Model="PS-3204">
        <Measurement ID="0" NameTag="adc" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="1" NameTag="Voltage" UnitType="mV" Type="LinearConv" Inputs="0" Params="1,-2048" Accuracy="4" DefaultUnit="mV" Maximum="2000" MeasType="Voltage" Minimum="0" TypicalMin="0" TypicalMax="1000" Precision="1" ShortNameTag="Volt" SymbolTag="V" Visible="1"/>
        <Measurement ID="2" NameTag="pH" UnitType="Unitless" Type="UserCal" Inputs="1" Params="177,4,-182,10" CalFlags="1,1,1,1" Accuracy="0.1" Maximum="14" MeasType="pH" Minimum="0" TypicalMin="4" TypicalMax="10" Precision="2" SymbolTag="pH" Visible="1" IsISE="1" IsDefaultMeas="1"/>
        <Measurement ID="3" NameTag="ISEAmmonium" UnitType="mgpL" Type="UserCal" Inputs="1" Params="75,10,130,100" CalFlags="1,1,1,1" Accuracy="0.1" Maximum="14" MeasType="Concentration" Minimum="0" Precision="2" ShortNameTag="ISEAmmonium_SN" SymbolTag="NH4+" Visible="1" IsISE="1" Internal="1"/>
        <Measurement ID="4" NameTag="ISECalcium" UnitType="mgpL" Type="UserCal" Inputs="1" Params="30,10,55,100" CalFlags="1,1,1,1" Accuracy="0.1" Maximum="14" MeasType="Concentration" Minimum="0" Precision="2" ShortNameTag="ISECalcium_SN" SymbolTag="Ca2+" Visible="1" IsISE="1" Internal="1"/>
        <Measurement ID="5" NameTag="ISEChloride" UnitType="mgpL" Type="UserCal" Inputs="1" Params="160,10,106,100" CalFlags="1,1,1,1" Accuracy="0.1" Maximum="14" MeasType="Concentration" Minimum="0" Precision="2" ShortNameTag="ISEChloride_SN" SymbolTag="Cl-" Visible="1" IsISE="1" Internal="1"/>
        <Measurement ID="6" NameTag="ISECO2" UnitType="mgpL" Type="UserCal" Inputs="1" Params="45,10,100,100" CalFlags="1,1,1,1" Accuracy="0.1" Maximum="14" MeasType="Concentration" Minimum="0" Precision="2" ShortNameTag="ISECO2_SN" SymbolTag="CO2" Visible="1" IsISE="1" Internal="1"/>
        <Measurement ID="7" NameTag="ISENitrate" UnitType="mgpL" Type="UserCal" Inputs="1" Params="64,10,120,100" CalFlags="1,1,1,1" Accuracy="0.1" Maximum="14" MeasType="Concentration" Minimum="0" Precision="2" ShortNameTag="ISENitrate_SN" SymbolTag="NO3-" Visible="1" IsISE="1" Internal="1"/>
        <Measurement ID="8" NameTag="ISENitrite" UnitType="mgpL" Type="UserCal" Inputs="1" Params="223,10,279,100" CalFlags="1,1,1,1" Accuracy="0.1" Maximum="14" MeasType="Concentration" Minimum="0" Precision="2" ShortNameTag="ISENitrite_SN" SymbolTag="NO2-" Visible="1" IsISE="1" Internal="1"/>
        <Measurement ID="9" NameTag="ISEPotassium" UnitType="mgpL" Type="UserCal" Inputs="1" Params="50,10,106,100" CalFlags="1,1,1,1" Accuracy="0.1" Maximum="14" MeasType="Concentration" Minimum="0" Precision="2" ShortNameTag="ISEPotassium_SN" SymbolTag="K+" Visible="1" IsISE="1" Internal="1"/>
        <Measurement ID="10" NameTag="ISESodium" UnitType="mgpL" Type="UserCal" Inputs="1" Params="40,10,100,100" CalFlags="1,1,1,1" Accuracy="0.1" Maximum="14" MeasType="Concentration" Minimum="0" Precision="2" ShortNameTag="ISESodium_SN" SymbolTag="Na+" Visible="1" IsISE="1" Internal="1"/>
        <Measurement ID="11" NameTag="ISEFluoride" UnitType="mgpL" Type="UserCal" Inputs="1" Params="-40,10,17,100" CalFlags="1,1,1,1" Accuracy="0.1" Maximum="14" MeasType="Concentration" Minimum="0" Precision="2" ShortNameTag="ISEFluoride_SN" SymbolTag="Fluoride_SYM" Visible="1" IsISE="1" Internal="1"/>
        <Measurement ID="12" NameTag="ISELead" UnitType="mgpL" Type="UserCal" Inputs="1" Params="-215,10,187,100" CalFlags="1,1,1,1" Accuracy="0.1" Maximum="14" MeasType="Concentration" Minimum="0" Precision="2" ShortNameTag="ISELead_SN" SymbolTag="Pb2+" Visible="1" IsISE="1" Internal="1"/>
        <Measurement ID="13" NameTag="ISEOther" UnitType="mgpL" Type="UserCal" Inputs="1" Params="40,10,60,100" CalFlags="1,1,1,1" Accuracy="0.1" Maximum="14" MeasType="Concentration" Minimum="0" Precision="2" ShortNameTag="ISEOther_SN" SymbolTag="ISEOther_SYM" Visible="1" IsISE="1" Internal="1"/>
      </Sensor>
      <Sensor ID="2022" Tag="WirelessPressureSensor" DefaultRate="20Hz" IconID="143" MaxRate="1000Hz" Model="PS-3203" SupportsZeroOnStart="1">
        <Measurement ID="0" NameTag="adc" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="1" NameTag="Pressure" UnitType="psi" Type="FactoryCal" Inputs="0" Params="16016,14.7,38688,34.7" Accuracy="0.1" Maximum="350" MeasType="Pressure" Minimum="20" TypicalMin="0" TypicalMax="20" OffsetZero="1" Precision="1" ShortNameTag="Press" SymbolTag="pressureAbsolute" Visible="1"/>
      </Sensor>
      <Sensor ID="2023" Tag="WirelessForceSensor" DefaultRate="20Hz" IconID="250" MaxRate="1000Hz" Model="PS-3202" SupportsZeroOnStart="1">
        <Measurement ID="0" NameTag="RawForce" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="1" NameTag="ForceFCal" UnitType="N" Type="FactoryCal" Inputs="0" Params="32768,0,5000,50" Internal="1"/>
        <Measurement ID="4" NameTag="Force" UnitType="N" Type="UserCal" Inputs="1" Params="0,0,50,50" CalFlags="1,1,1,1" Accuracy="1" CanChangeSign="1" Maximum="50" MeasType="Force" Minimum="-50" TypicalMin="-5" TypicalMax="5" OffsetZero="1" Precision="2" SymbolTag="F" Visible="1"/>
      </Sensor>
      <Sensor ID="2024" Tag="WirelessAccelerationSensor" DefaultRate="20Hz" IconID="131" MaxRate="500Hz" Model="PS-3202" SupportsZeroOnStart="1">
        <Measurement ID="0" NameTag="X" Type="RawDigital" DataSize="2" TwosComp="1" Internal="1"/>
        <Measurement ID="1" NameTag="Y" Type="RawDigital" DataSize="2" TwosComp="1" Internal="1"/>
        <Measurement ID="2" NameTag="Z" Type="RawDigital" DataSize="2" TwosComp="1" Internal="1"/>
        <Measurement ID="3" NameTag="Accelerationx" UnitType="ms2" Type="FactoryCal" Inputs="0" Params="0,0,1,0.004787" Accuracy="0.01" Maximum="10" MeasType="Acceleration" Minimum="-10" TypicalMin="-1" TypicalMax="1" OffsetZero="1" Precision="1" ShortNameTag="accx" SymbolTag="ax" Visible="1"/>
        <Measurement ID="4" NameTag="Accelerationy" UnitType="ms2" Type="FactoryCal" Inputs="1" Params="0,0,1,0.004787" Accuracy="0.01" Maximum="10" MeasType="Acceleration" Minimum="-10" TypicalMin="-1" TypicalMax="1" OffsetZero="1" Precision="1" ShortNameTag="accy" SymbolTag="ay" Visible="1"/>
        <Measurement ID="5" NameTag="Accelerationz" UnitType="ms2" Type="FactoryCal" Inputs="2" Params="0,0,1,0.004787" Accuracy="0.01" Maximum="10" MeasType="Acceleration" Minimum="-10" TypicalMin="-1" TypicalMax="1" OffsetZero="1" Precision="1" ShortNameTag="accz" SymbolTag="az" Visible="1"/>
        <Measurement ID="6" NameTag="AccelerationResultant" UnitType="ms2" Type="ThreeInputVector" Inputs="3,4,5" Accuracy="0.01" Maximum="10" MeasType="Acceleration" Minimum="0" TypicalMin="0" TypicalMax="1" Precision="1" ShortNameTag="accresult" SymbolTag="a" Visible="1" IsDefaultMeas="1"/>
      </Sensor>
      <Sensor ID="2025" Tag="SmartCartForceSensor" DefaultRate="20Hz" IconID="250" MaxRate="2000Hz" Model="ME-1240" SupportsZeroOnStart="1">
        <Measurement ID="0" NameTag="RawForce" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="1" NameTag="ForceFCal" UnitType="N" Type="FactoryCal" Inputs="0" Params="32768,0,1000,100" Internal="1"/>
        <Measurement ID="4" NameTag="Force" UnitType="N" Type="UserCal" Inputs="1" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="1" CanChangeSign="1" Maximum="100" MeasType="Force" Minimum="-100" TypicalMin="-10" TypicalMax="10" OffsetZero="1" Precision="2" Visible="1" SymbolTag="F"/>
      </Sensor>
      <Sensor ID="2026" Tag="SmartCartAccelerationSensor" DefaultRate="20Hz" IconID="131" MaxRate="500Hz" Model="ME-1240" SupportsZeroOnStart="1">
        <Measurement ID="0" NameTag="X" Type="RawDigital" DataSize="2" TwosComp="1" Internal="1"/>
        <Measurement ID="1" NameTag="Y" Type="RawDigital" DataSize="2" TwosComp="1" Internal="1"/>
        <Measurement ID="2" NameTag="Z" Type="RawDigital" DataSize="2" TwosComp="1" Internal="1"/>
        <Measurement ID="3" NameTag="Accelerationx" UnitType="ms2" Type="FactoryCal" Inputs="0" Params="0,0,1,0.004787" Accuracy="0.01" Maximum="10" MeasType="Acceleration" Minimum="-10" TypicalMin="-1" TypicalMax="1" OffsetZero="1" Precision="1" ShortNameTag="accx" SymbolTag="ax" Visible="1"/>
        <Measurement ID="4" NameTag="Accelerationy" UnitType="ms2" Type="FactoryCal" Inputs="1" Params="0,0,1,0.004787" Accuracy="0.01" Maximum="10" MeasType="Acceleration" Minimum="-10" TypicalMin="-1" TypicalMax="1" OffsetZero="1" Precision="1" ShortNameTag="accy" SymbolTag="ay" Visible="1"/>
        <Measurement ID="5" NameTag="Accelerationz" UnitType="ms2" Type="FactoryCal" Inputs="2" Params="0,0,1,0.004787" Accuracy="0.01" Maximum="10" MeasType="Acceleration" Minimum="-10" TypicalMin="-1" TypicalMax="1" OffsetZero="1" Precision="1" ShortNameTag="accz" SymbolTag="az" Visible="1"/>
        <Measurement ID="6" NameTag="AccelerationResultant" UnitType="ms2" Type="ThreeInputVector" Inputs="3,4,5" Accuracy="0.01" Maximum="10" MeasType="Acceleration" Minimum="0" TypicalMin="0" TypicalMax="1" Precision="1" ShortNameTag="accresult" SymbolTag="a" Visible="1" IsDefaultMeas="1"/>
      </Sensor>
      <Sensor ID="2027" Tag="SmartCartPositionSensor" DefaultRate="20Hz" IconID="1131" MaxRate="500Hz" Model="ME-1240" SupportsZeroOnStart="1" ZeroOnRead="1" ZeroOnStart="1">
        <Measurement ID="0" NameTag="RawCountChange" Type="RawDigital" DataSize="2" TwosComp="1" CanChangeSign="1" Internal="1"/>
        <Measurement ID="1" NameTag="Position" UnitType="m" Type="RotaryPos" Inputs="0" Params="0.09895,816" Accuracy="0.001" Maximum="1" MeasType="Position" Minimum="-1" TypicalMin="-0.2" TypicalMax="0.2" Precision="4" ShortNameTag="pos" SymbolTag="x" Visible="1" IsDefaultMeas="1"/>
        <Measurement ID="2" NameTag="Velocity" UnitType="mps" Type="Derivative" Inputs="1" Params="3" Accuracy="0.001" Maximum="0.5" MeasType="Velocity" Minimum="-0.5" TypicalMin="-0.1" TypicalMax="0.1" Precision="3" ShortNameTag="vel" SymbolTag="velocity" Visible="1"/>
        <Measurement ID="3" NameTag="Acceleration" UnitType="ms2" Type="Derivative" Inputs="2" Params="3" Accuracy="0.001" Maximum="0.2" MeasType="Acceleration" Minimum="-0.2" TypicalMin="-0.05" TypicalMax="0.05" Precision="3" ShortNameTag="acc" SymbolTag="a" Visible="1"/>
      </Sensor>
      <Sensor ID="2028" Tag="WirelessGyroSensor" DefaultRate="20Hz" IconID="1132" MaxRate="500Hz" Model="PS-3202" SupportsZeroOnStart="1">
        <Measurement ID="0" NameTag="X" Type="RawDigital" DataSize="2" TwosComp="1" Internal="1"/>
        <Measurement ID="1" NameTag="Y" Type="RawDigital" DataSize="2" TwosComp="1" Internal="1"/>
        <Measurement ID="2" NameTag="Z" Type="RawDigital" DataSize="2" TwosComp="1" Internal="1"/>
        <Measurement ID="3" NameTag="AngularVelocityx" UnitType="degps" Type="FactoryCal" Inputs="0" Params="0,0,1,0.07" Accuracy="0.01" Maximum="10" MeasType="AngularVelocity" Minimum="-10" TypicalMin="-1" TypicalMax="1" OffsetZero="1" Precision="1" ShortNameTag="angvelx" SymbolTag="omegaLx" Visible="1"/>
        <Measurement ID="4" NameTag="AngularVelocityy" UnitType="degps" Type="FactoryCal" Inputs="1" Params="0,0,1,0.07" Accuracy="0.01" Maximum="10" MeasType="AngularVelocity" Minimum="-10" TypicalMin="-1" TypicalMax="1" OffsetZero="1" Precision="1" ShortNameTag="angvely" SymbolTag="omegaLy" Visible="1"/>
        <Measurement ID="5" NameTag="AngularVelocityz" UnitType="degps" Type="FactoryCal" Inputs="2" Params="0,0,1,0.07" Accuracy="0.01" Maximum="10" MeasType="AngularVelocity" Minimum="-10" TypicalMin="-1" TypicalMax="1" OffsetZero="1" Precision="1" ShortNameTag="angvelz" SymbolTag="omegaLz" Visible="1"/>
      </Sensor>
      <Sensor ID="2029" Tag="SmartCartGyroSensor" DefaultRate="20Hz" IconID="1132" MaxRate="500Hz" Model="ME-1240" SupportsZeroOnStart="1">
        <Measurement ID="0" NameTag="X" Type="RawDigital" DataSize="2" TwosComp="1" Internal="1"/>
        <Measurement ID="1" NameTag="Y" Type="RawDigital" DataSize="2" TwosComp="1" Internal="1"/>
        <Measurement ID="2" NameTag="Z" Type="RawDigital" DataSize="2" TwosComp="1" Internal="1"/>
        <Measurement ID="3" NameTag="AngularVelocityx" UnitType="degps" Type="FactoryCal" Inputs="0" Params="0,0,1,0.00875" Accuracy="0.01" Maximum="10" MeasType="AngularVelocity" Minimum="-10" TypicalMin="-1" TypicalMax="1" OffsetZero="1" Precision="1" ShortNameTag="angvelx" SymbolTag="omegaLx" Visible="1"/>
        <Measurement ID="4" NameTag="AngularVelocityy" UnitType="degps" Type="FactoryCal" Inputs="1" Params="0,0,1,0.00875" Accuracy="0.01" Maximum="10" MeasType="AngularVelocity" Minimum="-10" TypicalMin="-1" TypicalMax="1" OffsetZero="1" Precision="1" ShortNameTag="angvely" SymbolTag="omegaLy" Visible="1"/>
        <Measurement ID="5" NameTag="AngularVelocityz" UnitType="degps" Type="FactoryCal" Inputs="2" Paramsx="0,0,1,0.00875" Accuracy="0.01" Maximum="10" MeasType="AngularVelocity" Minimum="-10" TypicalMin="-1" TypicalMax="1" OffsetZero="1" Precision="1" ShortNameTag="angvelz" SymbolTag="omegaLz" Visible="1"/>
      </Sensor>
      <Sensor ID="2030" Tag="WirelessLightSensor1" DefaultRate="1Hz" IconID="132" MaxRate="2Hz" Model="PS-3213">
        <Measurement ID="0" NameTag="R" UnitType="percent" Type="LinearConv" Inputs="9" Params="0.0015258,0" Internal="1" MeasType="LightIntensity" Precision="1" Minimum="0" Maximum="100" Visible="1" SymbolTag="r"/>
        <Measurement ID="1" NameTag="G" UnitType="percent" Type="LinearConv" Inputs="10" Params="0.0015258,0" Internal="1" MeasType="LightIntensity" Precision="1" Minimum="0" Maximum="100" Visible="1" SymbolTag="g"/>
        <Measurement ID="2" NameTag="B" UnitType="percent" Type="LinearConv" Inputs="11" Params="0.0015258,0" Internal="1" MeasType="LightIntensity" Precision="1" Minimum="0" Maximum="100" Visible="1" SymbolTag="b"/>
        <Measurement ID="3" NameTag="IR" UnitType="percent" Type="LinearConv" Inputs="12" Params="0.0015258,0" Internal="1" MeasType="LightIntensity" Precision="1" Minimum="0" Maximum="100" Visible="1" SymbolTag="ir"/>
        <Measurement ID="4" NameTag="UVA" UnitType="Unitless" Type="LinearConv" Inputs="13" Params="1,0" MeasType="LightIntensity" Precision="0" Minimum="0" Maximum="100" Visible="1" ShortNameTag="UVA_SN" SymbolTag="UVa"/>
        <Measurement ID="5" NameTag="UVB" UnitType="Unitless" Type="LinearConv" Inputs="14" Params="1,0" MeasType="LightIntensity" Precision="0" Minimum="0" Maximum="100" Visible="1" ShortNameTag="UVB_SN" SymbolTag="UVb"/>
        <Measurement ID="7" NameTag="UVIndex" UnitType="Unitless" Type="UserCal" Inputs="15" Params="0,0,9175,7" CalFlags="0,0,1,1" MeasType="UVIndex" Visible="1" SymbolTag="UVi"/>
        <Measurement ID="8" NameTag="Illuminance" UnitType="lux" Type="LinearConv" Inputs="16" Params="2,0" MeasType="LightIntensity" Minimum="0" Maximum="50000" Visible="1" SymbolTag="Illum" IsDefaultMeas="1"/>
        <Measurement ID="9" NameTag="R" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="10" NameTag="G" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="11" NameTag="B" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="12" NameTag="IR" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="13" NameTag="UVA" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="14" NameTag="UVB" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="15" NameTag="UVIRaw" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="16" NameTag="LuxCal" Type="FactoryCal" Inputs="10" Params="0,0,1,1" Internal="1"/>
        <Measurement ID="17" NameTag="SolarIrradiance" UnitType="wpm2" Type="LinearConv" Inputs="8" Params="0.0104,0" MeasType="LightIntensity" Minimum="0" Maximum="500" Visible="1" ShortNameTag="IrradianceSN" SymbolTag="Irrad"/>
        <Measurement ID="18" NameTag="SolarPAR" UnitType="umolpm2ps" Type="LinearConv" Inputs="8" Params="0.0185,0" MeasType="PAR" Minimum="0" Maximum="1000" Visible="1" ShortNameTag="PAR" SymbolTag="PAR"/>
      </Sensor>
      <Sensor ID="2031" Tag="WirelessVoltageSensor" DefaultRate="20Hz" IconID="135" MaxBurstRate="100000Hz" MaxRate="1000Hz" Model="PS-3211" SupportsRange="1" SupportsTrigger="1" SupportsZeroOnStart="1" MaxBurstSamples="1000">
        <Measurement ID="0" NameTag="RawVoltage" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="1" NameTag="CalVoltage" UnitType="V" Type="FactoryCal" Inputs="0" Params="32768,0,65536,5" Internal="1"/>
        <Measurement ID="2" NameTag="CalVoltage" UnitType="V" Type="FactoryCal" Inputs="0" Params="32768,0,65536,15" Internal="1"/>
        <Measurement ID="3" NameTag="Voltage" UnitType="V" Type="Select" Inputs="1,2" Accuracy="0.005" Maximum="15" MeasType="Voltage" Minimum="-15" TypicalMin="-2" TypicalMax="2" OffsetZero="1" Precision="3" ShortNameTag="Volt" SymbolTag="V" Visible="1"/>
        <Measurement ID="100" NameTag="VoltageRangeSettings" UnitType="Unitless" Type="Constant" Internal="1" MeasType="None" Value="3" Values="pm5v:1:pm15v:3" IsRange="1"/>
      </Sensor>
      <Sensor ID="2032" Tag="WirelessCurrentSensor" DefaultRate="20Hz" IconID="457"  MaxBurstRate="100000Hz" MaxRate="1000Hz" Model="PS-3212" SupportsRange="1" SupportsTrigger="1" SupportsZeroOnStart="1" MaxBurstSamples="1000">
        <Measurement ID="0" NameTag="RawCurrent" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="1" NameTag="CalCurrent" UnitType="A" Type="FactoryCal" Inputs="0" Params="32768,0,65536,0.1" Accuracy="0.01" Internal="1" Maximum="1" MeasType="Current" Minimum="-1" Precision="2" ShortNameTag="Curr" SymbolTag="current"/>
        <Measurement ID="2" NameTag="CalCurrent" UnitType="A" Type="FactoryCal" Inputs="0" Params="32768,0,65536,1.0" Accuracy="0.01" Internal="1" Maximum="1" MeasType="Current" Minimum="-1" Precision="2" ShortNameTag="Curr" SymbolTag="current"/>
        <Measurement ID="3" NameTag="Current" UnitType="A" Type="Select" Inputs="1,2" Accuracy="0.005" Maximum="1" MeasType="Current" Minimum="-1" TypicalMin="-0.1" TypicalMax="0.1" OffsetZero="1" Precision="3" RangeSettingsDigitsCounts="100|4:3" ShortNameTag="Curr" SymbolTag="current" Visible="1"/>
        <Measurement ID="100" NameTag="CurrentRangeSettings" UnitType="Unitless" Type="Constant" Internal="1" MeasType="None" Value="10" Values="pm100ma:1:pm1a:10"  IsRange="1"/>
      </Sensor>
      <Sensor ID="2033" Tag="WirelessConductivitySensor" DefaultRate="2Hz" IconID="461" SupportsRange="1" MaxRate="10Hz" Model="PS-3210">
        <Measurement ID="0" NameTag="RawConductivity" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="1" NameTag="FCalConductivity" Type="FactoryCal" Inputs="0" Params="0,0,1,1" Internal="1"/>
        <Measurement ID="2" NameTag="Conductivity" UnitType="uSpcm" Type="UserCal" Inputs="1" Params="0,0,1,1" CalFlags="1,1,1,1" Accuracy="0.01" Maximum="20000" MeasType="Conductivity" Minimum="0" TypicalMin="500" TypicalMax="5000" Precision="1" ShortNameTag="Conduct" SymbolTag="sigmaL" Visible="1" IsDefaultMeas="1"/>
        <Measurement ID="3" NameTag="RawTemperature" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="4" NameTag="Temperature" UnitType="DegC" Type="LinearConv" Inputs="3" Params="0.00268127,-46.85" Internal="1" Accuracy="0.5" Maximum="135" MeasType="Temperature" Minimum="-35" Precision="1" ShortNameTag="Temp" SymbolTag="T" Visible="1"/>
        <Measurement ID="5" NameTag="TotalDissolvedSolids" UnitType="mgpL" Equation="[102]*([2]/(1+[101]*([4]-25)))" Minimum="0" Maximum="100" ShortNameTag="TDS" SymbolTag="TDS" Visible="1"/>
        <Measurement ID="100" NameTag="CondRangeSettings" UnitType="Unitless" Type="Constant" Internal="1" MeasType="None" Value="1" Values="20000uS:1:2000uS:0.1" Hidden="1" IsRange="1"/>
        <Measurement ID="101" NameTag="TempCorrCoeff" UnitType="Unitless" Type="Constant" Internal="1" MeasType="None" Value="0.02" Hidden="1"/>
        <Measurement ID="102" NameTag="TDSConst" UnitType="Unitless" Type="Constant" Description="DescTDSConstant" Internal="1" MeasType="None" Value="0.65" Hidden="0" StoreValueOnSensor="1" ConstType="TDSConst"/>
      </Sensor>
      <Sensor ID="2034" Tag="WirelessLightSensor2" DefaultRate="5Hz" IconID="132" MaxRate="20Hz" Model="PS-3213">
        <Measurement ID="0" NameTag="White" UnitType="Unitless" Equation="([4]+([5]*1.27)+([6]*1.49))/3.76" MeasType="LightIntensity" Precision="0" Minimum="0" Maximum="100" Visible="1" SymbolTag="w" IsDefaultMeas="1"/>
        <Measurement ID="1" NameTag="R" UnitType="percent" Equation="([4]/[0])*26.6" MeasType="LightIntensity" Precision="1" Minimum="0" Maximum="100" TypicalMin="0" TypicalMax="50" Visible="1" SymbolTag="r" PreferredColor="0xFFFF0000"/>
        <Measurement ID="2" NameTag="G" UnitType="percent" Equation="(([5]*1.27)/[0])*26.6" MeasType="LightIntensity" Precision="1" Minimum="0" Maximum="100" TypicalMin="0" TypicalMax="50" Visible="1" SymbolTag="g" PreferredColor="0xFF008000"/>
        <Measurement ID="3" NameTag="B" UnitType="percent" Equation="(([6]*1.49)/[0])*26.6" MeasType="LightIntensity" Precision="1" Minimum="0" Maximum="100" TypicalMin="0" TypicalMax="50" Visible="1" SymbolTag="b" PreferredColor="0xFF0000FF"/>
        <Measurement ID="4" NameTag="R" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="5" NameTag="G" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="6" NameTag="B" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="7" NameTag="White" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
      </Sensor>
      <Sensor ID="2035" Tag="WirelessCO2Sensor" DefaultRate="1Hz" IconID="201" MaxRate="1Hz" Model="PS-3208">
        <Measurement ID="0" NameTag="CO2Concentration" UnitType="ppm" Type="UserCal" Inputs="2" Params="400,400,50000,50000" CalFlags="1,1,0,0" MeasType="Concentration" Precision="0" ShortNameTag="CO2Conc" SymbolTag="CO2" Minimum="0" Maximum="50000" Symbol="CO2" Visible="1"/>
        <Measurement ID="1" NameTag="RawCO2Concentration" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="2" NameTag="RawUncalCO2Concentration" UnitType="ppm" Type="LinearConv" Inputs="1" Params="2,0" Internal="1" MeasType="Concentration" Precision="0" ShortNameTag="CO2Conc" SymbolTag="CO2" Minimum="0" Maximum="50000" Symbol="CO2" Visible="1"/>
      </Sensor>
      <Sensor ID="2036" Tag="WirelessCurrentModuleSensor" DefaultRate="20Hz" IconID="457"  MaxBurstRate="100000Hz" MaxRate="1000Hz" Model="PS-3212" SupportsRange="1" SupportsTrigger="1" SupportsZeroOnStart="1" MaxBurstSamples="1000">
        <Measurement ID="0" NameTag="RawCurrent" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="1" NameTag="CalCurrent" UnitType="A" Type="FactoryCal" Inputs="0" Params="32768,0,65536,0.1" Accuracy="0.01" Internal="1" Maximum="1" MeasType="Current" Minimum="-1" Precision="2" ShortNameTag="Curr" SymbolTag="current"/>
        <Measurement ID="2" NameTag="CalCurrent" UnitType="A" Type="FactoryCal" Inputs="0" Params="32768,0,65536,1.0" Accuracy="0.01" Internal="1" Maximum="1" MeasType="Current" Minimum="-1" Precision="2" ShortNameTag="Curr" SymbolTag="current"/>
        <Measurement ID="3" NameTag="Current" UnitType="A" Type="Select" Inputs="1,2" Accuracy="0.005" Maximum="1" MeasType="Current" Minimum="-1" TypicalMin="-0.1" TypicalMax="0.1" OffsetZero="1" Precision="3" RangeSettingsDigitsCounts="100|4:3" ShortNameTag="Curr" SymbolTag="current" Visible="1"/>
        <Measurement ID="100" NameTag="CurrentRangeSettings" UnitType="Unitless" Type="Constant" Internal="1" MeasType="None" Value="10" Values="pm100ma:1:pm1a:10" IsRange="1"/>
      </Sensor>
      <Sensor ID="2037" Tag="WirelessWeatherSensor" DefaultRate="1Hz" MaxRate="1Hz" IconID="215" Model="PS-3209">
        <Measurement ID="0" NameTag="Temperature" UnitType="DegC" UnitGroup="Weather" Equation="(([8]/65536)*165)-40" MeasType="Temperature" Precision="1" ShortNameTag="Temp" SymbolTag="T" Minimum="0" Maximum="100" TypicalMin="15" TypicalMax="30" Visible="1" IsDefaultMeas="1"/>
        <Measurement ID="1" NameTag="RelativeHumidity" UnitType="percent" Equation="([9]/65536)*100" MeasType="Humidity" ShortNameTag="RelHumid" SymbolTag="RH" Precision="1" Minimum="0" Maximum="100" TypicalMin="15" TypicalMax="85" Visible="1"/>
        <Measurement ID="2" NameTag="AbsoluteHumidity" UnitType="gpm3" Equation="((13.24*[1])/([0]+273.15))*(2.71828^((17.42*[0])/([0]+239.7)))" MeasType="AbsoluteHumidity" ShortNameTag="AbsHum" SymbolTag="H" Precision="1" Minimum="0" Maximum="100" TypicalMin="5" TypicalMax="20" Visible="1"/>
        <Measurement ID="3" NameTag="BarometricPressure" UnitType="kPa" UnitGroup="Weather" Equation="[10]*0.002" MeasType="Pressure" ShortNameTag="BarPress" SymbolTag="pressureBarometric" Precision="1" Minimum="0" Maximum="100" TypicalMin="0" TypicalMax="20" Visible="1"/>
        <Measurement ID="4" NameTag="WindSpeed" UnitType="mps" UnitGroup="WindSpeed" Equation="[11]*0.0009144" MeasType="Speed" ShortNameTag="speed" SymbolTag="speedWind" Precision="1" Minimum="0" Maximum="100" TypicalMin="0" TypicalMax="10" Visible="1"/>
        <Measurement ID="5" NameTag="DewPoint" UnitType="DegC" UnitGroup="Weather" Equation="dewpoint([0],[1])" Accuracy="1" Maximum="135" MeasType="DewPoint" Minimum="-35" Precision="1" ShortNameTag="DewPt" SymbolTag="TD" TypicalMin="-10" TypicalMax="35" Visible="1"/>
        <Measurement ID="6" NameTag="WindChill" UnitType="DegC" UnitGroup="Weather" Equation="windchill([0],[4])" Accuracy="1" Maximum="135" MeasType="WindChill" Minimum="-35" Precision="1" SymbolTag="TW" TypicalMin="-10" TypicalMax="35" Visible="1"/>
        <Measurement ID="7" NameTag="Humidex" UnitType="DegC" UnitGroup="Weather" Equation="heatindex([0],[1])" Accuracy="1" Maximum="10" MeasType="Humidex" Minimum="-10" Precision="1" SymbolTag="TH" Visible="1"/>
        <Measurement ID="8" NameTag="RawTemperature" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="9" NameTag="RawHumidity" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="10" NameTag="RawBaroPressure" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="11" NameTag="RawWindSpeed" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
      </Sensor>
      <Sensor ID="2038" Tag="WirelessGPSSensor" DefaultRate="1Hz" IconID="2038" MaxRate="1Hz" Model="PS-3209" NoDefaultMeas="1">
        <Measurement ID="0" NameTag="RawLatitude" UnitType="Unitless" Type="RawDigital" DataSize="4" Internal="1"/>
        <Measurement ID="1" NameTag="RawLongitude" UnitType="Unitless" Type="RawDigital" DataSize="4" Internal="1"/>
        <Measurement ID="2" NameTag="RawAltitude" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="3" NameTag="RawSpeed" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="4" NameTag="SatelliteCount" UnitType="Unitless" Type="RawDigital" MeasType="Count" ShortNameTag="SatCount" SymbolTag="Count" Precision="0" DataSize="1" Visible="1"/>
        <Measurement ID="5" NameTag="Latitude" UnitType="deg" UnitGroup="GPS" Equation="[0]*0.000001" MeasType="Latitude" ShortNameTag="Lat" SymbolTag="Lat" DefaultUnit="deg" Precision="5" Minimum="-90" Maximum="90" TypicalMin="-70" TypicalMax="70" Visible="1" IsDefaultMeas="1"/>
        <Measurement ID="6" NameTag="Longitude" UnitType="deg" UnitGroup="GPS" Equation="[1]*0.000001" MeasType="Longitude" ShortNameTag="Long" SymbolTag="Long" DefaultUnit="deg" Precision="5" Minimum="-180" Maximum="180" Visible="1"/>
        <Measurement ID="7" NameTag="Altitude" UnitType="m" UnitGroup="GPS" Equation="([2]/3)-500" MeasType="Altitude" ShortNameTag="Alt" SymbolTag="Alt" Precision="0" Minimum="-100" Maximum="10000" TypicalMin="0" TypicalMax="300" Visible="1"/>
        <Measurement ID="8" NameTag="Speed" UnitType="mps" UnitGroup="GPS" Equation="[3]*0.0514444" MeasType="Speed" ShortNameTag="speed" SymbolTag="speed" Precision="2" Minimum="0" Maximum="100" TypicalMin="0" TypicalMax="30" Visible="1"/>
      </Sensor>
      <Sensor ID="2039" Tag="WirelessLightSensor" DefaultRate="1Hz" IconID="132" MaxRate="1Hz" Model="PS-3209" NoDefaultMeas="1">
        <Measurement ID="0" NameTag="UVIRaw" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="1" NameTag="RawGreen" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="2" NameTag="UVIndex" UnitType="Unitless" Type="UserCal" Inputs="0" Params="0,0,100,1" CalFlags="0,0,1,1" MeasType="UVIndex" Minimum="0" Maximum="10" Visible="1" SymbolTag="UVi"/>
        <Measurement ID="3" NameTag="Illuminance" UnitType="lux" Type="LinearConv" Inputs="4" Params="2,0" MeasType="LightIntensity" Minimum="0" Maximum="50000" TypicalMin="0" TypicalMax="5000" Visible="1" ShortNameTag="IlluminanceSN" SymbolTag="Illum" IsDefaultMeas="1"/>
        <Measurement ID="4" NameTag="LuxCal" UnitType="Unitless" Type="FactoryCal" Inputs="1" Params="0,0,1,1" Internal="1"/>
        <Measurement ID="5" NameTag="SolarIrradiance" UnitType="wpm2" Type="LinearConv" Inputs="3" Params="0.0104,0" MeasType="LightIntensity" Minimum="0" Maximum="500" Visible="1" ShortNameTag="IrradianceSN" SymbolTag="Irrad"/>
        <Measurement ID="6" NameTag="SolarPAR" UnitType="umolpm2ps" Type="LinearConv" Inputs="3" Params="0.0185,0" MeasType="PAR" Minimum="0" Maximum="1000" Visible="1" ShortNameTag="PAR" SymbolTag="PAR"/>
      </Sensor>
      <Sensor ID="2040" Tag="WirelessHeartRateSensor" DefaultRate="1Hz" IconID="205" MaxRate="1Hz" Model="PS-3206/7">
        <Measurement ID="0" NameTag="HeartRate" UnitType="BeatsPerMin" Type="RawDigital" DataSize="2" Accuracy="1" Display="Graph" Internal="0" Maximum="240" MeasType="HeartRate" Minimum="40" TypicalMin="40" TypicalMax="120" Precision="0" ShortNameTag="HeartRt" SymbolTag="HR" Visible="1" IsDefaultMeas="1"/>
        <Measurementx ID="1" NameTag="PPInterval" UnitType="ms" Type="RawDigital" DataSize="2" Accuracy="1" Display="Graph" Internal="0" Maximum="1000" MeasType="Time" Minimum="0" Precision="0" Visible="1"/>
      </Sensor>
      <Sensor ID="2041" Tag="WirelessColorimeter" DefaultRate="1Hz" IconID="2041" MaxRate="1Hz" Model="PS-3213">
        <Measurement ID="0" NameTag="Red650" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="1" NameTag="Orange600" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="2" NameTag="Yellow570" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="3" NameTag="Green550" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="4" NameTag="Blue500" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="5" NameTag="Violet450" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="6" NameTag="Violet450nmAbsorbance" UnitType="Unitless" Type="Absorbance" Inputs="12" Accuracy="0.01" Maximum="2" MeasType="Absorbance" Minimum="0" Precision="3" ShortNameTag="Violet450nmAbsorb" SymbolTag="AViolet" Visible="1" PreferredColor="0xFF7F00FF"/>
        <Measurement ID="7" NameTag="Blue500nmAbsorbance" UnitType="Unitless" Type="Absorbance" Inputs="13" Accuracy="0.01" Maximum="2" MeasType="Absorbance" Minimum="0" Precision="3" ShortNameTag="Blue500nmAbsorb" SymbolTag="ABlue" Visible="1" PreferredColor="0xFF0000FF"/>
        <Measurement ID="8" NameTag="Green550nmAbsorbance" UnitType="Unitless" Type="Absorbance" Inputs="14" Accuracy="0.01" Maximum="2" MeasType="Absorbance" Minimum="0" Precision="3" ShortNameTag="Green550nmAbsorb" SymbolTag="AGreen" Visible="1" PreferredColor="0xFF00FF00"/>
        <Measurement ID="9" NameTag="Yellow570nmAbsorbance" UnitType="Unitless" Type="Absorbance" Inputs="15" Accuracy="0.01" Maximum="2" MeasType="Absorbance" Minimum="0" Precision="3" ShortNameTag="Yellow570nmAbsorb" SymbolTag="AYellow" Visible="1" PreferredColor="0xFFFFF300"/>
        <Measurement ID="10" NameTag="Orange600nmAbsorbance" UnitType="Unitless" Type="Absorbance" Inputs="16" Accuracy="0.01" Maximum="2" MeasType="Absorbance" Minimum="0" Precision="3" ShortNameTag="Orange600nmAbsorb" SymbolTag="AOrange" Visible="1" PreferredColor="0xFFFF7F00"/>
        <Measurement ID="11" NameTag="Red650nmAbsorbance" UnitType="Unitless" Type="Absorbance" Inputs="17" Accuracy="0.01" Maximum="2" MeasType="Absorbance" Minimum="0" Precision="3" ShortNameTag="Red650nmAbsorb" SymbolTag="ARed" Visible="1" PreferredColor="0xFFFF0000"/>
        <Measurement ID="12" NameTag="Violet450nmTransmittance" UnitType="percent" Type="UserCal" Inputs="5" Params="0,0,10000,100" CalFlags="0,0,1,1" Accuracy="1" Maximum="100" MeasType="Transmittance" Minimum="0" Precision="1" ShortNameTag="Violet450nmTransmit" SymbolTag="TViolet" Visible="1" PreferredColor="0xFF7F00FF"/>
        <Measurement ID="13" NameTag="Blue500nmTransmittance" UnitType="percent" Type="UserCal" Inputs="4" Params="0,0,10000,100" CalFlags="0,0,1,1" Accuracy="1" Maximum="100" MeasType="Transmittance" Minimum="0" Precision="1" ShortNameTag="Blue500nmTransmit" SymbolTag="TBlue" Visible="1" PreferredColor="0xFF0000FF"/>
        <Measurement ID="14" NameTag="Green550nmTransmittance" UnitType="percent" Type="UserCal" Inputs="3" Params="0,0,10000,100" CalFlags="0,0,1,1" Accuracy="1" Maximum="100" MeasType="Transmittance" Minimum="0" Precision="1" ShortNameTag="Green550nmTransmit" SymbolTag="TGreen" Visible="1" PreferredColor="0xFF00FF00"/>
        <Measurement ID="15" NameTag="Yellow570nmTransmittance" UnitType="percent" Type="UserCal" Inputs="2" Params="0,0,10000,100" CalFlags="0,0,1,1" Accuracy="1" Maximum="100" MeasType="Transmittance" Minimum="0" Precision="1" ShortNameTag="Yellow570nmTransmit" SymbolTag="TYellow" Visible="1" PreferredColor="0xFFFFF300"/>
        <Measurement ID="16" NameTag="Orange600nmTransmittance" UnitType="percent" Type="UserCal" Inputs="1" Params="0,0,10000,100" CalFlags="0,0,1,1" Accuracy="1" Maximum="100" MeasType="Transmittance" Minimum="0" Precision="1" ShortNameTag="Orange600nmTransmit" SymbolTag="TOrange" Visible="1" PreferredColor="0xFFFF7F00"/>
        <Measurement ID="17" NameTag="Red650nmTransmittance" UnitType="percent" Type="UserCal" Inputs="0" Params="0,0,10000,100" CalFlags="0,0,1,1" Accuracy="1" Maximum="100" MeasType="Transmittance" Minimum="0" Precision="1" ShortNameTag="Red650nmTransmit" SymbolTag="TRed" Visible="1" PreferredColor="0xFFFF0000" IsDefaultMeas="1"/>
        <Measurement ID="21" NameTag="Ammonia" UnitType="mgpL" Equation="table([10],0,-0.117,0.617,1.56,2,8.13)" Accuracy="0.05" Maximum="3" MeasType="Concentration" Minimum="1" Precision="1" ShortNameTag="NH3" SymbolTag="NH3" TypicalMax="3" TypicalMin="1" Visible="1"/>
        <Measurement ID="23" NameTag="Chlorine" UnitType="mgpL" Equation="([7]*8.56)-0.197" Accuracy="0.05" Maximum="5" MeasType="Concentration" Minimum="1" Precision="1" ShortNameTag="ChlorineSN" SymbolTag="Cl" TypicalMax="3" TypicalMin="1" Visible="1"/>
        <Measurement ID="24" NameTag="Iron" UnitType="mgpL" Equation="table([8],0,0.0641,0.833,5.85,2,101.6)" Accuracy="0.05" Maximum="7" MeasType="Concentration" Minimum="0" Precision="1" ShortNameTag="Fe" SymbolTag="Fe" TypicalMax="7" TypicalMin="0" Visible="1"/>
        <Measurement ID="26" NameTag="Phosphate" UnitType="mgpL" Equation="table([11],0,-0.017,0.647,5.33,2,42.4)" Accuracy="0.05" Maximum="8" MeasType="Concentration" Minimum="1" Precision="1" ShortNameTag="PO4" SymbolTag="PO4" TypicalMax="8" TypicalMin="1" Visible="1"/>
        <Measurement ID="29" NameTag="Nitrate" UnitType="mgpL" Equation="table([6],0,-0.196,1.93,7.04,3,30.5)" Accuracy="0.05" Maximum="2" MeasType="Concentration" Minimum="1" Precision="2" ShortNameTag="NO3" SymbolTag="NO3" TypicalMax="2" TypicalMin="1" Visible="1"/>
      </Sensor>
      <Sensor ID="2042" Tag="WirelessTurbidimeter" DefaultRate="1Hz" IconID="2042" MaxRate="1Hz" Model="PS-3213">
        <Measurement ID="0" NameTag="RawTurbidity" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="1" NameTag="Turbidity" UnitType="NTU" Type="UserCal" Inputs="0" Params="0,0,10000,100" CalFlags="1,1,1,1" Accuracy="1" Limits="0,1000" Maximum="400" MeasType="Turbidity" Minimum="0" TypicalMin="0" TypicalMax="200" Precision="1" ShortNameTag="Turb" SymbolTag="Turb" Visible="1"/>
      </Sensor>
      <Sensor ID="2043" Tag="WirelessForceSensor" DefaultRate="20Hz" IconID="250" MaxRate="2000Hz" Model="PS-3216" SupportsZeroOnStart="1">
        <Measurement ID="0" NameTag="RawForce" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="1" NameTag="ForceFCal" UnitType="N" Type="FactoryCal" Inputs="0" Params="32768,0,5000,50" Internal="1"/>
        <Measurement ID="4" NameTag="Force" UnitType="N" Type="UserCal" Inputs="1" Params="0,0,50,50" CalFlags="1,1,1,1" Accuracy="1" CanChangeSign="1" Maximum="50" MeasType="Force" Minimum="-50" TypicalMin="-5" TypicalMax="5" OffsetZero="1" Precision="2" Visible="1" IsDefaultMeas="1"/>
      </Sensor>
      <Sensor ID="2044" Tag="WirelessAccelerationSensor" DefaultRate="20Hz" IconID="131" MaxRate="500Hz" Model="PS-3216" SupportsZeroOnStart="1">
        <Measurement ID="0" NameTag="X" Type="RawDigital" DataSize="2" TwosComp="1" Internal="1"/>
        <Measurement ID="1" NameTag="Y" Type="RawDigital" DataSize="2" TwosComp="1" Internal="1"/>
        <Measurement ID="2" NameTag="Z" Type="RawDigital" DataSize="2" TwosComp="1" Internal="1"/>
        <Measurement ID="3" NameTag="Accelerationx" UnitType="ms2" Type="FactoryCal" Inputs="0" Params="0,0,1,0.004787" Accuracy="0.01" Maximum="10" MeasType="Acceleration" Minimum="-10" TypicalMin="-1" TypicalMax="1" OffsetZero="1" Precision="1" ShortNameTag="accx" SymbolTag="ax" Visible="1"/>
        <Measurement ID="4" NameTag="Accelerationy" UnitType="ms2" Type="FactoryCal" Inputs="1" Params="0,0,1,0.004787" Accuracy="0.01" Maximum="10" MeasType="Acceleration" Minimum="-10" TypicalMin="-1" TypicalMax="1" OffsetZero="1" Precision="1" ShortNameTag="accy" SymbolTag="ay" Visible="1"/>
        <Measurement ID="5" NameTag="Accelerationz" UnitType="ms2" Type="FactoryCal" Inputs="2" Params="0,0,1,0.004787" Accuracy="0.01" Maximum="10" MeasType="Acceleration" Minimum="-10" TypicalMin="-1" TypicalMax="1" OffsetZero="1" Precision="1" ShortNameTag="accz" SymbolTag="az" Visible="1"/>
        <Measurement ID="6" NameTag="AccelerationResultant" UnitType="ms2" Type="ThreeInputVector" Inputs="3,4,5" Accuracy="0.01" Maximum="10" MeasType="Acceleration" Minimum="0" TypicalMin="0" TypicalMax="1" Precision="1" ShortNameTag="accresult" SymbolTag="a" Visible="1" IsDefaultMeas="1"/>
      </Sensor>
      <Sensor ID="2045" Tag="WirelessCompass" DefaultRate="1Hz" MaxRate="1Hz" IconID="2045" Model="PS-3209" NoDefaultMeas="1">
        <Measurement ID="1" NameTag="RawHeading" UnitType="Unitless" Type="RawDigital" TwosComp="1" DataSize="2" Internal="1"/>
        <Measurement ID="3" NameTag="WindDirection" UnitType="deg" UnitGroup="GPS" Equation="([5]+180)%360" MeasType="Direction" ShortNameTag="WindDir" SymbolTag="WD" DefaultUnit="deg" Precision="0" Minimum="00" Maximum="360" Visible="1" IsDefaultMeas="1"/>
        <Measurement ID="4" NameTag="MagneticHeading" UnitType="deg" UnitGroup="GPS" Equation="[1]*0.1" MeasType="Direction" ShortNameTag="MagHead" SymbolTag="MH" DefaultUnit="deg" Precision="0" Minimum="0" Maximum="360" Visible="1"/>
        <Measurement ID="5" NameTag="TrueHeading" UnitType="deg" UnitGroup="GPS" Equation="([4]+[100])%360" MeasType="Direction" ShortNameTag="TrueHead" SymbolTag="TrHd" DefaultUnit="deg" Precision="0" Minimum="0" Maximum="360" Visible="1"/>
        <Measurement ID="100" NameTag="Declination" UnitType="deg" UnitGroup="GPS" Type="Constant" Description="DescDeclination" Internal="1" MeasType="Direction" Value="0" ConstType="Declination"/>
        <Measurementx ID="10" NameTag="MagX" UnitType="Unitless" Type="RawDigital" TwosComp="1" DataSize="2" Visible="1"/>
        <Measurementx ID="11" NameTag="MagY" UnitType="Unitless" Type="RawDigital" TwosComp="1" DataSize="2" Visible="1"/>
        <Measurementx ID="12" NameTag="MagZ" UnitType="Unitless" Type="RawDigital" TwosComp="1" DataSize="2" Visible="1"/>
      </Sensor>
      <Sensor ID="2046" Tag="WirelessBloodPressureSensor" DefaultRate="100Hz" IconID="143" MinRate="100Hz" MaxRate="100Hz" Model="PS-3218">
        <Measurement ID="0" NameTag="RawAdc" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="1" NameTag="CuffPressure" UnitType="mmHg" DefaultUnit="mmHg" Type="FactoryCal" Inputs="0" Params="3000,0,38688,181" Accuracy="0.1" Maximum="350" MeasType="Pressure" Minimum="20" TypicalMin="50" TypicalMax="200" Precision="1" ShortNameTag="CuffPress" SymbolTag="pressureBlood" Visible="1"/>
        <Measurement ID="2" NameTag="PulsePressure" UnitType="mmHg" DefaultUnit="mmHg" Equation="bloodpressure([1])" Accuracy="0.1" Maximum="350" MeasType="Pressure" Minimum="20" Precision="1" Internal="1"/>
        <Measurement ID="3" NameTag="PulsePeaks" UnitType="mmHg" DefaultUnit="mmHg" Equation="bppeak([2])" Accuracy="0.1" Maximum="350" MeasType="Pressure" Minimum="20" Precision="1" Internal="1"/>
        <Measurement ID="4" NameTag="MeanArterialPressure" UnitType="mmHg" DefaultUnit="mmHg" Equation="bpmap([2])" Accuracy="1" Maximum="350" MeasType="Pressure" Minimum="20" TypicalMin="50" TypicalMax="200" Precision="0" ShortNameTag="MAP" SymbolTag="pressureBlood" Visible="1"/>
        <Measurement ID="5" NameTag="SystolicPressure" UnitType="mmHg" DefaultUnit="mmHg" Equation="systolic([2])" Accuracy="1" Maximum="350" MeasType="Pressure" Minimum="20" TypicalMin="50" TypicalMax="200" Precision="0" ShortNameTag="SystolicPress" SymbolTag="pressureBlood" Visible="1" IsDefaultMeas="1"/>
        <Measurement ID="6" NameTag="DiastolicPressure" UnitType="mmHg" DefaultUnit="mmHg" Equation="diastolic([2])" Accuracy="1" Maximum="350" MeasType="Pressure" Minimum="20" TypicalMin="50" TypicalMax="200" Precision="0" ShortNameTag="DiastolicPress" SymbolTag="pressureBlood" Visible="1"/>
        <Measurement ID="7" NameTag="PulseRate" UnitType="BeatsPerMin" Equation="bppulse([2])" Accuracy="1" Maximum="350" MeasType="HeartRate" Minimum="20" TypicalMin="50" TypicalMax="120" Precision="0" ShortNameTag="Pulse" SymbolTag="bloodPressRate" Visible="1"/>
      </Sensor>
      <Sensor ID="2047" Tag="WirelessRotaryMotionSensor" DefaultRate="20Hz" IconID="1131" MaxRate="1000Hz" Model="PS-3220" SupportsZeroOnStart="1" ZeroOnRead="1" ZeroOnStart="1">
        <Measurement ID="0" NameTag="RawCountChange" Type="RawDigital" DataSize="2" TwosComp="1" CanChangeSign="1" Internal="1"/>
        <Measurement ID="1" NameTag="Angle" UnitType="rad" Type="RotaryPos" Inputs="0" Params="6.28319,2000" Accuracy="0.002" Maximum="6.5" MeasType="Angle" Minimum="-6.5" TypicalMin="-1.5" TypicalMax="1.5" Precision="3" ShortNameTag="ang" SymbolTag="thetaL" Visible="1"/>
        <Measurement ID="2" NameTag="AngularVelocity" UnitType="radps" Type="Derivative" Inputs="1" Params="3" Accuracy="0.002" Maximum="6.5" MeasType="AngularVelocity" Minimum="-6.5" TypicalMin="-1" TypicalMax="1" Precision="3" ShortNameTag="angvel" SymbolTag="omegaL" Visible="1" IsDefaultMeas="1"/>
        <Measurement ID="3" NameTag="AngularAcceleration" UnitType="radps2" Type="Derivative" Inputs="2" Params="3" Accuracy="0.002" Maximum="6.5" MeasType="AngularAcceleration" Minimum="-6.5" TypicalMin="-1" TypicalMax="1" Precision="3" ShortNameTag="angacc" SymbolTag="alphaL" Visible="1"/>
        <Measurement ID="7" NameTag="Position" UnitType="m" Equation="[1]*[100]/6.2832" Accuracy="0.001" Maximum="1" MeasType="Position" Minimum="-1" TypicalMin="-0.1" TypicalMax="0.1" Precision="4" ShortNameTag="pos" SymbolTag="x" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="8" NameTag="Velocity" UnitType="mps" Type="Derivative" Inputs="7" Params="3" Accuracy="0.001" Maximum="0.5" MeasType="Velocity" Minimum="-0.5" TypicalMin="-0.1" TypicalMax="0.1" Precision="3" ShortNameTag="vel" SymbolTag="velocity" Visible="1"/>
        <Measurement ID="9" NameTag="Acceleration" UnitType="ms2" Type="Derivative" Inputs="8" Params="3" Accuracy="0.001" Maximum="0.2" MeasType="Acceleration" Minimum="-0.2" TypicalMin="-0.05" TypicalMax="0.05" Precision="3" ShortNameTag="acc" SymbolTag="a" Visible="1"/>
        <Measurement ID="100" NameTag="LinearAccessory" UnitType="Unitless" Type="Constant" HasCustom="1" CustomNameTag="LinearConversionValue" Internal="1" Value="0.15" Values="SmallPulley:0.03:MediumPulley:0.09:LargePulleyGroove:0.15:LargePulleyORing:0.175:UserDefined:1.00" ConstType="RMSLinear"/>
      </Sensor>
      <Sensor ID="2048" Tag="WirelessMotionSensor" Class="1" DefaultRate="20Hz" IconID="1130" MaxRate="250Hz" Model="PS-3219" SupportsZeroOnStart="1" SupportsRange="1">
        <Measurement ID="0" NameTag="EchoTime" UnitType="us" Type="RawDigital" DataSize="2" Accuracy="1" Internal="1" Maximum="20000" Minimum="0" Precision="0"/>
        <Measurement ID="1" NameTag="Position" UnitType="m" Equation="usound([0],[101])" Accuracy="0.001" CanChangeSign="1" Maximum="8" MeasType="Position" Minimum="0.015" TypicalMin="0" TypicalMax="1" OffsetZero="1" Precision="2" ShortNameTag="pos" SymbolTag="x" Visible="1" IsDefaultMeas="1"/>
        <Measurement ID="2" NameTag="Velocity" UnitType="mps" Type="Derivative" Inputs="1" Params="3" Accuracy="0.01" Maximum="2" MeasType="Velocity" Minimum="-2" TypicalMin="-0.5" TypicalMax="0.5" Precision="2" ShortNameTag="vel" SymbolTag="velocity" Visible="1"/>
        <Measurement ID="3" NameTag="Acceleration" UnitType="ms2" Type="Derivative" Inputs="2" Params="3" Accuracy="0.1" Maximum="10" MeasType="Acceleration" Minimum="-10" TypicalMin="-2" TypicalMax="2" Precision="2" ShortNameTag="acc" SymbolTag="a" Visible="1"/>
        <Measurement ID="100" NameTag="MotionRange" UnitType="Unitless" Type="Constant" Internal="1" MeasType="Velocity" Value="2" Values="MotionShort:1:MotionLong:2"  IsRange="1"/>
        <Measurement ID="101" NameTag="SpeedOfSound" UnitType="mps" Type="Constant" Internal="1" MeasType="Velocity" Value="344" ConstType="SpeedOfSound"/>
      </Sensor>
      <Sensor ID="2049" Tag="WirelessODOSensor" DefaultRate="1Hz" IconID="140" MaxRate="1Hz" Model="PS-3224">
        <Measurement ID="0" NameTag="RawDO2Saturation" Internal="1" Type="RawDigital" DataSize="2"/>
        <Measurement ID="1" NameTag="RawDO2Concentration" Internal="1" Type="RawDigital" DataSize="2"/>
        <Measurement ID="2" NameTag="RawTemperature" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="3" NameTag="UncalDO2Saturation" UnitType="percent" Equation="[0]*0.0045776" MeasType="Saturation" Internal="1"/>
        <Measurement ID="4" NameTag="DO2Saturation" UnitType="percent" Type="UserCal" Inputs="3" Params="0,0,100,100" CalFlags="0,0,1,1" MeasType="Saturation" Minimum="0" Maximum="100" TypicalMin="75" TypicalMax="100" Visible="1"/>
        <Measurement ID="5" NameTag="DO2Concentration" UnitType="mgpL" Equation="[1]*0.00030518" MeasType="Concentration" Minimum="0" Maximum="50" TypicalMin="4" TypicalMax="14" Visible="1" IsDefaultMeas="1"/>
        <Measurement ID="6" NameTag="O2GasConcentration" UnitType="percent" Equation="[4]*0.209" Accuracy="1" Maximum="100" Minimum="0" TypicalMin="75" TypicalMax="100" Precision="2" Visible="1"/>
		<Measurement ID="7" NameTag="Temperature" UnitType="DegC" Equation="([2]*0.0045776)-50" Accuracy="0.5" Maximum="135" MeasType="Temperature" Minimum="-35" TypicalMin="15" TypicalMax="30" Precision="1" ShortNameTag="Temp" SymbolTag="T" Visible="1"/>
        <Measurement ID="100" NameTag="Salinity" UnitType="ppt" Type="Constant" Description="DescSalinityConstantWODO" Internal="1" MeasType="Salinity" ConstType="Salinity" UserCalType="Constant" Value="0" Minimum="0.0" Maximum="40.0"/>
      </Sensor>
      <Sensor ID="2050" Tag="WirelessDropCounterSensor" DefaultRate="5Hz" IconID="207" MaxRate="10Hz" Model="PS-3214" ZeroOnRead="1" ZeroOnStart="1">
        <Measurement ID="0" NameTag="DropsSample" UnitType="drops" Type="RawDigital" DataSize="2" Accuracy="1" Maximum="50" MeasType="DropsPerSample" Minimum="0" Precision="0" SymbolTag="R" Visible="1"/>
        <Measurement ID="1" NameTag="DropCount" UnitType="drops" Type="RotaryPos" Inputs="0" Params="1,1" Accuracy="1" Maximum="500" MeasType="Count" Minimum="0" TypicalMin="0" TypicalMax="100" Precision="0" ShortNameTag="Drops" SymbolTag="N" Visible="1" IsDefaultMeas="1"/>
        <Measurement ID="2" NameTag="FluidVolume" UnitType="mL" Type="UserCal" Inputs="1" Params="0,0,30,1" CalFlags="0,0,1,1" Accuracy="0.01" DefaultUnit="mL" Maximum="20" MeasType="Volume" Minimum="0" Precision="2" ShortNameTag="Vol" SymbolTag="V" Visible="1"/>
        <Measurement ID="100" NameTag="DropVolume" UnitType="mL" Type="Constant" Internal="1" MeasType="Volume" Value="0.033" CalibrationID="2"/>
      </Sensor>
      <Sensor ID="2051" Tag="WirelessMagFieldSensor" DefaultRate="10Hz" MaxRate="100Hz" IconID="2051" SupportsRange="1" Model="PS-3221" SupportsZeroOnStart="1">
        <Measurement ID="0" NameTag="RawMagX" UnitType="Unitless" Type="RawDigital" TwosComp="1" DataSize="2" Internal="1"/>
        <Measurement ID="1" NameTag="RawMagY" UnitType="Unitless" Type="RawDigital" TwosComp="1" DataSize="2" Internal="1"/>
        <Measurement ID="2" NameTag="RawMagZ" UnitType="Unitless" Type="RawDigital" TwosComp="1" DataSize="2" Internal="1"/>
        <Measurement ID="3" NameTag="MagX50G" UnitType="utesla" Type="UserCal" Inputs="0" Params="0,0,1,0.15" CalFlags="0,1,0,0" MeasType="MagneticField" DefaultUnit="gauss" Internal="1"/>
        <Measurement ID="4" NameTag="MagY50G" UnitType="utesla" Type="UserCal" Inputs="1" Params="0,0,1,0.15" CalFlags="0,1,0,0" MeasType="MagneticField" DefaultUnit="gauss" Internal="1"/>
        <Measurement ID="5" NameTag="MagZ50G" UnitType="utesla" Type="UserCal" Inputs="2" Params="0,0,1,0.15" CalFlags="0,1,0,0" MeasType="MagneticField" DefaultUnit="gauss" Internal="1"/>
        <Measurement ID="6" NameTag="MagX1300G" UnitType="utesla" Type="UserCal" Inputs="0" Params="0,0,1,6.125" CalFlags="0,1,0,0" MeasType="MagneticField" DefaultUnit="gauss" Internal="1"/>
        <Measurement ID="7" NameTag="MagY1300G" UnitType="utesla" Type="UserCal" Inputs="1" Params="0,0,1,6.125" CalFlags="0,1,0,0" MeasType="MagneticField" DefaultUnit="gauss" Internal="1"/>
        <Measurement ID="8" NameTag="MagZ1300G" UnitType="utesla" Type="UserCal" Inputs="2" Params="0,0,1,6.125" CalFlags="0,1,0,0" MeasType="MagneticField" DefaultUnit="gauss" Internal="1"/>
        <Measurement ID="9" NameTag="MagFieldX" UnitType="utesla" Type="Select" Inputs="3,6" Accuracy="100" CanChangeSign="1" Maximum="10000" MeasType="MagneticField" DefaultUnit="gauss" Minimum="-10000" TypicalMin="-100" TypicalMax="100" OutputFormatMode="2" Precision="3" ShortNameTag="MagX" SymbolTag="Bx" OffsetZero="1" Visible="1"/>
        <Measurement ID="10" NameTag="MagFieldY" UnitType="utesla" Type="Select" Inputs="4,7" Accuracy="100" CanChangeSign="1" Maximum="10000" MeasType="MagneticField" DefaultUnit="gauss" Minimum="-10000" TypicalMin="-100" TypicalMax="100" OutputFormatMode="2" Precision="3" ShortNameTag="MagY" SymbolTag="By" OffsetZero="1" Visible="1"/>
        <Measurement ID="11" NameTag="MagFieldZ" UnitType="utesla" Type="Select" Inputs="5,8" Accuracy="100" CanChangeSign="1" Maximum="10000" MeasType="MagneticField" DefaultUnit="gauss" Minimum="-10000" TypicalMin="-100" TypicalMax="100" OutputFormatMode="2" Precision="3" ShortNameTag="MagZ" SymbolTag="Bz" OffsetZero="1" Visible="1"/>
        <Measurement ID="12" NameTag="MagFieldResultant" UnitType="utesla" Type="ThreeInputVector" Inputs="9,10,11" Accuracy="100" Maximum="10000" MeasType="MagneticField" DefaultUnit="gauss" Minimum="0" TypicalMin="0" TypicalMax="100" OutputFormatMode="2" Precision="3" ShortNameTag="MagR" SymbolTag="BR" Visible="1" IsDefaultMeas="1"/>
        <Measurement ID="100" NameTag="RangeSettings" UnitType="Unitless" Type="Constant" Internal="1" MeasType="None" Value="1" Values="pm50G:1:pm1300G:2" IsRange="1"/>
      </Sensor>
      <Sensor ID="2052" Tag="WirelessTempLink" DefaultRate="2Hz" IconID="136" MaxRate="20Hz" Model="PS-3222">
        <Measurement ID="0" NameTag="RawTemperature" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="1" NameTag="UncalTemperature" UnitType="DegC" Equation="([0]/172.463)-40" Internal="1"/>
		<Measurement ID="2" NameTag="Temperature" UnitType="DegC" Type="UserCal" Inputs="1" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="0.5" Maximum="135" MeasType="Temperature" Minimum="-35" TypicalMin="15" TypicalMax="30" Precision="1" ShortNameTag="Temp" SymbolTag="T" Visible="1"/>
      </Sensor>
      <Sensor ID="2053" Tag="WirelessAccelerometer" DefaultRate="20Hz" IconID="131" MaxRate="5000Hz" Model="PS-3223" SupportsZeroOnStart="1" SupportsRange="1" SupportsTrigger="1" MaxBurstSamples="10000">
        <Measurement ID="0" NameTag="X" UnitType="Unitless" Type="RawDigital" DataSize="2" TwosComp="1" Internal="1"/>
        <Measurement ID="1" NameTag="Y" UnitType="Unitless" Type="RawDigital" DataSize="2" TwosComp="1" Internal="1"/>
        <Measurement ID="2" NameTag="Z" UnitType="Unitless" Type="RawDigital" DataSize="2" TwosComp="1" Internal="1"/>
        <Measurement ID="3" NameTag="X16" UnitType="ms2" Type="FactoryCal" Inputs="0" Params="0,0,1,0.004787" Internal="1"/>
        <Measurement ID="4" NameTag="Y16" UnitType="ms2" Type="FactoryCal" Inputs="1" Params="0,0,1,0.004787" Internal="1"/>
        <Measurement ID="5" NameTag="Z16" UnitType="ms2" Type="FactoryCal" Inputs="2" Params="0,0,1,0.004787" Internal="1"/>
        <Measurement ID="6" NameTag="X100" UnitType="ms2" Type="FactoryCal" Inputs="0" Params="0,0,1,0.03" Internal="1"/>
        <Measurement ID="7" NameTag="Y100" UnitType="ms2" Type="FactoryCal" Inputs="1" Params="0,0,1,0.03" Internal="1"/>
        <Measurement ID="8" NameTag="Z100" UnitType="ms2" Type="FactoryCal" Inputs="2" Params="0,0,1,0.03" Internal="1"/>
        <Measurement ID="9" NameTag="X200" UnitType="ms2" Type="FactoryCal" Inputs="0" Params="0,0,1,0.06" Internal="1"/>
        <Measurement ID="10" NameTag="Y200" UnitType="ms2" Type="FactoryCal" Inputs="1" Params="0,0,1,0.06" Internal="1"/>
        <Measurement ID="11" NameTag="Z200" UnitType="ms2" Type="FactoryCal" Inputs="2" Params="0,0,1,0.06" Internal="1"/>
        <Measurement ID="12" NameTag="X400" UnitType="ms2" Type="FactoryCal" Inputs="0" Params="0,0,1,0.12" Internal="1"/>
        <Measurement ID="13" NameTag="Y400" UnitType="ms2" Type="FactoryCal" Inputs="1" Params="0,0,1,0.12" Internal="1"/>
        <Measurement ID="14" NameTag="Z400" UnitType="ms2" Type="FactoryCal" Inputs="2" Params="0,0,1,0.12" Internal="1"/>
        <Measurement ID="15" NameTag="Accelerationx" UnitType="ms2" Type="Select" Inputs="19,22,25,28" Accuracy="0.01" Maximum="10" MeasType="Acceleration" Minimum="-10" TypicalMin="-1" TypicalMax="1" OffsetZero="1" Precision="1" ShortNameTag="accx" SymbolTag="ax" Visible="1" SupportsTrigger="1"/>
        <Measurement ID="16" NameTag="Accelerationy" UnitType="ms2" Type="Select" Inputs="20,23,26,29" Accuracy="0.01" Maximum="10" MeasType="Acceleration" Minimum="-10" TypicalMin="-1" TypicalMax="1" OffsetZero="1" Precision="1" ShortNameTag="accy" SymbolTag="ay" Visible="1" SupportsTrigger="1"/>
        <Measurement ID="17" NameTag="Accelerationz" UnitType="ms2" Type="Select" Inputs="21,24,27,30" Accuracy="0.01" Maximum="10" MeasType="Acceleration" Minimum="-10" TypicalMin="-1" TypicalMax="1" OffsetZero="1" Precision="1" ShortNameTag="accz" SymbolTag="az" Visible="1" SupportsTrigger="1"/>
        <Measurement ID="18" NameTag="AccelerationResultant" UnitType="ms2" Type="ThreeInputVector" Inputs="15,16,17" Accuracy="0.01" Maximum="10" MeasType="Acceleration" Minimum="0" TypicalMin="0" TypicalMax="1" Precision="1" ShortNameTag="accresult" SymbolTag="a" Visible="1" IsDefaultMeas="1"/>
        <Measurement ID="19" NameTag="UX16" UnitType="ms2" Type="UserCal" Inputs="3" CalFlags="1,1,0,0" Params="0,0,9.81,9.81" Internal="1"/>
        <Measurement ID="20" NameTag="UY16" UnitType="ms2" Type="UserCal" Inputs="4" CalFlags="1,1,0,0" Params="0,0,9.81,9.81" Internal="1"/>
        <Measurement ID="21" NameTag="UZ16" UnitType="ms2" Type="UserCal" Inputs="5" CalFlags="1,1,0,0" Params="0,0,9.81,9.81" Internal="1"/>
        <Measurement ID="22" NameTag="UX100" UnitType="ms2" Type="UserCal" Inputs="6" CalFlags="1,1,0,0" Params="0,0,9.81,9.81" Internal="1"/>
        <Measurement ID="23" NameTag="UY100" UnitType="ms2" Type="UserCal" Inputs="7" CalFlags="1,1,0,0" Params="0,0,9.81,9.81" Internal="1"/>
        <Measurement ID="24" NameTag="UZ100" UnitType="ms2" Type="UserCal" Inputs="8" CalFlags="1,1,0,0" Params="0,0,9.81,9.81" Internal="1"/>
        <Measurement ID="25" NameTag="UX200" UnitType="ms2" Type="UserCal" Inputs="9" CalFlags="1,1,0,0" Params="0,0,9.81,9.81" Internal="1"/>
        <Measurement ID="26" NameTag="UY200" UnitType="ms2" Type="UserCal" Inputs="10" CalFlags="1,1,0,0" Params="0,0,9.81,9.81" Internal="1"/>
        <Measurement ID="27" NameTag="UZ200" UnitType="ms2" Type="UserCal" Inputs="11" CalFlags="1,1,0,0" Params="0,0,9.81,9.81" Internal="1"/>
        <Measurement ID="28" NameTag="UX400" UnitType="ms2" Type="UserCal" Inputs="12" CalFlags="1,1,0,0" Params="0,0,9.81,9.81" Internal="1"/>
        <Measurement ID="29" NameTag="UY400" UnitType="ms2" Type="UserCal" Inputs="13" CalFlags="1,1,0,0" Params="0,0,9.81,9.81" Internal="1"/>
        <Measurement ID="30" NameTag="UZ400" UnitType="ms2" Type="UserCal" Inputs="14" CalFlags="1,1,0,0" Params="0,0,9.81,9.81" Internal="1"/>
        <Measurement ID="100" NameTag="RangeSettings" UnitType="Unitless" Type="Constant" Internal="1" MeasType="None" Value="1" Values="pm16g:1:pm100g:2:pm200g:3:pm400g:4" IsRange="1"/>
		</Sensor>
      <Sensor ID="2054" Tag="WirelessAltimeter" DefaultRate="20Hz" IconID="208" MaxRate="200Hz" Model="PS-3223" SupportsZeroOnStart="1" SupportsRange="1">
        <Measurement ID="0" NameTag="RawAltitude" UnitType="Unitless" Type="RawDigital" DataSize="4" Internal="1"/>
        <Measurement ID="1" NameTag="Altitude" UnitType="m" Type="UserCal" Inputs="2" Params="0,0,1,1" CalFlags="1,1,0,0" MeasType="Position" OffsetZero="1" ShortNameTag="Alt" SymbolTag="h" Precision="1" Minimum="0" Maximum="5000" TypicalMin="0" TypicalMax="300" Visible="1"/>
        <Measurement ID="2" NameTag="Altitude" UnitType="m" Equation="[0]/1000" Internal="1"/>
        <Measurement ID="100" NameTag="FilterSettings" UnitType="Unitless" Type="Constant" Internal="1" MeasType="None" Value="2" Values="FilterLow:1:FilterMedium:2:FilterHigh:3" IsRange="1"/>
      </Sensor>
      <Sensor ID="2055" Tag="WirelessSmartGateSensor" DefaultRate="20Hz" IconID="208" MaxRate="50Hz" Model="PS-3225">
        <Measurement ID="0" NameTag="Blocked" UnitType="Unitless" Type="RawDigital" DataSize="1" Internal="1"/>
        <Measurement ID="1" NameTag="TimeStamp" UnitType="us" Type="RawDigital" DataSize="2" Internal="1"/>
      </Sensor>
      <Sensor ID="2056" Tag="WirelessGyroSensor" DefaultRate="20Hz" IconID="1132" MaxRate="1000Hz" Model="PS-3223" SupportsZeroOnStart="1" SupportsTrigger="1" MaxBurstSamples="10000">
        <Measurement ID="0" NameTag="X" Type="RawDigital" DataSize="2" TwosComp="1" Internal="1"/>
        <Measurement ID="1" NameTag="Y" Type="RawDigital" DataSize="2" TwosComp="1" Internal="1"/>
        <Measurement ID="2" NameTag="Z" Type="RawDigital" DataSize="2" TwosComp="1" Internal="1"/>
        <Measurement ID="3" NameTag="AngularVelocityx" UnitType="degps" Type="FactoryCal" Inputs="0" Params="0,0,1,0.07" Accuracy="0.01" Maximum="10" MeasType="AngularVelocity" Minimum="-10" TypicalMin="-1" TypicalMax="1" OffsetZero="1" Precision="1" ShortNameTag="angvelx" SymbolTag="omegaLx" Visible="1" SupportsTrigger="1"/>
        <Measurement ID="4" NameTag="AngularVelocityy" UnitType="degps" Type="FactoryCal" Inputs="1" Params="0,0,1,0.07" Accuracy="0.01" Maximum="10" MeasType="AngularVelocity" Minimum="-10" TypicalMin="-1" TypicalMax="1" OffsetZero="1" Precision="1" ShortNameTag="angvely" SymbolTag="omegaLy" Visible="1" SupportsTrigger="1"/>
        <Measurement ID="5" NameTag="AngularVelocityz" UnitType="degps" Type="FactoryCal" Inputs="2" Params="0,0,1,0.07" Accuracy="0.01" Maximum="10" MeasType="AngularVelocity" Minimum="-10" TypicalMin="-1" TypicalMax="1" OffsetZero="1" Precision="1" ShortNameTag="angvelz" SymbolTag="omegaLz" Visible="1" SupportsTrigger="1"/>
      </Sensor>
      <Sensor ID="2057" Tag="WirelessOxygenGasSensor" DefaultRate="1Hz" IconID="210" MaxRate="10Hz" Model="PS-3217">
        <Measurement ID="0" NameTag="RawO2" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="1" NameTag="RawTemp" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="2" NameTag="RawHumidity" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="3" NameTag="OxygenGasConcentration" UnitType="pph" Type="UserCal" Inputs="0" Params="0,0,13697,20.9" CalFlags="0,0,1,1" MeasType="Concentration" DefaultUnit="pph" Precision="1" Minimum="0" Maximum="100" TypicalMin="75" TypicalMax="100" ShortNameTag="O2Conc" SymbolTag="O2" Visible="1" IsDefaultMeas="1"/>
        <Measurement ID="4" NameTag="Temperature" UnitType="DegC" Equation="(([1]/65536)*165)-40" MeasType="Temperature" Precision="1" ShortNameTag="Temp" SymbolTag="T" Minimum="0" Maximum="100" TypicalMin="15" TypicalMax="30" Visible="1"/>
        <Measurement ID="5" NameTag="RelativeHumidity" UnitType="percent" Equation="([2]/65536)*100" MeasType="Humidity" ShortNameTag="RelHumid" SymbolTag="RH" Precision="1" Minimum="0" Maximum="100" TypicalMin="15" TypicalMax="85" Visible="1"/>
        <Measurement ID="6" NameTag="AbsoluteHumidity" UnitType="gpm3" Equation="((13.24*[5])/([4]+273.15))*(2.71828^((17.42*[4])/([4]+239.7)))" MeasType="AbsoluteHumidity" ShortNameTag="AbsHum" SymbolTag="H" Precision="1" Minimum="0" Maximum="100" TypicalMin="5" TypicalMax="20" Visible="1"/>
      </Sensor>
      <Sensor ID="2058" Tag="DiffractionPosition" DefaultRate="20Hz" IconID="1131" MaxRate="100Hz" Model="OS-8441" SupportsZeroOnStart="1" ZeroOnStart="1" ZeroOnRead="1">
        <Measurement ID="0" NameTag="RawCountChange" Type="RawDigital" DataSize="2" TwosComp="1" CanChangeSign="1" Internal="1"/>
        <Measurement ID="1" NameTag="Position" UnitType="m" Type="RotaryPos" Inputs="0" Params="0.01,2000" Accuracy="0.00001" Maximum="1" MeasType="Position" Minimum="-1" TypicalMin="-0.1" TypicalMax="0.1" Precision="2" ShortNameTag="pos" SymbolTag="x" DefaultUnit="mm" Visible="1" IsDefaultMeas="1"/>
      </Sensor>
      <Sensor ID="2059" Tag="DiffractionIntensity" DefaultRate="20Hz" IconID="234" MaxRate="100Hz" Model="OS-8441" SupportsZeroOnStart="1" SupportsRange="1">
        <Measurement ID="0" NameTag="RawIntensity" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="1" NameTag="LightIntensity" UnitType="percent" Type="LinearConv" Inputs="0" Params="0.0015259,0" MeasType="LightIntensity" Precision="1" ShortNameTag="Intens" SymbolTag="IntensityLight" Minimum="0" Maximum="100" TypicalMin="0" TypicalMax="10" Visible="1" OffsetZero="1"/>
        <Measurement ID="2" NameTag="LogLightIntensity" UnitType="Unitless" Equation="log(limit([1],0.01,100))+2" MeasType="LightIntensity" Precision="1" Minimum="-0" Maximum="4" TypicalMin="0" TypicalMax="2" Visible="1" SymbolTag="IntensityLight"/>
        <Measurement ID="100" NameTag="Sensitivity" UnitType="Unitless" Type="Constant" Description="DescSensitivity" Internal="1" MeasType="None" Value="2" Values="FilterLow:1:FilterMedium:2:FilterHigh:3" IsRange="1"/>
      </Sensor>
      <!-- Sensor ID=2060 is the Wireless ACDC Module, but for its "sensor name" I can use the regular OutputVoltageSensor tag  -->
      <Sensor ID="2060" Tag="OutputVoltageSensor" DefaultRate="20Hz" IconID="135" MaxBurstRate="100000Hz" MaxRate="1000Hz" Model="EM-3533" SupportsTrigger="1" SupportsZeroOnStart="1" MaxBurstSamples="500">
        <Measurement ID="0" NameTag="RawWaveVoltage" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="1" NameTag="Voltage" UnitType="V" Type="FactoryCal" Inputs="0" Params="0,32768,3,65535" Accuracy="0.005" Maximum="3" MeasType="Voltage" Minimum="-3" TypicalMin="-1" TypicalMax="1" OffsetZero="1" Precision="3" ShortNameTag="Volt" SymbolTag="V" Visible="1"/>
      </Sensor>
      <Sensor ID="2061" Tag="WirelessLightSensor1" DefaultRate="1Hz" IconID="132" MaxRate="2Hz" Model="PS-3213A">
        <Measurement ID="0" NameTag="R" UnitType="percent" Type="LinearConv" Inputs="9" Params="0.0015258,0" Internal="1" MeasType="LightIntensity" Precision="1" Minimum="0" Maximum="100" Visible="1" SymbolTag="r"/>
        <Measurement ID="1" NameTag="G" UnitType="percent" Type="LinearConv" Inputs="10" Params="0.0015258,0" Internal="1" MeasType="LightIntensity" Precision="1" Minimum="0" Maximum="100" Visible="1" SymbolTag="g"/>
        <Measurement ID="2" NameTag="B" UnitType="percent" Type="LinearConv" Inputs="11" Params="0.0015258,0" Internal="1" MeasType="LightIntensity" Precision="1" Minimum="0" Maximum="100" Visible="1" SymbolTag="b"/>
        <Measurement ID="3" NameTag="IR" UnitType="percent" Type="LinearConv" Inputs="12" Params="0.0015258,0" Internal="1" MeasType="LightIntensity" Precision="1" Minimum="0" Maximum="100" Visible="1" SymbolTag="ir"/>
        <Measurement ID="7" NameTag="UVIndex" UnitType="Unitless" Type="UserCal" Inputs="15" Params="0,0,1,1" CalFlags="0,0,1,1" MeasType="UVIndex" Visible="1" SymbolTag="UVi"/>
        <Measurement ID="8" NameTag="Illuminance" UnitType="lux" Type="LinearConv" Inputs="16" Params="2,0" MeasType="LightIntensity" Minimum="0" Maximum="50000" Visible="1" SymbolTag="Illum" IsDefaultMeas="1"/>
        <Measurement ID="9" NameTag="R" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="10" NameTag="G" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="11" NameTag="B" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="12" NameTag="IR" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="15" NameTag="UVIRaw" UnitType="Unitless" Type="RawDigital" DataSize="2" Visible="1"/>
        <Measurement ID="16" NameTag="LuxCal" Type="FactoryCal" Inputs="10" Params="0,0,1,1" Internal="1"/>
        <Measurement ID="17" NameTag="SolarIrradiance" UnitType="wpm2" Type="LinearConv" Inputs="8" Params="0.0104,0" MeasType="LightIntensity" Minimum="0" Maximum="500" Visible="1" ShortNameTag="IrradianceSN" SymbolTag="Irrad"/>
        <Measurement ID="18" NameTag="SolarPAR" UnitType="umolpm2ps" Type="LinearConv" Inputs="8" Params="0.0185,0" MeasType="PAR" Minimum="0" Maximum="1000" Visible="1" ShortNameTag="PAR" SymbolTag="PAR"/>
      </Sensor>
      <Sensor ID="2062" Tag="WirelessSoundWaveSensor" DefaultRate="1000Hz" IconID="2062" MaxBurstRate="100000Hz" MaxRate="2000Hz" Model="PS-3227" SupportsTrigger="1" SupportsZeroOnStart="1" MaxBurstSamples="500">
        <Measurement ID="0" NameTag="RawSoundWave" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="1" NameTag="SoundWave" UnitType="percent" Type="LinearConv" Inputs="0" Params="0.00305,-93" Accuracy="0.001" Maximum="50" MeasType="SoundIntensity" SymbolTag="IntensitySound" Minimum="-50" TypicalMin="-5" TypicalMax="5" OffsetZero="1" Precision="0.001" Visible="1"/>
      </Sensor>
      <Sensor ID="2063" Tag="WirelessSoundLevelSensor" DefaultRate="5Hz" IconID="2063" MaxRate="20Hz" Model="PS-3227">
        <Measurement ID="0" NameTag="SoundLevelA" UnitType="dBA" Type="LinearConv" Inputs="2" Params="0.1,0" Accuracy="3" Maximum="125" MeasType="SoundLevelA" Minimum="25" TypicalMin="25" TypicalMax="80" Precision="1" ShortNameTag="SoundLvlA" SymbolTag="IA" Visible="1"/>
        <Measurement ID="1" NameTag="SoundLevelC" UnitType="dBC" Type="LinearConv" Inputs="3" Params="0.1,0" Accuracy="3" Maximum="125" MeasType="SoundLevelC" Minimum="25" TypicalMin="25" TypicalMax="80" Precision="1" ShortNameTag="SoundLvlC" SymbolTag="IC" Visible="1" IsDefaultMeas="1"/>
        <Measurement ID="2" NameTag="RawSoundLevelA" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="3" NameTag="RawSoundLevelC" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
      </Sensor>
      <Sensor ID="2064" Tag="STEMMotorPosition" DefaultRate="20Hz" IconID="1131" MaxRate="1000Hz" Model="PS-3220" SupportsZeroOnStart="1" ZeroOnRead="1" ZeroOnStart="1">
        <Measurement ID="0" NameTag="RawCountChange" Type="RawDigital" DataSize="2" TwosComp="1" CanChangeSign="1" Internal="1"/>
        <Measurement ID="1" NameTag="RawCountChange" Type="RawDigital" DataSize="2" TwosComp="1" CanChangeSign="1" Internal="1"/>
        <Measurement ID="2" NameTag="RawCountChange" Type="RawDigital" DataSize="2" TwosComp="1" CanChangeSign="1" Internal="1"/>
        <Measurement ID="3" NameTag="RawCountChange" Type="RawDigital" DataSize="2" TwosComp="1" CanChangeSign="1" Internal="1"/>
        <Measurement ID="4" NameTag="Angle %1" UnitType="rad" Type="RotaryPos" Inputs="0" Params="6.28319,816" Ordinal = "1" Accuracy="0.002" Maximum="6.5" MeasType="Angle" Minimum="-6.5" TypicalMin="-1" TypicalMax="1" Precision="3" ShortNameTag="ang" SymbolTag="thetaL" Visible="1" IsDefaultMeas="1"/>
        <Measurement ID="5" NameTag="Angle %1" UnitType="rad" Type="RotaryPos" Inputs="1" Params="6.28319,816" Ordinal = "2" Accuracy="0.002" Maximum="6.5" MeasType="Angle" Minimum="-6.5" TypicalMin="-1" TypicalMax="1" Precision="3" ShortNameTag="ang" SymbolTag="thetaL" Visible="1"/>
        <Measurement ID="6" NameTag="Angle %1" UnitType="rad" Type="RotaryPos" Inputs="2" Params="6.28319,816" Ordinal = "3" Accuracy="0.002" Maximum="6.5" MeasType="Angle" Minimum="-6.5" TypicalMin="-1" TypicalMax="1" Precision="3" ShortNameTag="ang" SymbolTag="thetaL" Visible="1"/>
        <Measurement ID="7" NameTag="Angle %1" UnitType="rad" Type="RotaryPos" Inputs="3" Params="6.28319,816" Ordinal = "4" Accuracy="0.002" Maximum="6.5" MeasType="Angle" Minimum="-6.5" TypicalMin="-1" TypicalMax="1" Precision="3" ShortNameTag="ang" SymbolTag="thetaL" Visible="1"/>
        <Measurement ID="8" NameTag="AngularVelocity %1" UnitType="radps" Type="Derivative" Inputs="4" Params="3" Ordinal = "1" Accuracy="0.002" Maximum="6.5" MeasType="AngularVelocity" Minimum="-6.5" TypicalMin="-1" TypicalMax="1" Precision="3" ShortNameTag="angvel" SymbolTag="omegaL" Visible="1"/>
        <Measurement ID="9" NameTag="AngularVelocity %1" UnitType="radps" Type="Derivative" Inputs="5" Params="3" Ordinal = "2" Accuracy="0.002" Maximum="6.5" MeasType="AngularVelocity" Minimum="-6.5" TypicalMin="-1" TypicalMax="1" Precision="3" ShortNameTag="angvel" SymbolTag="omegaL" Visible="1"/>
        <Measurement ID="10" NameTag="AngularVelocity %1" UnitType="radps" Type="Derivative" Inputs="6" Params="3" Ordinal = "3" Accuracy="0.002" Maximum="6.5" MeasType="AngularVelocity" Minimum="-6.5" TypicalMin="-1" TypicalMax="1" Precision="3" ShortNameTag="angvel" SymbolTag="omegaL" Visible="1"/>
        <Measurement ID="11" NameTag="AngularVelocity %1" UnitType="radps" Type="Derivative" Inputs="7" Params="3" Ordinal = "4" Accuracy="0.002" Maximum="6.5" MeasType="AngularVelocity" Minimum="-6.5" TypicalMin="-1" TypicalMax="1" Precision="3" ShortNameTag="angvel" SymbolTag="omegaL" Visible="1"/>
      </Sensor>
      <Sensor ID="2065" Tag="WirelessSoilMoisture" DefaultRate="1Hz" IconID="257" MaxRate="1Hz" Model="PS-3228">
        <Measurement ID="0" NameTag="adc" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="1" NameTag="VWCLoamRaw" UnitType="Unitless" Equation="table([0],7122,45,14100,20,17245,15,51725,0)" MeasType="PercentVWC" Internal="1"/>
        <Measurement ID="2" NameTag="VWCSandRaw" UnitType="Unitless" Equation="table([0],6344,35,11964,15,50689,0)" MeasType="PercentVWC" Internal="1"/>
        <Measurement ID="3" NameTag="VWCClayRaw" UnitType="Unitless" Equation="table([0],6499,45,11234,25,19999,15,52875,0)" MeasType="PercentVWC" Internal="1"/>
        <Measurement ID="4" NameTag="VWCLoam" UnitType="percent" Type="UserCal" Inputs="1" Params="0,0,45,45" CalFlags="1,1,1,1" Limits="0,100" Accuracy="1" Maximum="100" TypicalMin="0" TypicalMax="50" MeasType="PercentVWC" SymbolTag="thetaL" Minimum="0" Precision="0" Visible="1"/>
        <Measurement ID="5" NameTag="VWCSand" UnitType="percent" Type="UserCal" Inputs="2" Params="0,0,35,35" CalFlags="1,1,1,1" Limits="0,100" Accuracy="1" Maximum="100" TypicalMin="0" TypicalMax="50" MeasType="PercentVWC" SymbolTag="thetaL" Minimum="0" Precision="0" Visible="1"/>
        <Measurement ID="6" NameTag="VWCClay" UnitType="percent" Type="UserCal" Inputs="3" Params="0,0,45,45" CalFlags="1,1,1,1" Limits="0,100" Accuracy="1" Maximum="100" TypicalMin="0" TypicalMax="50" MeasType="PercentVWC" SymbolTag="thetaL" Minimum="0" Precision="0" Visible="1"/>
        <Measurementx ID="10" NameTag="GWCCalc" UnitType="percent" Equation="table([0],10747,-0.00186,100,31979,-0.000938,90.1,42332,-0.00193,121.8,55046,-0.00157,106.6,65535,-0.00191,125)" Accuracy="1" Maximum="100" MeasType="PercentVWC" SymbolTag="thetaL" Minimum="0" Precision="0" Visible="1"/>
      </Sensor>
      <Sensor ID="2066" Tag="CodeNodeTempLightSound" DefaultRate="20Hz" IconID="136" MaxRate="100Hz" Model="PS-3231">
        <Measurement ID="0" NameTag="RawTemperature" Type="RawDigital" DataSize="2" TwosComp="1" Internal="1"/>
        <Measurement ID="1" NameTag="RawLight" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="2" NameTag="RawSoundLevel" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
		<Measurement ID="3" NameTag="Temperature" UnitType="DegC" Equation="[0]*0.01" Accuracy="0.5" Maximum="135" MeasType="Temperature" Minimum="-35" TypicalMin="15" TypicalMax="30" Precision="1" ShortNameTag="Temp" SymbolTag="T" Visible="1"/>
        <Measurement ID="4" NameTag="Brightness" UnitType="percent" Equation="sqrt([1])*0.3906" MeasType="Brightness" Minimum="0" Maximum="100" TypicalMin="0" TypicalMax="20" Visible="1" ShortNameTag="brightness" SymbolTag="brns" IsDefaultMeas="1"/>
        <Measurement ID="5" NameTag="Loudness" UnitType="percent" Equation="[2]*0.001526" Accuracy="0" Maximum="100" MeasType="Loudness" Minimum="0" TypicalMin="0" TypicalMax="50" Precision="1" ShortNameTag="loudness" SymbolTag="ldns" Visible="1"/>
      </Sensor>
      <Sensor ID="2067" Tag="CodeNodeMagneticField" DefaultRate="20Hz" MaxRate="100Hz" IconID="134" Model="PS-3231" SupportsZeroOnStart="1">
        <Measurement ID="0" NameTag="RawMagX" UnitType="Unitless" Type="RawDigital" TwosComp="1" DataSize="2" Internal="1"/>
        <Measurement ID="1" NameTag="RawMagY" UnitType="Unitless" Type="RawDigital" TwosComp="1" DataSize="2" Internal="1"/>
        <Measurement ID="2" NameTag="RawMagZ" UnitType="Unitless" Type="RawDigital" TwosComp="1" DataSize="2" Internal="1"/>
        <Measurement ID="7" NameTag="MagneticFieldStrength" UnitType="utesla" Equation="[1]*0.15" MeasType="MagneticField" DefaultUnit="gauss" Minimum="-1000" Maximum="1000" ShortNameTag="MagField" SymbolTag="B" Visible="1" OffsetZero="1" CanChangeSign="1"/>
      </Sensor>
      <Sensor ID="2068" Tag="CodeNodeMotion" DefaultRate="20Hz" IconID="2068" MaxRate="100Hz" SupportsZeroOnStart="1" Model="PS-3231" SupportsRange="1">
        <Measurement ID="0" NameTag="RawX" UnitType="Unitless" Type="RawDigital" DataSize="2" TwosComp="1" Internal="1"/>
        <Measurement ID="1" NameTag="RawY" UnitType="Unitless" Type="RawDigital" DataSize="2" TwosComp="1" Internal="1"/>
        <Measurement ID="2" NameTag="RawZ" UnitType="Unitless" Type="RawDigital" DataSize="2" TwosComp="1" Internal="1"/>
        <Measurement ID="3" NameTag="Accelerationx" UnitType="ms2" Equation="[9]" CanChangeSign="1" OffsetZero="1" Accuracy="0.01" Maximum="10" TypicalMin="-1" TypicalMax="1" MeasType="Acceleration" ShortNameTag="accx" SymbolTag="ax" Minimum="-10" Precision="1" Visible="1"/>
        <Measurement ID="4" NameTag="Accelerationy" UnitType="ms2" Equation="[10]" CanChangeSign="1" OffsetZero="1" Accuracy="0.01" Maximum="10" TypicalMin="-1" TypicalMax="1" MeasType="Acceleration" ShortNameTag="accy" SymbolTag="ay" Minimum="-10" Precision="1" Visible="1"/>
        <Measurement ID="5" NameTag="MotionZ" UnitType="ms2" Equation="[11]" CanChangeSign="1" OffsetZero="1" Accuracy="0.01" Maximum="10" MeasType="Acceleration" Minimum="-10" Precision="1" Internal="1"/>
        <Measurement ID="7" NameTag="TiltAngleX" UnitType="deg" DefaultUnit="deg" Equation="atan2([9],sqrt(([10]*[10])+([11]*[11])))*180/3.1416" CanChangeSign="1" OffsetZero="1" Accuracy="0.01" Maximum="90" MeasType="Direction" ShortNameTag="tiltX" SymbolTag="thetaX" Minimum="-90" Precision="1" Visible="1"/>
        <Measurement ID="8" NameTag="TiltAngleY" UnitType="deg" DefaultUnit="deg" Equation="atan2([10],sqrt(([9]*[9])+([11]*[11])))*180/3.1416" CanChangeSign="1" OffsetZero="1" Accuracy="0.01" Maximum="90" MeasType="Direction" ShortNameTag="tiltY" SymbolTag="thetaY" Minimum="-90" Precision="1" Visible="1"/>
        <Measurement ID="9" NameTag="FCalMotionX" UnitType="ms2" Type="FactoryCal" Inputs="0" Params="0,0,1,0.002394" Internal="1"/>
        <Measurement ID="10" NameTag="FCalMotionY" UnitType="ms2" Type="FactoryCal" Inputs="1" Params="0,0,1,0.002394" Internal="1"/>
        <Measurement ID="11" NameTag="FCalMotionZ" UnitType="ms2" Type="FactoryCal" Inputs="2" Params="0,0,1,0.002394" Internal="1"/>
        <Measurement ID="12" NameTag="RawCartPosition" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="13" NameTag="CartPosition" UnitType="m" Equation="codenodepos([12],0.0001,.0247)" Minimum="0" Maximum="2" TypicalMin="0" TypicalMax="0.2" MeasType="Position" ShortNameTag="pos" SymbolTag="x" Visible="1"/>
        <Measurement ID="14" NameTag="CartVelocity" UnitType="mps" Type="Derivative" Inputs="13" Params="3" Minimum="0" Maximum="2" TypicalMin="0" TypicalMax="0.1" MeasType="Velocity" ShortNameTag="vel" SymbolTag="velocity" Visible="1"/>
	  </Sensor>
      <Sensor ID="2069" Tag="CodeNodeButtons" DefaultRate="20Hz" IconID="2069" MaxRate="100Hz" Model="PS-3231">
        <Measurement ID="0" NameTag="Button1" UnitType="Unitless" ShortNameTag="button1" SymbolTag="btn1" Type="RawDigital" DataSize="1" Precision="0" Minimum="0" Maximum="1" Visible="1"/>
        <Measurement ID="1" NameTag="Button2" UnitType="Unitless" ShortNameTag="button2" SymbolTag="btn2" Type="RawDigital" DataSize="1" Precision="0" Minimum="0" Maximum="1" Visible="1"/>
      </Sensor>
      <Sensor ID="2070" Tag="ControlNodeStepperPosition" DefaultRate="20Hz" IconID="1131" MaxRate="100Hz" Model="PS-2970" SupportsZeroOnStart="1" ZeroOnRead="1" ZeroOnStart="1">
        <Measurement ID="0" NameTag="RawCountChange1" Type="RawDigital" DataSize="2" TwosComp="1" UnitType="Unitless" CanChangeSign="1" Internal="1"/>
        <Measurement ID="1" NameTag="RawCountChange2" Type="RawDigital" DataSize="2" TwosComp="1" UnitType="Unitless" CanChangeSign="1" Internal="1"/>
        <Measurement ID="2" NameTag="AngleOrd" UnitType="rad" DefaultUnit="deg" Type="RotaryPos" Inputs="0" Params="6.28319,480" Ordinal = "1" Accuracy="0.002" Maximum="6.5" MeasType="Angle" Minimum="-6.5" TypicalMin="-1" TypicalMax="1" Precision="3" ShortNameTag="ang" SymbolTag="thetaL" Visible="1" IsDefaultMeas="1"/>
        <Measurement ID="3" NameTag="AngleOrd" UnitType="rad" DefaultUnit="deg" Type="RotaryPos" Inputs="1" Params="6.28319,480" Ordinal = "2" Accuracy="0.002" Maximum="6.5" MeasType="Angle" Minimum="-6.5" TypicalMin="-1" TypicalMax="1" Precision="3" ShortNameTag="ang" SymbolTag="thetaL" Visible="1"/>
        <Measurement ID="4" NameTag="AngularVelocityOrd" UnitType="radps" DefaultUnit="degps" Type="Derivative" Inputs="2" Params="3" Ordinal = "1" Accuracy="0.002" Maximum="6.5" MeasType="AngularVelocity" Minimum="-6.5" TypicalMin="-1" TypicalMax="1" Precision="3" ShortNameTag="angvel" SymbolTag="omegaL" Visible="1"/>
        <Measurement ID="5" NameTag="AngularVelocityOrd" UnitType="radps" DefaultUnit="degps" Type="Derivative" Inputs="3" Params="3" Ordinal = "2" Accuracy="0.002" Maximum="6.5" MeasType="AngularVelocity" Minimum="-6.5" TypicalMin="-1" TypicalMax="1" Precision="3" ShortNameTag="angvel" SymbolTag="omegaL" Visible="1"/>
      </Sensor>
      <Sensor ID="2071" Tag="WirelessSpirometer" DefaultRate="50Hz" IconID="2071" MaxRate="1000Hz" Model="PS-3234">
        <Measurement ID="0" NameTag="RawFlowRate" UnitType="Unitless" Type="RawDigital" DataSize="2" TwosComp="1" Internal="1"/>
        <Measurement ID="1" NameTag="VolumetricFlowRate" UnitType="Lps" Equation="[0]/1000.0" MeasType="VolumeFlowRate" Minimum="0" Maximum="30" ShortNameTag="VoluFlowRate" SymbolTag="flowRateVolume" TypicalMin="0" TypicalMax="30" Visible="1"/>
        <Measurement ID="2" NameTag="TotalFlowVolume" UnitType="L" Equation="integral([1])" MeasType="FlowVolume" Minimum="0" Maximum="10" ShortNameTag="TotFlowVol" SymbolTag="totFloVol" TypicalMin="0" TypicalMax="10" Visible="1"/>
        <Measurement ID="3" NameTag="MaxFlowRate" UnitType="Lps" Equation="max([1])" MeasType="VolumeFlowRate" Minimum="0" Maximum="10" ShortNameTag="MaxFlow" SymbolTag="Rmax" TypicalMin="3" TypicalMax="6" Visible="1"/>
        <Measurement ID="4" NameTag="PerBreathVolume" UnitType="L" Equation="perbreathvolume([1],[2],3)" MeasType="FlowVolume" Minimum="0" Maximum="10" ShortNameTag="PerBreathVol" SymbolTag="perBreathV" TypicalMin="0" TypicalMax="3" Visible="1"/>
        <Measurement ID="5" NameTag="LungVolume" UnitType="L" Equation="2.5-[2]" MeasType="FlowVolume" Minimum="0" Maximum="10" ShortNameTag="LungVol" SymbolTag="lungV" TypicalMin="0" TypicalMax="6" Visible="1" IsDefaultMeas="1"/>
        <Measurementx ID="10" NameTag="RawPressure" UnitType="Unitless" Type="RawDigital" DataSize="2" TwosComp="1" Internal="1"/>
      </Sensor>
      <Sensor ID="2072" Tag="WirelessPowerMeter" DefaultRate="20Hz" IconID="208" MaxRate="100Hz" Model="XX-XXXX">
        <Measurement ID="0" NameTag="RawShuntVoltage" UnitType="Unitless" Type="RawDigital" TwosComp="1" DataSize="2" Internal="1"/>
        <Measurement ID="1" NameTag="RawBusVoltage" UnitType="Unitless" Type="RawDigital" TwosComp="1" DataSize="2" Internal="1"/>
        <Measurement ID="2" NameTag="ShuntVoltage" UnitType="V" Equation="[0]*0.0000025" Visible="1"/>
        <Measurement ID="3" NameTag="BusVoltage" UnitType="V" Equation="[1]*0.00125" Visible="1"/>
        <Measurement ID="4" NameTag="ShuntCurrent" UnitType="A" Equation="[2]*10.0" Visible="1"/>
        <Measurement ID="5" NameTag="Power" UnitType="W" Equation="[3]*[4]" Visible="1"/>
      </Sensor>
      <Sensor ID="2073" Tag="WirelessPolarimeter" Model="PS-3237" DefaultRate="100Hz" IconID="3003" MaxRate="1000Hz">
        <Measurement ID="0" NameTag="RawPosition" UnitType="Unitless" Type="RawDigital" DataSize="2" TwosComp="1" Internal="1" MeasType="Position"/>
        <Measurement ID="1" NameTag="Intensity" UnitType="Unitless" Type="RawDigital" DataSize="2" Accuracy="1" Maximum="1000" MeasType="Intensity" Minimum="0" Precision="0" Visible="1"/>
        <Measurement ID="2" NameTag="Angle" UnitType="deg" Type="LinearConv" Inputs="0" Params="0.09,0" Accuracy="0.1" DefaultUnit="deg" Display="Graph" Maximum="360" MeasType="Angle" Minimum="0" Precision="1" Visible="1"/>
      </Sensor>
      <Sensor ID="2074" Tag="EKGVoltage" DefaultRate="200Hz" IconID="147" MaxRate="1000Hz" MinRate="50Hz" Model="PS-3236">
        <Measurement ID="0" NameTag="RawVoltage" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="1" NameTag="Voltage" UnitType="mV" Equation="smooth((([0]-28500)*0.000065),17)" Accuracy="0.005" DefaultUnit="mV" Maximum="3" MeasType="Voltage" Minimum="-3" Precision="3" ShortNameTag="Volt" SymbolTag="V" Visible="1"/>
      </Sensor>
      <Sensor ID="2075" Tag="EKGHeartRate" DefaultRate="1s" IconID="147" MaxRate="1s" Model="PS-3236">
        <Measurement ID="0" NameTag="RawHeartRate" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="1" NameTag="HeartRate" UnitType="BeatsPerMin" Equation="ekgbeat(timestamp([0],0.0001),[100])" Accuracy="1" Maximum="250" MeasType="HeartRate" Minimum="30" Precision="0" ShortNameTag="HeartRt" SymbolTag="HR" TypicalMax="120" TypicalMin="50" Visible="1"/>
        <Measurement ID="100" NameTag="HeartRateAveraging" UnitType="Unitless" Type="Constant" Internal="1" Value="0" Description="DescHeartRateAveraging" Values="NoAveraging:0:FiveSecondAvg:5"/>
      </Sensor>
      <Sensor ID="2076" Tag="WirelessForcePlatform" DefaultRate="20Hz" IconID="225" MaxRate="10000Hz" SupportsZeroOnStart="1" ZeroOnStart="0" SupportsTrigger="1" MaxBurstSamples="8190" Model="PS-3229">
        <Measurement ID="0" NameTag="RawForce1" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="1" NameTag="RawForce2" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="2" NameTag="RawForce3" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="3" NameTag="RawForce4" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="5" NameTag="ForceBeamOrd" UnitType="N" Type="FactoryCal" Inputs="0" Params="32768,0,1000,100" MeasType="Force" Ordinal="1" ShortNameTag="ForceOrd" SymbolTag="FOrd" OffsetZero="1" SupportsTrigger="1" CanChangeSign="1" Minimum="-275" Maximum="1100" TypicalMin="0" TypicalMax="200" Visible="1"/>
        <Measurement ID="6" NameTag="ForceBeamOrd" UnitType="N" Type="FactoryCal" Inputs="1" Params="32768,0,1000,100" MeasType="Force" Ordinal="2" ShortNameTag="ForceOrd" SymbolTag="FOrd" OffsetZero="1" SupportsTrigger="1" CanChangeSign="1" Minimum="-275" Maximum="1100" TypicalMin="0" TypicalMax="200" Visible="1"/>
        <Measurement ID="7" NameTag="ForceBeamOrd" UnitType="N" Type="FactoryCal" Inputs="2" Params="32768,0,1000,100" MeasType="Force" Ordinal="3" ShortNameTag="ForceOrd" SymbolTag="FOrd" OffsetZero="1" SupportsTrigger="1" CanChangeSign="1" Minimum="-275" Maximum="1100" TypicalMin="0" TypicalMax="200" Visible="1"/>
        <Measurement ID="8" NameTag="ForceBeamOrd" UnitType="N" Type="FactoryCal" Inputs="3" Params="32768,0,1000,100" MeasType="Force" Ordinal="4" ShortNameTag="ForceOrd" SymbolTag="FOrd" OffsetZero="1" SupportsTrigger="1" CanChangeSign="1" Minimum="-275" Maximum="1100" TypicalMin="0" TypicalMax="200" Visible="1"/>
        <Measurement ID="10" NameTag="ForceNormal" UnitType="N" Equation="[5]+[6]+[7]+[8]" MeasType="Force" ShortNameTag="ForceNormal_SN" SymbolTag="ForceNormal" SupportsTrigger="1" Minimum="-1100" Maximum="4400" TypicalMin="0" TypicalMax="800" Visible="1" IsDefaultMeas="1"/>
      </Sensor>
      <Sensor ID="2077" Tag="WirelessForcePlatform2D" DefaultRate="20Hz" IconID="226" MaxRate="10000Hz" SupportsZeroOnStart="1" ZeroOnStart="0" SupportsTrigger="1" MaxBurstSamples="6550" Model="PS-3230">
        <Measurement ID="0" NameTag="RawForce1" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="1" NameTag="RawForce2" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="2" NameTag="RawForce3" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="3" NameTag="RawForce4" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="4" NameTag="RawForce5" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="5" NameTag="ForceBeamOrd" UnitType="N" Type="FactoryCal" Inputs="0" Params="32768,0,1000,100" MeasType="Force" Ordinal="1" ShortNameTag="ForceOrd" SymbolTag="FOrd" OffsetZero="1" SupportsTrigger="1" CanChangeSign="1" Minimum="-275" Maximum="1100" TypicalMin="0" TypicalMax="200" Visible="1"/>
        <Measurement ID="6" NameTag="ForceBeamOrd" UnitType="N" Type="FactoryCal" Inputs="1" Params="32768,0,1000,100" MeasType="Force" Ordinal="2" ShortNameTag="ForceOrd" SymbolTag="FOrd" OffsetZero="1" SupportsTrigger="1" CanChangeSign="1" Minimum="-275" Maximum="1100" TypicalMin="0" TypicalMax="200" Visible="1"/>
        <Measurement ID="7" NameTag="ForceBeamOrd" UnitType="N" Type="FactoryCal" Inputs="2" Params="32768,0,1000,100" MeasType="Force" Ordinal="3" ShortNameTag="ForceOrd" SymbolTag="FOrd" OffsetZero="1" SupportsTrigger="1" CanChangeSign="1" Minimum="-275" Maximum="1100" TypicalMin="0" TypicalMax="200" Visible="1"/>
        <Measurement ID="8" NameTag="ForceBeamOrd" UnitType="N" Type="FactoryCal" Inputs="3" Params="32768,0,1000,100" MeasType="Force" Ordinal="4" ShortNameTag="ForceOrd" SymbolTag="FOrd" OffsetZero="1" SupportsTrigger="1" CanChangeSign="1" Minimum="-275" Maximum="1100" TypicalMin="0" TypicalMax="200" Visible="1"/>
        <Measurement ID="9" NameTag="ParallelForce" UnitType="N" Type="FactoryCal" Inputs="4" Params="32768,0,1000,100" MeasType="Force" ShortNameTag="ParallelF" SymbolTag="ForceParallel" OffsetZero="1" SupportsTrigger="1" CanChangeSign="1" Minimum="-1100" Maximum="1100" TypicalMin="-200" TypicalMax="200" Visible="1"/>
        <Measurement ID="10" NameTag="ForceNormal" UnitType="N" Equation="[5]+[6]+[7]+[8]" MeasType="Force" ShortNameTag="ForceNormal_SN" SymbolTag="ForceNormal" SupportsTrigger="1" Minimum="-1100" Maximum="4400" TypicalMin="0" TypicalMax="800" Visible="1" IsDefaultMeas="1"/>
      </Sensor>
       <Sensor ID="2079" Tag="WirelessGM" DefaultRate="30s" IconID="424" MaxRate="10Hz" MinRate="3600s" Model="PS-3238" FirstSampleAtT1="1">
        <Measurement ID="0" NameTag="CountRate" UnitType="CountsPerSample" Type="RawDigital" DataSize="2" MeasType="CountsPerSample" Precision="0" Minimum="0" Maximum="100" ShortNameTag="CountRate_SN" SymbolTag="R" Visible="1"/>
        <Measurement ID="1" NameTag="TubeVoltage" UnitType="V" Type="RawDigital" DataSize="2" Accuracy="1" Minimum="450" Maximum="600" MeasType="Voltage" Precision="0" ShortNameTag="TubeVolt" SymbolTag="V" Visible="1"/>
        <!--Debug--><Measurementx ID="100" NameTag="VoltageMode" UnitType="Unitless" Type="Constant" Internal="1" MeasType="None" Value="1" Values="Normal:1:RawPot:2" IsRange="1"/>
      </Sensor>
      <Sensor ID="2080" Tag="WirelessMeltTempSensor" DefaultRate="2Hz" IconID="136" MaxRate="10Hz" Model="PS-3239">
        <Measurement ID="0" NameTag="RawTemperature" UnitType="Unitless" Type="RawDigital" DataSize="2" MeasType="Temperature" Precision="0" Internal="1"/>
        <Measurement ID="1" NameTag="Temperature" UnitType="DegC" Equation="[0]*0.01" MeasType="Temperature" ShortNameTag="Temp" SymbolTag="T" Precision="2" Minimum="0" Maximum="350" TypicalMin="20" TypicalMax="200" Visible="1"/>
        <!--Debug--><Measurementx ID="2" NameTag="RawBoardTemperature" UnitType="Unitless" Type="RawDigital" DataSize="2" MeasType="None" Precision="0" Visible="1"/>
        <!--Debug--><Measurementx ID="3" NameTag="BoardTemperature" UnitType="DegC" Equation="([2]*0.002670329)-49" MeasType="Temperature" Precision="2" Visible="1"/>
        <!--Debug--><Measurementx ID="4" NameTag="rawTargetTemperature" UnitType="DegC" Type="RawDigital" DataSize="2" Visible="1"/>
        <!--Debug--><Measurementx ID="5" NameTag="TargetTemperature" UnitType="DegC" Equation="[4]*0.01" MeasType="Temperature" Precision="2" Visible="1"/>
        <!--Debug--><Measurementx ID="6" NameTag="adcTemperature" UnitType="Unitless" Type="RawDigital" DataSize="2" Visible="1"/>
        <!--Debug--><Measurementx ID="7" NameTag="RawHeaterPercent" UnitType="Unitless" Type="RawDigital" DataSize="2" Visible="1"/>
        <!--Debug--><Measurementx ID="8" NameTag="HeaterPercent" UnitType="percent" Equation="[7]/100" DataSize="2" Visible="1"/>
        <!--Debug--><Measurementx ID="100" NameTag="Debug" UnitType="Unitless" Type="Constant" Internal="1" MeasType="None" Value="2" Values="Off:1:On:2" IsRange="1"/>
      </Sensor>
      <Sensor ID="2082" Tag="ControlNodeOnboardSensor" DefaultRate="20Hz" IconID="2082" MaxRate="50Hz" SupportsZeroOnStart="1" Model="PS-3232">
        <Measurement ID="0" NameTag="RawX" UnitType="Unitless" Type="RawDigital" DataSize="2" TwosComp="1" Internal="1"/>
        <Measurement ID="1" NameTag="RawY" UnitType="Unitless" Type="RawDigital" DataSize="2" TwosComp="1" Internal="1"/>
        <Measurement ID="2" NameTag="RawZ" UnitType="Unitless" Type="RawDigital" DataSize="2" TwosComp="1" Internal="1"/>
        <Measurement ID="3" NameTag="Accelerationx" UnitType="ms2" Equation="[9]" CanChangeSign="1" OffsetZero="1" Accuracy="0.01" Maximum="10" TypicalMin="-1" TypicalMax="1" MeasType="Acceleration" ShortNameTag="accx" SymbolTag="ax" Minimum="-10" Precision="1" Visible="1"/>
        <Measurement ID="4" NameTag="Accelerationy" UnitType="ms2" Equation="[10]" CanChangeSign="1" OffsetZero="1" Accuracy="0.01" Maximum="10" TypicalMin="-1" TypicalMax="1" MeasType="Acceleration" ShortNameTag="accy" SymbolTag="ay" Minimum="-10" Precision="1" Visible="1"/>
        <Measurement ID="5" NameTag="Accelerationz" UnitType="ms2" Equation="[11]" CanChangeSign="1" OffsetZero="1" Accuracy="0.01" Maximum="10" TypicalMin="-1" TypicalMax="1" MeasType="Acceleration" ShortNameTag="accz" SymbolTag="az" Minimum="-10" Precision="1" Visible="1"/>
        <Measurement ID="9" NameTag="FCalMotionX" UnitType="ms2" Type="FactoryCal" Inputs="0" Params="0,0,1,0.002394" Internal="1"/>
        <Measurement ID="10" NameTag="FCalMotionY" UnitType="ms2" Type="FactoryCal" Inputs="1" Params="0,0,1,0.002394" Internal="1"/>
        <Measurement ID="11" NameTag="FCalMotionZ" UnitType="ms2" Type="FactoryCal" Inputs="2" Params="0,0,1,0.002394" Internal="1"/>
        <Measurement ID="12" NameTag="RawServoResistance1" UnitType="Unitless" Type="RawDigital" DataSize="1" Internal="1"/>
        <Measurement ID="13" NameTag="RawServoResistance2" UnitType="Unitless" Type="RawDigital" DataSize="1" Internal="1"/>
        <Measurement ID="14" NameTag="ServoCurrentOrd" UnitType="percent" Equation="[12]*12.5" Accuracy="10" Maximum="100" MeasType="None" Minimum="0" Precision="0" Ordinal="1" ShortNameTag="CurrOrd" SymbolTag="IOrd" Visible="1"/>
        <Measurement ID="15" NameTag="ServoCurrentOrd" UnitType="percent" Equation="[13]*12.5" Accuracy="10" Maximum="100" MeasType="None" Minimum="0" Precision="0" Ordinal="2" ShortNameTag="CurrOrd" SymbolTag="IOrd" Visible="1"/>
	  </Sensor>
      <Sensor ID="2083" Tag="WirelessCOSensor" DefaultRate="1Hz" IconID="1066" MaxRate="10Hz" Model="PS-3242">
        <Measurement ID="0" NameTag="RawCO" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="1" NameTag="RawTemp" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="2" NameTag="RawHumidity" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="3" NameTag="COConcentration" UnitType="ppm" Type="UserCal" Inputs="0" Params="8820,0,38000,1000" CalFlags="1,1,1,1" MeasType="Concentration" Precision="1" Minimum="0" Maximum="100" TypicalMin="75" TypicalMax="100" ShortNameTag="COConc" SymbolTag="CO" Visible="1" IsDefaultMeas="1"/>
        <Measurement ID="4" NameTag="Temperature" UnitType="DegC" Equation="(([1]/65536)*165)-40" MeasType="Temperature" Precision="1" ShortNameTag="Temp" SymbolTag="T" Minimum="0" Maximum="100" TypicalMin="15" TypicalMax="30" Visible="1"/>
        <Measurement ID="5" NameTag="RelativeHumidity" UnitType="percent" Equation="([2]/65536)*100" MeasType="Humidity" ShortNameTag="RelHumid" SymbolTag="RH" Precision="1" Minimum="0" Maximum="100" TypicalMin="15" TypicalMax="85" Visible="1"/>
        <Measurement ID="6" NameTag="AbsoluteHumidity" UnitType="gpm3" Equation="((13.24*[5])/([4]+273.15))*(2.71828^((17.42*[4])/([4]+239.7)))" MeasType="AbsoluteHumidity" ShortNameTag="AbsHum" SymbolTag="H" Precision="1" Minimum="0" Maximum="100" TypicalMin="5" TypicalMax="20" Visible="1"/>
      </Sensor>
      <Sensor ID="2084" Tag="WirelessAirQuality" DefaultRate="1Hz" IconID="1067" MaxRate="1Hz" Model="PS-3226" SupportsZeroOnStart="1">
        <Measurement ID="0" NameTag="RawTemp" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="1" NameTag="RawHumidity" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="2" NameTag="RawOzone" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="3" NameTag="RawVOC" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="4" NameTag="RawPM1_0" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="5" NameTag="RawPM2_5" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="6" NameTag="RawPM10_0" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="10" NameTag="Temperature" UnitType="DegC" Equation="(([0]/65536)*165)-40" MeasType="Temperature" Precision="1" ShortNameTag="Temp" SymbolTag="T" Minimum="0" Maximum="100" TypicalMin="15" TypicalMax="30" Visible="1"/>
        <Measurement ID="11" NameTag="RelativeHumidity" UnitType="percent" Equation="([1]/65536)*100" MeasType="Humidity" ShortNameTag="RelHumid" SymbolTag="RH" Precision="1" Minimum="0" Maximum="100" TypicalMin="15" TypicalMax="85" Visible="1"/>
        <Measurement ID="12" NameTag="OzoneAndNOx" UnitType="ppm" Equation="([2]*0.000520562)-7.48829" MeasType="Concentration" ShortNameTag="OzoneNOx" SymbolTag="Ozone" OffsetZero="1" Precision="1" Minimum="0" Maximum="100" TypicalMin="15" TypicalMax="85" Visible="1" IsDefaultMeas="1"/>
        <Measurement ID="13" NameTag="VolOrgCompounds" UnitType="ppm" Equation="[3]" MeasType="Concentration" ShortNameTag="VolOrgCds" SymbolTag="VOC" Precision="1" Minimum="0" Maximum="100" Visible="1"/>
        <Measurement ID="14" NameTag="ParticMatter1" UnitType="ugpm3" Equation="[4]" MeasType="Concentration" ShortNameTag="PartMatter1" SymbolTag="PM1" Precision="1" Minimum="0" Maximum="30" Visible="1"/>
        <Measurement ID="15" NameTag="ParticMatter2" UnitType="ugpm3" Equation="[5]" MeasType="Concentration" ShortNameTag="PartMatter2" SymbolTag="PM2" Precision="1" Minimum="0" Maximum="30" Visible="1"/>
        <Measurement ID="16" NameTag="ParticMatter10" UnitType="ugpm3" Equation="[6]" MeasType="Concentration" ShortNameTag="PartMatter10" SymbolTag="PM10" Precision="1" Minimum="0" Maximum="30" Visible="1"/>
      </Sensor>
      <Sensor ID="2085" Tag="WirelessCharge" DefaultRate="10Hz" IconID="203" MaxRate="10Hz" Model="PS-3240" SupportsTareCmd="1" SupportsZeroOnStart="1">
        <Measurement ID="0" NameTag="RawCharge" Type="RawDigital" DataSize="2" Visible="1"/>
        <Measurement ID="1" NameTag="Voltage" UnitType="V" Type="LinearConv" Inputs="0" Params="1,0" Accuracy="1" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="1" TypicalMin="-1" Visible="1" />
        <Measurement ID="2" NameTag="Charge" UnitType="nC" Type="LinearConv" Inputs="1" Params="10,0" Accuracy="1" Maximum="100" MeasType="Charge" Minimum="-100" Precision="3" SymbolTag="Q" TypicalMax="10" TypicalMin="-10" Visible="1" VisibleSds="1" DefaultUnit="nC" IsDefaultMeas="1"/>
      </Sensor>
      <Sensor ID="2086" Tag="WirelessGM2" DefaultRate="10Hz" IconID="424" MinRate="10Hz" MaxRate="10Hz" Model="PS-3238" FirstSampleAtT1="1">
        <Measurement ID="0" NameTag="IntervalCount" UnitType="Unitless" Equation="gmIntervalCount([2])" DataSize="2" MeasType="Count" Precision="0" Minimum="0" Maximum="100" ShortNameTag="IntCt" SymbolTag="ICt" Visible="1"/>
        <Measurement ID="1" NameTag="RunningCount" UnitType="Unitless" Equation="sum([2])" DataSize="2" MeasType="Count" Precision="0" Minimum="0" Maximum="100" ShortNameTag="RunCt" SymbolTag="RCt" Visible="1"/>
        <Measurement ID="2" NameTag="RawCount" UnitType="V" Type="RawDigital" DataSize="2" MeasType="Count" Precision="0" Internal="1"/>
      </Sensor>
      <Sensor ID="2501" Tag="HighSpeedStepper" DefaultRate="20Hz" IconID="2501" MaxRate="50Hz" Model="PS-2976" SupportsZeroOnStart="1" ZeroOnRead="1" ZeroOnStart="1">
        <Measurement ID="0" NameTag="RawCountChange" Type="RawDigital" DataSize="2" TwosComp="1" UnitType="Unitless" CanChangeSign="1" Internal="1"/>
        <Measurement ID="1" NameTag="Angle" UnitType="rad" DefaultUnit="rev" Type="RotaryPos" Inputs="0" Params="6.28319,960" Accuracy="0.002" Maximum="6.5" MeasType="Angle" Minimum="-6.5" TypicalMin="-6.28" TypicalMax="6.28" Precision="3" ShortNameTag="ang" SymbolTag="thetaL" Visible="1" IsDefaultMeas="1"/>
        <Measurement ID="2" NameTag="AngularVelocity" UnitType="radps" DefaultUnit="revps" Type="Derivative" Inputs="1" Params="3" Accuracy="0.002" Maximum="6.5" MeasType="AngularVelocity" Minimum="-6.5" TypicalMin="-6.28" TypicalMax="6.28" Precision="3" ShortNameTag="angvel" SymbolTag="omegaL" Visible="1"/>
        <Measurement ID="3" NameTag="Position" UnitType="m" Equation="[1]*0.0371" Accuracy="0.001" Maximum="1" MeasType="Position" Minimum="-1" Precision="4" ShortNameTag="pos" SymbolTag="x" Visible="1"/>
        <Measurement ID="4" NameTag="Velocity" UnitType="mps" Type="Derivative" Equation="[2]*0.0371" Accuracy="0.001" Maximum="0.5" MeasType="Velocity" Minimum="-0.5" Precision="3" ShortNameTag="vel" SymbolTag="velocity" Visible="1"/>
      </Sensor>
      <Sensor ID="2502" Tag="LowSpeedStepper" DefaultRate="20Hz" IconID="2501" MaxRate="50Hz" Model="PS-2978" SupportsZeroOnStart="1" ZeroOnRead="1" ZeroOnStart="1">
        <Measurement ID="0" NameTag="RawCountChange" Type="RawDigital" DataSize="2" TwosComp="1" UnitType="Unitless" CanChangeSign="1" Internal="1"/>
        <Measurement ID="1" NameTag="Angle" UnitType="rad" DefaultUnit="rev" Type="RotaryPos" Inputs="0" Params="6.28319,5760" Accuracy="0.002" Maximum="6.5" MeasType="Angle" Minimum="-6.5" TypicalMin="-0.63" TypicalMax="0.63" Precision="3" ShortNameTag="ang" SymbolTag="thetaL" Visible="1" IsDefaultMeas="1"/>
        <Measurement ID="2" NameTag="AngularVelocity" UnitType="radps" DefaultUnit="revps" Type="Derivative" Inputs="1" Params="3" Accuracy="0.002" Maximum="6.5" MeasType="AngularVelocity" Minimum="-6.5" TypicalMin="-0.63" TypicalMax="0.63" Precision="3" ShortNameTag="angvel" SymbolTag="omegaL" Visible="1"/>
      </Sensor>
      <Sensor ID="2503" Tag="ControlNodeStepperPosition3" DefaultRate="20Hz" IconID="1131" MaxRate="50Hz" Model="PS-XXXX" SupportsZeroOnStart="1" ZeroOnRead="1" ZeroOnStart="1">
        <Measurement ID="0" NameTag="RawCountChange" Type="RawDigital" DataSize="2" TwosComp="1" UnitType="Unitless" CanChangeSign="1" Internal="1"/>
        <Measurement ID="1" NameTag="Angle" UnitType="rad" DefaultUnit="rev" Type="RotaryPos" Inputs="0" Params="6.28319,480" Accuracy="0.002" Maximum="6.5" MeasType="Angle" Minimum="-6.5" TypicalMin="-6.28" TypicalMax="6.28" Precision="3" ShortNameTag="ang" SymbolTag="thetaL" Visible="1" IsDefaultMeas="1"/>
        <Measurement ID="2" NameTag="AngularVelocity" UnitType="radps" DefaultUnit="revps" Type="Derivative" Inputs="1" Params="3" Accuracy="0.002" Maximum="6.5" MeasType="AngularVelocity" Minimum="-6.5" TypicalMin="-1" TypicalMax="1" Precision="3" ShortNameTag="angvel" SymbolTag="omegaL" Visible="1"/>
      </Sensor>
      <Sensor ID="2504" Tag="LineFollower" DefaultRate="20Hz" IconID="2504" MaxRate="50Hz" SupportsZeroOnStart="1" Model="PS-3320">
        <Measurement ID="0" NameTag="LineDetectOrd" UnitType="percent" Equation="100-([4]*0.392)" OffsetZero="1" Minimum="0" Maximum="100" Ordinal="1" ShortNameTag="LineDetOrd" SymbolTag="LOrd" MeasType="Intensity" Visible="1"/>
        <Measurement ID="1" NameTag="LineDetectOrd" UnitType="percent" Equation="100-([5]*0.392)" OffsetZero="1" Minimum="0" Maximum="100" Ordinal="2" ShortNameTag="LineDetOrd" SymbolTag="LOrd" MeasType="Intensity" Visible="1"/>
        <Measurement ID="2" NameTag="LineDetectOrd" UnitType="percent" Equation="100-([6]*0.392)" OffsetZero="1" Minimum="0" Maximum="100" Ordinal="3" ShortNameTag="LineDetOrd" SymbolTag="LOrd" MeasType="Intensity" Visible="1"/>
        <Measurement ID="3" NameTag="LineDetectOrd" UnitType="percent" Equation="100-([7]*0.392)" OffsetZero="1" Minimum="0" Maximum="100" Ordinal="4" ShortNameTag="LineDetOrd" SymbolTag="LOrd" MeasType="Intensity" Visible="1"/>
        <Measurement ID="4" NameTag="RawLineDetect1" UnitType="Percent" Type="RawDigital" DataSize="1" MeasType="LineDetectors" Internal="1"/>
        <Measurement ID="5" NameTag="RawLineDetect2" UnitType="Percent" Type="RawDigital" DataSize="1" MeasType="LineDetectors" Internal="1"/>
        <Measurement ID="6" NameTag="RawLineDetect3" UnitType="Percent" Type="RawDigital" DataSize="1" MeasType="LineDetectors" Internal="1"/>
        <Measurement ID="7" NameTag="RawLineDetect4" UnitType="Percent" Type="RawDigital" DataSize="1" MeasType="LineDetectors" Internal="1"/>
      </Sensor>
      <Sensor ID="2505" Tag="RangeFinder" DefaultRate="20Hz" IconID="2505" MaxRate="50Hz" Model="PS-3321">
        <Measurement ID="0" NameTag="Distance" UnitType="mm" Type="RawDigital" DataSize="2" ShortNameTag="Dist" SymbolTag="d" MeasType="Distance" Minimum="0" Maximum="1000"  TypicalMin="0" TypicalMax="1000" Limits="0,1000" Visible="1"/>
      </Sensor>
      <Sensor ID="2506" Tag="PowerOutput" DefaultRate="20Hz" IconID="2506" MaxRate="50Hz" Model="PS-3324">
      </Sensor>
      <Sensor ID="2507" Tag="Greenhouse" DefaultRate="1Hz" IconID="2507" MaxRate="1Hz" Model="PS-2997">
        <Measurement ID="0" NameTag="RawTemperature" UnitType="DegC" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="1" NameTag="RawHumidity" UnitType="percent" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="2" NameTag="RawLight" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
        <Measurement ID="3" NameTag="RawMoisture" UnitType="Unitless" Type="RawDigital" DataSize="2" Internal="1"/>
		    <Measurement ID="4" NameTag="Temperature" UnitType="DegC" Equation="[0]*0.1" Accuracy="0.5" Maximum="135" MeasType="Temperature" Minimum="-35" TypicalMin="15" TypicalMax="30" Precision="1" ShortNameTag="Temp" SymbolTag="T" Visible="1" IsDefaultMeas="1"/>
		    <Measurement ID="5" NameTag="RelativeHumidity" UnitType="percent" Equation="[1]*0.1" Accuracy="0.5" Maximum="100" MeasType="RelativeHumidity" Minimum="0" TypicalMin="20" TypicalMax="90" Precision="1" ShortNameTag="RelHum" SymbolTag="RH" Visible="1"/>
        <Measurement ID="6" NameTag="Brightness" UnitType="percent" Equation="sqrt([2])*0.3906" MeasType="Brightness" Minimum="0" Maximum="100" TypicalMin="0" TypicalMax="20" Visible="1" ShortNameTag="brightness" SymbolTag="brns"/>
        <Measurement ID="7" NameTag="VWCLoam" UnitType="percent" Equation="table(([3]*60.8)+336.9,7122,45,14100,20,17245,15,51725,0)" Limits="0,100" Accuracy="1" Maximum="100" TypicalMin="0" TypicalMax="50" MeasType="PercentVWC" SymbolTag="thetaL" Minimum="0" Precision="0" Visible="1"/>
        <Measurement ID="8" NameTag="VWCSand" UnitType="percent" Equation="table(([3]*60.8)+336.9,6344,35,11964,15,50689,0)" Limits="0,100" Accuracy="1" Maximum="100" TypicalMin="0" TypicalMax="50" MeasType="PercentVWC" SymbolTag="thetaL" Minimum="0" Precision="0" Visible="1"/>
        <Measurement ID="9" NameTag="VWCClay" UnitType="percent" Equation="table(([3]*60.8)+336.9,6499,45,11234,25,19999,15,52875,0)" Limits="0,100" Accuracy="1" Maximum="100" TypicalMin="0" TypicalMax="50" MeasType="PercentVWC" SymbolTag="thetaL" Minimum="0" Precision="0" Visible="1"/>
      </Sensor>
      <Sensor ID="2508" Tag="GreenhouseGrowLight" DefaultRate="20Hz" IconID="2508" MaxRate="50Hz" Model="PS-xxxx">
      </Sensor>
      <Sensor ID="3000" Tag="OOSpectrumAnalyzer" Version="2.0" Class="0" DefaultRate="1Hz" FileName="OceanOpticsUsb.sds" FloatParams="0" Icon="00008100c201a4c298e413792c3d722d164218226614810d0006000000000000" IconID="3000" Latency="100" MaxDatasheet="8192" MaxRate="10Hz" Model="OO-0001" Warmup="1">
        <Measurement ID="0" NameTag="Intensity" UnitType="Unitless" Type="RawDigital" DataSize="8" Accuracy="1" Display="Graph" Internal="0" Maximum="4095" Minimum="0" Precision="0" TypicalMax="4095" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDefault="1"/>
        <Measurement ID="1" NameTag="MinusDark" UnitType="Unitless" Type="RawDigital" DataSize="8" Accuracy="1" Display="Graph" Internal="0" Maximum="4095" Minimum="0" Precision="0" TypicalMax="4095" TypicalMin="0" Visible="0"/>
        <Measurement ID="2" NameTag="Absorbance" UnitType="Unitless" Type="RawDigital" DataSize="8" Accuracy="1" Display="Graph" Internal="0" Maximum="4" Minimum="0" Precision="2" TypicalMax="4" TypicalMin="0" Visible="1"/>
        <Measurement ID="3" NameTag="Transmission" UnitType="Unitless" Type="RawDigital" DataSize="8" Accuracy="1" Display="Graph" Internal="0" Maximum="100" Minimum="0" Precision="1" TypicalMax="100" TypicalMin="0" Visible="1" IsDefaultMeas="1"/>
        <Measurement ID="4" NameTag="RelIrradiance" UnitType="Unitless" Type="RawDigital" DataSize="8" Accuracy="1" Display="Graph" Internal="0" Maximum="1" Minimum="0" Precision="2" TypicalMax="1" TypicalMin="0" Visible="1"/>
      </Sensor>
      <Sensor ID="3001" Tag="OOSpectrumAnalyzer" Version="2.0" Class="0" DefaultRate="1Hz" FloatParams="0" IconID="3000" Latency="100" MaxDatasheet="8192" MaxRate="5Hz" Model="OO-0001" Warmup="1">
        <Measurement ID="0" NameTag="IntensityVsTime" Type="RawDigital" DataSize="8" Accuracy="1" Display="Graph" UnitType="Unitless" Internal="0" Maximum="4095" Minimum="0" Precision="2" TypicalMax="4095" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDefault="1"/>
        <Measurement ID="1" NameTag="MinusDarkVsTime" Type="RawDigital" DataSize="8" Accuracy="1" Display="Graph" UnitType="Unitless" Internal="0" Maximum="4095" Minimum="0" Precision="0" TypicalMax="4095" TypicalMin="0" Visible="0"/>
        <Measurement ID="2" NameTag="AbsorbanceVsTime" Type="RawDigital" DataSize="8" Accuracy="1" Display="Graph" UnitType="Unitless" Internal="0" Maximum="4" Minimum="0" Precision="2" TypicalMax="4" TypicalMin="0" Visible="1"/>
        <Measurement ID="3" NameTag="TransmissionVsTime" Type="RawDigital" DataSize="8" Accuracy="1" Display="Graph" UnitType="Unitless" Internal="0" Maximum="100" Minimum="0" Precision="1" TypicalMax="100" TypicalMin="0" Visible="1"/>
        <Measurement ID="4" NameTag="RelIrradianceVsTime" Type="RawDigital" DataSize="8" Accuracy="1" Display="Graph" UnitType="Unitless" Internal="0" Maximum="1" Minimum="0" Precision="2" TypicalMax="1" TypicalMin="0" Visible="1"/>
        <Measurement ID="5" NameTag="IntensityVsWavelength" Type="RawDigital" DataSize="8" Accuracy="1" Display="Graph" UnitType="Unitless" IndMeasType="Wavelength" IndUnitType="nm" Internal="0" Maximum="4095" Minimum="0" Precision="0" TypicalMax="4095" TypicalMin="0" Visible="1" VisibleSds="1" XplorerDefault="1" IsDefaultMeas="1"/>
        <Measurement ID="6" NameTag="MinusDarkVsWavelength" Type="RawDigital" DataSize="8" Accuracy="1" Display="Graph" UnitType="Unitless" IndMeasType="Wavelength" IndUnitType="nm" Internal="0" Maximum="4095" Minimum="0" Precision="0" TypicalMax="4095" TypicalMin="0" Visible="0"/>
        <Measurement ID="7" NameTag="AbsorbanceVsWavelength" Type="RawDigital" DataSize="8" Accuracy="1" Display="Graph" UnitType="Unitless" IndMeasType="Wavelength" IndUnitType="nm" Internal="0" Maximum="4" Minimum="0" Precision="2" TypicalMax="4" TypicalMin="0" Visible="1"/>
        <Measurement ID="8" NameTag="TransmissionVsWavelength" Type="RawDigital" DataSize="8" Accuracy="1" Display="Graph" UnitType="Unitless" IndMeasType="Wavelength" IndUnitType="nm" Internal="0" Maximum="100" Minimum="0" Precision="1" TypicalMax="100" TypicalMin="0" Visible="1"/>
        <Measurement ID="9" NameTag="RelIrradianceVsWavelength" Type="RawDigital" DataSize="8" Accuracy="1" Display="Graph" UnitType="Unitless" IndMeasType="Wavelength" IndUnitType="nm" Internal="0" Maximum="1" Minimum="0" Precision="2" TypicalMax="1" TypicalMin="0" Visible="1"/>
      </Sensor>
      <Sensor ID="3002" Tag="OhausBalance" DefaultRate="1Hz" IconID="3002" MaxRate="1Hz">
        <Measurement ID="0" NameTag="Mass" UnitType="g" Type="RawDigital" DataSize="8" Accuracy="1" Maximum="1000" MeasType="Mass" Minimum="0" TypicalMin="0" TypicalMax="500" Precision="0" Visible="1"/>
      </Sensor>
      <Sensor ID="3003" Tag="Polarimeter" Model="PS-2235" DefaultRate="100Hz" IconID="3003" MaxRate="1000Hz">
        <Measurement ID="0" NameTag="RawPosition" UnitType="Unitless" Type="RawDigital" DataSize="2" TwosComp="1" Internal="1" MeasType="Position"/>
        <Measurement ID="1" NameTag="Intensity" UnitType="Unitless" Type="RawDigital" DataSize="2" Accuracy="1" Maximum="1000" MeasType="Intensity" Minimum="0" Precision="0" Visible="1"/>
        <Measurement ID="2" NameTag="Angle" UnitType="deg" Type="LinearConv" Inputs="0" Params="0.09,0" Accuracy="0.1" DefaultUnit="deg" Display="Graph" Maximum="360" MeasType="Angle" Minimum="0" Precision="1" Visible="1"/>
      </Sensor>
      <!-- Sensor IDs 20000 - 21999 are for standard CI sensors -->
      <Sensor ID="20128" Tag="VoltageSensor" Version="2.0" Class="0" DefaultRate="20Hz" FileName="CISensor20128.sds" FloatParams="1" IconID="135" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6503" Warmup="250" SupportsZeroOnStart="1">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="Voltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" OffsetZero="1" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="1" TypicalMin="-1" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="5" NameTag="CurrentProbePS2184" UnitType="A" Type="LinearConv" Inputs="4" Params="10,0" Accuracy="1" Internal="0" Maximum="1" MeasType="Current" Minimum="-1" OffsetZero="1" Precision="4" ShortNameTag="Curr" SymbolTag="current" TypicalMax="0.1" TypicalMin="-0.1" VisibleSds="1" XplorerDisplay="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20129" Tag="PowerAmplifier" Version="2.0" Class="0" DefaultRate="100Hz" FileName="CISensor20129.sds" FloatParams="1" Gain="10" IconID="501" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6552A" Warmup="250">
        <Measurement ID="4" NameTag="OutputVoltage" UnitType="V" Type="RawDigital" DataSize="8" Accuracy="0.005" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="VoltsOut" SymbolTag="V" TypicalMax="1" TypicalMin="-1" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="5" NameTag="OutputCurrent" UnitType="A" Type="RawDigital" DataSize="8" Accuracy="0.01" Display="None" Internal="0" Maximum="1" MeasType="Current" Minimum="0" Precision="2" ShortNameTag="CurrOut" SymbolTag="current" TypicalMax="0.1" TypicalMin="-0.1" Visible="1" VisibleSds="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20130" Tag="ForceSensor" Version="2.0" Class="0" DefaultRate="20Hz" FileName="CISensor20130.sds" FloatParams="1" IconID="511" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6537" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="forceVoltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="1" TypicalMin="-1" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Force" UnitType="N" Type="UserCal" Inputs="4" Params="-8,-50,8,50" CalFlags="1,1,1,1" Accuracy="0.01" CanChangeSign="1" CIVarName="force" Display="None" Internal="0" Maximum="8" MeasType="Force" Minimum="-8" Precision="2" SymbolTag="F" TypicalMax="1" TypicalMin="-1" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <SupportedCmd ID="65" Size="4"/> 
      </Sensor>
      <Sensor ID="20131" Tag="AccelerationSensor" Version="2.0" Class="0" DefaultRate="20Hz" FileName="CISensor20131.sds" FloatParams="1" IconID="458" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6558" SupportsZeroOnStart="1" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="accelerationVoltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="1" TypicalMin="-1" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Acceleration" UnitType="grav" Type="UserCal" Inputs="4" Params="-1,-1,1,1" CalFlags="1,1,1,1" Accuracy="0.01" CIVarName="accelerationG" Display="None" Internal="0" Maximum="5" MeasType="Acceleration" Minimum="-5" Precision="2" ShortNameTag="acc" SymbolTag="a" TypicalMax="0.5" TypicalMin="-0.5" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <Measurement ID="6" NameTag="Acceleration" UnitType="ms2" Type="UserCal" Inputs="4" Params="-1,-9.810000000000001,1,9.810000000000001" CalFlags="1,1,1,1" Accuracy="0.1" CIVarName="acceleration" Display="None" Internal="0" InternalUnit="1" Maximum="50" MeasType="Acceleration" Minimum="-50" Precision="1" ShortNameTag="acc" SymbolTag="a" TypicalMax="0" TypicalMin="0"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20132" Tag="LightSensor" Version="2.0" Class="0" DefaultRate="20Hz" FileName="CISensor20132.sds" FloatParams="1" IconID="132" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6504A" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="Voltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="LightIntensity" UnitType="percent" Type="UserCal" Inputs="4" Params="0,0,5,100" CalFlags="1,1,1,1" Accuracy="1" CIVarName="light" Display="None" Internal="0" Maximum="100" MeasType="LightIntensity" Minimum="0" Precision="1" ShortNameTag="Intens" SymbolTag="IntensityLight" TypicalMax="100" TypicalMin="0" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20133" Tag="SoundSensor" Version="2.0" Class="0" DefaultRate="5000Hz" FileName="CISensor20133.sds" FloatParams="1" IconID="151" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="UI-5101/CI-6506B" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="SoundIntensity" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="Voltage" Display="None" Internal="0" Maximum="10" MeasType="SoundIntensity" Minimum="-10" Precision="3" ShortNameTag="Intens" SymbolTag="IA" TypicalMax="1" TypicalMin="-1" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20134" Tag="MagneticFieldSensor" Version="2.0" Class="0" DefaultRate="10Hz" FileName="CISensor20134.sds" FloatParams="1" IconID="134" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6520A" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="magneticVoltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="1" TypicalMin="-1" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="MagneticFieldStrength1X" UnitType="gauss" Type="UserCal" Inputs="4" Params="-10,-1000,10,1000" CalFlags="1,1,1,1" Accuracy="10" CanChangeSign="1" CIVarName="fieldStrengthGauss1x" Display="None" Internal="0" Maximum="1000" MeasType="MagneticField" Minimum="-1000" Precision="0" ShortNameTag="MagField" SymbolTag="B" TypicalMax="100" TypicalMin="-100" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <Measurement ID="6" NameTag="MagneticFieldStrength10X" UnitType="gauss" Type="UserCal" Inputs="4" Params="-10,-100,10,100" CalFlags="1,1,1,1" Accuracy="1" CanChangeSign="1" CIVarName="fieldStrengthGauss10x" Display="None" Internal="0" Maximum="100" MeasType="MagneticField" Minimum="-100" Precision="0" ShortNameTag="MagField" SymbolTag="B" TypicalMax="10" TypicalMin="-10" Visible="1"/>
        <Measurement ID="7" NameTag="MagneticFieldStrength100X" UnitType="gauss" Type="UserCal" Inputs="4" Params="-10,-10,10,10" CalFlags="1,1,1,1" Accuracy="0.1" CanChangeSign="1" CIVarName="fieldStrengthGauss100x" Display="None" Internal="0" Maximum="10" MeasType="MagneticField" Minimum="-10" Precision="1" ShortNameTag="MagField" SymbolTag="B" TypicalMax="1" TypicalMin="-1" Visible="1"/>
        <Measurement ID="8" NameTag="MagneticFieldStrength" UnitType="gauss" Type="UserCal" Inputs="4" Params="-2,-2000,2,2000" CalFlags="1,1,1,1" Accuracy="10" CanChangeSign="1" CIVarName="fieldStrengthGauss" Display="None" Internal="0" Maximum="2000" MeasType="MagneticField" Minimum="-2000" Precision="1" TypicalMax="100" TypicalMin="-100" Visible="0"/>
        <Measurement ID="9" NameTag="MagneticFieldStrength1X" UnitType="tesla" Type="UserCal" Inputs="4" Params="-10,-0.1,10,0.1" CalFlags="1,1,1,1" Accuracy="0.01" CIVarName="fieldStrengthTesla1x" Display="None" Internal="0" InternalUnit="1" Maximum="0.1" MeasType="MagneticField" Minimum="-0.1" Precision="2" ShortNameTag="MagField" SymbolTag="B" TypicalMax="0" TypicalMin="0"/>
        <Measurement ID="10" NameTag="MagneticFieldStrength10X" UnitType="tesla" Type="UserCal" Inputs="4" Params="-10,-0.01,10,0.01" CalFlags="1,1,1,1" Accuracy="0.001" CIVarName="fieldStrengthTesla10x" Display="None" Internal="0" InternalUnit="1" Maximum="0.01" MeasType="MagneticField" Minimum="-0.01" Precision="3" ShortNameTag="MagField" SymbolTag="B" TypicalMax="0" TypicalMin="0"/>
        <Measurement ID="11" NameTag="MagneticFieldStrength100X" UnitType="tesla" Type="UserCal" Inputs="4" Params="-10,-0.001,10,0.001" CalFlags="1,1,1,1" Accuracy="0.0001" CIVarName="fieldStrengthTesla100x" Display="None" Internal="0" InternalUnit="1" Maximum="0.001" MeasType="MagneticField" Minimum="-0.001" Precision="4" ShortNameTag="MagField" SymbolTag="B" TypicalMax="0" TypicalMin="0"/>
        <Measurement ID="12" NameTag="MagneticFieldStrength" UnitType="tesla" Type="UserCal" Inputs="4" Params="-2,-0.2,2,0.2" CalFlags="1,1,1,1" Accuracy="0.001" CIVarName="fieldStrengthTesla" Display="None" Internal="0" InternalUnit="1" Maximum="0.2" MeasType="MagneticField" Minimum="-0.2" Precision="3" TypicalMax="0" TypicalMin="0"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20135" Tag="CurrentSensor" Version="2.0" Class="0" DefaultRate="20Hz" FileName="CISensor20135.sds" FloatParams="1" Gain="10" IconID="457" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6556" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="currentVoltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="1" TypicalMin="-1" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Current" UnitType="A" Type="UserCal" Inputs="4" Params="0,0,1,1" CalFlags="1,1,1,1" Accuracy="0.002" CIVarName="current" Display="None" Internal="0" Maximum="1" MeasType="Current" Minimum="0" Precision="3" ShortNameTag="Curr" SymbolTag="current" TypicalMax="0.1" TypicalMin="-0.1" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20136" Tag="TemperatureSensor" Version="2.0" Class="0" DefaultRate="10Hz" FileName="CISensor20136.sds" FloatParams="1" Gain="10" IconID="136" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6505A" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="tempVoltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="10" TypicalMin="-10" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Temperature" UnitType="DegC" Type="UserCal" Inputs="4" Params="0,0,1,100" CalFlags="1,1,1,1" Accuracy="0.5" CIVarName="temp" Display="None" Internal="0" Maximum="105" MeasType="Temperature" Minimum="-5" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="30" TypicalMin="15" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <Measurement ID="6" NameTag="Temperature" UnitType="DegF" Type="UserCal" Inputs="4" Params="0,32,1,212" CalFlags="1,1,1,1" Accuracy="0.5" CIVarName="tempF" Display="None" Internal="0" InternalUnit="1" Maximum="221" MeasType="Temperature" Minimum="23" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="0" TypicalMin="0"/>
        <Measurement ID="7" NameTag="Temperature" UnitType="K" Type="UserCal" Inputs="4" Params="0,273.15,1,373.15" CalFlags="1,1,1,1" Accuracy="0.5" CIVarName="tempK" Display="None" Internal="0" InternalUnit="1" Maximum="378.15" MeasType="Temperature" Minimum="268.15" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="0" TypicalMin="0"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20137" Tag="TemperatureSensorWithTypeKProbe" Version="2.0" Class="0" DefaultRate="10Hz" FileName="CISensor20137.sds" FloatParams="1" IconID="137" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6526" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="tempVoltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="10" TypicalMin="-10" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Temperature" UnitType="DegC" Type="UserCal" Inputs="4" Params="0,0,1,100" CalFlags="1,1,1,1" Accuracy="5" CIVarName="temp" Display="None" Internal="0" Maximum="1000" MeasType="Temperature" Minimum="-150" Precision="0" ShortNameTag="Temp" SymbolTag="T" TypicalMax="250" TypicalMin="50" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <Measurement ID="6" NameTag="Temperature" UnitType="DegF" Type="UserCal" Inputs="4" Params="0,32,1,212" CalFlags="1,1,1,1" Accuracy="0.5" CIVarName="tempF" Display="None" Internal="0" InternalUnit="1" Maximum="1832" MeasType="Temperature" Minimum="-238" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="0" TypicalMin="0"/>
        <Measurement ID="7" NameTag="Temperature" UnitType="K" Type="UserCal" Inputs="4" Params="0,273.15,1,373.15" CalFlags="1,1,1,1" Accuracy="0.5" CIVarName="tempK" Display="None" Internal="0" InternalUnit="1" Maximum="1273.15002" MeasType="Temperature" Minimum="123.15" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="0" TypicalMin="0"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20138" Tag="TemperatureSensorRTD" Version="2.0" Class="0" DefaultRate="10Hz" FileName="CISensor20138.sds" FloatParams="1" IconID="452" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6525" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="tempVoltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="10" TypicalMin="-10" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Temperature" UnitType="DegC" Type="UserCal" Inputs="4" Params="0,0,1,100" CalFlags="1,1,1,1" Accuracy="5" CIVarName="temp" Display="None" Internal="0" Maximum="200" MeasType="Temperature" Minimum="-200" Precision="0" ShortNameTag="Temp" SymbolTag="T" TypicalMax="30" TypicalMin="15" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <Measurement ID="6" NameTag="Temperature" UnitType="DegF" Type="UserCal" Inputs="4" Params="0,32,1,212" CalFlags="1,1,1,1" Accuracy="0.5" CIVarName="tempF" Display="None" Internal="0" InternalUnit="1" Maximum="392" MeasType="Temperature" Minimum="-204" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="0" TypicalMin="0"/>
        <Measurement ID="7" NameTag="Temperature" UnitType="K" Type="UserCal" Inputs="4" Params="0,273.15,1,373.15" CalFlags="1,1,1,1" Accuracy="0.5" CIVarName="tempK" Display="None" Internal="0" InternalUnit="1" Maximum="473.15" MeasType="Temperature" Minimum="73.15000000000001" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="0" TypicalMin="0"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20139" Tag="pHSensor" Version="2.0" Class="0" DefaultRate="10Hz" FileName="CISensor20139.sds" FloatParams="1" IconID="139" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6507A" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="pHVoltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="10" TypicalMin="-10" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="pH" UnitType="Unitless" Type="UserCal" Inputs="4" Params="0.4,4,1,10" CalFlags="1,1,1,1" Accuracy="0.1" CIVarName="pH" Display="None" Internal="0" Maximum="10" MeasType="pH" Minimum="4" Precision="1" SymbolTag="pH" TypicalMax="10" TypicalMin="4" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20140" Tag="DissolvedOxygenSensor" Version="2.0" Class="0" DefaultRate="10Hz" FileName="CISensor20140.sds" FloatParams="1" IconID="140" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6542" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="oxygenVoltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="10" TypicalMin="-10" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="OxygenConcentration" UnitType="mgpL" Type="UserCal" Inputs="4" Params="0,0,2.93,8.24" CalFlags="1,1,1,1" Accuracy="0.1" CIVarName="oxygenConcentration" Display="None" Internal="0" Maximum="9" MeasType="Concentration" Minimum="0" Precision="1" ShortNameTag="O2Conc" SymbolTag="O2Con" TypicalMax="20" TypicalMin="0" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <Measurement ID="6" NameTag="OxygenSaturation" UnitType="percent" Type="UserCal" Inputs="4" Params="0,0,2.93,100" CalFlags="1,1,1,1" Accuracy="1" CIVarName="oxygenSaturation" Display="None" Internal="0" Maximum="100" MeasType="Saturation" Minimum="0" Precision="0" ShortNameTag="O2Sat" SymbolTag="O2Sat" TypicalMax="100" TypicalMin="75" Visible="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20141" Tag="ConductivitySensor" Version="2.0" Class="0" DefaultRate="10Hz" FileName="CISensor20141.sds" FloatParams="1" IconID="461" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6729/6739A" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="conductivityVoltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="10" TypicalMin="-10" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Conductivity20K" UnitType="uSpcm" Type="UserCal" Inputs="4" Params="0,0,10,20000" CalFlags="1,1,1,1" Accuracy="2" CIVarName="conductivity20K" Display="None" Internal="0" Maximum="20000" MeasType="Conductivity" Minimum="0" Precision="0" ShortNameTag="Conduct20k" SymbolTag="sigmaL20k" TypicalMax="20000" TypicalMin="1000" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <Measurement ID="6" NameTag="Conductivity2K" UnitType="uSpcm" Type="UserCal" Inputs="4" Params="0,0,10,2000" CalFlags="1,1,1,1" Accuracy="2" CIVarName="conductivity2K" Display="None" Internal="0" Maximum="2000" MeasType="Conductivity" Minimum="0" Precision="0" ShortNameTag="Conduct2K" SymbolTag="sigmaL2K" TypicalMax="2000" TypicalMin="500" Visible="1"/>
        <Measurement ID="7" NameTag="Conductivity200" UnitType="uSpcm" Type="UserCal" Inputs="4" Params="0,0,10,200" CalFlags="1,1,1,1" Accuracy="2" CIVarName="conductivity200" Display="None" Internal="0" Maximum="200" MeasType="Conductivity" Minimum="0" Precision="0" ShortNameTag="Conduct200" SymbolTag="sigmaL200" TypicalMax="200" TypicalMin="50" Visible="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20142" Tag="Colorimeter" Version="2.0" Class="0" DefaultRate="10Hz" FileName="CISensor20142.sds" FloatParams="1" IconID="509" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6747," Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="colorimeterVoltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="10" TypicalMin="-10" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Transmittance" UnitType="percent" Type="UserCal" Inputs="4" Params="0,0,4.5,100" CalFlags="1,1,1,1" Accuracy="1" CIVarName="transmittance" Display="None" Internal="0" Maximum="100" MeasType="Transmittance" Minimum="0" Precision="0" ShortNameTag="Trans" SymbolTag="T" TypicalMax="100" TypicalMin="0" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <Measurement ID="6" NameTag="Absorbance" UnitType="Unitless" Type="Absorbance" Inputs="5" Accuracy="0.02" CIVarName="absorbance" Display="None" Internal="0" Maximum="2" MeasType="Absorbance" Minimum="0" Precision="2" ShortNameTag="Absorb" SymbolTag="A" TypicalMax="2" TypicalMin="0" Visible="1" VisibleSds="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20143" Tag="PressureSensorAbsolute" Version="2.0" Class="0" DefaultRate="20Hz" FileName="CISensor20143.sds" FloatParams="1" IconID="143" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6532A" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="pressureVoltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="1" TypicalMin="-1" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="AbsolutePressure" UnitType="kPa" Type="UserCal" Inputs="4" Params="0,0,7,700" CalFlags="1,1,1,1" Accuracy="0.1" CIVarName="pressure" Display="None" Internal="0" Maximum="700" MeasType="Pressure" Minimum="0" Precision="1" ShortNameTag="Press" SymbolTag="pressureAbsolute" TypicalMax="120" TypicalMin="0" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20144" Tag="PressureSensorDifferential" Version="2.0" Class="0" DefaultRate="10Hz" FileName="CISensor20144.sds" FloatParams="1" IconID="454" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6533" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="pressureVoltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="10" TypicalMin="-10" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="PressureDifferential" UnitType="kPa" Type="UserCal" Inputs="4" Params="0,0,7,700" CalFlags="1,1,1,1" Accuracy="0.1" CIVarName="pressure" Display="None" Internal="0" Maximum="700" MeasType="Pressure" Minimum="0" Precision="1" ShortNameTag="PressDiff" SymbolTag="pressureRelative" TypicalMax="100" TypicalMin="0" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20145" Tag="LowPressureSensor" Version="2.0" Class="0" DefaultRate="20Hz" FileName="CISensor20145.sds" FloatParams="1" IconID="143" Latency="19" ListNameTag="PressureSensorLow" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6534A" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="pressureVoltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="10" TypicalMin="-10" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Pressure" UnitType="kPa" Type="UserCal" Inputs="4" Params="0,0,10,10" CalFlags="1,1,1,1" Accuracy="0.01" CIVarName="pressure" Display="None" Internal="0" Maximum="10" MeasType="Pressure" Minimum="0" Precision="2" ShortNameTag="Press" SymbolTag="pressure" TypicalMax="100" TypicalMin="0" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20146" Tag="Barometer" Version="2.0" Class="0" DefaultRate="10Hz" FileName="CISensor20146.sds" FloatParams="1" IconID="455" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6531A" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="barometerVoltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="10" TypicalMin="-10" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="BarometricPressure" UnitType="inHg" Type="UserCal" Inputs="4" Params="-4,24,4,32" CalFlags="1,1,1,1" Accuracy="0.005" CIVarName="pressureInHg" Display="None" Internal="0" Maximum="32" MeasType="Pressure" Minimum="24" Precision="3" ShortNameTag="Press" SymbolTag="pressureBarometric" TypicalMax="31" TypicalMin="29" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <Measurement ID="6" NameTag="BarometricPressure" UnitType="mmHg" Type="UserCal" Inputs="4" Params="-4,609.6,4,812.8" CalFlags="1,1,1,1" Accuracy="0.1" CIVarName="pressureMMHg" Display="None" Internal="0" InternalUnit="1" Maximum="768" MeasType="Pressure" Minimum="576" Precision="1" ShortNameTag="Press" SymbolTag="pressureBarometric" TypicalMax="0" TypicalMin="0"/>
        <Measurement ID="7" NameTag="BarometricPressure" UnitType="mBar" Type="UserCal" Inputs="4" Params="-4,794.7000000000001,4,1059.6" CalFlags="1,1,1,1" Accuracy="0.1" CIVarName="pressureMBar" Display="None" Internal="0" InternalUnit="1" Maximum="1060" MeasType="Pressure" Minimum="790" Precision="1" ShortNameTag="Press" SymbolTag="pressureBarometric" TypicalMax="0" TypicalMin="0"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20147" Tag="EKG" Version="2.0" Class="0" DefaultRate="100Hz" FileName="CISensor20147.sds" FloatParams="1" IconID="147" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6539A" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="voltage" DefaultUnit="mV" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="3" TypicalMin="-1" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="5" NameTag="HeartRate" UnitType="BeatsPerMin" Type="Period" Inputs="4" Params="30,30,2,60" Accuracy="1" CIVarName="heartRate" Display="None" Internal="0" Maximum="150" MeasType="HeartRate" Minimum="10" Precision="0" SymbolTag="HR" TypicalMax="120" TypicalMin="50" Visible="1" VisibleSds="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20148" Tag="HeartRateSensor" Version="2.0" Class="0" DefaultRate="50Hz" FileName="CISensor20148.sds" FloatParams="1" IconID="148" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6543B" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="Voltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="10" TypicalMin="-10" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="HeartRate" UnitType="BeatsPerMin" Type="Period" Inputs="4" Params="30,30,2,60" Accuracy="1" CIVarName="heartRate" Display="None" Internal="0" Maximum="150" MeasType="HeartRate" Minimum="10" Precision="0" ShortNameTag="Rate" SymbolTag="HR" TypicalMax="120" TypicalMin="50" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20149" Tag="RespirationRateSensor" Version="2.0" Class="0" DefaultRate="20Hz" FileName="CISensor20149.sds" FloatParams="1" IconID="217" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6535" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="Voltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="10" TypicalMin="-10" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="RespirationRate" UnitType="BreathPerMin" Type="Period" Inputs="4" Params="30,30,5,60" Accuracy="1" CIVarName="RespirationRate" Display="None" Internal="0" Maximum="20" MeasType="BreathRate" Minimum="2" Precision="0" ShortNameTag="Rate" SymbolTag="R" TypicalMax="100" TypicalMin="25" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20150" Tag="ForceSensorStudent" Version="2.0" Class="0" DefaultRate="20Hz" FileName="CISensor20150.sds" FloatParams="1" IconID="504" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6519" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="forceVoltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="1" TypicalMin="-1" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Force" UnitType="N" Type="UserCal" Inputs="4" Params="-3.5,-20,3.5,20" CalFlags="1,1,1,1" Accuracy="0.5" CanChangeSign="1" CIVarName="force" Display="None" Internal="0" Maximum="20" MeasType="Force" Minimum="-20" Precision="1" SymbolTag="F" TypicalMax="2" TypicalMin="-2" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20153" Tag="RelativeHumiditySensor" Version="2.0" Class="0" DefaultRate="10Hz" FileName="CISensor20153.sds" FloatParams="1" IconID="462" Latency="19" ListNameTag="HumiditySensorRelative" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6559" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="humidityVoltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="10" TypicalMin="-10" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="RelativeHumidity" UnitType="percent" Type="UserCal" Inputs="4" Params="0,0,10,100" CalFlags="1,1,1,1" Accuracy="0.5" CIVarName="humidity" Display="None" Internal="0" Maximum="100" MeasType="Humidity" Minimum="0" Precision="1" ShortNameTag="RelHumid" SymbolTag="RH" TypicalMax="85" TypicalMin="15" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20155" Tag="IonSelectiveElectrodeAmplifierBox" Version="2.0" Class="0" DefaultRate="10Hz" FileName="CISensor20155.sds" FloatParams="1" Gain="10" IconID="464" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6738" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="voltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="10" TypicalMin="-10" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="5" NameTag="CalibratedUnits" UnitType="V" Type="UserCal" Inputs="4" Params="-10,-10,10,10" CalFlags="1,1,1,1" Accuracy="0.005" CIVarName="calVoltage" Display="None" Internal="0" Maximum="10" MeasType="CalibratedUnits" Minimum="-10" Precision="3" ShortNameTag="CalUnits" SymbolTag="VC" TypicalMax="10" TypicalMin="-10" Visible="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20160" Tag="IRSensor" Version="2.0" Class="0" DefaultRate="10Hz" FileName="CISensor20160.sds" FloatParams="1" IconID="220" Latency="19" ListNameTag="LightSensorInfrared" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6628" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="Voltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="1" TypicalMin="-1" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="LightIntensity" UnitType="percent" Type="UserCal" Inputs="4" Params="0,0,5,100" CalFlags="1,1,1,1" Accuracy="1" CIVarName="light" Display="None" Internal="0" Maximum="100" MeasType="LightIntensity" Minimum="0" Precision="1" ShortNameTag="Intens" SymbolTag="IntensityIR" TypicalMax="10" TypicalMin="0" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20161" Tag="ChargeSensor" Version="2.0" Class="0" DefaultRate="10Hz" FileName="CISensor20161.sds" FloatParams="1" IconID="203" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6555" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="Voltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="1" TypicalMin="-1" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Charge1x" UnitType="uC" Type="UserCal" Inputs="4" Params="-10,-0.1,10,0.1" CalFlags="1,1,1,1" Accuracy="0.001" CIVarName="charge1x" Display="None" Internal="0" Maximum="0.1" MeasType="Charge" Minimum="-0.1" Precision="3" ShortNameTag="Charge" SymbolTag="Q1X" TypicalMax="0.01" TypicalMin="-0.01" Visible="1" VisibleSds="1" DefaultUnit="nC" IsDefaultMeas="1"/>
        <Measurement ID="6" NameTag="Charge5x" UnitType="uC" Type="UserCal" Inputs="4" Params="-2,-0.02,2,0.02" CalFlags="1,1,1,1" Accuracy="0.0001" CIVarName="charge5x" Display="None" Internal="0" Maximum="0.02" MeasType="Charge" Minimum="-0.02" Precision="4" ShortNameTag="Charge" SymbolTag="Q5X" TypicalMax="0.002" TypicalMin="-0.002" Visible="0"/>
        <Measurement ID="7" NameTag="Charge20x" UnitType="uC" Type="UserCal" Inputs="4" Params="-0.5,-0.005,0.5,0.005" CalFlags="1,1,1,1" Accuracy="0" CIVarName="charge20x" Display="None" Internal="0" Maximum="0.005" MeasType="Charge" Minimum="-0.005" Precision="5" ShortNameTag="Charge" SymbolTag="Q20X" TypicalMax="0.0005" TypicalMin="-0.0005" Visible="0"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20162" Tag="DepthSensor" Version="2.0" Class="0" DefaultRate="2Hz" FileName="CISensor20162.sds" FloatParams="1" IconID="512" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6731" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="Voltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="1" TypicalMin="-1" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="DepthFreshWater" UnitType="ft" Type="UserCal" Inputs="4" Params="0,0,10,34.6" CalFlags="1,1,1,1" Accuracy="0.1" CIVarName="depthFresh" Display="None" Internal="0" Maximum="34.6" MeasType="Position" Minimum="0" Precision="1" ShortNameTag="DepthFreshWater_SN" SymbolTag="depthFresh" TypicalMax="1.5" TypicalMin="0" Visible="1" IsDefaultMeas="1"/>
        <Measurement ID="6" NameTag="DepthSaltWater" UnitType="ft" Type="UserCal" Inputs="4" Params="0,0,10,33.79" CalFlags="1,1,1,1" Accuracy="0.1" CIVarName="depthSalt" Display="None" Internal="0" Maximum="34.6" MeasType="Position" Minimum="0" Precision="1" ShortNameTag="DepthSaltWater_SN" SymbolTag="depthSalt" TypicalMax="1.5" TypicalMin="0" Visible="0"/>
        <Measurement ID="7" NameTag="DepthFreshWater" UnitType="m" Type="UserCal" Inputs="4" Params="0,0,10,10.546" CalFlags="1,1,1,1" Accuracy="0.1" CIVarName="depthFreshMeter" Display="None" Internal="0" InternalUnit="1" Maximum="10.546" MeasType="Position" Minimum="0" Precision="1" ShortNameTag="DepthFreshWater_SN" SymbolTag="depthFresh" TypicalMax="0" TypicalMin="0" VisibleSds="1"/>
        <Measurement ID="8" NameTag="DepthSaltWater" UnitType="m" Type="UserCal" Inputs="4" Params="0,0,10,10.299" CalFlags="1,1,1,1" Accuracy="0.1" CIVarName="depthSaltMeter" Display="None" Internal="0" InternalUnit="1" Maximum="10.546" MeasType="Position" Minimum="0" Precision="1" ShortNameTag="DepthSaltWater_SN" SymbolTag="depthSalt" TypicalMax="0" TypicalMin="0"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20163" Tag="Electrometer" Version="2.0" Class="0" DefaultRate="20Hz" FileName="CISensor20163.sds" FloatParams="1" IconID="203" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="ES-9078" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="Voltage" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="4" Params="-5,-100,5,100" CalFlags="1,1,1,1" Accuracy="0.1" CIVarName="leadVoltage" Display="None" Internal="0" Maximum="100" MeasType="Voltage" Minimum="-100" Precision="1" ShortNameTag="Volt" SymbolTag="V" TypicalMax="10" TypicalMin="-10" Visible="1" VisibleSds="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20164" Tag="UVASensor" Version="2.0" Class="0" DefaultRate="10Hz" FileName="CISensor20164.sds" FloatParams="1" IconID="514" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-9784" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="Voltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="10" TypicalMin="-10" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="LightIntensity" UnitType="Percentofscalemax" Type="UserCal" Inputs="4" Params="0,0,5,100" CalFlags="1,1,1,1" Accuracy="1" CIVarName="light" Display="None" Internal="0" Maximum="100" MeasType="LightIntensity" Minimum="0" Precision="1" ShortNameTag="Intens" SymbolTag="IntensityUV" TypicalMax="100" TypicalMin="0" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20165" Tag="UserDefinedSensor" Version="2.0" Class="0" DefaultRate="10Hz" FileName="CISensor20165.sds" FloatParams="1" IconID="135" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="voltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="10" TypicalMin="-10" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="5" NameTag="UserDefined" UnitType="V" Type="UserCal" Inputs="4" Params="-10,-10,10,10" CalFlags="1,1,1,1" Accuracy="0.005" CIVarName="user" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="User" SymbolTag="U" TypicalMax="10" TypicalMin="-10" Visible="1" VisibleSds="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20166" Tag="ThermistorTemperatureSensor" Version="2.0" Class="0" DefaultRate="10Hz" FileName="CISensor20166.sds" FloatParams="1" IconID="463" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6527A" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="thermVoltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="10" TypicalMin="-10" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Temperature" UnitType="DegC" Type="UserCal" Inputs="6" Params="0,0,100,100" CalFlags="1,1,1,1" Accuracy="0.5" CIVarName="tempDegC" Internal="0" Maximum="135" MeasType="Temperature" Minimum="-35" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="30" TypicalMin="15" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="6" NameTag="Temperature" UnitType="DegC" Type="CITemperature" Inputs="4" Params="1" Accuracy="0.5" Internal="1" Maximum="135" MeasType="Temperature" Minimum="-35" Precision="1" ShortNameTag="Temp" SymbolTag="T"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20167" Tag="TemperatureSensorStainlessSteel" Version="2.0" Class="0" DefaultRate="10Hz" FileName="CISensor20167.sds" FloatParams="1" IconID="516" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6605" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="thermVoltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="10" TypicalMin="-10" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Temperature" UnitType="DegC" Type="CITemperature" Inputs="4" Params="0" Accuracy="0.5" CIVarName="tempDegC" Display="None" Internal="0" Maximum="135" MeasType="Temperature" Minimum="-35" Precision="1" ShortNameTag="Temp" SymbolTag="T" TypicalMax="30" TypicalMin="15" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20168" Tag="OxygenGasSensor" Version="2.0" Class="0" DefaultRate="1Hz" FileName="CISensor20168.sds" FloatParams="1" IconID="517" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6562" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="O2Voltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="10" TypicalMin="-10" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="PercentOxygenConcentration" UnitType="percent" Type="LinearConv" Inputs="4" Params="10,0" Accuracy="1" CIVarName="concentration" Display="None" Internal="0" Maximum="100" MeasType="Concentration" Minimum="0" Precision="0" ShortNameTag="O2Conc" SymbolTag="O2" TypicalMax="100" TypicalMin="75" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <Measurement ID="6" NameTag="OxygenGasConcentration" UnitType="ppm" Type="LinearConv" Inputs="4" Params="100000,0" Accuracy="200" CIVarName="concentrationPPM" Display="None" Internal="0" Maximum="1000000" MeasType="Concentration" Minimum="0" Precision="0" ShortNameTag="O2Conc" SymbolTag="O2" TypicalMax="300000" TypicalMin="150000" Visible="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20169" Tag="HighCurrentSensor" Version="2.0" Class="0" DefaultRate="20Hz" FileName="CISensor20169.sds" FloatParams="1" IconID="457" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6740" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="currentVoltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="1" TypicalMin="-1" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Current" UnitType="A" Type="UserCal" Inputs="4" Params="0,0,10,10" CalFlags="1,1,1,1" Accuracy="0.02" CIVarName="current" Display="None" Internal="0" Maximum="10" MeasType="Current" Minimum="-10" Precision="2" ShortNameTag="Curr" SymbolTag="current" TypicalMax="1" TypicalMin="-1" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20170" Tag="ForcePlatform" Version="2.0" Class="0" DefaultRate="20Hz" FileName="CISensor20170.sds" FloatParams="1" IconID="225" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6461" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="forceVoltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="1" TypicalMin="-1" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Force" UnitType="N" Type="UserCal" Inputs="4" Params="1.954,0,3.711,1000" CalFlags="1,1,1,1" Accuracy="1" CIVarName="forceN" Display="None" Internal="0" Maximum="2250" MeasType="Force" Minimum="0" Precision="2" SymbolTag="F" TypicalMax="200" TypicalMin="0" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <Measurement ID="6" NameTag="Force" UnitType="lbs" Type="UserCal" Inputs="4" Params="1.954,0,3.711,224.809" CalFlags="1,1,1,1" Accuracy="1" CIVarName="forcePounds" Display="None" Internal="0" InternalUnit="1" Maximum="500" MeasType="Force" Minimum="0" Precision="2" SymbolTag="F" TypicalMax="0" TypicalMin="0"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20171" Tag="CILoadCellAmplifier" Version="2.0" Class="0" DefaultRate="20Hz" FileName="CISensor20171.sds" FloatParams="1" IconID="130" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6464" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="loadCellVoltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="1" TypicalMin="-1" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Force5N" UnitType="N" Type="UserCal" Inputs="4" Params="0,0,9.841,5" CalFlags="1,1,1,1" Accuracy="0.01" CanChangeSign="1" CIVarName="forceN5N" Display="None" Internal="0" Maximum="5" MeasType="Force" Minimum="-5" Precision="1" ShortNameTag="Force" SymbolTag="F" TypicalMax="0.5" TypicalMin="-0.5" Visible="0" VisibleSds="1"/>
        <Measurement ID="6" NameTag="Force5N" UnitType="lbs" Type="UserCal" Inputs="4" Params="0,0,9.841,1.124" CalFlags="1,1,1,1" Accuracy="0.001" CIVarName="forcePounds5N" Display="None" Internal="0" InternalUnit="1" Maximum="1.124" MeasType="Force" Minimum="-1.124" Precision="1" ShortNameTag="Force" SymbolTag="F" TypicalMax="0" TypicalMin="0"/>
        <Measurement ID="7" NameTag="Force100N" UnitType="N" Type="UserCal" Inputs="4" Params="0,0,9.841,100" CalFlags="1,1,1,1" Accuracy="0.1" CanChangeSign="1" CIVarName="forceN100N" Display="None" Internal="0" Maximum="100" MeasType="Force" Minimum="-100" Precision="1" ShortNameTag="Force" SymbolTag="F" TypicalMax="10" TypicalMin="-10" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <Measurement ID="8" NameTag="Force100N" UnitType="lbs" Type="UserCal" Inputs="4" Params="0,0,9.841,22.481" CalFlags="1,1,1,1" Accuracy="0.05" CIVarName="forcePounds100N" Display="None" Internal="0" InternalUnit="1" Maximum="22.48" MeasType="Force" Minimum="-22.48" Precision="1" ShortNameTag="Force" SymbolTag="F" TypicalMax="0" TypicalMin="0"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20172" Tag="HighSensitivityLightSensor" Version="2.0" Class="0" DefaultRate="20Hz" FileName="CISensor20172.sds" FloatParams="1" IconID="514" Latency="19" ListNameTag="LightSensorHighSensitivity" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6604" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="Voltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="1" TypicalMin="-1" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="LightIntensity" UnitType="percent" Type="UserCal" Inputs="4" Params="0,0,5,100" CalFlags="1,1,1,1" Accuracy="1" CIVarName="light" Display="None" Internal="0" Maximum="100" MeasType="LightIntensity" Minimum="0" Precision="1" ShortNameTag="Intens" SymbolTag="IntensityLight" TypicalMax="10" TypicalMin="0" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20173" Tag="BroadSpectrumLightSensor" Version="2.0" Class="0" DefaultRate="10Hz" FileName="CISensor20173.sds" FloatParams="1" IconID="514" Latency="19" ListNameTag="LightSensorBroadSpectrum" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6630" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="Voltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="10" TypicalMin="-10" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="LightIntensity" UnitType="percent" Type="UserCal" Inputs="4" Params="0,0,5,100" CalFlags="1,1,1,1" Accuracy="1" CIVarName="light" Display="None" Internal="0" Maximum="100" MeasType="LightIntensity" Minimum="0" Precision="1" ShortNameTag="Intens" SymbolTag="IntensityLight" TypicalMax="100" TypicalMin="0" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20174" Tag="ForceSensorEconomy" Version="2.0" Class="0" DefaultRate="20Hz" FileName="CISensor20174.sds" FloatParams="1" IconID="511" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6746" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="forceVoltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="1" TypicalMin="-1" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Force" UnitType="N" Type="UserCal" Inputs="4" Params="-8,-50,8,50" CalFlags="1,1,1,1" Accuracy="0.5" CanChangeSign="1" CIVarName="force" Display="None" Internal="0" Maximum="20" MeasType="Force" Minimum="-20" Precision="1" SymbolTag="F" TypicalMax="2" TypicalMin="-2" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20175" Tag="DCPowerSupplyFilament" Version="2.0" Class="0" DefaultRate="20Hz" FloatParams="1" IconID="132" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="BEM-5001" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="FilamentVoltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" Internal="0" Maximum="6.3" MeasType="Voltage" Minimum="0" TypicalMax="10" TypicalMin="0" Precision="2" ShortNameTag="FilVolt" SymbolTag="Vf" Visible="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20176" Tag="DCPowerSupplyVoltage" Version="2.0" Class="0" DefaultRate="20Hz" FloatParams="1" IconID="135" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="BEM-5001" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" Internal="1" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="10" TypicalMin="-10" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Voltage" UnitType="V" Equation="10.0*[4]" Accuracy="0.005" Internal="0" Maximum="30" MeasType="Voltage" Minimum="-4.5" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="10" TypicalMin="-5" Visible="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20177" Tag="DCCurrentAmplifier" Version="2.0" Class="0" DefaultRate="20Hz" FloatParams="1" IconID="246" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="BEM-5004" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" Internal="1" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="10" TypicalMin="-10" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Current" UnitType="A" Equation="[100]*[4]*1000.0" Accuracy="0.005" Internal="0" Maximum="30" MeasType="Current" Minimum="-4.5" Precision="3" ShortNameTag="Volt" SymbolTag="current" TypicalMax="10" TypicalMin="-5" Visible="1"/>
        <Measurement ID="100" NameTag="CurrentRangeSettings" UnitType="Unitless" Type="Constant" Internal="1" MeasType="None" Value="1e-13" Values="x108:1e-8:x109:1e-9:x1010:1e-10:x1011:1e-11:x1012:1e-12:x1013:1e-13"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20178" Tag="DCPowerSupplyII12V" Version="2.0" Class="0" DefaultRate="20Hz" FloatParams="1" IconID="135" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="BEM-5002" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.05" Internal="1" Maximum="10" MeasType="Voltage" Minimum="0" Precision="2" ShortNameTag="Volt" SymbolTag="V" Visible="1"/>
        <Measurement ID="5" NameTag="Voltage" UnitType="V" Equation="[4]" Accuracy="0.05" Maximum="12" MeasType="Voltage" Minimum="0" TypicalMax="2" TypicalMin="0" Precision="2" ShortNameTag="Volt" SymbolTag="V" Visible="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20179" Tag="DCPowerSupplyII200V" Version="2.0" Class="0" DefaultRate="20Hz" FloatParams="1" Gain="10" IconID="135" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="BEM-5002" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" Internal="1" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="10" TypicalMin="-10" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Voltage" UnitType="V" Equation="100.0*[4]" Accuracy="0.5" Maximum="200" MeasType="Voltage" Minimum="0" TypicalMax="20" TypicalMin="0" Precision="1" ShortNameTag="Volt" SymbolTag="V" Visible="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20180" Tag="HallEffectVoltageSensor" Version="2.0" DefaultRate="10Hz" FloatParams="1" Gain="10" IconID="135" MaxRate="50000Hz" Model="SE-7260">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.05" Internal="1" Maximum="10" MeasType="Voltage" Minimum="0" Precision="2" ShortNameTag="Volt" SymbolTag="V" Visible="1"/>
        <Measurement ID="5" NameTag="HallEffectVoltageName" UnitType="V" Equation="[4]" Accuracy="0.05" Maximum="0.1" MeasType="Voltage" DefaultUnit="mV" Minimum="-0.1" TypicalMax="0.01" TypicalMin="-0.01" Precision="1" ShortNameTag="Volt" SymbolTag="HallEffectVoltageSymbol" Visible="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20181" Tag="HallEffectCurrentSensor" Version="2.0" DefaultRate="10Hz" FloatParams="1" Gain="10" IconID="457" MaxRate="50000Hz" Model="SE-7260">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.05" Internal="1" Maximum="10" MeasType="Voltage" Minimum="0" Precision="2" ShortNameTag="Volt" SymbolTag="V" Visible="1"/>
        <Measurement ID="5" NameTag="Current" UnitType="A" Equation="[4]/100" Accuracy="5" Maximum="10" MeasType="Current" DefaultUnit="mA" Minimum="-10" TypicalMax="1" TypicalMin="-1" Precision="2" ShortNameTag="Curr" SymbolTag="HallEffectCurrentSymbol" Visible="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="20201" Tag="CarbonDioxideGasSensor" Version="2.0" Class="0" DefaultRate="1Hz" FileName="CISensor20201.sds" FloatParams="1" IconID="201" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="CI-6561" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="UserCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" CIVarName="co2voltage" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="10" TypicalMin="-10" Visible="0" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="CO2Concentration10K" UnitType="ppm" Type="LinearConv" Inputs="4" Params="1000,0" Accuracy="200" CIVarName="concentration10K" Display="None" Internal="0" Maximum="10000" MeasType="Concentration" Minimum="0" Precision="0" ShortNameTag="CO2Conc10k" SymbolTag="CO2" TypicalMax="2000" TypicalMin="200" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <Measurement ID="6" NameTag="CO2Concentration100K" UnitType="ppm" Type="LinearConv" Inputs="4" Params="10000,0" Accuracy="200" CIVarName="concentration100K" Display="None" Internal="0" Maximum="1000000" MeasType="Concentration" Minimum="0" Precision="0" ShortNameTag="CO2Conc100k" SymbolTag="CO2" TypicalMax="5000" TypicalMin="2000" Visible="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <!-- Sensor IDs 20300 - 20399 are for special 850 internal sensors -->
      <Sensor ID="20300" Tag="OutputVoltageSensor" DefaultRate="20Hz" IconID="135" MaxRate="10000000Hz" SupportsZeroOnStart="1">
        <Measurement ID="0" NameTag="OutputVoltage" UnitType="V" Type="RawDigital" DataSize="8" Accuracy="0.005" Maximum="10" MeasType="Voltage" Minimum="-10" OffsetZero="1" Precision="3" ShortNameTag="VoltsOut" SymbolTag="Vo" TypicalMax="1" TypicalMin="-1" Visible="1"/>
      </Sensor>
      <Sensor ID="20302" Tag="OutputVoltageCurrentSensor" Version="2.0" DefaultRate="20Hz" IconID="135" MaxRate="1000000Hz" SupportsZeroOnStart="1" >
        <Measurement ID="0" NameTag="OutputVoltage" CIVarName="outVoltage" UnitType="V" Type="RawDigital" DataSize="8" Accuracy="0.005" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" TypicalMax="1" TypicalMin="-1" OffsetZero="1" Precision="3" ShortNameTag="VoltsOut" SymbolTag="Vo" Visible="1"/>
        <Measurement ID="1" NameTag="OutputCurrent" CIVarName="outCurrent" UnitType="A" Type="RawDigital" DataSize="8" Accuracy="0.002" Internal="0" Maximum="1" MeasType="Current" Minimum="-0.1" TypicalMax="0.1" TypicalMin="-1" OffsetZero="1" Precision="3" ShortNameTag="CurrOut" SymbolTag="Io" Visible="1" IsDefaultMeas="1"/>
      </Sensor>
      <Sensor ID="20303" Tag="OutputFrequencySensor" DefaultRate="20Hz" IconID="2013" MaxRate="100Hz">
        <Measurement ID="0" NameTag="OutputFrequency" UnitType="Hz" Type="RawDigital" DataSize="8" Accuracy="0.001" Maximum="500000" TypicalMax="10000" TypicalMin="0" MeasType="Frequency" Minimum="0.001" Precision="3" SymbolTag="Fo" Visible="1"/>
      </Sensor>
      <Sensor ID="20304" Tag="PeakAmplitudeSensor" DefaultRate="20Hz" IconID="2012" MaxRate="100Hz" SupportsZeroOnStart="1" >
        <Measurement ID="0" NameTag="PeakAmplitude" UnitType="V" Type="RawDigital" DataSize="8" Accuracy="0.01" Maximum="20.0" MeasType="Voltage" Minimum="-20.0" TypicalMax="2" TypicalMin="-2" OffsetZero="1" Precision="2" SymbolTag="Vp" Visible="1"/>
      </Sensor>
      <Sensor ID="20305" Tag="OutputCurrentSensor" DefaultRate="20Hz" IconID="457" MaxRate="10000000Hz" SupportsZeroOnStart="1" >
        <Measurement ID="0" NameTag="OutputCurrent" UnitType="A" Type="RawDigital" DataSize="8" Accuracy="0.005" Maximum="0.4" MeasType="Current" Minimum="-0.4" OffsetZero="1" Precision="3" ShortNameTag="CurrOut" SymbolTag="Io" TypicalMax="0.1" TypicalMin="-0.1" Visible="1"/>
      </Sensor>
      <Sensor ID="20306" Tag="PeakCurrentSensor" DefaultRate="20Hz" IconID="2015" MaxRate="100Hz" SupportsZeroOnStart="1" >
        <Measurement ID="0" NameTag="PeakCurrent" UnitType="A" Type="RawDigital" DataSize="8" Accuracy="0.005" Maximum="0.4" MeasType="Current" Minimum="-0.4" OffsetZero="1" Precision="3" SymbolTag="Ipeak" TypicalMax="0.1" TypicalMin="-0.1" Visible="1"/>
      </Sensor>
      <!-- Sensor IDs 21000 - 21299 are for CI digital timing and counting modes -->
      <Sensor ID="21000" Tag="CustomTimer" IconID="438" IsPhotogateTimer="1" NumInputs="1"/>
      <Sensor ID="21001" Tag="OnePhotogateSingleFlag" IconID="440" IsPhotogateTimer="1" NumInputs="1">
        <Measurement ID="0" NameTag="State" UnitType="Unitless" TimerTest="Y4Z0" MeasType="State" SymbolTag="State" Visible="0"/>
        <Measurement ID="1" NameTag="TimeInGate" UnitType="s" TimerTest="B0U0" MeasType="Time" ShortNameTag="TimeInGate_SN" SymbolTag="deltaUtInGate" Visible="1"/>
        <Measurement ID="2" NameTag="Speed" UnitType="mps" Equation="[100]/[1]" MeasType="Speed" SymbolTag="speed" Visible="1"/>
        <Measurement ID="100" NameTag="FlagWidth" UnitType="m" Type="Constant" Internal="1" MeasType="Length" Value="0.05"/>
      </Sensor>
      <Sensor ID="21005" Tag="PendulumTimer" IconID="443" SmartGateIconID="1443" IsPhotogateTimer="1" NumInputs="1">
        <Measurement ID="0" NameTag="State" CIVarName="0" UnitType="Unitless" TimerTest="Y4Z0" MeasType="State" SymbolTag="State" Visible="0"/>
        <Measurement ID="1" NameTag="BlockEventTimes" UnitType="s" TimerTest="Y1B0" MeasType="Time" ShortNameTag="BlockEventTimes_SN" SymbolTag="t" Visible="0"/>
        <Measurement ID="3" NameTag="Period" CIVarName="period" UnitType="s" TimerTest="K1B0B0B0" MeasType="Period" ShortNameTag="Per" SymbolTag="Period" Visible="1"/>
        <Measurement ID="4" NameTag="BlocktoBlockTimes" UnitType="s" TimerTest="K1Y0B0B0" MeasType="Time" ShortNameTag="BlocktoBlockTimes_SN" SymbolTag="t" Visible="0"/>
        <Measurement ID="5" NameTag="Speed" CIVarName="velocity" UnitType="mps" Equation="[100]/[6]" MeasType="Speed" SymbolTag="speed" Visible="1"/>
        <Measurement ID="6" NameTag="TimeInGate" UnitType="s" TimerTest="B0U0" MeasType="Time" ShortNameTag="TimeInGate_SN" SymbolTag="deltaUtInGate" Visible="0"/>
        <Measurement ID="100" NameTag="PendulumWidth" CIVarName="pendulumWidth" UnitType="m" Type="Constant" Internal="1" MeasType="Length" Value="0.016"/>
      </Sensor>
      <Sensor ID="21006" Tag="PhotogateWithPulley" IconID="445"  SmartGateIconID="1445" IsPhotogateTimer="1" Model="ME-6838" NumInputs="1">
        <Measurement ID="0" NameTag="State" CIVarName="0" UnitType="Unitless" TimerTest="Y4Z0" MeasType="State" SymbolTag="State" Visible="0"/>
        <Measurement ID="1" NameTag="BlockCount" UnitType="Unitless" TimerTest="Y3B0" MeasType="Count" Visible="1"/>
        <Measurement ID="2" NameTag="BlocktoBlockTimes" CIVarName="spokeTimer" UnitType="s" TimerTest="K1Y0B0B0" MeasType="Time" ShortNameTag="BlocktoBlockTimes_SN" SymbolTag="deltaUtBlock" Visible="0"/>
        <Measurement ID="3" NameTag="Position" CIVarName="position" UnitType="m" Equation="[1]*[100]" MeasType="Position" ShortNameTag="pos" SymbolTag="x" Visible="1"/>
        <Measurement ID="4" NameTag="LinearSpeed" CIVarName="velocity" UnitType="mps" Equation="deriv([3])" MeasType="Speed" ShortNameTag="speed" SymbolTag="speed" Visible="1"/>
        <Measurement ID="5" NameTag="LinearAcceleration" CIVarName="acceleration" UnitType="ms2" Equation="deriv([4])" MeasType="Acceleration" ShortNameTag="acc" SymbolTag="a" Visible="1"/>
        <Measurement ID="6" NameTag="Angle" CIVarName="angularPosition" UnitType="deg" Equation="[1]*[101]" MeasType="Angle" ShortNameTag="ang" SymbolTag="thetaL" Visible="1"/>
        <Measurement ID="7" NameTag="AngularSpeed" CIVarName="angularVelocity" UnitType="degps" Equation="deriv([6])" MeasType="AngularSpeed" ShortNameTag="angspeed" SymbolTag="omegaLSpeed" Visible="1"/>
        <Measurement ID="8" NameTag="AngularAcceleration" CIVarName="angularAcceleration" UnitType="degps2" Equation="deriv([7])" MeasType="AngularAcceleration" ShortNameTag="angacc" SymbolTag="alphaL" Visible="1"/>
        <Measurement ID="100" NameTag="SpokeArcLength" CIVarName="spokeArcLength" UnitType="m" Type="Constant" Internal="1" MeasType="Length" Value="0.015"/>
        <Measurement ID="101" NameTag="SpokeAngle" CIVarName="spokeAngle" UnitType="deg" Type="Constant" Internal="1" MeasType="Angle" Value="36"/>
      </Sensor>
      <Sensor ID="21008" Tag="PicketFence" IconID="444" SmartGateIconID="1444" IsPhotogateTimer="1" NumInputs="1">
        <Measurement ID="0" NameTag="State" CIVarName="0" UnitType="Unitless" TimerTest="Y4Z0" MeasType="State" SymbolTag="State" Visible="0"/>
        <Measurement ID="1" NameTag="BlockEventTimes" UnitType="s" TimerTest="Y1B0" MeasType="Time" ShortNameTag="BlockEventTimes_SN" SymbolTag="t" Visible="1"/>
        <Measurement ID="2" NameTag="BlocktoBlockTimes" CIVarName="bandTimer" UnitType="s" TimerTest="Y0K1B0B0" MeasType="Time" ShortNameTag="BlocktoBlockTimes_SN" SymbolTag="t" Visible="0"/>
        <Measurement ID="3" NameTag="Speed" CIVarName="velocity" UnitType="mps" Equation="deriv([5])" MeasType="Speed" SymbolTag="speed" Visible="1"/>
        <Measurement ID="4" NameTag="Acceleration" CIVarName="acceleration" UnitType="ms2" Equation="deriv([3])" MeasType="Acceleration" ShortNameTag="acc" SymbolTag="a" Visible="1"/>
        <Measurement ID="5" NameTag="Position" CIVarName="position" UnitType="m" TimerTest="Y3B0" Equation="([5]-1)*[100]" MeasType="Position" ShortNameTag="pos" SymbolTag="x" Visible="1"/>
        <Measurement ID="6" NameTag="EventTimes" UnitType="s" TimerTest="Y1Z0" MeasType="Time" ShortNameTag="EventTimes_SN" SymbolTag="t" Visible="0"/>
        <Measurement ID="100" NameTag="FlagSpacing" CIVarName="bandSpacing" UnitType="m" Type="Constant" Internal="1" MeasType="Length" Value="0.05"/>
      </Sensor>
      <Sensor ID="21009" Tag="CollisionSingleFlag" IconID="438" IsPhotogateTimer="1" NumInputs="2">
        <Measurement ID="0" NameTag="StateOrd" UnitType="Unitless" TimerTest="Y4Z0" MeasType="State" Ordinal="1" SymbolTag="SOrd" Visible="0"/>
        <Measurement ID="1" NameTag="StateOrd" UnitType="Unitless" TimerTest="Y4Z1" MeasType="State" Ordinal="2" SymbolTag="SOrd" Visible="0"/>
        <Measurement ID="2" NameTag="TimeInGateOrd" UnitType="s" TimerTest="B0U0" MeasType="Time" Ordinal="1" ShortNameTag="TimeInGateOrd_SN" SymbolTag="deltaUtOrdInGate" Visible="1"/>
        <Measurement ID="3" NameTag="TimeInGateOrd" UnitType="s" TimerTest="B1U1" MeasType="Time" Ordinal="2" ShortNameTag="TimeInGateOrd_SN" SymbolTag="deltaUtOrdInGate" Visible="1"/>
        <Measurement ID="5" NameTag="SpeedinGateOrd" UnitType="mps" Equation="[100]/[2]" MeasType="Speed" Ordinal="1" ShortNameTag="speedOrd" SymbolTag="vOrd" Visible="1"/>
        <Measurement ID="6" NameTag="SpeedinGateOrd" UnitType="mps" Equation="[100]/[3]" MeasType="Speed" Ordinal="2" ShortNameTag="speedOrd" SymbolTag="vOrd" Visible="1"/>
        <Measurement ID="7" NameTag="EventTimesOrd" UnitType="s" TimerTest="Y1Z0" MeasType="Time" ShortNameTag="EventTimesOrd_SN" Ordinal="1" SymbolTag="tOrd" Visible="0"/>
        <Measurement ID="8" NameTag="EventTimesOrd" UnitType="s" TimerTest="Y1Z1" MeasType="Time" ShortNameTag="EventTimesOrd_SN" Ordinal="2" SymbolTag="tOrd" Visible="0"/>
        <Measurement ID="100" NameTag="FlagLength" UnitType="m" Type="Constant" Internal="1" MeasType="Length" Value="0.05"/>
      </Sensor>
      <Sensor ID="21010" Tag="CollisionDoubleFlag" IconID="439" IsPhotogateTimer="1" NumInputs="2">
        <Measurement ID="0" NameTag="StateOrd" UnitType="Unitless" TimerTest="Y4Z0" MeasType="State" Ordinal="1" SymbolTag="SOrd" Visible="0"/>
        <Measurement ID="1" NameTag="StateOrd" UnitType="Unitless" TimerTest="Y4Z1" MeasType="State" Ordinal="2" SymbolTag="SOrd" Visible="0"/>
        <Measurement ID="2" NameTag="BlockBlockTimeInGateOrd" UnitType="s" TimerTest="B0B0" MeasType="Time" Ordinal="1" ShortNameTag="BlockBlockTimeInGateOrd_SN" SymbolTag="deltaUtOrdBlock" Visible="1"/>
        <Measurement ID="3" NameTag="BlockBlockTimeInGateOrd" UnitType="s" TimerTest="B1B1" MeasType="Time" Ordinal="2" ShortNameTag="BlockBlockTimeInGateOrd_SN" SymbolTag="deltaUtOrdBlock" Visible="1"/>
        <Measurement ID="5" NameTag="SpeedinGateOrd" UnitType="mps" Equation="[100]/[2]" MeasType="Speed" Ordinal="1" ShortNameTag="speedOrd" SymbolTag="vOrd" Visible="1"/>
        <Measurement ID="6" NameTag="SpeedinGateOrd" UnitType="mps" Equation="[100]/[3]" MeasType="Speed" Ordinal="2" ShortNameTag="speedOrd" SymbolTag="vOrd" Visible="1"/>
        <Measurement ID="7" NameTag="EventTimesOrd" UnitType="s" TimerTest="Y1Z0" MeasType="Time" ShortNameTag="EventTimesOrd_SN" Ordinal="1" SymbolTag="tOrd" Visible="0"/>
        <Measurement ID="8" NameTag="EventTimesOrd" UnitType="s" TimerTest="Y1Z1" MeasType="Time" ShortNameTag="EventTimesOrd_SN" Ordinal="2" SymbolTag="tOrd" Visible="0"/>
        <Measurement ID="9" NameTag="BlockEventTimesOrd" UnitType="s" TimerTest="Y1B0" MeasType="Time" Ordinal="1" ShortNameTag="BlockEventTimesOrd_SN" SymbolTag="tBOrd" Visible="0"/>
        <Measurement ID="10" NameTag="BlockEventTimesOrd" UnitType="s" TimerTest="Y1B1" MeasType="Time" Ordinal="2" ShortNameTag="BlockEventTimesOrd_SN" SymbolTag="tBOrd" Visible="0"/>
        <Measurement ID="100" NameTag="PhotogateSpacing" UnitType="m" Type="Constant" Internal="1" MeasType="Length" Value="0.1" IsPhotogateSpacing="1"/>
      </Sensor>
      <Sensor ID="21011" Tag="RotationalDynamicsApparatus" IconID="429" IsDigitalCounter="1" NumInputs="1">
        <Measurement ID="0" NameTag="CountsPerSample" CIVarName="plateCounter" UnitType="CountsPerSample" Type="RawDigital" DataSize="2" MeasType="CountsPerSample" ShortNameTag="Ctssample" SymbolTag="N" Visible="0"/>
        <Measurement ID="1" NameTag="Angle" CIVarName="angularPosition" UnitType="deg" Equation="(sum([0])/[100])*360" MeasType="Angle" ShortNameTag="angle" SymbolTag="thetaL" Visible="1"/>
        <Measurement ID="2" NameTag="AngularVelocity" CIVarName="angularVelocity" UnitType="degps" Equation="deriv([1])" MeasType="AngularVelocity" ShortNameTag="angvel" SymbolTag="omegaL" Visible="1"/>
        <Measurement ID="3" NameTag="AngularAcceleration" CIVarName="angularAcceleration" UnitType="degps2" Equation="deriv([2])" MeasType="AngularAcceleration" ShortNameTag="angacc" SymbolTag="alphaL" Visible="1"/>
        <Measurement ID="100" NameTag="NumberOfBands" CIVarName="bands" Type="Constant" Internal="1" MeasType="Count" Value="200"/>
      </Sensor>
      <Sensor ID="21012" Tag="GeigerCounter" DefaultRate="1Hz" IconID="424" FirstSampleAtT1="1" IsDigitalCounter="1" MaxRate="100Hz" Model="SN-7927A" NumInputs="1">
        <Measurement ID="0" NameTag="GeigerCounts" UnitType="CountsPerSample" Type="RawDigital" DataSize="2" MeasType="CountsPerSample" Precision="0" ShortNameTag="Ctssample" SymbolTag="R" Visible="1"/>
      </Sensor>
      <Sensor ID="21013" Tag="DropCounter" DefaultRate="1Hz" IconID="432" IsDigitalCounter="1" MaxRate="100Hz" Model="CI-6499" NumInputs="1">
        <Measurement ID="0" NameTag="Counter" UnitType="drops" Type="RawDigital" DataSize="2" MeasType="Counter" Precision="0" SymbolTag="C" Visible="0"/>
        <Measurement ID="1" NameTag="DropCount" UnitType="drops" Equation="chgfilter(0,sum([0]))" MeasType="Count" Precision="0" ShortNameTag="Count" SymbolTag="N" Visible="1"/>
        <Measurement ID="2" NameTag="FluidVolume" UnitType="mL" Equation="last(1,[1]*[100])"  DefaultUnit="mL" MeasType="Volume" ShortNameTag="Vol" SymbolTag="V" Visible="1" IsDefaultMeas="1"/>
        <Measurement ID="100" NameTag="DropVolume" UnitType="mL" Type="Constant" Internal="1" MeasType="Volume" Value="0.033"/>
      </Sensor>
      <Sensor ID="21017" Tag="FreeFallAdapter" IconID="426"  IsPhotogateTimer="1" NumInputs="1">
        <Measurement ID="0" NameTag="State" CIVarName="0" UnitType="Unitless" TimerTest="Y4Z0" MeasType="State" SymbolTag="State" Visible="0"/>
        <Measurement ID="1" NameTag="TimeOfFall" CIVarName="timeOfFall" UnitType="s" TimerTest="B0U0" MeasType="Time" ShortNameTag="TimeOfFall_SN" SymbolTag="t" Visible="1"/>
        <Measurement ID="2" NameTag="Acceleration" CIVarName="acceleration" UnitType="ms2" Equation="(2.0*[100])/([1]*[1])" MeasType="Acceleration" ShortNameTag="acc" SymbolTag="a" Visible="1"/>
        <Measurement ID="100" NameTag="DistanceOfFall" CIVarName="height" UnitType="m" Type="Constant" Internal="1" MeasType="Position" Value="1"/>
      </Sensor>
      <Sensor ID="21018" Tag="TimeOfFlight1gate" IconID="446" IsPhotogateTimer="1" NumInputs="2">
        <Measurement ID="1" NameTag="TimeOfFlight" CIVarName="flightTimer" UnitType="s" TimerTest="Q1B0B1" MeasType="Time" ShortNameTag="TimeOfFlight_SN" SymbolTag="t" Visible="1"/>
        <Measurement ID="2" NameTag="BlockEventTimes" UnitType="s" TimerTest="Y1B*" MeasType="Time" ShortNameTag="BlockEventTimes_SN" SymbolTag="tB" Visible="0"/>
      </Sensor>
      <Sensor ID="21019" Tag="TimeOfFlight2gates" IconID="447" IsPhotogateTimer="1" NumInputs="3">
        <Measurement ID="0" NameTag="InitialSpeed" UnitType="mps" Equation="[100]/[2]" MeasType="Speed" ShortNameTag="speed" SymbolTag="speed" Visible="1"/>
        <Measurement ID="1" NameTag="TimeOfFlight" UnitType="s" TimerTest="Q1B0B2" MeasType="Time" ShortNameTag="TimeOfFlight_SN" SymbolTag="t" Visible="1"/>
        <Measurement ID="2" NameTag="TimeBetweenGates" UnitType="s" TimerTest="Q1B0B1" MeasType="Time" ShortNameTag="TimeBetweenGates_SN" SymbolTag="deltaUtBetween" Visible="0"/>
        <Measurement ID="3" NameTag="BlockEventTimes" UnitType="s" TimerTest="Y1B*" MeasType="Time" ShortNameTag="BlockEventTimes_SN" SymbolTag="tB" Visible="0"/>
        <Measurement ID="100" NameTag="PhotogateSpacing" UnitType="m" Type="Constant" Internal="1" MeasType="Length" Value="0.1" IsPhotogateSpacing="1"/>
      </Sensor>
      <Sensor ID="21021" Tag="FlowRateSensorCI" DefaultRate="2Hz" IconID="431" IsDigitalCounter="1" MaxRate="100Hz" Model="CI-6730" NumInputs="1">
        <Measurement ID="0" NameTag="Counter" UnitType="Unitless" Type="RawDigital" DataSize="2" MeasType="Counter" Precision="0" SymbolTag="C" Visible="0"/>
        <Measurement ID="1" NameTag="FlowPulses" UnitType="Unitless" Equation="sum([0])" MeasType="Count" Precision="0" ShortNameTag="Pulses" SymbolTag="N" Visible="1"/>
        <Measurement ID="2" NameTag="FlowRate" UnitType="fps" Equation="deriv([1]/[100])" MeasType="Speed" ShortNameTag="Rate" SymbolTag="flowRateVelocity" Visible="1"/>
        <Measurement ID="100" NameTag="PulsesPerFoot" UnitType="Unitless" Type="Constant" Internal="1" MeasType="Count" Value="8.62"/>
      </Sensor>
      <Sensor ID="21022" Tag="DigitalInput" IconID="2014" IsPhotogateTimer="1" NumInputs="1">
        <Measurement ID="0" NameTag="State" UnitType="Unitless" TimerTest="Y4Z0" MeasType="State" SymbolTag="State" Visible="1"/>
      </Sensor>
      <Sensor ID="21023" Tag="GeneralCounter" DefaultRate="1Hz" IconID="430" IsDigitalCounter="1" MaxRate="100Hz" NumInputs="1">
        <Measurement ID="0" NameTag="Counts" UnitType="CountsPerSample" Type="RawDigital" DataSize="2" MeasType="CountsPerSample" Precision="0" ShortNameTag="Ctssample" SymbolTag="cps" Visible="1"/>
      </Sensor>
      <Sensor ID="21030" Tag="OnePhotogateDoubleFlag" IconID="441" IsPhotogateTimer="1" NumInputs="1">
        <Measurement ID="0" NameTag="State" UnitType="Unitless" TimerTest="Y4Z0" MeasType="State" SymbolTag="State" Visible="0"/>
        <Measurement ID="1" NameTag="BlocktoBlockTime" UnitType="s" TimerTest="Y0A2B0B0" MeasType="Time" ShortNameTag="BlocktoBlockTime_SN" SymbolTag="deltaUtInGate" Visible="1"/>
        <Measurement ID="2" NameTag="Speed" UnitType="mps" Equation="[100]/[1]" MeasType="Speed" SymbolTag="speed" Visible="1"/>
        <Measurement ID="3" NameTag="BlockEventTimes" UnitType="s" TimerTest="Y1B0" MeasType="Time" ShortNameTag="BlockEventTimes_SN" SymbolTag="tB" Visible="0"/>
        <Measurement ID="4" NameTag="EventTimes" UnitType="s" TimerTest="Y1Z0" MeasType="Time" ShortNameTag="EventTimes_SN" SymbolTag="t" Visible="0"/>
        <Measurement ID="100" NameTag="FlagSpacing" UnitType="m" Type="Constant" Internal="1" MeasType="Length" Value="0.025"/>
      </Sensor>
      <Sensor ID="21031" Tag="OnePhotogateTripleFlag" IconID="442" IsPhotogateTimer="1" NumInputs="1">
        <Measurement ID="0" NameTag="State" UnitType="Unitless" TimerTest="Y4Z0" MeasType="State" SymbolTag="State" Visible="0"/>
        <Measurement ID="1" NameTag="BlockEventTimes" UnitType="s" TimerTest="Y1B0" MeasType="Time" ShortNameTag="BlockEventTimes_SN" SymbolTag="tB" Visible="0"/>
        <Measurement ID="2" NameTag="BlocktoBlockTimes" UnitType="s" TimerTest="Y0S2K1B0B0" MeasType="Time" ShortNameTag="BlocktoBlockTimes_SN" SymbolTag="deltaUtBlock" Visible="1"/>
        <Measurement ID="3" NameTag="Speed" UnitType="mps" Equation="[100]/[2]" MeasType="Speed" SymbolTag="speed" Visible="1"/>
        <Measurement ID="4" NameTag="Acceleration" UnitType="ms2" Equation="deriv([3])" MeasType="Acceleration" ShortNameTag="acc" SymbolTag="a" Visible="1"/>
        <Measurement ID="5" NameTag="EventTimes" UnitType="s" TimerTest="Y1Z0" MeasType="Time" ShortNameTag="EventTimes_SN" SymbolTag="t" Visible="0"/>
        <Measurement ID="100" NameTag="FlagSpacing" UnitType="m" Type="Constant" Internal="1" MeasType="Length" Value="0.025"/>
      </Sensor>
      <Sensor ID="21032" Tag="TwoPhotogatesSingleFlag" IconID="448" IsPhotogateTimer="1" NumInputs="2">
        <Measurement ID="0" NameTag="StateOrd" UnitType="Unitless" TimerTest="Y4Z0" MeasType="State" Ordinal="1" SymbolTag="SOrd" Visible="0"/>
        <Measurement ID="1" NameTag="StateOrd" UnitType="Unitless" TimerTest="Y4Z1" MeasType="State" Ordinal="2" SymbolTag="SOrd" Visible="0"/>
        <Measurement ID="2" NameTag="TimeInGateOrd" UnitType="s" TimerTest="B0U0" MeasType="Time" Ordinal="1" ShortNameTag="TimeInGateOrd_SN" SymbolTag="deltaUtOrdInGate" Visible="0"/>
        <Measurement ID="3" NameTag="TimeInGateOrd" UnitType="s" TimerTest="B1U1" MeasType="Time" Ordinal="2" ShortNameTag="TimeInGateOrd_SN" SymbolTag="deltaUtOrdInGate" Visible="0"/>
        <Measurement ID="5" NameTag="TimeBetweenGates" UnitType="s" TimerTest="B0B1" MeasType="Time" ShortNameTag="TimeBetweenGates_SN" SymbolTag="deltaUtBetween" Visible="1"/>
        <Measurement ID="6" NameTag="SpeedinGateOrd" UnitType="mps" Equation="[100]/[2]" MeasType="Speed" Ordinal="1" ShortNameTag="speedOrd" SymbolTag="vOrd" Visible="1"/>
        <Measurement ID="7" NameTag="SpeedinGateOrd" UnitType="mps" Equation="[100]/[3]" MeasType="Speed" Ordinal="2" ShortNameTag="speedOrd" SymbolTag="vOrd" Visible="1"/>
        <Measurement ID="9" NameTag="SpeedBetweenGates" UnitType="mps" Equation="[101]/[5]" MeasType="Speed" ShortNameTag="SpeedBetwGates" SymbolTag="v1to2" Visible="1"/>
        <Measurement ID="10" NameTag="AccelerationBetweenGates" UnitType="ms2" Equation="deriv(combine([6],[7]))" MeasType="Acceleration" ShortNameTag="acc" SymbolTag="a" Visible="1"/>
        <Measurement ID="11" NameTag="BlockEventTimesforGateOrd" UnitType="s" TimerTest="Y1B0" MeasType="Time" Ordinal="1" ShortNameTag="BlockEventTimesforGateOrd_SN" SymbolTag="tBOrd" Visible="0"/>
        <Measurement ID="12" NameTag="BlockEventTimesforGateOrd" UnitType="s" TimerTest="Y1B0" MeasType="Time" Ordinal="2" ShortNameTag="BlockEventTimesforGateOrd_SN" SymbolTag="tBOrd" Visible="0"/>
        <Measurement ID="13" NameTag="EventTimesforGateOrd" UnitType="s" TimerTest="Y1Z0" MeasType="Time" Ordinal="1" ShortNameTag="EventTimesforGateOrd_SN" SymbolTag="tOrd" Visible="0"/>
        <Measurement ID="14" NameTag="EventTimesforGateOrd" UnitType="s" TimerTest="Y1Z1" MeasType="Time" Ordinal="2" ShortNameTag="EventTimesforGateOrd_SN" SymbolTag="tOrd" Visible="0"/>
        <Measurement ID="100" NameTag="FlagLength" UnitType="m" Type="Constant" Internal="1" MeasType="Length" Value="0.05"/>
        <Measurement ID="101" NameTag="PhotogateSpacing" UnitType="m" Type="Constant" Internal="1" MeasType="Length" Value="0.1" IsPhotogateSpacing="1"/>
      </Sensor>
      <Sensor ID="21033" Tag="TwoPhotogatesDoubleFlag" IconID="449" IsPhotogateTimer="1" NumInputs="2">
        <Measurement ID="0" NameTag="StateOrd" UnitType="Unitless" TimerTest="Y4Z0" MeasType="State" Ordinal="1" SymbolTag="SOrd" Visible="0"/>
        <Measurement ID="1" NameTag="StateOrd" UnitType="Unitless" TimerTest="Y4Z1" MeasType="State" Ordinal="2" SymbolTag="SOrd" Visible="0"/>
        <Measurement ID="2" NameTag="BlocktoBlockTimeInGateOrd" UnitType="s" TimerTest="B0B0" MeasType="Time" Ordinal="1" ShortNameTag="BlocktoBlockTimeInGateOrd_SN" SymbolTag="deltaUtOrdBlock" Visible="0"/>
        <Measurement ID="3" NameTag="BlocktoBlockTimeInGateOrd" UnitType="s" TimerTest="B1B1" MeasType="Time" Ordinal="2" ShortNameTag="BlocktoBlockTimeInGateOrd_SN" SymbolTag="deltaUtOrdBlock" Visible="0"/>
        <Measurement ID="5" NameTag="TimeBetweenGates" UnitType="s" TimerTest="B0B1" MeasType="Time" ShortNameTag="TimeBetweenGates_SN" SymbolTag="deltaUtBetween" Visible="1"/>
        <Measurement ID="6" NameTag="SpeedinGateOrd" UnitType="mps" Equation="[100]/[2]" MeasType="Speed" Ordinal="1" ShortNameTag="speedOrd" SymbolTag="vOrd" Visible="1"/>
        <Measurement ID="7" NameTag="SpeedinGateOrd" UnitType="mps" Equation="[100]/[3]" MeasType="Speed" Ordinal="2" ShortNameTag="speedOrd" SymbolTag="vOrd" Visible="1"/>
        <Measurement ID="9" NameTag="SpeedBetweenGates" UnitType="mps" Equation="[101]/[5]" MeasType="Speed" ShortNameTag="SpeedBetwGates" SymbolTag="v1to2" Visible="1"/>
        <Measurement ID="10" NameTag="AccelerationBetweenGates" UnitType="ms2" Equation="deriv(combine([6],[7]))" MeasType="Acceleration" ShortNameTag="acc" SymbolTag="a" Visible="1"/>
        <Measurement ID="11" NameTag="BlockEventTimesforGateOrd" UnitType="s" TimerTest="Y1B0" MeasType="Time" Ordinal="1" ShortNameTag="BlockEventTimesforGateOrd_SN" SymbolTag="tBOrd" Visible="0"/>
        <Measurement ID="12" NameTag="BlockEventTimesforGateOrd" UnitType="s" TimerTest="Y1B1" MeasType="Time" Ordinal="2" ShortNameTag="BlockEventTimesforGateOrd_SN" SymbolTag="tBOrd" Visible="0"/>
        <Measurement ID="13" NameTag="EventTimesforGateOrd" UnitType="s" TimerTest="Y1Z0" MeasType="Time" Ordinal="1" ShortNameTag="EventTimesforGateOrd_SN" SymbolTag="tOrd" Visible="0"/>
        <Measurement ID="14" NameTag="EventTimesforGateOrd" UnitType="s" TimerTest="Y1Z1" MeasType="Time" Ordinal="2" ShortNameTag="EventTimesforGateOrd_SN" SymbolTag="tOrd" Visible="0"/>
        <Measurement ID="100" NameTag="FlagLength" UnitType="m" Type="Constant" Internal="1" MeasType="Length" Value="0.05"/>
        <Measurement ID="101" NameTag="PhotogateSpacing" UnitType="m" Type="Constant" Internal="1" MeasType="Length" Value="0.1" IsPhotogateSpacing="1"/>
      </Sensor>
      <Sensor ID="21034" Tag="SmartGateSingleFlag" IconID="451" IsPhotogateTimer="1" NumInputs="2">
        <Measurement ID="0" NameTag="StateOrd" UnitType="Unitless" TimerTest="Y4Z0" MeasType="State" Ordinal="1" SymbolTag="SOrd" Visible="0"/>
        <Measurement ID="1" NameTag="StateOrd" UnitType="Unitless" TimerTest="Y4Z1" MeasType="State" Ordinal="2" SymbolTag="SOrd" Visible="0"/>
        <Measurement ID="5" NameTag="TimeBetweenGates" UnitType="s" TimerTest="T2Q1A1B0B1" MeasType="Time" ShortNameTag="TimeBetweenGates_SN" SymbolTag="deltaUtBetween" Visible="0"/>
        <Measurement ID="9" NameTag="SpeedBetweenGates" UnitType="mps" Equation="[100]/[9]" TimerTest="T2Q1A1B0B1" MeasType="Speed" ShortNameTag="SpeedBetwGates" SymbolTag="v1to2" Visible="1"/>
        <Measurement ID="10" NameTag="VelocityBetweenGates" UnitType="mps" Equation="[100]/[10]" TimerTest="T2G1Q1A1B0B1" MeasType="Velocity" ShortNameTag="VelBetwGates" SymbolTag="v1to2" Visible="1"/>
        <Measurement ID="11" NameTag="BlockEventTimesforGateOrd" UnitType="s" TimerTest="Y1B0" MeasType="Time" Ordinal="1" ShortNameTag="BlockEventTimesforGateOrd_SN" SymbolTag="tBOrd" Visible="0"/>
        <Measurement ID="12" NameTag="BlockEventTimesforGateOrd" UnitType="s" TimerTest="Y1B1" MeasType="Time" Ordinal="2" ShortNameTag="BlockEventTimesforGateOrd_SN" SymbolTag="tBOrd" Visible="0"/>
        <Measurement ID="13" NameTag="EventTimesforGateOrd" UnitType="s" TimerTest="Y1Z0" MeasType="Time" Ordinal="1" ShortNameTag="EventTimesforGateOrd_SN" SymbolTag="tOrd" Visible="0"/>
        <Measurement ID="14" NameTag="EventTimesforGateOrd" UnitType="s" TimerTest="Y1Z1" MeasType="Time" Ordinal="2" ShortNameTag="EventTimesforGateOrd_SN" SymbolTag="tOrd" Visible="0"/>
        <Measurement ID="100" NameTag="PhotogateSpacing" UnitType="m" Type="Constant" Internal="1" Hidden="1" MeasType="Length" Value="0.1" IsPhotogateSpacing="1"/>
      </Sensor>
      <Sensor ID="21035" Tag="SmartGateDoubleFlag" IconID="453" IsPhotogateTimer="1" NumInputs="2">
        <Measurement ID="0" NameTag="StateOrd" UnitType="Unitless" TimerTest="Y4Z0" MeasType="State" Ordinal="1" SymbolTag="SOrd" Visible="0"/>
        <Measurement ID="1" NameTag="StateOrd" UnitType="Unitless" TimerTest="Y4Z1" MeasType="State" Ordinal="2" SymbolTag="SOrd" Visible="0"/>
        <Measurement ID="5" NameTag="TimeBetweenGates" UnitType="s" TimerTest="T2Q1A1B0B1" MeasType="Time" ShortNameTag="TimeBetweenGates_SN" SymbolTag="deltaUtBetween" Visible="0"/>
        <Measurement ID="9" NameTag="SpeedBetweenGates" UnitType="mps" Equation="[100]/[9]" TimerTest="T2Q1A1B0B1" MeasType="Speed" ShortNameTag="SpeedBetwGates" SymbolTag="v1to2" Visible="1"/>
        <Measurement ID="10" NameTag="VelocityBetweenGates" UnitType="mps" Equation="[100]/[10]" TimerTest="T2G1Q1A1B0B1" MeasType="Velocity" ShortNameTag="VelBetwGates" SymbolTag="v1to2" Visible="1"/>
        <Measurement ID="11" NameTag="BlockEventTimesforGateOrd" UnitType="s" TimerTest="Y1B0" MeasType="Time" Ordinal="1" ShortNameTag="BlockEventTimesforGateOrd_SN" SymbolTag="tBOrd" Visible="0"/>
        <Measurement ID="12" NameTag="BlockEventTimesforGateOrd" UnitType="s" TimerTest="Y1B1" MeasType="Time" Ordinal="2" ShortNameTag="BlockEventTimesforGateOrd_SN" SymbolTag="tBOrd" Visible="0"/>
        <Measurement ID="13" NameTag="EventTimesforGateOrd" UnitType="s" TimerTest="Y1Z0" MeasType="Time" Ordinal="1" ShortNameTag="EventTimesforGateOrd_SN" SymbolTag="tOrd" Visible="0"/>
        <Measurement ID="14" NameTag="EventTimesforGateOrd" UnitType="s" TimerTest="Y1Z1" MeasType="Time" Ordinal="2" ShortNameTag="EventTimesforGateOrd_SN" SymbolTag="tOrd" Visible="0"/>
        <Measurement ID="100" NameTag="PhotogateSpacing" UnitType="m" Type="Constant" Internal="1" Hidden="1" MeasType="Length" Value="0.1" IsPhotogateSpacing="1"/>
      </Sensor>
      <Sensor ID="21130" Tag="MotionSensorII" Version="2.0" Class="1" DefaultRate="20Hz" FileName="CISensor21130.sds" FloatParams="0" IconID="422" Latency="100000" MaxDatasheet="2048" MaxRate="250Hz" Model="CI-6742A" NumInputs="2" SupportsZeroOnStart="1" Warmup="1">
        <Measurement ID="0" NameTag="EchoTime" Type="RawDigital" DataSize="4" Accuracy="1" CIVarName="pingEchoTime" Display="Graph" Internal="1" Maximum="20000" Minimum="0" Precision="0" TypicalMax="10000" TypicalMin="0" Visible="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="Position" UnitType="m" Type="USoundPos" Inputs="0" Params="344" Accuracy="0.001" CanChangeSign="1" CIVarName="position" Display="Graph" Internal="0" Maximum="8" MeasType="Position" Minimum="0.015" OffsetZero="1" Precision="3" ShortNameTag="pos" SymbolTag="x" TypicalMax="2" TypicalMin="0" Visible="1"/>
        <Measurement ID="2" NameTag="Velocity" UnitType="mps" Type="Derivative" Inputs="1" Params="3" Accuracy="0.01" CIVarName="velocity" Display="Graph" Internal="0" Maximum="2" MeasType="Velocity" Minimum="-2" Precision="2" ShortNameTag="vel" SymbolTag="velocity" TypicalMax="0.5" TypicalMin="-0.5" Visible="1"/>
        <Measurement ID="3" NameTag="Acceleration" UnitType="ms2" Type="Derivative" Inputs="2" Params="3" Accuracy="0.1" CIVarName="acceleration" Display="Graph" Internal="0" Maximum="10" MeasType="Acceleration" Minimum="-10" Precision="1" ShortNameTag="acc" SymbolTag="a" TypicalMax="2" TypicalMin="-2" Visible="1"/>
        <Measurement ID="4" NameTag="PingEchoTime" UnitType="s" Type="USoundPos" Inputs="0" Params="2" Accuracy="0.000001" Display="Graph" Internal="0" Maximum="0.05" MeasType="Time" Minimum="0.0001" Precision="6" SymbolTag="t" TypicalMax="0.01" TypicalMin="0.0001" Visible="0"/>
        <Measurement ID="100" NameTag="SpeedOfSound" UnitType="mps" Type="Constant" CIVarName="speedOfSound" Internal="1" MeasType="Velocity" Value="344" ConstType="SpeedOfSound"/>
      </Sensor>
      <Sensor ID="21131" Tag="RotaryMotionSensor" Version="2.0" Class="0" DefaultRate="20Hz" FileName="CISensor21131.sds" FloatParams="0" IconID="423" IsDigitalCounter="1" Latency="100" MaxDatasheet="8192" MaxRate="1000Hz" Model="CI-6538" NumInputs="2" SendResetCmd="1" Warmup="1" ZeroOnRead="1" ZeroOnStart="1">
        <Measurement ID="0" NameTag="Countssample" UnitType="CountsPerSample" Type="RawDigital" DataSize="4" Accuracy="1" CIVarName="rotationCounts" Display="None" Internal="0" Maximum="32000" MeasType="CountsPerSample" Minimum="-32000" Precision="0" ShortNameTag="Ctssample" SymbolTag="C" TypicalMax="100" TypicalMin="-100" Visible="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="Angle" UnitType="rad" Type="LinearConv" Inputs="11" Params="0.01745329,0" Accuracy="0.002" CIVarName="angularPositionRad" Display="Graph" Internal="0" Maximum="6.5" MeasType="Angle" Minimum="-6.5" Precision="3" ShortNameTag="ang" SymbolTag="thetaL" TypicalMax="1.5" TypicalMin="-1.5" Visible="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="AngularVelocity" UnitType="radps" Type="Derivative" Inputs="1" Params="3" Accuracy="0.002" CIVarName="angularVelocityRad" Display="Graph" Internal="0" Maximum="6.5" MeasType="AngularVelocity" Minimum="-6.5" Precision="3" ShortNameTag="angvel" SymbolTag="omegaL" TypicalMax="1" TypicalMin="-1" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="AngularAcceleration" UnitType="radps2" Type="Derivative" Inputs="2" Params="3" Accuracy="0.002" CIVarName="angularAccelerationRad" Display="Graph" Internal="0" Maximum="6.5" MeasType="AngularAcceleration" Minimum="-6.5" Precision="3" ShortNameTag="angacc" SymbolTag="alphaL" TypicalMax="1" TypicalMin="-1" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Angle" UnitType="deg" Type="LinearConv" Inputs="1" Params="57.29578,0" Accuracy="0.1" CIVarName="angularPosition" Display="Graph" Internal="0" InternalUnit="1" Maximum="360" MeasType="Angle" Minimum="-360" Precision="1" ShortNameTag="AngPosition" TypicalMax="180" TypicalMin="-180" Visible="0" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="AngularVelocity" UnitType="degps" Type="LinearConv" Inputs="2" Params="57.29578,0" Accuracy="0.1" CIVarName="angularVelocity" Display="Graph" Internal="0" InternalUnit="1" Maximum="360" MeasType="AngularVelocity" Minimum="-360" Precision="1" ShortNameTag="angvel" SymbolTag="omegaL" TypicalMax="180" TypicalMin="-180" Visible="0" XplorerDisplay="1"/>
        <Measurement ID="6" NameTag="AngularAcceleration" UnitType="degps2" Type="LinearConv" Inputs="3" Params="57.29578,0" Accuracy="0.1" CIVarName="angularAcceleration" Display="Graph" Internal="0" InternalUnit="1" Maximum="360" MeasType="AngularAcceleration" Minimum="-360" Precision="1" ShortNameTag="angacc" SymbolTag="alphaL" TypicalMax="180" TypicalMin="-180" Visible="0" XplorerDisplay="1"/>
        <Measurement ID="7" NameTag="Position" UnitType="m" Type="LinearConv" Inputs="11" Params=".0004166667,0" Accuracy="0.001" CIVarName="position" Display="Graph" Internal="0" Maximum="1" MeasType="Position" Minimum="-1" Precision="4" ShortNameTag="pos" SymbolTag="x" TypicalMax="0.1" TypicalMin="-0.1" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="8" NameTag="Velocity" UnitType="mps" Type="Derivative" Inputs="7" Params="3" Accuracy="0.001" CIVarName="velocity" Display="Graph" Internal="0" Maximum="0.5" MeasType="Velocity" Minimum="-0.5" Precision="3" ShortNameTag="vel" SymbolTag="velocity" TypicalMax="0.1" TypicalMin="-0.1" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="9" NameTag="Acceleration" UnitType="ms2" Type="Derivative" Inputs="8" Params="3" Accuracy="0.001" CIVarName="acceleration" Display="Graph" Internal="0" Maximum="0.2" MeasType="Acceleration" Minimum="-0.2" Precision="3" ShortNameTag="acc" SymbolTag="a" TypicalMax="0.05" TypicalMin="-0.05" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="10" NameTag="Counts" UnitType="Unitless" Type="RotaryPos" Inputs="0" Params="1,1" Accuracy="0.002" CanChangeSign="1" CIVarName="netCounts" Display="Graph" Maximum="6.5" MeasType="Count" Minimum="-6.5" Precision="0" SymbolTag="N" TypicalMax="3" TypicalMin="-3" Visible="0" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="11" NameTag="ResolutionScale" UnitType="Unitless" Type="LinearConv" Inputs="10" Params="1,0" Accuracy="0.002" MeasType="Count" Internal="1"/>
        <Measurement ID="100" NameTag="LinearScale" UnitType="m" Type="Constant" CIVarName="linearCalDistance" Internal="1" MeasType="Position" Value="0.15" ConstType="RMSLinear"/>
        <Measurement ID="101" NameTag="Resolution" UnitType="Unitless" Type="Constant" CIVarName="divisions" Internal="1" MeasType="CountsPerRev" Value="360" ConstType="RMSResolution"/>
      </Sensor>
      <Sensor ID="21132" Tag="SmartGateTimer" IconID="266" IsPhotogateTimer="1" NumInputs="2">
        <Measurement ID="0" NameTag="StateOrd" UnitType="Unitless" TimerTest="Y4Z0" Ordinal="1" MeasType="State" SymbolTag="SOrd" Visible="0"/>
        <Measurement ID="1" NameTag="StateOrd" UnitType="Unitless" TimerTest="Y4Z1" Ordinal="2" MeasType="State" SymbolTag="SOrd" Visible="0"/>
        <Measurement ID="2" NameTag="SpeedBetweenGates" UnitType="mps" Equation="[100]/[2]" TimerTest="B0B1" MeasType="Speed" ShortNameTag="Speed" SymbolTag="speed" Visible="1"/>
        <Measurement ID="100" NameTag="PhotogateSpacing" UnitType="m" Type="Constant" Internal="1" MeasType="Length" Value="0.015" IsPhotogateSpacing="1"/>
      </Sensor>
      <!-- Sensor IDs 22000 - 22199 are CI digital hardware IDs -->
      <Sensor ID="22016" Tag="LaserSwitch" IconID="427" NumInputs="1"/>
      <Sensor ID="22020" Tag="4to1Adapter" IconID="436" NumInputs="1"/>
      <Sensor ID="22128" Tag="Photogate" IconID="420" NumInputs="1"/>
      <Sensor ID="22133" Tag="TimeOfFlightAccessory" IconID="425" NumInputs="1"/>
      <!-- Sensor IDs 23000 - 23299 are for CI digital timing and counting modes for SPARKvue.  The tens & ones digits of the ID correspond to the SPARKvue timer IDs -->
      <Sensor ID="23001" Tag="SVPhotogateAndPicketFence" IconID="444" SmartGateIconID="1444" IsPhotogateTimer="1" NumInputs="1">
        <Measurement ID="0" NameTag="Position" CIVarName="position" UnitType="m" TimerTest="Y3B0" Equation="([0]-1)*[100]" MeasType="Position" ShortNameTag="pos" SymbolTag="x" Visible="1"/>
        <Measurement ID="1" NameTag="Speed" CIVarName="velocity" UnitType="mps" Equation="deriv([0])" MeasType="Speed" SymbolTag="speed" Visible="1"/>
        <Measurement ID="2" NameTag="Acceleration" CIVarName="acceleration" UnitType="ms2" Equation="deriv([1])" MeasType="Acceleration" ShortNameTag="acc" SymbolTag="a" Visible="1"/>
        <Measurement ID="100" NameTag="FlagSpacing" CIVarName="bandSpacing" UnitType="m" Type="Constant" Internal="1" MeasType="Length" Value="0.05"/>
      </Sensor>
      <Sensor ID="23002" Tag="SVSmartPulleyLinear" IconID="445"  SmartGateIconID="1445" IsPhotogateTimer="1" Model="ME-6838" NumInputs="1">
        <Measurement ID="0" NameTag="BlockCount" UnitType="Unitless" TimerTest="Y3B0" MeasType="Count" Internal="1" Visible="0"/>
        <Measurement ID="1" NameTag="Position" CIVarName="position" UnitType="m" Equation="[0]*[100]" MeasType="Position" ShortNameTag="pos" SymbolTag="x" Visible="1"/>
        <Measurement ID="2" NameTag="Speed" CIVarName="velocity" UnitType="mps" Equation="deriv([1])" MeasType="Speed" SymbolTag="speed" Visible="1"/>
        <Measurement ID="3" NameTag="Acceleration" CIVarName="acceleration" UnitType="ms2" Equation="deriv([2])" MeasType="Acceleration" ShortNameTag="acc" SymbolTag="a" Visible="1"/>
        <Measurement ID="100" NameTag="SpokeArcLength" CIVarName="spokeArcLength" UnitType="m" Type="Constant" Internal="1" MeasType="Length" Value="0.015"/>
      </Sensor>
      <Sensor ID="23003" Tag="SVSmartPulleyRotational" IconID="445"  SmartGateIconID="1445" IsPhotogateTimer="1" Model="ME-6838" NumInputs="1">
        <Measurement ID="0" NameTag="BlockCount" UnitType="Unitless" TimerTest="Y3B0" MeasType="Count" Internal="1" Visible="0"/>
        <Measurement ID="1" NameTag="Angle" CIVarName="angularPosition" UnitType="deg" Equation="[0]*[100]" MeasType="Angle" ShortNameTag="ang" SymbolTag="thetaL" Visible="1"/>
        <Measurement ID="2" NameTag="AngularSpeed" CIVarName="angularVelocity" UnitType="degps" Equation="deriv([1])" MeasType="AngularSpeed" ShortNameTag="angspeed" SymbolTag="omegaLSpeed" Visible="1" IsDefaultMeas="1"/>
        <Measurement ID="3" NameTag="AngularAcceleration" CIVarName="angularAcceleration" UnitType="degps2" Equation="deriv([2])" MeasType="AngularAcceleration" ShortNameTag="angacc" SymbolTag="alphaL" Visible="1"/>
        <Measurement ID="100" NameTag="SpokeAngle" CIVarName="spokeAngle" UnitType="deg" Type="Constant" Internal="1" MeasType="Angle" Value="36"/>
      </Sensor>
      <Sensor ID="23004" Tag="FreeFallAdapter" IconID="426" IsPhotogateTimer="1" NumInputs="1" SmartGateChannels="2">
        <Measurement ID="0" NameTag="TimeOfFall" CIVarName="timeOfFall" UnitType="s" TimerTest="B0U0" MeasType="Time" ShortNameTag="TimeOfFall_SN" SymbolTag="t" Visible="1"/>
        <Measurement ID="1" NameTag="Acceleration" CIVarName="acceleration" UnitType="ms2" Equation="(2.0*[100])/([0]*[0])" MeasType="Acceleration" ShortNameTag="acc" SymbolTag="a" Visible="1"/>
        <Measurement ID="100" NameTag="DistanceOfFall" CIVarName="height" UnitType="m" Type="Constant" Internal="1" MeasType="Position" Value="1"/>
      </Sensor>
      <Sensor ID="23005" Tag="SVPhotogateAndPendulum" IconID="443" SmartGateIconID="1443" IsPhotogateTimer="1" NumInputs="1">
        <Measurement ID="0" NameTag="Period" CIVarName="period" UnitType="s" TimerTest="K1B0B0B0" MeasType="Period" ShortNameTag="Per" SymbolTag="Period" Visible="1"/>
        <Measurement ID="1" NameTag="Speed" CIVarName="velocity" UnitType="mps" Equation="[100]/[2]" MeasType="Speed" SymbolTag="speed" Visible="1"/>
        <Measurement ID="2" NameTag="TimeInGate" UnitType="s" TimerTest="B0U0" MeasType="Time" ShortNameTag="TimeInGate_SN" SymbolTag="deltaUtInGate" Internal="1" Visible="0"/>
        <Measurement ID="100" NameTag="PendulumWidth" CIVarName="pendulumWidth" UnitType="m" Type="Constant" Internal="1" MeasType="Length" Value="0.016"/>
      </Sensor>
      <Sensor ID="23006" Tag="SVTimeOfFlight" IconID="447" IsPhotogateTimer="1" NumInputs="3">
        <Measurement ID="0" NameTag="InitialSpeed" UnitType="mps" Equation="[100]/[2]" MeasType="Speed" ShortNameTag="speed" SymbolTag="speed" Visible="1"/>
        <Measurement ID="1" NameTag="TimeOfFlight" UnitType="s" TimerTest="Q1B0B2" MeasType="Time" ShortNameTag="TimeOfFlight_SN" SymbolTag="t" Visible="1"/>
        <Measurement ID="2" NameTag="TimeBetweenGates" UnitType="s" TimerTest="Q1B0B1" MeasType="Time" ShortNameTag="TimeBetweenGates_SN" SymbolTag="deltaUtBetween" Internal="1" Visible="0"/>
        <Measurement ID="100" NameTag="PhotogateSpacing" UnitType="m" Type="Constant" Internal="1" MeasType="Length" Value="0.1" IsPhotogateSpacing="1"/>
      </Sensor>
      <Sensor ID="23007" Tag="SVPhotogateTiming" IconID="448" IsPhotogateTimer="1" NumInputs="2" SmartGateChannels="0,2">
        <Measurement ID="0" NameTag="TimeInGate" UnitType="s" TimerTest="B*U*" MeasType="Time" Ordinal="1" ShortNameTag="TimeInGateOrd_SN" SymbolTag="deltaUtOrdInGate" Visible="0"/>
        <Measurement ID="1" NameTag="SpeedinGate" UnitType="mps" Equation="[100]/[0]" MeasType="Speed" Ordinal="1" ShortNameTag="speedOrd" SymbolTag="vOrd" Visible="1"/>
        <Measurement ID="2" NameTag="TimeBetweenGates" UnitType="s" TimerTest="B0B1" MeasType="Time" ShortNameTag="TimeBetweenGates_SN" SymbolTag="deltaUtBetween" Visible="1"/>
        <Measurement ID="3" NameTag="VelocityBetweenGates" UnitType="mps" Equation="[101]/[2]" MeasType="Speed" ShortNameTag="SpeedBetwGates" SymbolTag="v1to2" Visible="1"/>
        <Measurement ID="100" NameTag="FlagLength" UnitType="m" Type="Constant" Internal="1" MeasType="Length" Value="0.05"/>
        <Measurement ID="101" NameTag="PhotogateSpacing" UnitType="m" Type="Constant" Internal="1" MeasType="Length" Value="0.1" IsPhotogateSpacing="1"/>
      </Sensor>
      <Sensor ID="23008" Tag="SVGeneralCounting" DefaultRate="1Hz" IconID="430" IsDigitalCounter="1" MaxRate="100Hz" NumInputs="1">
        <Measurement ID="0" NameTag="Counts" UnitType="counts" Equation="count([1],[100])" MeasType="Counter" Precision="0" SymbolTag="cps" Visible="1"/>
        <Measurement ID="1" NameTag="CountsPerSample" UnitType="counts" Type="RawDigital" DataSize="2" Internal="1" MeasType="Counter"/>
        <Measurement ID="100" NameTag="CountTimerInterval" CIVarName="count" UnitType="s" Type="Constant" Internal="1" MeasType="Time" Value="1"/>
      </Sensor>
      <!-- Sensor ID 23009 corresponds to SPARKvue timer 9, which is TIMER_TYPE_RECORDABLE; I'm not sure if it's used but I'm leaving it availabe for legacy -->
      <Sensor ID="23010" Tag="SVDigitalInput" IconID="2014" IsPhotogateTimer="1" NumInputs="1">
        <Measurement ID="0" NameTag="State" UnitType="Unitless" TimerTest="Y4Z0" MeasType="State" SymbolTag="State" Visible="1"/>
      </Sensor>
      <Sensor ID="23011" Tag="SVCollisionTimer" IconID="438" IsPhotogateTimer="1" NumInputs="2" SmartGateChannels="0,2">
        <Measurement ID="0" NameTag="TimeInGateOrd" UnitType="s" TimerTest="B0U0" MeasType="Time" Ordinal="1" ShortNameTag="TimeInGateOrd_SN" SymbolTag="deltaUtOrdInGate" Internal="1" Visible="1"/>
        <Measurement ID="1" NameTag="TimeInGateOrd" UnitType="s" TimerTest="B1U1" MeasType="Time" Ordinal="2" ShortNameTag="TimeInGateOrd_SN" SymbolTag="deltaUtOrdInGate" Internal="1" Visible="1"/>
        <Measurement ID="2" NameTag="SpeedinGateOrd" UnitType="mps" Equation="[100]/[0]" MeasType="Speed" Ordinal="1" ShortNameTag="speedOrd" SymbolTag="vOrd" Visible="1"/>
        <Measurement ID="3" NameTag="SpeedinGateOrd" UnitType="mps" Equation="[100]/[1]" MeasType="Speed" Ordinal="2" ShortNameTag="speedOrd" SymbolTag="vOrd" Visible="1"/>
        <Measurement ID="100" NameTag="FlagLength" UnitType="m" Type="Constant" Internal="1" MeasType="Length" Value="0.05"/>
      </Sensor>
      <Sensor ID="23012" Tag="MotionSensor" Version="2.0" Class="1" DefaultRate="20Hz" FileName="CISensor21130.sds" FloatParams="0" IconID="422" Latency="100000" MaxDatasheet="2048" MaxRate="250Hz" Model="CI-6742A" NumInputs="2" SupportsZeroOnStart="1" Warmup="1">
        <Measurement ID="0" NameTag="EchoTime" Type="RawDigital" DataSize="4" Accuracy="1" CIVarName="pingEchoTime" Display="Graph" Internal="1" Maximum="20000" Minimum="0" Precision="0" TypicalMax="10000" TypicalMin="0" Visible="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="Position" UnitType="m" Type="USoundPos" Inputs="0" Params="344" Accuracy="0.001" CanChangeSign="1" CIVarName="position" Display="Graph" Internal="0" Maximum="8" MeasType="Position" Minimum="0.015" OffsetZero="1" Precision="3" ShortNameTag="pos" SymbolTag="x" TypicalMax="2" TypicalMin="0" Visible="1"/>
        <Measurement ID="2" NameTag="Velocity" UnitType="mps" Type="Derivative" Inputs="1" Params="3" Accuracy="0.01" CIVarName="velocity" Display="Graph" Internal="0" Maximum="2" MeasType="Velocity" Minimum="-2" Precision="2" ShortNameTag="vel" SymbolTag="velocity" TypicalMax="0.5" TypicalMin="-0.5" Visible="1"/>
        <Measurement ID="3" NameTag="Acceleration" UnitType="ms2" Type="Derivative" Inputs="2" Params="3" Accuracy="0.1" CIVarName="acceleration" Display="Graph" Internal="0" Maximum="10" MeasType="Acceleration" Minimum="-10" Precision="1" ShortNameTag="acc" SymbolTag="a" TypicalMax="2" TypicalMin="-2" Visible="1"/>
        <Measurement ID="4" NameTag="PingEchoTime" UnitType="s" Type="USoundPos" Inputs="0" Params="2" Accuracy="0.000001" Display="Graph" Internal="0" Maximum="0.05" MeasType="Time" Minimum="0.0001" Precision="6" SymbolTag="t" TypicalMax="0.01" TypicalMin="0.0001" Visible="0"/>
        <Measurement ID="100" NameTag="SpeedOfSound" UnitType="mps" Type="Constant" CIVarName="speedOfSound" Internal="1" MeasType="Velocity" Value="344" ConstType="SpeedOfSound"/>
      </Sensor>
      <Sensor ID="23013" Tag="RotaryMotionSensor" Version="2.0" Class="0" DefaultRate="20Hz" FileName="CISensor21131.sds" FloatParams="0" IconID="423" IsDigitalCounter="1" Latency="100" MaxDatasheet="8192" MaxRate="1000Hz" Model="CI-6538" NumInputs="2" SendResetCmd="1" Warmup="1" ZeroOnRead="1" ZeroOnStart="1">
        <Measurement ID="0" NameTag="Countssample" UnitType="CountsPerSample" Type="RawDigital" DataSize="4" Accuracy="1" CIVarName="rotationCounts" Display="None" Internal="1" Maximum="32000" MeasType="CountsPerSample" Minimum="-32000" Precision="0" ShortNameTag="Ctssample" SymbolTag="C" TypicalMax="100" TypicalMin="-100" Visible="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="AngularPosition" UnitType="rad" Type="LinearConv" Inputs="11" Params="0.01745329,0" Accuracy="0.002" CIVarName="angularPositionRad" Display="Graph" Internal="0" Maximum="6.5" MeasType="Angle" Minimum="-6.5" Precision="3" ShortNameTag="ang" SymbolTag="thetaL" TypicalMax="1.5" TypicalMin="-1.5" Visible="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="AngularVelocity" UnitType="radps" Type="Derivative" Inputs="1" Params="3" Accuracy="0.002" CIVarName="angularVelocityRad" Display="Graph" Internal="0" Maximum="6.5" MeasType="AngularVelocity" Minimum="-6.5" Precision="3" ShortNameTag="angvel" SymbolTag="omegaL" TypicalMax="1" TypicalMin="-1" Visible="1" XplorerDisplay="1" IsDefaultMeas="1"/>
        <Measurement ID="3" NameTag="AngularAcceleration" UnitType="radps2" Type="Derivative" Inputs="2" Params="3" Accuracy="0.002" CIVarName="angularAccelerationRad" Display="Graph" Internal="0" Maximum="6.5" MeasType="AngularAcceleration" Minimum="-6.5" Precision="3" ShortNameTag="angacc" SymbolTag="alphaL" TypicalMax="1" TypicalMin="-1" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="AngularPosition" UnitType="deg" Type="LinearConv" Inputs="1" Params="57.29578,0" Accuracy="0.1" CIVarName="angularPosition" Display="Graph" Internal="0" InternalUnit="1" Maximum="360" MeasType="Angle" Minimum="-360" Precision="1" ShortNameTag="AngPosition" TypicalMax="180" TypicalMin="-180" Visible="0" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="AngularVelocity" UnitType="degps" Type="LinearConv" Inputs="2" Params="57.29578,0" Accuracy="0.1" CIVarName="angularVelocity" Display="Graph" Internal="0" InternalUnit="1" Maximum="360" MeasType="AngularVelocity" Minimum="-360" Precision="1" ShortNameTag="angvel" SymbolTag="omegaL" TypicalMax="180" TypicalMin="-180" Visible="0" XplorerDisplay="1"/>
        <Measurement ID="6" NameTag="AngularAcceleration" UnitType="degps2" Type="LinearConv" Inputs="3" Params="57.29578,0" Accuracy="0.1" CIVarName="angularAcceleration" Display="Graph" Internal="0" InternalUnit="1" Maximum="360" MeasType="AngularAcceleration" Minimum="-360" Precision="1" ShortNameTag="angacc" SymbolTag="alphaL" TypicalMax="180" TypicalMin="-180" Visible="0" XplorerDisplay="1"/>
        <Measurement ID="7" NameTag="LinearPosition" UnitType="m" Type="LinearConv" Inputs="11" Params=".0004166667,0" Accuracy="0.001" CIVarName="position" Display="Graph" Internal="0" Maximum="1" MeasType="Position" Minimum="-1" Precision="4" ShortNameTag="pos" SymbolTag="x" TypicalMax="0.1" TypicalMin="-0.1" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="8" NameTag="LinearVelocity" UnitType="mps" Type="Derivative" Inputs="7" Params="3" Accuracy="0.001" CIVarName="velocity" Display="Graph" Internal="0" Maximum="0.5" MeasType="Velocity" Minimum="-0.5" Precision="3" ShortNameTag="vel" SymbolTag="velocity" TypicalMax="0.1" TypicalMin="-0.1" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="9" NameTag="LinearAcceleration" UnitType="ms2" Type="Derivative" Inputs="8" Params="3" Accuracy="0.001" CIVarName="acceleration" Display="Graph" Internal="0" Maximum="0.2" MeasType="Acceleration" Minimum="-0.2" Precision="3" ShortNameTag="acc" SymbolTag="a" TypicalMax="0.05" TypicalMin="-0.05" Visible="1" XplorerDisplay="1"/>
        <Measurement ID="10" NameTag="Counts" UnitType="Unitless" Type="RotaryPos" Inputs="0" Params="1,1" Accuracy="0.002" CanChangeSign="1" CIVarName="netCounts" Display="Graph" Internal="1" Maximum="6.5" MeasType="Count" Minimum="-6.5" Precision="0" SymbolTag="N" TypicalMax="3" TypicalMin="-3" Visible="0" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="11" NameTag="ResolutionScale" UnitType="Unitless" Type="LinearConv" Inputs="10" Params="1,0" Accuracy="0.002" MeasType="Count" Internal="1"/>
        <Measurement ID="100" NameTag="LinearScale" UnitType="m" Type="Constant" CIVarName="linearCalDistance" Internal="1" MeasType="Position" Value="0.15" ConstType="RMSLinear"/>
        <Measurement ID="101" NameTag="Resolution" UnitType="Unitless" Type="Constant" CIVarName="divisions" Internal="1" MeasType="CountsPerRev" Value="360" ConstType="RMSResolution"/>
      </Sensor>
      <!-- Sensor ID 23014 corresponds to SPARKvue timer 14, which is TIMER_TYPE_RELAY; I'm not sure if it's used but I'm leaving it availabe for legacy -->
      <Sensor ID="23015" Tag="SpeedBetweenGates" IconID="451" IsPhotogateTimer="1" NumInputs="2">
        <Measurement ID="0" NameTag="SpeedBetweenGates" UnitType="mps" Equation="[100]/[0]" TimerTest="T2Q1A1B0B1" MeasType="Speed" ShortNameTag="SpeedBetwGates" SymbolTag="v1to2" Visible="1"/>
        <Measurement ID="100" NameTag="PhotogateSpacing" UnitType="m" Type="Constant" Internal="1" MeasType="Length" Value="0.015" IsPhotogateSpacing="1"/>
      </Sensor>
      <!-- Sensor ID 23016-23017 corresponded to first pass of UK Timing mode; I'm reserving this number in case we decide to bring them back -->
      <Sensor ID="23018" Tag="SVPhotogateTiming1Gate" IconID="426" IsPhotogateTimer="1" NumInputs="1">
        <Measurement ID="0" NameTag="TimeInGate" UnitType="s" TimerTest="B0U0" MeasType="Time" Ordinal="1" ShortNameTag="TimeInGate_SN" SymbolTag="deltaUtOrdInGate" Visible="1"/>
        <Measurement ID="1" NameTag="SpeedinGate" UnitType="mps" Equation="[100]/[0]" MeasType="Speed" Ordinal="1" ShortNameTag="speed" SymbolTag="speed" Visible="1"/>
        <Measurement ID="100" NameTag="FlagLength" UnitType="m" Type="Constant" Internal="1" MeasType="Length" Value="0.05"/>
      </Sensor>
      <Sensor ID="23019" Tag="SVPhotogateTiming2Gates" IconID="448" IsPhotogateTimer="1" NumInputs="2" SmartGateChannels="0,2">
        <Measurement ID="0" NameTag="TimeInGateOrd" UnitType="s" TimerTest="B0U0" MeasType="Time" Ordinal="1" ShortNameTag="TimeInGateOrd_SN" SymbolTag="deltaUtOrdInGate" Visible="1"/>
        <Measurement ID="1" NameTag="SpeedinGateOrd" UnitType="mps" Equation="[100]/[0]" MeasType="Speed" Ordinal="1" ShortNameTag="speedOrd" SymbolTag="vOrd" Visible="1"/>
        <Measurement ID="2" NameTag="TimeInGateOrd" UnitType="s" TimerTest="B1U1" MeasType="Time" Ordinal="2" ShortNameTag="TimeInGateOrd_SN" SymbolTag="deltaUtOrdInGate" Visible="1"/>
        <Measurement ID="3" NameTag="SpeedinGateOrd" UnitType="mps" Equation="[100]/[2]" MeasType="Speed" Ordinal="2" ShortNameTag="speedOrd" SymbolTag="vOrd" Visible="1"/>
        <Measurement ID="4" NameTag="TimeBetweenGates" UnitType="s" TimerTest="B0B1" MeasType="Time" ShortNameTag="TimeBetweenGates_SN" SymbolTag="deltaUtBetween" Visible="1"/>
        <Measurement ID="5" NameTag="VelocityBetweenGates" UnitType="mps" Equation="[101]/[4]" MeasType="Speed" ShortNameTag="SpeedBetwGates" SymbolTag="v1to2" Visible="1"/>
        <Measurement ID="6" NameTag="AccelerationBetweenGates" UnitType="ms2" DefaultUnit="ms2" Equation="diff([3],[1],1)" MeasType="Acceleration" Ordinal="1" ShortNameTag="acc" SymbolTag="a" Visible="1"/>
        <Measurement ID="100" NameTag="FlagLength" UnitType="m" Type="Constant" Internal="1" MeasType="Length" Value="0.05"/>
        <Measurement ID="101" NameTag="PhotogateSpacing" UnitType="m" Type="Constant" Internal="1" MeasType="Length" Value="0.1" IsPhotogateSpacing="1"/>
      </Sensor>
      <!-- Sensor IDs 23050 - 23059 are allocated for the UK Timing Modes -->
      <Sensor ID="23050" Tag="SVUKSingleGateSingleInterrupt" IconID="440" IsPhotogateTimer="1" NumInputs="1">
        <Measurement ID="0" NameTag="SpeedAtA" UnitType="mps" Equation="[100]/[1]" MeasType="Speed" Ordinal="1" ShortNameTag="speed" SymbolTag="speed" Visible="1" Internal="1" UKTimingMask="256" IsDefaultMeas="1"/>
        <Measurement ID="1" NameTag="TimeInA" UnitType="s" TimerTest="T2Y0B0U0" MeasType="Time" Ordinal="1" ShortNameTag="TimeInGate_SN" SymbolTag="deltaUtOrdInGate" Visible="1" Internal="1" UKTimingMask="257"/>
        <Measurement ID="100" NameTag="CardLength" UnitType="m" Type="Constant" Internal="1" MeasType="Length" Value="0.05"/>
      </Sensor>
      <Sensor ID="23051" Tag="SVUKSingleGateDoubleInterrupt" IconID="441" IsPhotogateTimer="1" NumInputs="1">
        <Measurement ID="0" NameTag="SpeedAtA" UnitType="mps" Equation="[100]/[1]" MeasType="Speed" Ordinal="1" ShortNameTag="speed" SymbolTag="speed" Visible="1" Internal="1" UKTimingMask="256" IsDefaultMeas="1"/>
        <Measurement ID="1" NameTag="TimeInA" UnitType="s" TimerTest="T2Y0B0U0" MeasType="Time" Ordinal="1" ShortNameTag="TimeInGate_SN" SymbolTag="deltaUtOrdInGate" Visible="1" Internal="1" UKTimingMask="257"/>
        <Measurement ID="2" NameTag="AccelerationAtA" UnitType="ms2" DefaultUnit="ms2" Equation="diff([4],[3],1)" MeasType="Acceleration" Ordinal="1" ShortNameTag="acc" SymbolTag="a" Visible="1"  Internal="1" UKTimingMask="65536"/>
        <Measurement ID="3" NameTag="SpeedAtA1" UnitType="mps" Equation="[100]/[5]" MeasType="Speed" Ordinal="1" ShortNameTag="speed" SymbolTag="speed" Visible="1" Internal="1" UKTimingMask="65536"/>
        <Measurement ID="4" NameTag="SpeedAtA2" UnitType="mps" Equation="[100]/[6]" MeasType="Speed" Ordinal="1" ShortNameTag="speed" SymbolTag="speed" Visible="1" Internal="1" UKTimingMask="65536"/>
        <Measurement ID="5" NameTag="TimeInA1" UnitType="s" TimerTest="T2Y0I2B0U0" MeasType="Time" Ordinal="1" ShortNameTag="TimeInGate_SN" SymbolTag="deltaUtOrdInGate" Visible="1" Internal="1" UKTimingMask="65536"/>
        <Measurement ID="6" NameTag="TimeInA2" UnitType="s" TimerTest="T2Y0I1B0U0" MeasType="Time" Ordinal="1" ShortNameTag="TimeInGate_SN" SymbolTag="deltaUtOrdInGate" Visible="1" Internal="1" UKTimingMask="65536"/>
        <Measurement ID="7" NameTag="TimeA1toA2" UnitType="s" Equation="diff([9],[8],0)" MeasType="Time" Ordinal="1" ShortNameTag="TimeInGate_SN" SymbolTag="deltaUtOrdInGate" Visible="1" Internal="1" UKTimingMask="65536"/>
        <Measurement ID="8" NameTag="MidTimeInA1" UnitType="s" TimerTest="T2Y5I2B0U0" MeasType="Time" Ordinal="1" ShortNameTag="EventTimesOrd_SN" SymbolTag="t" Visible="1" Internal="1"/>
        <Measurement ID="9" NameTag="MidTimeInA2" UnitType="s" TimerTest="T2Y5I1B0U0" MeasType="Time" Ordinal="2" ShortNameTag="EventTimesOrd_SN" SymbolTag="t" Visible="1" Internal="1"/>
        <Measurement ID="100" NameTag="SegmentLength" UnitType="m" Type="Constant" Internal="1" MeasType="Length" Value="0.05"/>
      </Sensor>
      <Sensor ID="23052" Tag="SVUKDoubleGateSingleInterrupt" IconID="448" IsPhotogateTimer="1" NumInputs="2" SmartGateChannels="0,2">
        <Measurement ID="0" NameTag="SpeedAtA" UnitType="mps" Equation="[100]/[2]" MeasType="Speed" Ordinal="1" ShortNameTag="speed" SymbolTag="speed" Visible="1" Internal="1" UKTimingMask="2560" IsDefaultMeas="1"/>
        <Measurement ID="1" NameTag="SpeedAtB" UnitType="mps" Equation="[100]/[3]" MeasType="Speed" Ordinal="1" ShortNameTag="speed" SymbolTag="speed" Visible="1" Internal="1" UKTimingMask="2560"/>
        <Measurement ID="2" NameTag="TimeInA" UnitType="s" TimerTest="T2Y0B0U0" MeasType="Time" Ordinal="1" ShortNameTag="TimeInGate_SN" SymbolTag="deltaUtOrdInGate" Visible="1" Internal="1" UKTimingMask="2574"/>
        <Measurement ID="3" NameTag="TimeInB" UnitType="s" TimerTest="T2Y0B1U1" MeasType="Time" Ordinal="1" ShortNameTag="TimeInGate_SN" SymbolTag="deltaUtOrdInGate" Visible="1" Internal="1" UKTimingMask="2574"/>
        <Measurement ID="4" NameTag="AccelerationAtoB" UnitType="ms2" DefaultUnit="ms2" Equation="diff([6],[5],1)" MeasType="Acceleration" Ordinal="1" ShortNameTag="acc" SymbolTag="a" Visible="1" Internal="1" UKTimingMask="262144"/>
        <Measurement ID="5" NameTag="VelocityAtA" UnitType="mps" Equation="[100]/[2]" MeasType="Velocity" Ordinal="1" ShortNameTag="vel" SymbolTag="velocity" Visible="1" Internal="1" UKTimingMask="262144"/>
        <Measurement ID="6" NameTag="VelocityAtB" UnitType="mps" Equation="[100]/[3]" MeasType="Velocity" Ordinal="1" ShortNameTag="vel" SymbolTag="velocity" Visible="1" Internal="1" UKTimingMask="262144"/>
        <Measurement ID="7" NameTag="VelocityAtoB" UnitType="mps" Equation="[100]/[8]" MeasType="Velocity" Ordinal="1" ShortNameTag="vel" SymbolTag="velocity" Visible="1" Internal="1" UKTimingMask="1024"/>
        <Measurement ID="8" NameTag="TimeAtoB" UnitType="s" TimerTest="T2Y0B0B1" MeasType="Time" Ordinal="1" ShortNameTag="TimeInGate_SN" SymbolTag="deltaUtOrdInGate" Visible="1" Internal="1" UKTimingMask="265230"/>
        <Measurement ID="100" NameTag="CardLength" UnitType="m" Type="Constant" Internal="1" MeasType="Length" Value="0.05"/>
      </Sensor>
      <Sensor ID="23053" Tag="SVUKDoubleGateDoubleInterrupt" IconID="449" IsPhotogateTimer="1" NumInputs="2" SmartGateChannels="0,2">
        <Measurement ID="0" NameTag="DeltaAccelAtoB" UnitType="ms2" DefaultUnit="ms2" Equation="diff([2],[1],0)" MeasType="Acceleration" Ordinal="1" ShortNameTag="acc" SymbolTag="a" Visible="1" Internal="1"  UKTimingMask="1048576"/>
        <Measurement ID="1" NameTag="AccelerationAtA" UnitType="ms2" DefaultUnit="ms2" Equation="diff([4],[3],1)" MeasType="Acceleration" Ordinal="1" ShortNameTag="acc" SymbolTag="a" Visible="1" Internal="1"  UKTimingMask="1703936"/>
        <Measurement ID="2" NameTag="AccelerationAtB" UnitType="ms2" DefaultUnit="ms2" Equation="diff([6],[5],1)" MeasType="Acceleration" Ordinal="1" ShortNameTag="acc" SymbolTag="a" Visible="1" Internal="1"  UKTimingMask="1703936"/>
        <Measurement ID="3" NameTag="SpeedAtA1" UnitType="mps" Equation="[100]/[7]" MeasType="Speed" Ordinal="1" ShortNameTag="speed" SymbolTag="speed" Visible="1" Internal="1"  UKTimingMask="1703936" IsDefaultMeas="1"/>
        <Measurement ID="4" NameTag="SpeedAtA2" UnitType="mps" Equation="[100]/[8]" MeasType="Speed" Ordinal="1" ShortNameTag="speed" SymbolTag="speed" Visible="1" Internal="1"  UKTimingMask="1703936"/>
        <Measurement ID="5" NameTag="SpeedAtB1" UnitType="mps" Equation="[100]/[9]" MeasType="Speed" Ordinal="1" ShortNameTag="speed" SymbolTag="speed" Visible="1" Internal="1"  UKTimingMask="1703936"/>
        <Measurement ID="6" NameTag="SpeedAtB2" UnitType="mps" Equation="[100]/[10]" MeasType="Speed" Ordinal="1" ShortNameTag="speed" SymbolTag="speed" Visible="1" Internal="1"  UKTimingMask="1703936"/>
        <Measurement ID="7" NameTag="TimeInA1" UnitType="s" TimerTest="T2Y0I2B0U0" MeasType="Time" Ordinal="1" ShortNameTag="TimeInGate_SN" SymbolTag="deltaUtOrdInGate" Visible="1" Internal="1"  UKTimingMask="1703936"/>
        <Measurement ID="8" NameTag="TimeInA2" UnitType="s" TimerTest="T2Y0I1B0U0" MeasType="Time" Ordinal="2" ShortNameTag="TimeInGate_SN" SymbolTag="deltaUtOrdInGate" Visible="1" Internal="1"  UKTimingMask="1703936"/>
        <Measurement ID="9" NameTag="TimeInB1" UnitType="s" TimerTest="T2Y0I2B1U1" MeasType="Time" Ordinal="1" ShortNameTag="TimeInGate_SN" SymbolTag="deltaUtOrdInGate" Visible="1" Internal="1"  UKTimingMask="1703936"/>
        <Measurement ID="10" NameTag="TimeInB2" UnitType="s" TimerTest="T2Y0I1B1U1" MeasType="Time" Ordinal="2" ShortNameTag="TimeInGate_SN" SymbolTag="deltaUtOrdInGate" Visible="1" Internal="1"  UKTimingMask="1703936"/>
        <Measurement ID="11" NameTag="TimeA1toA2" UnitType="s" Equation="diff([14],[13],0)" MeasType="Time" Ordinal="1" ShortNameTag="TimeInGate_SN" SymbolTag="deltaUtOrdInGate" Visible="1" Internal="1"  UKTimingMask="1703936"/>
        <Measurement ID="12" NameTag="TimeB1toB2" UnitType="s" Equation="diff([16],[15],0)" MeasType="Time" Ordinal="1" ShortNameTag="TimeInGate_SN" SymbolTag="deltaUtOrdInGate" Visible="1" Internal="1"  UKTimingMask="1703936"/>
        <Measurement ID="13" NameTag="MidTimeInA1" UnitType="s" TimerTest="T2Y5I2B0U0" MeasType="Time" Ordinal="1" ShortNameTag="EventTimesOrd_SN" SymbolTag="t" Visible="1" Internal="1"/>
        <Measurement ID="14" NameTag="MidTimeInA2" UnitType="s" TimerTest="T2Y5I1B0U0" MeasType="Time" Ordinal="2" ShortNameTag="EventTimesOrd_SN" SymbolTag="t" Visible="1" Internal="1"/>
        <Measurement ID="15" NameTag="MidTimeInB1" UnitType="s" TimerTest="T2Y5I2B1U1" MeasType="Time" Ordinal="1" ShortNameTag="EventTimesOrd_SN" SymbolTag="t" Visible="1" Internal="1"/>
        <Measurement ID="16" NameTag="MidTimeInB2" UnitType="s" TimerTest="T2Y5I1B1U1" MeasType="Time" Ordinal="2" ShortNameTag="EventTimesOrd_SN" SymbolTag="t" Visible="1" Internal="1"/>
        <Measurement ID="100" NameTag="SegmentLength" UnitType="m" Type="Constant" Internal="1" MeasType="Length" Value="0.05"/>
      </Sensor>
      <!-- Sensor IDs 30000 - 30099 are Vernier sensors -->
      <Sensor ID="30009" Tag="VernierCurrent" Version="2.0" Class="0" DefaultRate="10Hz" FileName="CISensor30009.sds" FloatParams="1" IconID="246" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="DCP-BTA" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="FactoryCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="10" TypicalMin="-10" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Current" UnitType="A" Type="UserCal" Inputs="4" Params="4.5,-0.5,0.5,0.5" CalFlags="1,1,1,1" Accuracy="0.02" Display="None" Internal="0" Maximum="10" MeasType="Current" Minimum="-10" Precision="2" ShortNameTag="Curr" SymbolTag="current" TypicalMax="1" TypicalMin="-1" Visible="1" VisibleSds="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="30020" Tag="VernierpH" Version="2.0" Class="0" DefaultRate="10Hz" FileName="CISensor30020.sds" FloatParams="1" IconID="139" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="pH-BTA" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="FactoryCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="1" TypicalMin="-1" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="pH" UnitType="Unitless" Type="UserCal" Inputs="4" Params="2.533,4,0.969,10" CalFlags="1,1,1,1" Accuracy="0.1" Display="None" Internal="0" Maximum="14" MeasType="pH" Minimum="1" Precision="5" SymbolTag="pH" TypicalMax="10" TypicalMin="4" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="30021" Tag="VernierConductivity" Version="2.0" Class="0" DefaultRate="10Hz" FileName="CISensor30021.sds" FloatParams="1" IconID="141" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="CON-BTA" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="FactoryCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="1" TypicalMin="-1" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Conductivity20K" UnitType="uSpcm" Type="UserCal" Inputs="4" Params="0,0,2.251,17600" CalFlags="1,1,1,1" Accuracy="2" Display="None" Internal="0" Maximum="20000" MeasType="Conductivity" Minimum="0" Precision="2" ShortNameTag="Conduct20k" SymbolTag="sigmaL20k" TypicalMax="10000" TypicalMin="1000" Visible="1" VisibleSds="1"/>
        <Measurement ID="6" NameTag="Conductivity2K" UnitType="uSpcm" Type="UserCal" Inputs="4" Params="0,0,2.349,1990" CalFlags="1,1,1,1" Accuracy="2" Display="None" Internal="0" Maximum="2000" MeasType="Conductivity" Minimum="0" Precision="3" ShortNameTag="Conduct2k" SymbolTag="sigmaL2K" TypicalMax="2000" TypicalMin="200" Visible="1" IsDefaultMeas="1"/>
        <Measurement ID="7" NameTag="Conductivity200" UnitType="uSpcm" Type="UserCal" Inputs="4" Params="0,0,2.237,147" CalFlags="1,1,1,1" Accuracy="2" Display="None" Internal="0" Maximum="200" MeasType="Conductivity" Minimum="0" Precision="4" ShortNameTag="Conduct200" SymbolTag="sigmaL200" TypicalMax="200" TypicalMin="50" Visible="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="30024" Tag="VernierGasPressureSensor" Version="2.0" Class="0" DefaultRate="10Hz" FileName="CISensor30024.sds" FloatParams="1" IconID="143" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="GPS-BTA" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="FactoryCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="10" TypicalMin="-10" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Pressure" UnitType="kPa" Type="UserCal" Inputs="4" Params="0,0,2.175,101.1" CalFlags="1,1,1,1" Accuracy="0.1" Display="None" Internal="0" Maximum="700" MeasType="Pressure" Minimum="0" Precision="4" ShortNameTag="Press" SymbolTag="pressure" TypicalMax="1000" TypicalMin="100" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="30025" Tag="VernierDualRangeForce" Version="2.0" Class="0" DefaultRate="10Hz" FileName="CISensor30025.sds" FloatParams="1" IconID="130" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="DRF-BTA" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="FactoryCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="1" TypicalMin="-1" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Force10N" UnitType="N" Type="UserCal" Inputs="4" Params="2.508,0,0.5,9.800000000000001" CalFlags="1,1,1,1" Accuracy="0.01" Display="None" Internal="0" Maximum="8" MeasType="Force" Minimum="-8" Precision="4" SymbolTag="F" TypicalMax="1" TypicalMin="-1" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <Measurement ID="6" NameTag="Force50N" UnitType="N" Type="UserCal" Inputs="4" Params="2.5,0,0.5,49" CalFlags="1,1,1,1" Accuracy="0.01" Display="None" Internal="0" Maximum="8" MeasType="Force" Minimum="-8" Precision="5" SymbolTag="F" TypicalMax="1" TypicalMin="-1" Visible="1" VisibleSds="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="30034" Tag="VernierLight" Version="2.0" Class="0" DefaultRate="10Hz" FileName="CISensor30034.sds" FloatParams="1" IconID="234" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="LS-BTA" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="FactoryCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="1" TypicalMin="-1" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Light600Lux" UnitType="lux" Type="UserCal" Inputs="4" Params="0,0,2.597,400" CalFlags="1,1,1,1" Accuracy="1" Display="None" Internal="0" Maximum="100" MeasType="LightIntensity" Minimum="0" Precision="3" ShortNameTag="LightIntens600lx" SymbolTag="IntensityLight" TypicalMax="100" TypicalMin="0" Visible="1" VisibleSds="1"/>
        <Measurement ID="6" NameTag="Light6KLux" UnitType="lux" Type="UserCal" Inputs="4" Params="0,0,2.364,4000" CalFlags="1,1,1,1" Accuracy="1" Display="None" Internal="0" Maximum="100" MeasType="LightIntensity" Minimum="0" Precision="4" ShortNameTag="LightIntens6klx" SymbolTag="IntensityLight" TypicalMax="1000" TypicalMin="0" Visible="1" VisibleSds="1"/>
        <Measurement ID="7" NameTag="Light150KLux" UnitType="lux" Type="UserCal" Inputs="4" Params="0,0,3.253,125000" CalFlags="1,1,1,1" Accuracy="1" Display="None" Internal="0" Maximum="100" MeasType="LightIntensity" Minimum="0" Precision="1" ShortNameTag="LightIntens150klx" SymbolTag="IntensityLight" TypicalMax="10000" TypicalMin="0" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="30037" Tag="VernierDissolvedOxygen" Version="2.0" Class="0" DefaultRate="10Hz" FileName="CISensor30037.sds" FloatParams="1" IconID="140" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="DO-BTA" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="FactoryCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="10" TypicalMin="-10" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="OxygenConcentration" UnitType="mgpL" Type="UserCal" Inputs="4" Params="0.1,0,2.73,8.6" CalFlags="1,1,1,1" Accuracy="0.1" Display="None" Internal="0" Maximum="9" MeasType="Concentration" Minimum="0" Precision="1" ShortNameTag="O2Conc" TypicalMax="14" TypicalMin="6" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
      <Sensor ID="30054" Tag="VernierColorimeter" Version="2.0" Class="0" DefaultRate="10Hz" FileName="CISensor30054.sds" FloatParams="1" IconID="142" Latency="19" MaxDatasheet="8192" MaxRate="50000Hz" Model="COL-BTA" Warmup="250">
        <Measurement ID="0" NameTag="ADC" Type="RawDigital" DataSize="2" Accuracy="1" Display="Digits" Internal="1" Maximum="4095" Minimum="0" Precision="0" ShortNameTag="Counts" TypicalMax="4095" TypicalMin="0" XplorerDisplay="1"/>
        <Measurement ID="1" NameTag="V1X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,10" Accuracy="0.005" Display="None" Internal="1" Maximum="10" Minimum="-10" Precision="3" TypicalMax="10" TypicalMin="-10" XplorerDisplay="1"/>
        <Measurement ID="2" NameTag="V10X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,1" Accuracy="0.0005" Display="None" Internal="1" Maximum="1" Minimum="-1" Precision="4" TypicalMax="1" TypicalMin="-1" XplorerDisplay="1"/>
        <Measurement ID="3" NameTag="V100X" Type="FactoryCal" Inputs="0" Params="2045,0,4007,0.1" Accuracy="5e-005" Display="None" Internal="1" Maximum="0.1" Minimum="-0.1" Precision="5" TypicalMax="0.1" TypicalMin="-0.1" XplorerDisplay="1"/>
        <Measurement ID="4" NameTag="Voltage" UnitType="V" Type="FactoryCal" Inputs="1" Params="0,0,10,10" Accuracy="0.005" Display="None" Internal="0" Maximum="10" MeasType="Voltage" Minimum="-10" Precision="3" ShortNameTag="Volt" SymbolTag="V" TypicalMax="10" TypicalMin="-10" Visible="1" VisibleSds="1" XplorerDefault="1" XplorerDisplay="1"/>
        <Measurement ID="5" NameTag="Transmittance" UnitType="percent" Type="UserCal" Inputs="4" Params="0,0,3.5,100" CalFlags="1,1,1,1" Accuracy="1" Display="None" Internal="0" Maximum="100" MeasType="Transmittance" Minimum="0" Precision="5" ShortNameTag="Transmit" TypicalMax="100" TypicalMin="0" Visible="1" VisibleSds="1"/>
        <Measurement ID="6" NameTag="Absorbance" UnitType="Unitless" Type="Absorbance" Inputs="5" Accuracy="0.02" Display="None" Internal="0" Maximum="2" MeasType="Absorbance" Minimum="0" Precision="5" ShortNameTag="Absorb" TypicalMax="2" TypicalMin="0" Visible="1" VisibleSds="1" IsDefaultMeas="1"/>
        <SupportedCmd ID="65" Size="4"/>
      </Sensor>
     <!-- Sensor IDs 32000 - 33001 Video Lib Related Sensors - Add New Sensors BEFORE 33001, Due to Conflict with Expansion Port Sensor -->
      <Sensor ID="32299" Tag="VideoSnapshotSensor" Version="0.1" Class="0" DefaultRate="30Hz" FileName="" FloatParams="0" IconID="33001" Latency="1" MaxDatasheet="2048" MaxRate="1Hz" Model="PS-Video" Warmup="1">
        <Measurement ID="0" NameTag="ImageSequence" UnitType="Unitless" Type="FactoryCal" Inputs="0" Params="2048,0,0,0" Accuracy="0.1" Display="Graph" Internal="0" Maximum="1" MeasType="Video" Minimum="-1" Precision="1" ShortNameTag="Video" TypicalMax="1" TypicalMin="-1" Visible="0"/>
      </Sensor>
      <Sensor ID="33001" Tag="VideoSensor" Version="0.1" Class="0" DefaultRate="30Hz" FileName="" FloatParams="0" IconID="33001" Latency="1" MaxDatasheet="2048" MaxRate="100Hz" Model="PS-Video" Warmup="1">
        <Measurement ID="0" NameTag="VideoMeasurement" UnitType="Unitless" Type="FactoryCal" Inputs="0" Params="2048,0,0,0" Accuracy="0.1" Display="Graph" Internal="0" Maximum="1" MeasType="Video" Minimum="-1" Precision="1" ShortNameTag="Video" TypicalMax="1" TypicalMin="-1" Visible="0"/>
      </Sensor>
      <!-- Sensor IDs 33002 - 33099 Capstone 850 Expansion Port Sensors-->
      <Sensor ID="33002" Tag="ExpansionPortSensor" IconID="427" NumInputs="10">
      </Sensor>
    </Sensors>
    <InterfaceGroups>
        <Group ID="1" Name="WirelessSensors" InterfaceIDs="24,1025-1053,1055-1060,1062-1067"/>
        <Group ID="2" Name="DataStreamerSupported" InterfaceIDs="1025-1028,1030-1036,1039-1047,1049-1051"/>
        <Group ID="3" Name="Chemvue" InterfaceIDs="7,13,16,18,20,22,25,26,28,1024-1027,1030-1034,1036-1038,1043,1045,1046,1049,1053,1064-1067" />
    </InterfaceGroups>
    <Interfaces>
      <Interface ID="3" NameTag="USBLink" Image="USBLink.bmp">
        <Channel ID="0" NameTag="" HitRect="14,32,10,10" PlugDetect ="1" Type="Pasport" ChannelIDTag="1"/>
      </Interface>
      <Interface ID="4" NameTag="PowerLink" Image="PowerLink.bmp">
        <Channel ID="0" NameTag="Ch1" HitRect="19,60,10,10" PlugDetect ="1" Type="Pasport" ChannelIDTag="1"/>
        <Channel ID="1" NameTag="Ch2" HitRect="60,60,10,10" PlugDetect ="1" Type="Pasport" ChannelIDTag="2"/>
        <Channel ID="2" NameTag="Ch3" HitRect="99,60,10,10" PlugDetect ="1" Type="Pasport" ChannelIDTag="3"/>
      </Interface>
      <Interface ID="5" NameTag="Xplorer" Image="Xplorer.bmp">
        <Channel ID="0" NameTag="" HitRect="24,61,10,10" PlugDetect ="1" Type="Pasport" ChannelIDTag="1"/>
      </Interface>
      <Interface ID="6" NameTag="XplorerGLX" Image="GLX.bmp">
        <Channel ID="0" NameTag="Ch1" HitRect="63,53,10,10" PlugDetect ="1" Type="Pasport" ChannelIDTag="1"/>
        <Channel ID="1" NameTag="Ch2" HitRect="21,53,10,10" PlugDetect ="1" Type="Pasport" ChannelIDTag="2"/>
        <Channel ID="2" NameTag="Ch3" HitRect="26,73,10,10" PlugDetect ="1" Type="Pasport" ChannelIDTag="3"/>
        <Channel ID="3" NameTag="Ch4" HitRect="68,73,10,10" PlugDetect ="1" Type="Pasport" ChannelIDTag="4"/>
        <Channel ID="4" NameTag="Temp1" HitRect="94,65,10,10" PlugDetect ="1" Type="Temperature" ChannelIDTag="T1"/>
        <Channel ID="5" NameTag="Temp2" HitRect="94,55,10,10" PlugDetect ="1" Type="Temperature" ChannelIDTag="T2"/>
        <Channel ID="6" NameTag="Voltage" HitRect="94,45,10,10" PlugDetect ="1" Type="Voltage" ChannelIDTag="V"/>
        <Channel ID="7" NameTag="Sound" HitRect="94,35,10,10" PlugDetect ="1" Type="Sound" ChannelIDTag=""/>
      </Interface>
      <Interface ID="7" NameTag="SparkLink" Image="SparkLink.bmp">
        <Channel ID="0" NameTag="Ch2" HitRect="129,35,10,10" PlugDetect ="1" Type="Pasport" ChannelIDTag="2"/>
        <Channel ID="1" NameTag="Ch1" HitRect="37,35,10,10" PlugDetect ="1" Type="Pasport" ChannelIDTag="1"/>
        <Channel ID="2" NameTag="Voltage" HitRect="77,42,10,10" PlugDetect ="1" Type="Voltage" ChannelIDTag="V"/>
        <Channel ID="3" NameTag="Temp" HitRect="96,38,10,10" PlugDetect ="1" Type="Temperature" ChannelIDTag="T"/>
      </Interface>
      <Interface ID="8" NameTag="SparkSLS" Image="SparkSls.bmp">
        <Channel ID="0" NameTag="Ch2" HitRect="150,36,10,10" PlugDetect ="1" Type="Pasport" ChannelIDTag="2"/>
        <Channel ID="1" NameTag="Ch1" HitRect="56,36,10,10" PlugDetect ="1" Type="Pasport" ChannelIDTag="1"/>
        <Channel ID="2" NameTag="Voltage" HitRect="89,41,10,10" PlugDetect ="1" Type="Voltage" ChannelIDTag="V"/>
        <Channel ID="3" NameTag="Temp" HitRect="122,37,10,10" PlugDetect ="1" Type="Temperature" ChannelIDTag="T"/>
      </Interface>
      <Interface ID="9" NameTag="SW750" Image="SW750.bmp">
        <Channel ID="0" NameTag="" HitRect="166,51,16,16" Type="CIAnalog" ChannelIDTag="A"/>
        <Channel ID="1" NameTag="" HitRect="196,51,16,16" Type="CIAnalog" ChannelIDTag="B"/>
        <Channel ID="2" NameTag="" HitRect="225,51,16,16" Type="CIAnalog" ChannelIDTag="C"/>
        <Channel ID="3" NameTag="" HitRect="267,50,20,20" Type="Voltage" ChannelIDTag="Vo"/>
        <Channel ID="4" NameTag="" HitRect="0,0,0,0" Type="Current" ChannelIDTag="Io"/>
        <Channel ID="5" NameTag="" HitRect="52,61,10,10" Type="CIDigital" ChannelIDTag="1"/>
        <Channel ID="6" NameTag="" HitRect="77,61,10,10" Type="CIDigital" ChannelIDTag="2"/>
        <Channel ID="7" NameTag="" HitRect="103,61,10,10" Type="CIDigital" ChannelIDTag="3"/>
        <Channel ID="8" NameTag="" HitRect="128,61,10,10" Type="CIDigital" ChannelIDTag="4"/>
        <Channel ID="9" NameTag="SW750Output" HitRect="0,0,0,0" Type="Output" OutputType="4"/>
      </Interface>
      <Interface ID="10" NameTag="SW500" Image="SW500.bmp">
        <Channel ID="0" NameTag="" HitRect="109,40,16,16" Type="CIAnalog" ChannelIDTag="A"/>
        <Channel ID="1" NameTag="" HitRect="138,40,16,16" Type="CIAnalog" ChannelIDTag="B"/>
        <Channel ID="2" NameTag="" HitRect="167,40,16,16" Type="CIAnalog" ChannelIDTag="C"/>
        <Channel ID="3" NameTag="" HitRect="45,49,10,10" Type="CIDigital" ChannelIDTag="1"/>
        <Channel ID="4" NameTag="" HitRect="70,49,10,10" Type="CIDigital" ChannelIDTag="2"/>
      </Interface>
      <Interface ID="11" NameTag="FunctionGenerator" Image="DFG.bmp">
        <Channel ID="0" NameTag="FunctionGenerator" HitRect="0,0,0,0" Type="Output" OutputType="3"/>
      </Interface>
      <Interface ID="12" NameTag="OceanOptics" Image="Spectrometer.bmp">
        <Channel ID="0" NameTag="" HitRect="0,0,0,0" Type=""/>
      </Interface>
      <Interface ID="13" NameTag="PS850" Image="PS850.png">
        <Channel ID="0" NameTag="" HitRect="28,70,12,12" PlugDetect ="1" Type="Pasport" ChannelIDTag="P1"/>
        <Channel ID="1" NameTag="" HitRect="87,70,12,12" PlugDetect ="1" Type="Pasport" ChannelIDTag="P2"/>
        <Channel ID="2" NameTag="" HitRect="147,70,12,12" PlugDetect ="1" Type="Pasport" ChannelIDTag="P3"/>
        <Channel ID="3" NameTag="" HitRect="206,70,12,12" PlugDetect ="1" Type="Pasport" ChannelIDTag="P4"/>
        <Channel ID="4" NameTag="" HitRect="142,23,14,14" Type="CIAnalog" ChannelIDTag="A"/>
        <Channel ID="5" NameTag="" HitRect="166,23,14,14" Type="CIAnalog" ChannelIDTag="B"/>
        <Channel ID="6" NameTag="" HitRect="189,23,14,14" Type="CIAnalog" ChannelIDTag="C"/>
        <Channel ID="7" NameTag="" HitRect="213,23,14,14" Type="CIAnalog" ChannelIDTag="D"/>
        <Channel ID="8" NameTag="" HitRect="32,274,14,14" Type="CIAnalog" ChannelIDTag="XA"/>
        <Channel ID="9" NameTag="" HitRect="56,274,14,14" Type="CIAnalog" ChannelIDTag="XB"/>
        <Channel ID="10" NameTag="" HitRect="80,274,14,14" Type="CIAnalog" ChannelIDTag="XC"/>
        <Channel ID="11" NameTag="" HitRect="265,27,12,12" Type="Voltage" ChannelIDTag="O1"/>
        <Channel ID="12" NameTag="" HitRect="255,71,10,10" Type="Voltage" ChannelIDTag="O2"/>
        <Channel ID="13" NameTag="" HitRect="275,71,10,10" Type="Voltage" ChannelIDTag="O3"/>
        <Channel ID="14" NameTag="" Type="Voltage"/>
        <Channel ID="15" NameTag="" Type="Voltage"/>
        <Channel ID="16" NameTag="" Type="Voltage"/>
        <Channel ID="17" NameTag="" Type="Voltage"/>
        <Channel ID="18" NameTag="" Type="Voltage"/>
        <Channel ID="19" NameTag="" Type="Voltage"/>
        <Channel ID="20" NameTag="" Type="Voltage"/>
        <Channel ID="21" NameTag="" Type="Voltage"/>
        <Channel ID="22" NameTag="" Type="Voltage"/>
        <Channel ID="23" NameTag="" HitRect="47,29,10,10" PlugDetect ="1" Type="CIDigital" ChannelIDTag="1"/>
        <Channel ID="24" NameTag="" HitRect="67,29,10,10" PlugDetect ="1" Type="CIDigital" ChannelIDTag="2"/>
        <Channel ID="25" NameTag="" HitRect="87,29,10,10" PlugDetect ="1" Type="CIDigital" ChannelIDTag="3"/>
        <Channel ID="26" NameTag="" HitRect="107,29,10,10" PlugDetect ="1" Type="CIDigital" ChannelIDTag="4"/>
        <Channel ID="27" NameTag="850ExtDigitalIOOrd" HitRect="15,330,10,10" Type="CIDigital" Ordinal="1" OutputType="5" ChannelIDTag="X1"/>
        <Channel ID="28" NameTag="850ExtDigitalIOOrd" HitRect="52,330,10,10" Type="CIDigital" Ordinal="2" OutputType="5" ChannelIDTag="X2"/>
        <Channel ID="29" NameTag="850ExtDigitalIOOrd" HitRect="89,330,10,10" Type="CIDigital" Ordinal="3" OutputType="5" ChannelIDTag="X3"/>
        <Channel ID="30" NameTag="850ExtDigitalIOOrd" HitRect="126,330,10,10" Type="CIDigital" Ordinal="4" OutputType="5" ChannelIDTag="X4"/>
        <Channel ID="31" NameTag="850ExtDigitalIOOrd" HitRect="163,330,10,10" Type="CIDigital" Ordinal="5" OutputType="5" ChannelIDTag="X5"/>
        <Channel ID="32" NameTag="850ExtDigitalIOOrd" HitRect="200,330,10,10" Type="CIDigital" Ordinal="6" OutputType="5" ChannelIDTag="X6"/>
        <Channel ID="33" NameTag="850ExtDigitalIOOrd" HitRect="237,330,10,10" Type="CIDigital" Ordinal="7" OutputType="5" ChannelIDTag="X7"/>
        <Channel ID="34" NameTag="850ExtDigitalIOOrd" HitRect="274,330,10,10" Type="CIDigital" Ordinal="8" OutputType="5" ChannelIDTag="X8"/>
        <Channel ID="35" NameTag="850OutputOrd" Ordinal="1" Type="Output" OutputType="1"/>
        <Channel ID="36" NameTag="850OutputOrd" Ordinal="2" Type="Output" OutputType="2"/>
        <Channel ID="37" NameTag="850OutputOrd" Ordinal="3" Type="Output" OutputType="2"/>
        <Channel ID="38" NameTag="" Type="Voltage" HitRect="265,27,12,12" ChannelIDTag="O1"/>
        <Channel ID="39" NameTag="" Type="Voltage" HitRect="255,71,10,10" ChannelIDTag="O2"/>
        <Channel ID="40" NameTag="" Type="Voltage" HitRect="275,71,10,10" ChannelIDTag="O3"/>
        <Channel ID="41" NameTag="" Type="CIAnalog" HitRect="142,23,14,14" ChannelIDTag="A"/>
        <Channel ID="42" NameTag="" Type="CIAnalog" HitRect="166,23,14,14" ChannelIDTag="B"/>
        <Channel ID="43" NameTag="" Type="CIAnalog" HitRect="189,23,14,14" ChannelIDTag="C"/>
        <Channel ID="44" NameTag="" Type="CIAnalog" HitRect="213,23,14,14" ChannelIDTag="D"/>
        <Channel ID="45" NameTag="" Type="CIAnalog" HitRect="32,274,14,14" ChannelIDTag="XA"/>
        <Channel ID="46" NameTag="" Type="CIAnalog" HitRect="56,274,14,14" ChannelIDTag="XB"/>
        <Channel ID="47" NameTag="" Type="CIAnalog" HitRect="80,274,14,14" ChannelIDTag="XC"/>
        <Channel ID="48" NameTag="" Type="Voltage" HitRect="265,27,12,12" ChannelIDTag="O1"/>
        <Channel ID="49" NameTag="" Type="Voltage" HitRect="255,71,10,10" ChannelIDTag="O2"/>
        <Channel ID="50" NameTag="" Type="Voltage" HitRect="275,71,10,10" ChannelIDTag="O3"/>
        <Channel ID="51" NameTag="" Type="Voltage" ChannelIDTag="I1"/>
      </Interface>
      <Interface ID="16" NameTag="SparkLinkAir" BTNameMatch="SparkLink Air" Image="SparkLinkAir.bmp">
        <Channel ID="0" NameTag="Ch2" HitRect="130,35,10,10" PlugDetect ="1" Type="Pasport" ChannelIDTag="2"/>
        <Channel ID="1" NameTag="Ch1" HitRect="38,35,10,10" PlugDetect ="1" Type="Pasport" ChannelIDTag="1"/>
        <Channel ID="2" NameTag="Voltage" HitRect="77,42,10,10" PlugDetect ="1" Type="Voltage" ChannelIDTag="V"/>
        <Channel ID="3" NameTag="Temp" HitRect="96,38,10,10" PlugDetect ="1" Type="Temperature" ChannelIDTag="T"/>
      </Interface>
      <Interface ID="17" NameTag="AirLink2" BTNameMatch="AirLink2" Image="AirLink.bmp">
        <Channel ID="0" NameTag="" HitRect="16,54,10,10" PlugDetect ="1" Type="Pasport" ChannelIDTag="1"/>
      </Interface>
      <Interface ID="18" NameTag="OhausBalance" Image="Ohaus.bmp">
        <Channel ID="0" HitRect="60,30,10,10"/>
      </Interface>
      <Interface ID="19" NameTag="ForceAccel" Image="USBLink.bmp">
        <Channel ID="0" NameTag="" HitRect="9,32,10,10" PlugDetect ="1" Type="Pasport" ChannelIDTag="F"/>
        <Channel ID="1" NameTag="" HitRect="20,32,10,10" PlugDetect ="1" Type="Pasport" ChannelIDTag="A"/>
      </Interface>
      <Interface ID="20" NameTag="PascoSpectrometer" BTNameMatch="Spectrometer" Image="Spectrometer.bmp">
        <Channel ID="0" NameTag="" HitRect="0,0,0,0" Type=""/>
      </Interface>
      <Interface ID="21" NameTag="Polarimeter" BTNameMatch="Polarimeter" Image="Polarimeter.bmp" DiscoveryImage="Icon1062.png">
        <Channel ID="0" NameTag="" HitRect="0,0,0,0" PlugDetect ="1" Type=""/>
      </Interface>
      <Interface ID="22" NameTag="PS550" BTNameMatch="PS550" Image="PS550.png" AdvertisingName="550 Interface">
        <Channel ID="0" NameTag="" HitRect="50,34,10,10" PlugDetect ="1" Type="Pasport" ChannelIDTag="P1"/>
        <Channel ID="1" NameTag="" HitRect="94,34,10,10" PlugDetect ="1" Type="Pasport" ChannelIDTag="P2"/>
        <Channel ID="2" NameTag="" HitRect="170,29,14,14" Type="CIAnalog" ChannelIDTag="A"/>
        <Channel ID="3" NameTag="" HitRect="188,29,14,14" Type="CIAnalog" ChannelIDTag="B"/>
        <Channel ID="4" NameTag="" HitRect="228,34,10,10" Type="CIAnalog" ChannelIDTag="V"/>
        <Channel ID="5" NameTag="" HitRect="228,34,10,10" Type="CIAnalog" ChannelIDTag="I"/>
        <Channel ID="6" NameTag="" HitRect="134,35,10,10" PlugDetect ="1" Type="CIDigital" ChannelIDTag="1"/>
        <Channel ID="7" NameTag="" HitRect="150,35,10,10" PlugDetect ="1" Type="CIDigital" ChannelIDTag="2"/>
        <Channel ID="8" NameTag="550Output" Type="Output" OutputType="6"/>
        <Channel ID="9" NameTag="OutputFreq" Type="Voltage" HitRect="228,34,10,10" ChannelIDTag="O1"/>
        <Channel ID="10" NameTag="MinMax" Type="CIAnalog" HitRect="170,29,14,14" ChannelIDTag="A"/>
        <Channel ID="11" NameTag="MinMax" Type="CIAnalog" HitRect="188,29,14,14" ChannelIDTag="B"/>
        <Channel ID="12" NameTag="MinMax" Type="CIAnalog" HitRect="228,34,10,10" ChannelIDTag="V"/>
        <Channel ID="13" NameTag="MinMax" Type="CIAnalog" HitRect="228,34,10,10" ChannelIDTag="I"/>
      </Interface>
      <Interface ID="23" NameTag="OnBoardSensors" Image="">
          <Channel ID="0" NameTag="AccelerationSensor" HitRect="0,0,0,0" PlugDetect ="0" Type=""/>
          <Channel ID="1" NameTag="OnboardMicrophone" HitRect="0,0,0,0" PlugDetect ="0" Type=""/>
          <Channel ID="2" NameTag="AudioJackTemperatureProbe" HitRect="0,0,0,0" PlugDetect ="0" Type=""/>
          <Channel ID="3" NameTag="OnboardLightSensor" HitRect="0,0,0,0" PlugDetect ="0" Type=""/>
          <Channel ID="4" NameTag="OnboardGPSSensor" HitRect="0,0,0,0" PlugDetect ="0" Type=""/>
      </Interface>
      <Interface ID="24" NameTag="WirelessHeartRate" Image="" DiscoveryImage="Icon24.png" AdvertisingName="Polar H7">
          <Channel ID="0" NameTag="HeartRate" HitRect="0,0,0,0" SensorID="2040" Type="Pasport"/>
      </Interface>
      <Interface ID="25" NameTag="SparkLXi" Image="SparkLink.bmp">
        <Channel ID="0" NameTag="Ch2" HitRect="129,35,10,10" PlugDetect ="1" Type="Pasport" ChannelIDTag="2"/>
        <Channel ID="1" NameTag="Ch1" HitRect="37,35,10,10" PlugDetect ="1" Type="Pasport" ChannelIDTag="1"/>
        <Channel ID="2" NameTag="Voltage" HitRect="77,42,10,10" PlugDetect ="1" Type="Voltage" ChannelIDTag="V"/>
        <Channel ID="3" NameTag="Temp" HitRect="96,38,10,10" PlugDetect ="1" Type="Temperature" ChannelIDTag="T"/>
      </Interface>
      <Interface ID="26" NameTag="SparkLXi2" Image="SparkLink.bmp">
        <Channel ID="0" NameTag="Ch2" HitRect="129,35,10,10" PlugDetect ="1" Type="Pasport" ChannelIDTag="2"/>
        <Channel ID="1" NameTag="Ch1" HitRect="37,35,10,10" PlugDetect ="1" Type="Pasport" ChannelIDTag="1"/>
        <Channel ID="2" NameTag="Voltage" HitRect="77,42,10,10" PlugDetect ="1" Type="Voltage" ChannelIDTag="V"/>
        <Channel ID="3" NameTag="Temp" HitRect="96,38,10,10" PlugDetect ="1" Type="Temperature" ChannelIDTag="T"/>
      </Interface>
      <Interface ID="27" NameTag="BrolightSpectrometer" Image="Spectrometer.bmp">
        <Channel ID="0" NameTag="" HitRect="0,0,0,0" Type=""/>
      </Interface>
      <Interface ID="28" NameTag="SparkLXi2Vantron" Image="SparkLink.bmp">
        <Channel ID="0" NameTag="Ch2" HitRect="129,35,10,10" PlugDetect ="1" Type="Pasport" ChannelIDTag="2"/>
        <Channel ID="1" NameTag="Ch1" HitRect="37,35,10,10" PlugDetect ="1" Type="Pasport" ChannelIDTag="1"/>
        <Channel ID="2" NameTag="Voltage" HitRect="77,42,10,10" PlugDetect ="1" Type="Voltage" ChannelIDTag="V"/>
        <Channel ID="3" NameTag="Temp" HitRect="96,38,10,10" PlugDetect ="1" Type="Temperature" ChannelIDTag="T"/>
      </Interface>
      <Interface ID="1024" NameTag="Airlink3" AdvertisingName="AirLink" Image="Airlink3.png">
        <Channel ID="0" NameTag="" HitRect="22,26,15,15" PlugDetect ="1" Type="Pasport"/>
      </Interface>
      <Interface ID="1025" NameTag="WirelessTemperature" AdvertisingName="Temperature" SupportsLogging="1" DiscoveryImage="Icon1025.png">
          <Channel ID="0" NameTag="" HitRect="10,100,10,10" SensorID="2020" Type="Pasport"/>
      </Interface>
      <Interface ID="1026" NameTag="WirelessPH" AdvertisingName="pH" SupportsLogging="1" DiscoveryImage="Icon1026.png">
          <Channel ID="0" NameTag="" HitRect="10,100,10,10" SensorID="2021" Type="Pasport"/>
      </Interface>
      <Interface ID="1027" NameTag="WirelessPressure" AdvertisingName="Pressure" SupportsLogging="1" DiscoveryImage="Icon1027.png">
          <Channel ID="0" NameTag="" HitRect="10,100,10,10" SensorID="2022" Type="Pasport"/>
      </Interface>
      <Interface ID="1028" NameTag="WirelessForceAccel" AdvertisingName="Force Accel" SupportsLogging="1" DiscoveryImage="Icon1028.png">
          <Channel ID="0" NameTag="Force" HitRect="10,100,10,10" SensorID="2023" Type="Pasport"/>
          <Channel ID="1" NameTag="Accel" HitRect="10,100,10,10" SensorID="2024" Type="Pasport"/>
          <Channel ID="2" NameTag="Gyro" HitRect="10,100,10,10" SensorID="2028" Type="Pasport"/>
      </Interface>
      <Interface ID="1029" NameTag="SmartCart" AdvertisingName="Smart Cart" HasSensorDisplayOrder="1" DiscoveryImage="Icon1029.png">
          <Channel ID="0" NameTag="Force" HitRect="10,100,10,10" SensorID="2025" Type="Pasport" SensorDisplayOrder="1"/>
          <Channel ID="1" NameTag="Accel" HitRect="10,100,10,10" SensorID="2026" Type="Pasport" SensorDisplayOrder="2"/>
          <Channel ID="2" NameTag="Position" HitRect="10,100,10,10" SensorID="2027" Type="Pasport" SensorDisplayOrder="0"/>
          <Channel ID="3" NameTag="Gyro" HitRect="10,100,10,10" SensorID="2029" Type="Pasport" SensorDisplayOrder="3"/>
      </Interface>
      <Interface ID="1030" NameTag="WirelessLight" AdvertisingName="Light" SupportsLogging="1" DiscoveryImage="Icon1030.png">
          <Channel ID="0" NameTag="" HitRect="10,100,10,10" SensorID="2030" Type="Pasport"/>
          <Channel ID="1" NameTag="" HitRect="10,100,10,10" SensorID="2034" Type="Pasport"/>
      </Interface>
      <Interface ID="1031" NameTag="WirelessVoltage" AdvertisingName="Voltage" SupportsLogging="1" DiscoveryImage="Icon1031.png">
          <Channel ID="0" NameTag="" HitRect="10,100,10,10" SensorID="2031" Type="Pasport"/>
      </Interface>
      <Interface ID="1032" NameTag="WirelessCurrent" AdvertisingName="Current" SupportsLogging="1" DiscoveryImage="Icon1032.png">
          <Channel ID="0" NameTag="" HitRect="10,100,10,10" SensorID="2032" Type="Pasport"/>
      </Interface>
      <Interface ID="1033" NameTag="WirelessConductivity" AdvertisingName="Conductivity" SupportsLogging="1" DiscoveryImage="Icon1033.png">
          <Channel ID="0" NameTag="" HitRect="10,100,10,10" SensorID="2033" Type="Pasport"/>
      </Interface>
      <Interface ID="1034" NameTag="WirelessCO2" AdvertisingName="CO2" SupportsLogging="1" DiscoveryImage="Icon1034.png">
          <Channel ID="0" NameTag="" HitRect="10,100,10,10" SensorID="2035" Type="Pasport"/>
      </Interface>
      <Interface ID="1035" NameTag="WirelessCurrentModule" AdvertisingName="Current" SupportsLogging="1" DiscoveryImage="Icon1035.png">
          <Channel ID="0" NameTag="" HitRect="10,100,10,10" SensorID="2036" Type="Pasport"/>
      </Interface>
      <Interface ID="1036" NameTag="WirelessWeather" AdvertisingName="Weather" SupportsLogging="1" HasSensorDisplayOrder="1" DiscoveryImage="Icon1036.png">
          <Channel ID="0" NameTag="Weather" HitRect="10,100,10,10" SensorID="2037" Type="Pasport" SensorDisplayOrder="0"/>
          <Channel ID="1" NameTag="GPS" HitRect="10,100,10,10" SensorID="2038" Type="Pasport" SensorDisplayOrder="3"/>
          <Channel ID="2" NameTag="Light" HitRect="10,100,10,10" SensorID="2039" Type="Pasport" SensorDisplayOrder="1"/>
          <Channel ID="3" NameTag="Compass" HitRect="10,100,10,10" SensorID="2045" Type="Pasport" SensorDisplayOrder="2"/>
      </Interface>
      <Interface ID="1037" NameTag="WirelessLightSource" AdvertisingName="LightSource">
          <Channel ID="0" NameTag="RedOutput" Type="Output" OutputType="8"/>
          <Channel ID="1" NameTag="GreenOutput" Type="Output" OutputType="8"/>
          <Channel ID="2" NameTag="BlueOutput" Type="Output" OutputType="8"/>
      </Interface>
      <Interface ID="1038" NameTag="WirelessColorimeter" AdvertisingName="Colorimeter" SupportsLogging="1" MutuallyExclusive="1" DiscoveryImage="Icon1038.png">
          <Channel ID="0" NameTag="Colorimeter" HitRect="10,100,10,10" SensorID="2041" Type="Pasport"/>
          <Channel ID="1" NameTag="Turbidimeter" HitRect="10,100,10,10" SensorID="2042" Type="Pasport"/>
      </Interface>
      <Interface ID="1039" NameTag="WirelessLoadCell" AdvertisingName="Load Cell" SupportsLogging="1" DiscoveryImage="Icon1039.png">
          <Channel ID="0" NameTag="Force" HitRect="10,100,10,10" SensorID="2043" Type="Pasport"/>
          <Channel ID="1" NameTag="Accel" HitRect="10,100,10,10" SensorID="2044" Type="Pasport"/>
      </Interface>
      <Interface ID="1040" NameTag="WirelessBloodPressure" AdvertisingName="BP" DiscoveryImage="Icon1040.png">
          <Channel ID="0" NameTag="Pressure" HitRect="10,100,10,10" SensorID="2046" Type="Pasport"/>
      </Interface>
      <Interface ID="1041" NameTag="WirelessRotaryMotion" AdvertisingName="Rotary Motion" SupportsLogging="1" DiscoveryImage="Icon1041.png">
          <Channel ID="0" NameTag="Position" HitRect="10,100,10,10" SensorID="2047" Type="Pasport"/>
      </Interface>
      <Interface ID="1042" NameTag="WirelessMotion" AdvertisingName="Motion" DiscoveryImage="Icon1042.png">
          <Channel ID="0" NameTag="Position" HitRect="10,100,10,10" SensorID="2048" Type="Pasport"/>
      </Interface>
      <Interface ID="1043" NameTag="WirelessDropCounter" AdvertisingName="Drop Counter" DiscoveryImage="Icon1043.png">
          <Channel ID="0" NameTag="Drops" HitRect="10,100,10,10" SensorID="2050" Type="Pasport"/>
      </Interface>
      <Interface ID="1044" NameTag="WirelessMagField" AdvertisingName="Mag Field" SupportsLogging="1" DiscoveryImage="Icon1044.png">
          <Channel ID="0" NameTag="MagField" HitRect="10,100,10,10" SensorID="2051" Type="Pasport"/>
      </Interface>
      <Interface ID="1045" NameTag="WirelessODO" AdvertisingName="Optical DO" SupportsLogging="1" DiscoveryImage="Icon1045.png">
          <Channel ID="0" NameTag="ODO" HitRect="10,100,10,10" SensorID="2049" Type="Pasport"/>
      </Interface>
      <Interface ID="1046" NameTag="WirelessFastRespTemp" AdvertisingName="Temperature" SupportsLogging="1" DiscoveryImage="Icon1046.png">
          <Channel ID="0" NameTag="Temperature" HitRect="10,100,10,10" SensorID="2052" Type="Pasport"/>
      </Interface>
      <Interface ID="1047" NameTag="WirelessAccelAlt" AdvertisingName="Accel Alt" SupportsLogging="1" DiscoveryImage="Icon1047.png">
          <Channel ID="0" NameTag="Accel" HitRect="10,100,10,10" SensorID="2053" Type="Pasport"/>
          <Channel ID="1" NameTag="Gyro" HitRect="10,100,10,10" SensorID="2056" Type="Pasport"/>
          <Channel ID="2" NameTag="Altimeter" HitRect="10,100,10,10" SensorID="2054" Type="Pasport"/>
      </Interface>
      <Interface ID="1048" NameTag="WirelessSmartGate" AdvertisingName="Smart Gate" Image="WirelessSmartGate.png" DiscoveryImage="Icon1048.png">
          <Channel ID="0" NameTag="" HitRect="190,35,15,15" Type="CIDigital" SensorID="2055" ChannelIDTag="1"/>
          <Channel ID="1" NameTag="" HitRect="190,35,15,15" Type="CIDigital" ChannelIDTag="2"/>
          <Channel ID="2" NameTag="" HitRect="175,110,15,15" Type="CIDigital" ChannelIDTag="3"/>
          <Channel ID="3" NameTag="" HitRect="60,130,18,18" Type="CIDigital" ChannelIDTag="4"/>
      </Interface>
      <Interface ID="1049" NameTag="WirelessOxygenGas" AdvertisingName="O2" SupportsLogging="1" DiscoveryImage="Icon1049.png">
          <Channel ID="0" NameTag="Oxygen" HitRect="10,100,10,10" SensorID="2057" Type="Pasport"/>
      </Interface>
      <Interface ID="1050" NameTag="WirelessDiffraction" AdvertisingName="Diffraction" SupportsLogging="1" DiscoveryImage="Icon1050.png">
          <Channel ID="0" NameTag="Position" HitRect="10,100,10,10" SensorID="2058" Type="Pasport"/>
          <Channel ID="1" NameTag="Intensity" HitRect="10,100,10,10" SensorID="2059" Type="Pasport" IsDefaultMeas="1"/>
      </Interface>
      <Interface ID="1051" NameTag="WirelessACDCModule" AdvertisingName="AC/DC Module" DiscoveryImage="Icon1051.png">
          <Channel ID="0" NameTag="Voltage" SensorID="2060" Type="Pasport"/>
          <Channel ID="1" NameTag="WirelessFunctionGenerator" Type="Output" OutputType="9"/>
      </Interface>
      <Interface ID="1052" NameTag="WirelessSound" AdvertisingName="Sound" SupportsLogging="1" MutuallyExclusive="1" DiscoveryImage="Icon1052.png">
          <Channel ID="0" NameTag="SoundWave" HitRect="10,100,10,10" SensorID="2062" Type="Pasport"/>
          <Channel ID="1" NameTag="SoundLevel" HitRect="10,100,10,10" SensorID="2063" Type="Pasport"/>
      </Interface>
      <Interface ID="1053" NameTag="WirelessLightColor" SupportsLogging="1">
          <Channel ID="0" NameTag="" HitRect="10,100,10,10" SensorID="2061" Type="Pasport"/>
          <Channel ID="1" NameTag="" HitRect="10,100,10,10" SensorID="2034" Type="Pasport"/>
      </Interface>
      <Interface ID="1054" NameTag="WirelessSTEMModule" AdvertisingName="STEM Module">
          <Channel ID="0" NameTag="Wheel" SensorID="2064" Type="Pasport"/>
          <Channel ID="1" NameTag="Motor" Ordinal="1" Type="Output" OutputType="10"/>
          <Channel ID="2" NameTag="Motor" Ordinal="2" Type="Output" OutputType="10"/>
          <Channel ID="3" NameTag="Motor" Ordinal="3" Type="Output" OutputType="10"/>
          <Channel ID="4" NameTag="Motor" Ordinal="4" Type="Output" OutputType="10"/>
          <Channel ID="5" NameTag="GPIO" Type="Output" OutputType="11"/>
      </Interface>
      <Interface ID="1055" NameTag="WirelessSoilMoisture" SupportsLogging="1" AdvertisingName="Moisture" DiscoveryImage="Icon1055.png">
          <Channel ID="0" NameTag="SoilMoisture" SensorID="2065" Type="Pasport"/>
      </Interface>
      <Interface ID="1056" NameTag="WirelessCodeNode" AdvertisingName="//code.Node" HasSensorDisplayOrder="1" DiscoveryImage="Icon1056.png">
          <Channel ID="0" NameTag="TempLightSound" SensorID="2066" Type="Pasport" SensorDisplayOrder="0"/>
          <Channel ID="1" NameTag="Compass" SensorID="2067" Type="Pasport" SensorDisplayOrder="1"/>
          <Channel ID="2" NameTag="Acceleration" SensorID="2068" Type="Pasport" SensorDisplayOrder="2"/>
          <Channel ID="3" NameTag="Buttons" SensorID="2069" Type="Pasport" SensorDisplayOrder="3"/>
          <Channel ID="4" NameTag="RedOutput" Type="Output" OrdinalPos="1" OutputType="13"/>
          <Channel ID="5" NameTag="GreenOutput" Type="Output" OrdinalPos="2" OutputType="13"/>
          <Channel ID="6" NameTag="BlueOutput" Type="Output" OrdinalPos="3" OutputType="13"/>
          <Channel ID="7" NameTag="CodeNodeSpeaker" Type="Output" OutputType="14"/>
      </Interface>
      <Interface ID="1057" NameTag="WirelessControlNode" Image="ControlNode.png" AdvertisingName="//control.Node" DiscoveryImage="Icon1057.png">
          <Channel ID="0" NameTag="" HitRect="147,75,15,15" PlugDetect="1" Type="Pasport" ChannelIDTag="A"/>
          <Channel ID="1" NameTag="" HitRect="196,75,15,15" PlugDetect="1" Type="Pasport" ChannelIDTag="B"/>
          <Channel ID="2" NameTag="" HitRect="98,75,15,15" PlugDetect="1" Type="Pasport"/>
          <Channel ID="3" NameTag="" SensorID="2082" Type="Pasport"/>
          <Channel ID="4" NameTag="ControlNodeSpeaker" Type="Output" OutputType="14"/>
      </Interface>
      <Interface ID="1058" NameTag="WirelessSpirometer" SupportsLogging="1" AdvertisingName="Spirometer" DiscoveryImage="Icon1058.svg">
          <Channel ID="0" NameTag="Pressure" SensorID="2071" Type="Pasport"/>
      </Interface>
      <Interface ID="1059" NameTag="WirelessForcePlatform" AdvertisingName="Force Platform" SupportsLogging="1" DiscoveryImage="Icon1059.svg">
          <Channel ID="0" NameTag="ForceBeams" SensorID="2076" Type="Pasport"/>
      </Interface>
      <Interface ID="1060" NameTag="WirelessForcePlatform2D" AdvertisingName="Force Plat. 2D" SupportsLogging="1" DiscoveryImage="Icon1060.svg">
          <Channel ID="0" NameTag="ForceBeams2D" SensorID="2077" Type="Pasport"/>
      </Interface>
      <Interface ID="1061" NameTag="WirelessPowerMeter">
          <Channel ID="0" NameTag="Data" SensorID="2072" Type="Pasport"/>
      </Interface>
      <Interface ID="1062" NameTag="WirelessPolarimeter" AdvertisingName="Polarimeter" DiscoveryImage="Icon1062.png">
          <Channel ID="0" NameTag="Polarimeter" SensorID="2073" Type="Pasport"/>
      </Interface>
      <Interface ID="1063" NameTag="WirelessEKG" SupportsLogging="1" AdvertisingName="EKG" DiscoveryImage="Icon1063.png">
          <Channel ID="0" NameTag="Voltage" SensorID="2074" Type="Pasport"/>
          <Channel ID="1" NameTag="HeartRate" SensorID="2075" Type="Pasport"/>
      </Interface>
      <Interface ID="1064" NameTag="WirelessGM" SupportsLogging="1" AdvertisingName="Geiger Counter" DiscoveryImage="Icon1064.svg">
          <Channel ID="0" NameTag="Counts" SensorID="2079" Type="Pasport"/>
          <Channel ID="1" NameTag="Counts2" SensorID="2086" Type="Pasport"/>
          <!--Debug--><Channelx ID="1" NameTag="Voltage" Type="Output" OutputType="15"/>
      </Interface>
      <Interface ID="1065" NameTag="WirelessMeltTemp" SupportsLogging="0" AdvertisingName="Melt Temp" DiscoveryImage="Icon1065.svg">
          <Channel ID="0" NameTag="Temperature" SensorID="2080" Type="Pasport"/>
          <!--Debug--><Channelx ID="1" NameTag="SetTempRaw" Type="Output" OutputType="16"/>
          <!--Debug--><Channelx ID="2" NameTag="FanSpeedPercent" Type="Output" OutputType="17"/>
          <!--Debug--><Channelx ID="3" NameTag="HeaterPercent" Type="Output" OutputType="18"/>
      </Interface>
      <Interface ID="1066" NameTag="WirelessCO" AdvertisingName="CO" SupportsLogging="1" DiscoveryImage="Icon1066.png">
          <Channel ID="0" NameTag="CO" SensorID="2083" Type="Pasport"/>
      </Interface>
      <Interface ID="1067" NameTag="WirelessAirQuality" AdvertisingName="Air Quality" SupportsLogging="1" DiscoveryImage="Icon1067.svg">
          <Channel ID="0" NameTag="CO" SensorID="2084" Type="Pasport"/>
      </Interface>
      <Interface ID="1068" NameTag="WirelessCharge" AdvertisingName="Charge" SupportsLogging="1">
          <Channel ID="0" NameTag="Charge" SensorID="2085" Type="Pasport"/>
      </Interface>
    </Interfaces>
    <OutputGroups>
      <Group ID="1" Name="SigGenOutputs" OutputIDs="1-4,6,9,15-18"/>
      <Group ID="2" Name="BlocklyOutputs" OutputIDs="1-9,12,15-18"/>
      <Group ID="3" Name="BlocklyFrequencyOutputs" OutputIDs="1-4,6,9,14"/>
    </OutputGroups>
    <Outputs>
      <Output ID="1" NameTag="850OutputOrd">
        <Waveform Waveforms="Sine,Square,Triangle,RampUp,RampDown,PosSquare,PosRampUp,PosRampDown,DC"/>
        <Frequency Default="1000" Max="200000" Min="0.001" Step="0.001"/>
        <DutyCycle Default="50" Max="100" Min="0" Step="1"/>
        <Phase Max="360" Min="-360" Step="1.0"/>
        <DCVoltage Max="15" Min="-15" Step="0.01"/>
        <Amplitude Max="15" Min="0" Step="0.01"/>
        <Offset Max="15" Min="-15" Step="0.01"/>
        <VoltageLimit Default="15" Max="15" Min="0" Step="0.01"/>
        <CurrentLimit Steps="0.55,1.1,1.5"/>
        <SweepType Max="3" Min="0" Step="1" Types="Off,Single,Repeat,Bidirectional"/>
        <SweepInitFreq Max="200000" Min="0.001" Step="0.001"/>
        <SweepFinalFreq Max="200000" Min="0.001" Step="0.001"/>
        <SweepStepFreq Max="200000" Min="0.001" Step="0"/>
        <SweepDuration Max="10000" Min="1" Step="1"/>
      </Output>
      <Output ID="2" NameTag="850OutputOrd">
        <Waveform Waveforms="Sine,Square,Triangle,RampUp,RampDown,DC"/>
        <Frequency Max="500000" Min="0.001" Step="0.001"/>
        <DutyCycle Default="50" Max="100" Min="0" Step="1"/>
        <Phase Max="360" Min="-360" Step="1.0"/>
        <DCVoltage Max="10" Min="-10" Step="0.01"/>
        <Amplitude Max="10" Min="0" Step="0.01"/>
        <VoltageLimit Default="10" Max="10" Min="0" Step="0.01"/>
        <SweepType Max="3" Min="0" Step="1" Types="Off,Single,Repeat,Bidirectional"/>
        <SweepInitFreq Default="10" Max="500000" Min="0.001" Step="0.001"/>
        <SweepFinalFreq Default="100" Max="500000" Min="0.001" Step="0.001"/>
        <SweepStepFreq Default="0" Max="500000" Min="0" Step="0.001"/>
        <SweepDuration Default="5" Max="10000" Min="1" Step="1"/>
      </Output>
      <Output ID="3" NameTag="DigitalFunctionGenerator">
        <Waveform Waveforms="Sine,Square,Triangle,RampUp,RampDown,DC,External,ModSine,ModTriangle,ModRampUp,ModRampDown"/>
        <Frequency Max="150000" Min="0.001" Step="0.001"/>
        <DCVoltage Max="10" Min="-10" Step="0.01"/>
        <Amplitude Max="10" Min="0" Step="0.01"/>
        <Percent Max="100" Min="0" Step="0.1"/>
        <Offset Max="10" Min="-10" Step="0.01"/>
        <VoltageLimit Default="10" Max="10" Min="0" Step="0.01"/>
        <CurrentLimit Max="2" Min="0" Step="1" Steps="0.55,1.1,1.5"/>
        <SweepType Max="3" Min="0" Step="1" Types="Off,Single,Repeat,Bidirectional"/>
        <SweepInitFreq Default="10" Max="150000" Min="0.001" Step="0.001"/>
        <SweepFinalFreq Default="100" Max="150000" Min="0.001" Step="0.001"/>
        <SweepStepFreq Default="0" Max="150000" Min="0" Step="0.001"/>
        <SweepDuration Default="5" Max="10000" Min="1" Step="1"/>
      </Output>
      <Output ID="4" NameTag="SW750Output">
        <Waveform Waveforms="Sine,Square,Triangle,RampUp,RampDown,PosSquare,PosRampUp,PosRampDown,DC"/>
        <Frequency Max="100000" Min="0.001" Step="0.001"/>
        <DCVoltage Max="10" Min="-10" Step="0.01"/>
        <Amplitude Max="10" Min="0" Step="0.01"/>
        <VoltageLimit Default="5" Max="5" Min="0" Step="0.01"/>
      </Output>
      <Output ID="5" NameTag="PS850CIDigitalOutput">
        <Waveform Waveforms="Square,DC"/>
        <Frequency Max="100000" Min="0.001" Step="0.001"/>
        <DCVoltage Max="1" Min="0" Step="1"/>
        <Amplitude Max="1" Min="0" Step="1"/>
      </Output>
      <Output ID="6" NameTag="550Output">
        <Waveform Waveforms="Sine,Square,Triangle,RampUp,RampDown,PosSquare,PosRampUp,PosRampDown,DC"/>
        <Frequency Default="1000" Max="100000" Min="0.001" Step="0.001"/>
        <DutyCycle Default="50" Max="100" Min="0" Step="1"/>
        <DCVoltage Max="8" Min="-8" Step="0.01"/>
        <Amplitude Max="8" Min="0" Step="0.01"/>
        <Offset Max="8" Min="-8" Step="0.01"/>
        <VoltageLimit Default="8" Max="8" Min="0" Step="0.01"/>
        <SweepType Max="3" Min="0" Step="1" Types="Off,Single,Repeat,Bidirectional"/>
        <SweepInitFreq Max="100000" Min="0.001" Step="0.001"/>
        <SweepFinalFreq Max="100000" Min="0.001" Step="0.001"/>
        <SweepStepFreq Max="100000" Min="0.001" Step="0"/>
        <SweepDuration Max="10000" Min="1" Step="1"/>
      </Output>
      <Output ID="7" NameTag="FanCartAccessory">
        <Waveform Waveforms="DC"/>
        <DCVoltage Max="100" Min="-100" Step="1" Default="100"/>
      </Output>
      <Output ID="8" NameTag="LightSource" Hidden="1">
        <Waveform Waveforms="DC"/>
        <DCVoltage Max="255" Min="0" Step="1"/>
      </Output>
      <Output ID="9" NameTag="WirelessFunctionGenerator">
        <Waveform Waveforms="Sine,Square,Triangle,DC" Default="DC"/>
        <Frequency Default="100" Max="10000" Min="0.01" Step="0.01"/>
        <DCVoltage Max="3" Min="-3" Step="0.01"/>
        <Amplitude Max="3" Min="0" Step="0.01"/>
        <VoltageLimit Default="3" Max="3" Min="0" Step="0.01"/>
      </Output>
      <Output ID="10" NameTag="WirelessSTEMMotor">
        <Waveform Waveforms="DC"/>
        <DCVoltage Max="720" Min="-720" Step="1"/>
      </Output>
      <Output ID="11" NameTag="WirelessSTEMgpio">
        <Waveform Waveforms="DC"/>
        <DCVoltage Max="255" Min="0" Step="1"/>
      </Output>
      <Output ID="12" NameTag="SmartCartMotor">
        <Waveform Waveforms="DC"/>
        <DCVoltage Max="100" Min="-100" Step="0.1"/>
      </Output>
      <Output ID="13" NameTag="CodeNodeLED">
        <Waveform Waveforms="DC"/>
        <DCVoltage Max="255" Min="0" Step="1"/>
      </Output>
      <Output ID="14" NameTag="CodeNodeSound">
        <Waveform Waveforms="Square"/>
        <Frequency Default="220" Max="20000" Min="0" Step="1"/>
      </Output>
      <Output ID="15" NameTag="GeigerVoltage">
        <Waveform Waveforms="DC"/>
        <DCVoltage Max="700" Min="200" Default="500" Step="1"/>
        <!--Debug--><DCVoltagex Max="63" Min="0" Default="39" Step="1"/>
      </Output>
      <Output ID="16" NameTag="MeltTempSetTempRaw">
        <Waveform Waveforms="DC"/>
        <DCVoltage Max="8191" Min="0" Default="0" Step="1" DCLimit="8192"/>
        <VoltageLimit Default="8192" Max="8192" Min="0" Step="1"/>
      </Output>
      <Output ID="17" NameTag="MeltTempFanPercent">
        <Waveform Waveforms="DC"/>
        <DCVoltage Max="100" Min="0" Default="0" Step="1"/>
      </Output>
      <Output ID="18" NameTag="MeltTempHeaterPercent">
        <Waveform Waveforms="DC"/>
        <DCVoltage Max="10000" Min="0" Default="0" Step="1"/>
        <VoltageLimit Default="10000" Max="10000" Min="10000" Step="1"/>
      </Output>
    </Outputs>
  </Datasheets>
'''